' HanaSenpu is both BandInte and Lisanka/SheFoxEtte - Picture-Viewer with Zoom and Scroll, No Scaling; r.1+ (629 lines, 2024-Mar-13) written by Kaze (sanmayce@sanmayce.com), the magnificent magnifier 'MagScope' is written by OldMoses.
' This is special revision (1+, Linux only for now) turned into CPU/RAM benchmark therefore called differently ... HanaSenpu. Credits go to the superb Japanese anime series 'Sekirei', the sound is Kazehana Sekirei #0 talking.

' HanaSenpu a.k.a. Lisanka (SheFoxEtte) DIZ (description):
' - if no parameter is given on the command line (or as Drag-n-Drop on the .EXE or launcher) then BandInte is executed, otherwise Lisanka/SheFoxEtte;
' - if BandInte is to be executed then $ sudo ./HanaSenpu otherwise the hardware reading cannot be performed;
' - benchmarks the RAW CPU power in INTEGER department without using any cached/uncached RAM, stressing all cores (as many as presented);
' - the first metric is GB/s, it is somewhat smaller (~2GB/s less) than the e.g. AIDA's Memory Read Speed, but it is more realistic since all the QWORDS are summed;
' - the second metric is FPS and is closest to the combine MHz power of all cores since the code is supersimple and highlights FREQUENCY not IPC;
' - this GUI tool is 100% FREE written by QB64[PE] community;
' - portable, Linux/Windows;
' - allows scrolling and zooming (with a MagScope) a picture (usually PNG/JPG) pathfilename passed via the CLIPBOARD;
' - on Linux Drag-and-Drop a file onto Lisanka launcher, or just Ctrl+C a file from Caja, or pass it on command line;
' - adjustable ScrollStep and MagnifyFactor via keys 1..9 and Z..M respectively;
' - adjustable MagScope via MouseWheel.

$If WINDOWS Then
        Declare Library 'Directory Information using KERNEL32 provided by Dav
        Function GetModuleFileNameA (ByVal Module As Long, FileName As String, Byval nSize As Long)
        End Declare
$End If

$If WINDOWS Then
        PSPlike$ = _CWD$ ' unreliable, when starting PSP.EXE from (C:\mingw, current drive and folder) with D:\PSP.EXE and current folder on D: is D:\temp then _CWD$ instead of "D:\" is "D:\temp", why?!
        PSPreal$ = PATHpsp$
        PSPlike$ = PSPreal$
        If Right$(PSPlike$, 1) <> "\" Then PSPlike$ = PSPlike$ + "\"
        PathToEngage$ = _StartDir$
        If Right$(PathToEngage$, 1) <> "\" Then PathToEngage$ = PathToEngage$ + "\"
$Else
    PSPlike$ = _CWD$
    If Right$(PSPlike$, 1) <> "/" Then PSPlike$ = PSPlike$ + "/"
    PathToEngage$ = _StartDir$
    If Right$(PathToEngage$, 1) <> "/" Then PathToEngage$ = PathToEngage$ + "/"
$End If

'ChDir _StartDir$
$If WINDOWS Then
        'ChDir PSPlike$
$End If

' Browse filename from clipboard [
'Print _Clipboard$: End
GetFirstLineOfCLP$ = _Clipboard$
If InStr(GetFirstLineOfCLP$, Chr$(10)) Then
    GetFirstLineOfCLP$ = Left$(_Clipboard$, InStr(GetFirstLineOfCLP$, Chr$(10)) - 1)
    'Caution: Getting multilines from QB64 IDE there is one extra CR
    If Right$(GetFirstLineOfCLP$, 1) = Chr$(13) Then GetFirstLineOfCLP$ = Left$(_Clipboard$, InStr(GetFirstLineOfCLP$, Chr$(13)) - 1)
Else
End If
'For i = 1 To Len(GetFirstLineOfCLP$)
'    Print Mid$(GetFirstLineOfCLP$, i, 1);
'Next
'End

' First check whether COMMAND$ houses [path]filename, if empty then check clipboard, note that %F is to be used in Linux Launcher Cammand Line field for passing 2[+] arguments otherwise separate instances will be started.
If Command$ <> "" Then
    GetFirstLineOfCLP$ = Command$ 'override the clipboard
End If

If _FileExists(GetFirstLineOfCLP$) Then
    If UCase$(Right$(GetFirstLineOfCLP$, 4)) = ".JPG" Or UCase$(Right$(GetFirstLineOfCLP$, 4)) = ".PNG" Then
        source_handle& = _LoadImage(GetFirstLineOfCLP$, 32)
    Else
        BenchmarkMode = 1 ' fall back to benchmark mode if the valid file is not viewable
    End If
Else
    BenchmarkMode = 1 ' set if command line is empty AND no existing file via clipboard
    source_handle& = _LoadImage(PSPlike$ + "60dfcf94-841f-4e50-849a-163c0242efda_sharpen_dark.webp.png", 32)
End If

If BenchmarkMode = 1 Then
    _Title "HanaSenpu: BandInte r.1+; 'Q'-Quit; 'Z'..'M'-MagFactor; '1'..'9'-ScrollStep; Space+MouseMove=Arrows; MouseWheel-MagScopeSize"
Else
    _Title "HanaSenpu: Lisanka/SheFoxEtte r.1+; 'Q'-Quit; 'Z'..'M'-MagFactor; '1'..'9'-ScrollStep; Space+MouseMove=Arrows; MouseWheel-MagScopeSize"
End If

screamZZZ& = 0
screamZZZ& = _SndOpen(PSPlike$ + "Sekirei_E04_HanaSenpu.MP3")
_SndVol screamZZZ&, 0.8

ratio = 1
If BenchmarkMode = 1 Then
    magsiz% = 1200
    magfactor% = 2 ' should be 1 for MagScope OFF, 'Z'=2 is maximum minimum ... 2x, 'X'=3 is 3x, ... 'M'=8 is 8x
Else
    magsiz% = 700
    magfactor% = 1 ' should be 1 for MagScope OFF, 'Z'=2 is maximum minimum ... 2x, 'X'=3 is 3x, ... 'M'=8 is 8x
End If
ScrlStp = 16 ' this is '4' i.e. 2^4=16 pixels step
FramesPerSecond = 500

'80*8=640x25*16=400 *7/4 -> 7*160x7*100 1120x700
' Above mode is the minimum for 1366x768
' 640/480= 4:3

If _DesktopWidth <= 1650 Then
    MaxX = 10 ' 70*10=700 < 768
ElseIf _DesktopWidth >= 1920 Then
    MaxX = 14 ' 70*14=980 < 1080
ElseIf _DesktopWidth >= 2880 Then
    MaxX = 23 ' 70*23=1610 < 1800
End If

For i = 6 To MaxX
    dest_handle& = _NewImage(112 * i, 70 * i, 32) '+1 for the new line
    Do: Loop Until _ScreenExists
    _ScreenMove 13, 13
    Screen dest_handle&
    _Delay .05
Next
For i = MaxX + 1 To MaxX + 2 '12*112+13= 1357 < 1366; 16*112+13= 1805 < 1920; 25*112+13= 2813 < 2880
    dest_handle& = _NewImage(112 * i, 70 * MaxX, 32) '+1 for the new line
    Do: Loop Until _ScreenExists
    _ScreenMove 13, 13
    Screen dest_handle&
    _Delay .05
Next

' MakeMask [
s% = magsiz%
cn% = _ShR(s%, 1) - 1 '                                     image center
If msk& < -1 Then _FreeImage msk& '                         remove old mask if any
msk& = _NewImage(s%, s%, 32) '                              create mask image
_Dest msk&
Color , _RGB32(255, 0, 255) '                               fill mask with purple to clear color in SUB Magnify
Cls
FCirc cn%, cn%, cn%, _RGB32(0, 0, 0) '                      apply centered black circle to clearcolor in SUB Magnify
_Dest 0 '
' MakeMask ]

If source_handle& < -1 Then
    TRG_HorizontalEndPOS = _Width(dest_handle&) - 1
    TRG_VerticalEndPOS = _Height(dest_handle&) - 1
    SRC_HorizontalEndPOS = _Width(source_handle&) - 1
    SRC_VerticalEndPOS = _Height(source_handle&) - 1
    dx1 = 0: dy1 = 0
    sx1 = 0: sy1 = 0

    If sy1 + 96 <= SRC_VerticalEndPOS - TRG_VerticalEndPOS Then sy1 = sy1 + 96 ' for BandInte

    FieldLineLenPNG = 6
    _PutImage (dx1, dy1)-(TRG_HorizontalEndPOS, TRG_VerticalEndPOS), source_handle&, dest_handle&, (sx1, sy1)-(sx1 + TRG_HorizontalEndPOS, sy1 + TRG_VerticalEndPOS)
    LastX = _MouseX
    LastY = _MouseY
    LastHit~&& = EpochTime~&&: Stepping = 10

    If BenchmarkMode = 1 Then
        'BandInte [
        'q& = _NewImage(720, 400, 32)
        'Screen q&
        '_ControlChr Off
        TTF$ = "Monocode-Regular-V01.02b.ttf"
        FntSz = 32
        FNThandleT& = _LoadFont(PSPlike$ + TTF$, FntSz, "MONOSPACE")
        If FNThandleT& > 0 Then _Font FNThandleT& ' DO THE REMAPPING LATER AS IN SCHIZANDRA IN ORDER TO HAVE 'GESCH' CODEPAGE

        $If WINDOWS Then

                'run CPU-Z in console to redirect to 'BandInte.log'
                'Line below creates 'q.txt'
                '$ wine cpuz_x64.exe -txt=q

                '    Number of cores     4 (max 4)
                '    Number of threads   4 (max 4)
                '    Codename        Gemini Lake
                '    Specification       Intel(R) Celeron(R) N4100 CPU @ 1.10GHz
                '    Technology      14 nm
                '    L1 Data cache       4 x 24 KB (6-way, 64-byte line)
                '    L1 Instruction cache    4 x 32 KB (8-way, 64-byte line)
                '    L2 cache        4 MB (16-way, 64-byte line)
                'Memory Size         7752 MBytes
                '    family          ThinkPad 11e 5th Gen

        $Else
            Shell _Hide "sudo dmidecode --type 1 | grep -i -m1 " + Chr$(34) + "Family:" + Chr$(34) + " >" + PSPlike$ + "BandInte.log"
            Shell _Hide "sudo dmidecode --type 17 | grep -i -m1 " + Chr$(34) + "Type:" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"
            Shell _Hide "sudo dmidecode --type 17 | grep -i -m1 " + Chr$(34) + "Manufacturer:" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"
            Shell _Hide "sudo dmidecode --type 17 | grep -i -m1 " + Chr$(34) + "Configured Memory Speed:" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"

            Shell _Hide "lscpu | grep -i -m1 " + Chr$(34) + "Model name:" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"
            Shell _Hide "lscpu | grep -i -m1 " + Chr$(34) + "Thread(s) per core:" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"
            Shell _Hide "lscpu | grep -i -m1 " + Chr$(34) + "Core(s) per socket:" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"
            Shell _Hide "lscpu | grep -i -m1 " + Chr$(34) + "Socket(s):" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"
            Shell _Hide "lscpu | grep -i -m1 " + Chr$(34) + "CPU max MHz:" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"
            Shell _Hide "lscpu | grep -i -m1 " + Chr$(34) + "L1d cache" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"
            Shell _Hide "lscpu | grep -i -m1 " + Chr$(34) + "L1i cache" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"
            Shell _Hide "lscpu | grep -m1 " + Chr$(34) + "L2 cache" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"
            Shell _Hide "lscpu | grep -m1 " + Chr$(34) + "L3 cache" + Chr$(34) + " >>" + PSPlike$ + "BandInte.log"

            '[sanmayce@djudjeto5 ~]$ sudo dmidecode --type 1 | grep -i "Family:"
            '    Family: ThinkPad 11e 5th Gen
            '[sanmayce@djudjeto5 ~]$ sudo dmidecode --type 17 | grep -i "Locator:"
            '    Locator: ChannelA-DIMM0
            '    Bank Locator: BANK 0
            '    Locator: ChannelA-DIMM1
            '    Bank Locator: BANK 1
            '[sanmayce@djudjeto5 ~]$ sudo dmidecode --type 17 | grep -i "Type:"
            '    Type: DDR4
            '    Type: DDR4
            '[sanmayce@djudjeto5 ~]$ sudo dmidecode --type 17 | grep -i "Manufacturer:"
            '    Manufacturer: Micron
            '    Manufacturer: Micron
            '[sanmayce@djudjeto5 ~]$ sudo dmidecode --type 17 | grep -i "Configured Memory Speed:"
            '    Configured Memory Speed: 2400 MT/s
            '    Configured Memory Speed: 2400 MT/s
            '[sanmayce@djudjeto5 ~]$

            'Model name:            Intel(R) Celeron(R) N4100 CPU @ 1.10GHz
            '  Thread(s) per core:  1
            '  Core(s) per socket:  4
            '  Socket(s):           1
            '  CPU max MHz:         2400.0000
            'L1d:                   96 KiB (4 instances)
            'L1i:                   128 KiB (4 instances)
            'L2:                    4 MiB (1 instance)

            Open PSPlike$ + "BandInte.log" For Binary As #1
            If LOF(1) Then
                Line Input #1, l1$
                Line Input #1, l2$
                Line Input #1, l3$
                Line Input #1, l4$

                Line Input #1, l01$
                Line Input #1, l02$
                Line Input #1, l03$
                Line Input #1, l04$
                Line Input #1, l05$
                Line Input #1, l06$
                Line Input #1, l07$
                Line Input #1, l08$
                If Not EOF(1) Then
                    Line Input #1, l09$
                Else
                    l09$ = "L3 cache: NONE"
                End If
            End If
            Close #1

            '[sanmayce@djudjeto5 Shefoxette_r1]$ hexdump BandInte.log -C
            '00000000  09 46 61 6d 69 6c 79 3a  20 54 68 69 6e 6b 50 61  |.Family: ThinkPa|
            '00000010  64 20 31 31 65 20 35 74  68 20 47 65 6e 0a 09 54  |d 11e 5th Gen..T|
            '00000020  79 70 65 3a 20 44 44 52  34 0a 09 4d 61 6e 75 66  |ype: DDR4..Manuf|
            '00000030  61 63 74 75 72 65 72 3a  20 4d 69 63 72 6f 6e 0a  |acturer: Micron.|
            '00000040  09 43 6f 6e 66 69 67 75  72 65 64 20 4d 65 6d 6f  |.Configured Memo|
            '00000050  72 79 20 53 70 65 65 64  3a 20 32 34 30 30 20 4d  |ry Speed: 2400 M|
            '00000060  54 2f 73 0a                                       |T/s.|
            '00000064
            '[sanmayce@djudjeto5 Shefoxette_r1]$


            Color _RGB(3, 3, 3), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
            _PrintString (12, 9 + (FntSz + 3) * 0), "BandInte - reporting BANDWIDTH-n-INTEGER PROWESS of CPU" '12 is horizontal
            'Explanation: _PRINTSTRING allows text or font colors to be alpha blended in 32 bit screens.
            _PrintString (12, 9 + (FntSz + 3) * 2), TabulatedSTR$("Machine " + Mid$(l1$, 2)) '12 is horizontal

            '_PrintString (12, 9 + (FntSz + 3) * 3), TabulatedSTR$(Mid$(l2$, 2))
            '_PrintString (12, 9 + (FntSz + 3) * 4), TabulatedSTR$(Mid$(l3$, 2))
            l2$ = Mid$(l2$, 2)
            l3$ = Mid$(l3$, 2)
            l2l3$ = "RAM Type/Manufacturer: "
            _PrintString (12, 9 + (FntSz + 3) * 3), TabulatedSTR$(l2l3$ + LTrim$(Mid$(l2$, InStr(l2$, ":") + 1)) + "/" + LTrim$(Mid$(l3$, InStr(l3$, ":") + 1)))

            _PrintString (12, 9 + (FntSz + 3) * 4), TabulatedSTR$(Mid$(l4$, 2))
            _PrintString (12, 9 + (FntSz + 3) * 5), TabulatedSTR$("CPU " + l01$)
            _PrintString (12, 9 + (FntSz + 3) * 6), TabulatedSTR$(l02$)
            _PrintString (12, 9 + (FntSz + 3) * 7), TabulatedSTR$(l03$)
            _PrintString (12, 9 + (FntSz + 3) * 8), TabulatedSTR$(l04$)
            _PrintString (12, 9 + (FntSz + 3) * 9), TabulatedSTR$(l05$)
            _PrintString (12, 9 + (FntSz + 3) * 10), TabulatedSTR$(l06$)
            _PrintString (12, 9 + (FntSz + 3) * 11), TabulatedSTR$(l07$)
            _PrintString (12, 9 + (FntSz + 3) * 12), TabulatedSTR$(l08$)
            _PrintString (12, 9 + (FntSz + 3) * 13), TabulatedSTR$(l09$)

            Color _RGB(210, 120, 8), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 0), "BandInte - reporting BANDWIDTH-n-INTEGER PROWESS of CPU" '12 is horizontal
            'Explanation: _PRINTSTRING allows text or font colors to be alpha blended in 32 bit screens.
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 2), TabulatedSTR$("Machine " + Mid$(l1$, 2))

            '_PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 3), TabulatedSTR$(Mid$(l2$, 2))
            '_PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 4), TabulatedSTR$(Mid$(l3$, 2))
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 3), TabulatedSTR$(l2l3$ + LTrim$(Mid$(l2$, InStr(l2$, ":") + 1)) + "/" + LTrim$(Mid$(l3$, InStr(l3$, ":") + 1)))

            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 4), TabulatedSTR$(Mid$(l4$, 2))
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 5), TabulatedSTR$("CPU " + l01$)
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 6), TabulatedSTR$(l02$)
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 7), TabulatedSTR$(l03$)
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 8), TabulatedSTR$(l04$)
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 9), TabulatedSTR$(l05$)
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 10), TabulatedSTR$(l06$)
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 11), TabulatedSTR$(l07$)
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 12), TabulatedSTR$(l08$)
            _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 13), TabulatedSTR$(l09$)
        $End If

        _MouseShow "WAIT"

        Color _RGB(3, 3, 3), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12, 9 + (FntSz + 3) * 15), "Calculating BANDWIDTH..."
        Color _RGB(210, 120, 8), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 15), "Calculating BANDWIDTH..."

        _MouseMove 12 - 3 + Len("Calculating BANDWIDTH...") * 20 - 10, 9 - 3 + (FntSz + 3) * 16 - 16 'the goal is the pointer to be positioned after "..."

        $If WINDOWS Then
                Shell _Hide "CMD /C " + PSPlike$ + "BuBa_BunakBandwidth_YMM.exe 6 max > " + PSPlike$ + "BandInte.log" ' this doesn't generate the file, maybe .dll files are not found due to the path, the fix: use chdir to PSP at the top
        $Else
            Shell _Hide "echo performance | tee /sys/devices/system/cpu/cpu*/cpufreq/scaling_governor"
            If InStr(UCase$(l01$), "CELERON") Then
                Shell _Hide "sudo nice -n -20 " + PSPlike$ + "bandwidth_XMM.elf >" + PSPlike$ + "BandInte.log"
            Else
                Shell _Hide "sudo nice -n -20 " + PSPlike$ + "BuBa_BunakBandwidth_YMM.elf 6 max >" + PSPlike$ + "BandInte.log"
            End If
        $End If

        Open PSPlike$ + "BandInte.log" For Binary As #1
        If LOF(1) Then
            Do While Not EOF(1)
                Line Input #1, l$
            Loop
        End If
        Close #1

        l$ = Left$(l$, InStr(l$, "observed") - 1) + Mid$(l$, InStr(l$, "bandwidth"))
        Color _RGB(3, 3, 3), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12, 9 + (FntSz + 3) * 15), "Calculating BANDWIDTH..." + " " + l$
        Color _RGB(210, 120, 8), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 15), "Calculating BANDWIDTH..." + " " + l$

        Color _RGB(3, 3, 3), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12, 9 + (FntSz + 3) * 16), "Calculating INTEGER PROWESS to factorize..."
        Color _RGB(210, 120, 8), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 16), "Calculating INTEGER PROWESS to factorize..."

        _MouseMove 12 - 3 + Len("Calculating INTEGER PROWESS to factorize...") * 20 - 30, 9 - 3 + (FntSz + 3) * 17 - 16 'the goal is the pointer to be positioned after "..."

        $If WINDOWS Then
                Shell _Hide "CMD /C " + PSPlike$ + "factorize_FNPS.exe > " + PSPlike$ + "BandInte.log"
        $Else
            Shell _Hide "sudo nice -n -20 " + PSPlike$ + "factorize_FNPS.elf >" + PSPlike$ + "BandInte.log"
        $End If

        Open PSPlike$ + "BandInte.log" For Binary As #1
        If LOF(1) Then
            Do While Not EOF(1)
                Line Input #1, l$
            Loop
        End If
        Close #1
        l$ = Mid$(l$, InStr(l$, ":") + 1)
        Color _RGB(3, 3, 3), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12, 9 + (FntSz + 3) * 16), "Calculating INTEGER PROWESS to factorize..." + l$ + " FPS"
        Color _RGB(210, 120, 8), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 16), "Calculating INTEGER PROWESS to factorize..." + l$ + " FPS"

        Color _RGB(3, 3, 3), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12, 9 + (FntSz + 3) * 17), "Note: This number FPS (Factorizations-Per-Second) parallels the"
        Color _RGB(220, 60, 8), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 17), "Note: This number FPS (Factorizations-Per-Second) parallels the"

        Color _RGB(3, 3, 3), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12, 9 + (FntSz + 3) * 18), "combine FREQUENCY power of all cores since it DOESN'T stress any RAM."
        Color _RGB(220, 60, 8), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _PrintString (12 - 3, 9 - 3 + (FntSz + 3) * 18), "combine FREQUENCY power of all cores since it DOESN'T stress any RAM."

        '_PutImage (dx1, dy1)-(TRG_HorizontalEndPOS, TRG_VerticalEndPOS), source_handle&, dest_handle&, (sx1, sy1)-(sx1 + TRG_HorizontalEndPOS, sy1 + TRG_VerticalEndPOS)
        'copy (i.e. EMBEDDING) the stats into source:
        _PutImage (sx1, sy1)-(sx1 + TRG_HorizontalEndPOS, sy1 + TRG_VerticalEndPOS), dest_handle&, source_handle&, (dx1, dy1)-(TRG_HorizontalEndPOS, TRG_VerticalEndPOS)
        Color _RGB(20, 80, 110), _RGBA(0, 0, 0, 0) 'Foreground set to RED background to TRANSPARENT BLACK
        _MouseShow "DEFAULT"
        'Sleep
        _MouseMove 1110, 9 - 3 + (FntSz + 3) * 19 'the goal is the pointer to be positioned between FPS and GB/s
        ' Had to comment it out since error with initialization in SU occurred [
        '[sanmayce@djudjeto5 Shefoxette_r1+]$ sudo ./HanaSenpu
        '[sudo] password for sanmayce:
        'ALSA lib pcm_dmix.c:1000:(snd_pcm_dmix_open) unable to open slave
        'ALSA lib pcm_dmix.c:1000:(snd_pcm_dmix_open) unable to open slave
        'ALSA lib pcm_dmix.c:1000:(snd_pcm_dmix_open) unable to open slave
        'If screamZZZ& <> 0 Then _SndPlay screamZZZ&
        '_Delay 50
        ' Had to comment it out since error with initialization in SU occurred ]
        'BandInte ]
    End If

    Do
        buttondown1 = 0
        buttondown2 = 0
        buttondown3 = 0
        mwheel = 0
        WaitingForAKey$ = ""
        Do While WaitingForAKey$ = "" And (buttondown1 + buttondown2 + buttondown3 + Abs(mwheel) = 0) And _KeyHit = 0
            AsIfItIsINKEY% = _MouseInput
            If AsIfItIsINKEY% Then
                buttondown1 = _MouseButton(1)
                buttondown2 = _MouseButton(2)
                buttondown3 = _MouseButton(3)
                mwheel = _MouseWheel
            End If
            If mwheel = -1 Then
                If magsiz% < 1300 Then magsiz% = magsiz% + 100
            ElseIf mwheel = 1 Then
                If magsiz% > 100 Then magsiz% = magsiz% - 100
            End If
            WaitingForAKey$ = InKey$
            'the every-loop stepper [
            Select Case EpochTime~&& - LastHit~&&
                Case Is > 2 * 60: Stepping = 0
                Case Else
            End Select
            _Limit Int(FramesPerSecond * (Stepping * .1)) + 5 'to avoid 0
            'the every-loop stepper ]

            If _KeyDown(32) = 0 Then
                If magfactor% <> 1 Then _MouseHide Else _MouseShow "DEFAULT"
                Cls
                _PutImage (dx1, dy1)-(TRG_HorizontalEndPOS, TRG_VerticalEndPOS), source_handle&, dest_handle&, (sx1, sy1)-(sx1 + TRG_HorizontalEndPOS, sy1 + TRG_VerticalEndPOS)
                '_PutImage (0, 0)-(_Width(0) - 1, _Height(0) - 1), source_handle&, 0
                If _MouseInput Then LastHit~&& = EpochTime~&&: Stepping = 10
                Do While _MouseInput: Loop
                Mouse_StartX = _MouseX: Mouse_StartY = _MouseY
                If magfactor% > 1 Then
                    Magnify magfactor%, source_handle&, magsiz%, ratio, msk&
                End If
                _Display
            End If

            If (LastX <> _MouseX Or LastY <> _MouseY) And _KeyDown(32) Then
                Do While _MouseInput: Loop
                _MouseShow "CROSSHAIR" '"LINK" 'the hand needs to reverse the arrow-logic i.e directions have to be reversed, so use cross-hair
                LastHit~&& = EpochTime~&&: Stepping = 10
                If LastY < _MouseY Then
                    If sy1 + ScrlStp <= SRC_VerticalEndPOS - TRG_VerticalEndPOS Then sy1 = sy1 + ScrlStp
                End If
                If LastY > _MouseY Then
                    If sy1 - ScrlStp >= 0 Then sy1 = sy1 - ScrlStp
                End If
                If LastX < _MouseX Then
                    If sx1 + ScrlStp <= SRC_HorizontalEndPOS - TRG_HorizontalEndPOS Then sx1 = sx1 + ScrlStp
                End If
                If LastX > _MouseX Then
                    If sx1 - ScrlStp >= 0 Then sx1 = sx1 - ScrlStp
                End If
                Cls
                _PutImage (dx1, dy1)-(TRG_HorizontalEndPOS, TRG_VerticalEndPOS), source_handle&, dest_handle&, (sx1, sy1)-(sx1 + TRG_HorizontalEndPOS, sy1 + TRG_VerticalEndPOS)
                Locate 2, 2: Print "Use Arrows (or hold Space and move Mouse);"
                Locate 3, 2: Print "Use Mouse Wheel to increase/decrease MagScope size;"
                Locate 4, 2: Print "Use 1..9 for Scroll Granularity, 4 is default;"
                Locate 5, 2: Print "Use Z..M for MagScope; Z is 2x, X is 3x ..."
                Locate 6, 2: Print "ImageDimensions: "; LTrim$(Str$(SRC_HorizontalEndPOS + 1)); " x "; LTrim$(Str$(SRC_VerticalEndPOS + 1))
                Locate 7, 2: Print "TopLeftVerPos: "; AddCommasPaddedLEN$(sy1); "; TopLeftHorPos: "; AddCommasPaddedLEN$(sx1)
                _Display
                LastX = _MouseX
                LastY = _MouseY
            End If
            _Limit Int(FramesPerSecond * (Stepping * .1)) + 5 'to avoid 0
        Loop
        kk$ = WaitingForAKey$
        If Len(kk$) = 1 Then

            LastHit~&& = EpochTime~&&: Stepping = 10
            If kk$ = "1" Then ScrlStp = 2 ^ 1
            If kk$ = "2" Then ScrlStp = 2 ^ 2
            If kk$ = "3" Then ScrlStp = 2 ^ 3
            If kk$ = "4" Then ScrlStp = 2 ^ 4
            If kk$ = "5" Then ScrlStp = 2 ^ 5
            If kk$ = "6" Then ScrlStp = 2 ^ 6
            If kk$ = "7" Then ScrlStp = 2 ^ 7
            If kk$ = "8" Then ScrlStp = 2 ^ 8
            If kk$ = "9" Then ScrlStp = 2 ^ 9

            If UCase$(kk$) = "Z" Then
                _MouseHide
                magfactor% = 2
            ElseIf UCase$(kk$) = "X" Then
                _MouseHide
                magfactor% = 3
            ElseIf UCase$(kk$) = "C" Then
                _MouseHide
                magfactor% = 4
            ElseIf UCase$(kk$) = "V" Then
                _MouseHide
                magfactor% = 5
            ElseIf UCase$(kk$) = "B" Then
                _MouseHide
                magfactor% = 6
            ElseIf UCase$(kk$) = "N" Then
                _MouseHide
                magfactor% = 7
            ElseIf UCase$(kk$) = "M" Then
                _MouseHide
                magfactor% = 8
            Else ' Any other (non-system) key than Z..M sets magfactor% to 1 i.e. not using
                If kk$ <> "" Then
                    magfactor% = 1
                    '_MouseShow "crosshair"
                    If kk$ <> " " Then _MouseShow "DEFAULT"
                End If
            End If

        ElseIf Len(kk$) = 2 Then
            LastHit~&& = EpochTime~&&: Stepping = 10
            If Right$(kk$, 1) = Chr$(80) Then
                If sy1 + ScrlStp <= SRC_VerticalEndPOS - TRG_VerticalEndPOS Then sy1 = sy1 + ScrlStp
            End If
            If Right$(kk$, 1) = Chr$(72) Then
                If sy1 - ScrlStp >= 0 Then sy1 = sy1 - ScrlStp
            End If
            If Right$(kk$, 1) = Chr$(77) Then
                If sx1 + ScrlStp <= SRC_HorizontalEndPOS - TRG_HorizontalEndPOS Then sx1 = sx1 + ScrlStp
            End If
            If Right$(kk$, 1) = Chr$(75) Then
                If sx1 - ScrlStp >= 0 Then sx1 = sx1 - ScrlStp
            End If
            Cls
            _PutImage (dx1, dy1)-(TRG_HorizontalEndPOS, TRG_VerticalEndPOS), source_handle&, dest_handle&, (sx1, sy1)-(sx1 + TRG_HorizontalEndPOS, sy1 + TRG_VerticalEndPOS)
            'Locate 2, 2: Print "Use Arrows (or hold Space and Mouse); ImageDimensions: "; LTrim$(Str$(SRC_HorizontalEndPOS + 1)); " x "; LTrim$(Str$(SRC_VerticalEndPOS + 1)); "; Use 1..9 for Scroll Granularity, 3 is default; ";
            'Locate 3, 2: Print "TopLeftVerPos: "; AddCommasPaddedLEN$(sy1); "; TopLeftHorPos: "; AddCommasPaddedLEN$(sx1)
            _Display
        End If
    Loop Until UCase$(kk$) = "Q"
    _FreeImage source_handle& 'handle value MUST be less than -1 or error!
Else
    'grmbl sound
End If


System

Function AddCommasPaddedLEN$ (numeral)
    Shared FieldLineLenPNG
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    Padded$ = Right$("000,000,000,000,000", FieldLineLenPNG)
    'Padded$ = Right$("                   ", FieldLineLenPNG)
    'Padded$ = Right$("...................", FieldLineLenPNG)
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    AddCommasPaddedLEN$ = Padded$
End Function

Function EpochTime~&&
    DATEstamp$ = Date$: TIMEstamp$ = Time$
    Do While DATEstamp$ <> Date$ 'redo
        DATEstamp$ = Date$: TIMEstamp$ = Time$
    Loop
    m = Val(Left$(DATEstamp$, 2))
    d~&& = Val(Mid$(DATEstamp$, 4, 2))
    y~&& = Val(Right$(DATEstamp$, 4)) - 1970
    For i = 1 To m
        Select Case i 'Add the number of days for each previous month passed
            Case 1: d~&& = d~&& 'January doestn't have any carry over days.
            Case 2, 4, 6, 8, 9, 11: d~&& = d~&& + 31
            Case 3: d~&& = d~&& + 28
            Case 5, 7, 10, 12: d~&& = d~&& + 30
        End Select
    Next
    d~&& = d~&& + y~&& * 365
    For i = 2 To y Step 4
        If m > 2 Then d~&& = d~&& + 1 'add an extra day for leap year every 4 years, starting in 1970
    Next
    d~&& = d~&& - 1 'for year 2000
    EpochTime~&& = d~&& * 24 * 60 * 60 + Val(Left$(TIMEstamp$, 2)) * 3600 + Val(Mid$(TIMEstamp$, 4, 2)) * 60 + Val(Right$(TIMEstamp$, 2))
End Function

' OldMoses [

Sub Magnify (mf%, src&, s%, r!, msk&) 'Magnify magfactor%, source_handle&, magsiz%, ratio, msk&
    Shared dx1, dy1
    Shared sx1, sy1
    Shared TRG_HorizontalEndPOS
    Shared TRG_VerticalEndPOS
    Shared SRC_HorizontalEndPOS
    Shared SRC_VerticalEndPOS
    hs% = _ShR(s%, 1): hf% = hs% / mf% '                        radius and mag at radius
    x% = map!(_MouseX, 0, _Width(src&) * r!, 0, _Width(src&) - 1) 'map mouse position relative to image
    y% = map!(_MouseY, 0, _Height(src&) * r!, 0, _Height(src&) - 1)
    mag& = _NewImage(s%, s%, 32) '                              Create magnifier lense
    '_PutImage , src&, mag&, (x% - hf%, y% - hf%)-(x% + hf%, y% + hf%) 'portion of src& to mag&
    _PutImage , src&, mag&, ((x% - hf%) + sx1, (y% - hf%) + sy1)-((x% + hf%) + sx1, (y% + hf%) + sy1)



    _Dest mag&
    _ClearColor _RGB32(0, 0, 0), msk& '                         set clearcolor to inner circle of mask
    _PutImage , msk&, mag& '                                    overlay on magnifier
    _ClearColor _RGB32(255, 0, 255), mag& '                     clearcolor purple corners of mag& placed by mask
    _PutImage (_MouseX - hs% - 1, _MouseY - hs% - 1), mag&, 0 ' place finished magnifier to screen, mouse centered
    _FreeImage mag&
End Sub 'Magnify

Sub FCirc (CX As Integer, CY As Integer, RR As Integer, C As _Unsigned Long) 'by Steve McNeill
    Dim R As Integer, RError As Integer
    Dim X As Integer, Y As Integer
    R = Abs(RR)
    RError = -R
    X = R
    Y = 0
    If R = 0 Then PSet (CX, CY), C: Exit Sub
    Line (CX - X, CY)-(CX + X, CY), C, BF
    While X > Y
        RError = RError + Y * 2 + 1
        If RError >= 0 Then
            If X <> Y + 1 Then
                Line (CX - Y, CY - X)-(CX + Y, CY - X), C, BF
                Line (CX - Y, CY + X)-(CX + Y, CY + X), C, BF
            End If
            X = X - 1
            RError = RError - X * 2
        End If
        Y = Y + 1
        Line (CX - X, CY - Y)-(CX + X, CY - Y), C, BF
        Line (CX - X, CY + Y)-(CX + X, CY + Y), C, BF
    Wend
End Sub 'FCirc

Function map! (value!, minRange!, maxRange!, newMinRange!, newMaxRange!)
    map! = ((value! - minRange!) / (maxRange! - minRange!)) * (newMaxRange! - newMinRange!) + newMinRange!
End Function 'map!

' OldMoses ]

Function TabulatedSTR$ (a$)
    q = Len("Configured Memory Speed:")
    TabulatedSTR1$ = LTrim$(Left$(a$, InStr(a$, ":")))
    TabulatedSTR$ = TabulatedSTR1$ + Space$(q - Len(TabulatedSTR1$) + 1) + LTrim$(Mid$(a$, InStr(a$, ":") + 1))
End Function

$If WINDOWS Then
        Function PATHpsp$ 'TITLE$
        'Shared PATH$ 'optional path information shared with main module only

        FileName$ = Space$(256)
        Result = GetModuleFileNameA(0, FileName$, Len(FileName$)) '0 designates the current program
        If Result Then 'Result returns the length or bytes of the string information
        PATH$ = Left$(FileName$, Result)
        start = 1
        Do
        posit = InStr(start, PATH$, "\")
        If posit Then last = posit
        start = posit + 1
        Loop Until posit = 0
        'TITLE$ = Mid$(PATH$, last + 1)
        PATHpsp$ = Left$(PATH$, last)
        Else
        'TITLE$ = ""
        PATHpsp$ = ""
        End If
        End Function
$End If

