'Dirwalker.bas (7327 lines) written by Kaze(sanmayce@sanmayce.com), 2023-May-20
'Note1: Compile with '-O3 -ffast-math -mavx -maes'.
'Note2: For BLAKE3: '-O3 -ffast-math -msse4.2 -maes -fpermissive -DBLAKE3_NO_SSE2 -DBLAKE3_NO_SSE41 -DBLAKE3_NO_AVX2 -DBLAKE3_NO_AVX512 blake3.c blake3_dispatch.c blake3_portable.c' with copying 'blake3.h blake3_impl.h blake3.c blake3_dispatch.c blake3_portable.c' to 'qb64/internal/c'
'Note3: Try setting 'GraphicOrTextFlag' (see below) to 1 to go fully graphical.

'Edit (to raise the nasty ? FPS (default compile) to ?? FPS, on i5-7200U DDR4 1066MHz/2133MT/s, Windows 10, gcc 12.1) 'recompile_win.bat' at C:\qb64202\internal\temp
'by adding '-O3 -ffast-math -mavx' to the compile line, something like:
'
'@echo off
'cd %0\..\
'echo Recompiling...
'cd ../c
'c_compiler\bin\g++ -O3 -ffast-math -mavx -s -Wfatal-errors -w -Wall qbx.cpp  libqb\os\win\libqb_2_0.2_1001000001000.o  ..\..\.\internal\temp\icon.o -D DEPENDENCY_NO_SOCKETS -D DEPENDENCY_NO_PRINTER -D DEPENDENCY_ICON -D DEPENDENCY_NO_SCREENIMAGE -D DEPENDENCY_LOADFONT -D DEPENDENCY_AUDIO_OUT  parts\video\font\ttf\os\win\src.o parts\audio\out\os\win\src.a   parts\core\os\win\src.a -lopengl32 -lglu32   -mwindows -static-libgcc -static-libstdc++ -D GLEW_STATIC -D FREEGLUT_STATIC     -lwinmm -lksguid -ldxguid -lole32 -lgdi32 -o "..\..\Dirwalker.exe"
'pause

'Edit (to raise to 85 FPS, on i7-3630QM DDR3, Fedora 35, gcc 11.2.1) 'recompile_lnx.sh' at /home/kaze/qb64/internal/temp
'by adding '-O3 -ffast-math -mavx' to the compile line, something like:
'
'#!/bin/sh
'Pause()
'{
'OLDCONFIG=`stty -g`
'stty -icanon -echo min 1 time 0
'dd count=1 2>/dev/null
'stty $OLDCONFIG
'}
'echo "Recompiling..."
'cd ../c
'g++ -O3 -ffast-math -mavx -no-pie -w qbx.cpp  libqb/os/lnx/libqb_2_0.2_1001000001000.o  -D DEPENDENCY_NO_SOCKETS -D DEPENDENCY_NO_PRINTER -D DEPENDENCY_ICON -D DEPENDENCY_NO_SCREENIMAGE -D DEPENDENCY_LOADFONT -D DEPENDENCY_AUDIO_OUT  parts/video/font/ttf/os/lnx/src.o parts/audio/out/os/lnx/src.a parts/core/os/lnx/src.a -lGL -lGLU -lX11 -lpthread -ldl -lrt -D FREEGLUT_STATIC -o '/home/kaze/qb64/Dirwalker'
'echo "Press ENTER to exit..."
'Pause

Rem $dynamic
revision$ = "8++++"
revDATE$ = "2023-May-20"
'Allow the window to be resized
$Resize:On

Declare CustomType Library ".\wildcardKaze" ' CAUTION: BUG HAPPENS when passing non ASCIIZ strings i.e. QB64 strings should be postfixed with ASCII 0
    '//only *#
    'int Tcheburaschka_Wildcard_CaseSensitive (const char* mask, const char* name) {
    Function Tcheburaschka_Wildcard_CaseSensitive% (buf1 As String, buf2 As String)
    'Function Tcheburaschka_Wildcard_CaseSensitive% (ByVal buf1 As _Offset, Byval buf2 As _Offset)
    'int Tcheburaschka_Wildcard_CaseInsensitive (const char* mask, const char* name) {
    'Function Tcheburaschka_Wildcard_CaseInsensitive% (buf1 As String, buf2 As String)
    Function Tcheburaschka_Wildcard_CaseInsensitive% (ByVal buf1 As _Offset, Byval buf2 As _Offset)
    '//only *#
    'static unsigned char IterativeWildcards (const char *mask, const char *name) {
    'Function IterativeWildcards% (buf1 As String, buf2 As String)
    Function IterativeWildcards% (ByVal buf1 As _Offset, Byval buf2 As _Offset)
    '//       wildcard '*' any character(s) or empty,
    '//       wildcard '.' any ALPHA character(s) or empty,
    '//       wildcard '`' any NON-ALPHA character(s) or empty,
    '//       wildcard '@'/'#' any character {or empty}/{and not empty},
    '//       wildcard '^'/'$' any ALPHA character {or empty}/{and not empty},
    '//       wildcard '|'/'~' any NON-ALPHA character {or empty}/{and not empty},
    '//       wildcard '+'/'%' any DIGIT character {or empty}/{and not empty},
    '// How to Invoke: if ( EnhancedMaskTest_OrEmpty_AndNotEmpty_1(wrdARG, 0, wrdLOW, 0) ) { // Caution: Not lowercased as it should!
    'static unsigned char IP_enhanched_Kaze (const char *mask, long long maskPos, const char *name, long long namePos) {
    'Function IP_enhanched_Kaze% (buf1 As String, Byval buf1LEN As _Integer64, buf2 As String, Byval buf2LEN As _Integer64)
    Function IP_enhanched_Kaze% (ByVal buf1 As _Offset, Byval buf1LEN As _Integer64, Byval buf2 As _Offset, Byval buf2LEN As _Integer64)
End Declare

'int MINGW_readdir (char* file_name, long long* file_size, int* flags, char* LastStatusChange, char* LastFileAccess, char* LastFileModification) {
Declare CustomType Library ".\dirfile"
    Function MINGW_opendir% (Path As String)
    Function MINGW_readdir% (file_name As String, file_size As _Integer64, flags As Integer, T1 As String, T2 As String, T3 As String) 'int MINGW_readdir (char* file_name, long long* file_size, int* flags, char* LastStatusChange, char* LastFileAccess, char* LastFileModification) {
    Sub MINGW_closedir ()
    Function strchrKAZE~&& (ByVal buf1 As _Offset, Byval byteSOUGHT As Integer)
    'void MINGW_OpenReadCloseDIR (char *basePath, long long *Entries, char *PoolToHousePathS, long long *PoolToHousePathS_MAXsize, long long *PoolToHousePathS_REALsize) {
    Sub MINGW_OpenReadCloseDIR (file_name As String, Byval Entries As _Offset, Byval PoolToHousePathS As _Offset, Byval PoolToHousePathS_MAXsize As _Offset, Byval PoolToHousePathS_REALsize As _Offset)
End Declare

Declare CustomType Library ".\memKAZE"
    Sub memcpyKAZE (ByVal dest As _Offset, Byval source As _Offset, Byval bytes As Long)
    Function memcmpKAZE% (ByVal buf1 As _Offset, Byval buf2 As _Offset, Byval bytes As Long)
    Function memchrKAZE%& (ByVal buf1 As _Offset, Byval bytetosearch As Integer, Byval bytes As _Integer64)
    Function memsetKAZE%& (ByVal buf1 As _Offset, Byval bytetoFILL As Integer, Byval bytes As _Integer64)
End Declare

Declare CustomType Library ".\treedump"
    'void treedump(char *basePath, const int root, int WindowsFlag, long long *Entries)
    Sub treedump (file_name As String, Byval rootlevel As Integer, Byval WindowsFlag As Integer, Byval Entries As _Offset)
    'void treedumpMORE(char *basePath, const int root, int WindowsFlag, long long *Entries, long long *Directories, long long *Files)
    Sub treedumpMORE (file_name As String, Byval rootlevel As Integer, Byval WindowsFlag As Integer, Byval Entries As _Offset, Byval Fld As _Offset, Byval Fls As _Offset)
    'void treedumpPOOL(char *basePath, const int root, int WindowsFlag, long long *Entries, char *PoolToHousePathS, long long *PoolToHousePathS_MAXsize, long long *PoolToHousePathS_REALsize)
    Sub treedumpPOOL (file_name As String, Byval rootlevel As Integer, Byval WindowsFlag As Integer, Byval Entries As _Offset, Byval PoolToHousePathS As _Offset, Byval PoolToHousePathS_MAXsize As _Offset, Byval PoolToHousePathS_REALsize As _Offset)
    'void treedumpPOOL_DIRonly(char *basePath, const int root, int WindowsFlag, long long *Entries, char *PoolToHousePathS, long long *PoolToHousePathS_MAXsize, long long *PoolToHousePathS_REALsize)
    'void treedumpPOOL_FILonly(char *basePath, const int root, int WindowsFlag, long long *Entries, char *PoolToHousePathS, long long *PoolToHousePathS_MAXsize, long long *PoolToHousePathS_REALsize)
    Sub treedumpPOOL_DIRonly (file_name As String, Byval rootlevel As Integer, Byval WindowsFlag As Integer, Byval Entries As _Offset, Byval PoolToHousePathS As _Offset, Byval PoolToHousePathS_MAXsize As _Offset, Byval PoolToHousePathS_REALsize As _Offset)
    Sub treedumpPOOL_FILonly (file_name As String, Byval rootlevel As Integer, Byval WindowsFlag As Integer, Byval Entries As _Offset, Byval PoolToHousePathS As _Offset, Byval PoolToHousePathS_MAXsize As _Offset, Byval PoolToHousePathS_REALsize As _Offset)
End Declare

Declare CustomType Library ".\torus"
    'int Torus(unsigned char* b, int DonutHeight, int Eghty, float A, float B, int VerOff, int HorOff, int VerSize, int HorSize)
    Sub Torus (b As String, Byval DonutHeight As Integer, Byval Eghty As Integer, Byval A As Single, Byval B As Single, Byval VerOff As Integer, Byval HorOff As Integer, Byval VerSize As Integer, Byval HorSize As Integer)
End Declare

Declare CustomType Library ".\printfNS"
    'void x64toaKAZE (unsigned long long val, char *buf, unsigned radix, int is_neg)
    'char * _i64toaKAZE (long long val, char *buf, int radix)
    'char * _ui64toaKAZE (unsigned long long val, char *buf, int radix)
    'char * _ui64toaKAZEzerocomma (unsigned long long val, char *buf, int radix)
    'char * _ui64toaKAZEcomma (unsigned long long val, char *buf, int radix)
    Sub printNS Alias _ui64toaKAZE (ByVal VALtoPRNT As _Integer64, buf As String, Byval DonutHeight As Integer) ' The type suffix for _OFFSET is %& which designates the integer value's flexible size.
End Declare

'// manatarka.h:
'// In order to compile properly, edit the next line from E:\qb64\internal\temp\recompile_win.bat:
'// c_compiler\bin\g++ -s -Wfatal-errors ...
'// Insert "-O3 -msse4.1 -maes", or even better "-O3 -mavx2 -maes" for YMM variants, so:
'// c_compiler\bin\g++ -O3 -mavx2 -maes -s -Wfatal-errors ...

Declare CustomType Library ".\manatarka"
    Sub UCASE_XMM (ByVal QWORDSsrc As _Offset, Byval QWORDSdst As _Offset, Byval bytesto As _Integer64)
    Sub UCASE_XMM_inplace (ByVal QWORDSsrc As _Offset, Byval bytesto As _Integer64)
    Sub UCASE_XMM_inplace_NULL2SPC (ByVal QWORDSsrc As _Offset, Byval bytesto As _Integer64)
    Function Railgun_Doublet%& (HaystackADDR As String, NeedleADDR As String, Byval HaystackLEN As Long, Byval NeedleLEN As Long) '// Caution: For better speed the case 'if (cbPattern==1)' was removed, so Pattern must be longer than 1 char.
    'Function Railgun_Doublet%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As Long, Byval NeedleLEN As Long)
    Function Railgun_Trolldom_64%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As _Offset, Byval NeedleLEN As Long) ' Don't forget the nasty '#define QB64_32bit', currently it is commented out, in order to work as 64bit
    'Function Railgun_Trolldom_64%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As _Integer64, Byval NeedleLEN As Long) '// Caution: For better speed the case 'if (cbPattern==1)' was removed, so Pattern must be longer than 1 char.
    Function Railgun_Nyotengu_XMM_YMM_ZMM%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As _Integer64, Byval NeedleLEN As Long)
    'char * Railgun_Doublet (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern)
    'char * Railgun_Trolldom_64 (char * pbTarget, char * pbPattern, uint64_t cbTarget, uint32_t cbPattern)
    'char * Railgun_Nyotengu_XMM_YMM_ZMM (char * pbTarget, char * pbPattern, uint64_t cbTarget, uint32_t cbPattern) // Last change: 2020-Nov-30
    Sub DoubleDeuceAES_Gumbotron (ByVal buffer As _Offset, Byval bytesto As _Integer64, Byval LoPart As _Offset, Byval HiPart As _Offset) 'Note: This hasher uses AES extension, the CPU has to support it!
    ' Uncomment it if AVX2 is available, also uncomment in the header file '//#define KAZE_AVX2' [
    'Sub DoubleDeuceAES_Gumbotron_YMM (ByVal buffer As _Offset, Byval bytesto As _Integer64, Byval LoPart As _Offset, Byval HiPart As _Offset) 'Note: This hasher uses AES extension, the CPU has to support it!
    ' Uncomment it if AVX2 is available, also uncomment in the header file '//#define KAZE_AVX2' ]
    'void DoubleDeuceAES_Gumbotron(const uint8_t *buffer, size_t length, uint64_t *LoPart, uint64_t *HiPart) {

    'Sub memcpyKAZE (ByVal dest As _Offset, Byval source As _Offset, Byval bytes As Long)
    'Function memcmpKAZE% (ByVal buf1 As _Offset, Byval buf2 As _Offset, Byval bytes As Long)
End Declare

Declare CustomType Library ".\Schmekeriada"
    'void Quicksort_Magnetica_indirect (uint64_t* xgamsCACHE, size_t Order, size_t NumberOfLFs)
    Sub Quicksort_Indirect Alias Quicksort_Magnetica_indirect (ByVal buf As _Offset, Byval Order As Long, Byval NumberOfLFs As _Integer64) ' Order is 0 for non-fixed length, 0 is for fixed length - being faster
    'size_t memcount_sse2(const void *s, int c, size_t n)
    Function memcount_sse2&& (ByVal buf As _Offset, Byval ASCIICharacter As Long, Byval NumberOfBytess As _Integer64)
End Declare

Declare CustomType Library ".\qsm_linesize"
    'void Quicksort_QB64_v7_linesize(uint64_t QWORDSoff[], uint64_t QWORDS[], int64_t Left, int64_t Right)
    Sub Quicksort_QB64_v7_linesize (ByVal QWORDSoff As _Offset, Byval QWORDSlen As _Offset, Byval Left As _Integer64, Byval Right As _Integer64)
End Declare
'//Quicksort_QB64_v7_linesize MhandleOFF.OFFSET, MhandleLEN.OFFSET, 0, ElementsMinusOne

Dim SHA328bytes As String * 28 '//unsigned char SHA328bytes[28];
Dim SHA332bytes As String * 32 '// SHA3-256; BLAKE3-256

NakamichiSHA3$ = "Nakamichi"
Declare CustomType Library ".\sha3"
    'void FIPS202_SHA3_224(const unsigned char *input, unsigned int inputByteLen, unsigned char *output);
    'void SHA3_64bit(const unsigned char *input, unsigned long long int inputByteLen, unsigned char *output);
    Sub SHA3_32bit Alias FIPS202_SHA3_224 (bufTARGET As String, Byval BytesToHash As Long, bufTARGET As String) 'Ugh, only 32bit, use the long long below
    Sub SHA3_64bit (bufTARGET As String, Byval BytesToHash As _Integer64, bufTARGET As String)
End Declare

Declare CustomType Library ".\SHA1stream"
    'long long sha1_stream( char *filename, unsigned char SHA1digest[20] )
    Function sha1_stream&& (filename As String, SHA1digest As String) ' CAUTION: If file doesn't exist then seg fault
End Declare

Declare CustomType Library ".\SHA3stream"
    'long long sha3_stream( char *filename, unsigned char SHA3digest[32] )
    Function sha3_stream&& (filename As String, SHA3digest As String) ' CAUTION: If file doesn't exist then seg fault
End Declare

Declare CustomType Library ".\BLAKE3stream"
    'long long BLAKE3_stream( char *filename, unsigned char SHA3digest[32] )
    Function BLAKE3_stream&& (filename As String, SHA3digest As String) ' CAUTION: If file doesn't exist then seg fault
End Declare

' Despite SHA1 being broken, 'sha1sum' is part of Linux prompt, GNU coreutils, and it is useful anyways.

'NakamichiFILE$ = "Nakamichi" ' 9 bytes long file - no LF or CRLF
'dummy = BLAKE3_stream&&(NakamichiFILE$, SHA332bytes$)
'BLAKE3$ = ""
'For i = 1 To 32
'        MustBeTwoChars$ = Hex$(Asc(Mid$(SHA332bytes$, i, 1)))
'        If Len(MustBeTwoChars$) = 1 Then MustBeTwoChars$ = "0" + MustBeTwoChars$
'        BLAKE3$ = BLAKE3$ + MustBeTwoChars$
'Next
'Print BLAKE3$
'End

'NakamichiFILE$ = "Nakamichi" ' 9 bytes long file - no LF or CRLF
'dummy = sha3_stream&&(NakamichiFILE$, SHA332bytes$)
'SHA3$ = ""
'For i = 1 To 32
'        MustBeTwoChars$ = Hex$(Asc(Mid$(SHA332bytes$, i, 1)))
'        If Len(MustBeTwoChars$) = 1 Then MustBeTwoChars$ = "0" + MustBeTwoChars$
'        SHA3$ = SHA3$ + MustBeTwoChars$
'Next
'Print SHA3$
'End

'[kaze@w8 sha3sum-master]$ ./SHA3SUM.ELF Nakamichi
'Bit size must be 256, 384 or 512.
'Usage: ./SHA3SUM.ELF -b 256|384|512 [-k] [-x] string
' -b Digest size in bits
' -k Use KECCAK
' -x Hex string
'[kaze@w8 sha3sum-master]$ ./SHA3SUM.ELF Nakamichi -b 256 Nakamichi
'f616ef21c98b4cacf92d1a89a25c449c174f288cc80a1934dd49e731828ac518

' -rw-rw-r--. 1 kaze kaze       9 Jan 29 06:11 Nakamichi
'
' [kaze@w8 RESOURCES]$ ./sha3-256sum ../Nakamichi
' f616ef21c98b4cacf92d1a89a25c449c174f288cc80a1934dd49e731828ac518  ../Nakamichi
'
' -rwxrwxrwx. 1 kaze kaze 12811954607 May 21  2022 TEXTUAL_MADNESS_bare-minimum_2022_May_20.7z
'
' [kaze@w8 RESOURCES]$ ./sha3-256sum /home/kaze/_KAZE_MASTER_12.8\ GB/TEXTUAL_MADNESS_bare-minimum_2022_May_20.7z
' 0b0b8bb8d7059a165d366bde12467183a019119673e9e5f9c5b782e607fe676a  /home/kaze/_KAZE_MASTER_12.8 GB/TEXTUAL_MADNESS_bare-minimum_2022_May_20.7z

'NakamichiFILE$ = "Nakamichi"
'sha1_stream NakamichiFILE$, SHA328bytes$
'SHA1$ = ""
'For i = 1 To 20
'        MustBeTwoChars$ = Hex$(Asc(Mid$(SHA328bytes$, i, 1)))
'        If Len(MustBeTwoChars$) = 1 Then MustBeTwoChars$ = "0" + MustBeTwoChars$
'        SHA1$ = SHA1$ + MustBeTwoChars$
'Next
'Print SHA1$
'End

' 01/24/2023  05:54                 9 Nakamichi
' c:\qb6421>certutil -hashfile Nakamichi
' SHA1 hash of Nakamichi:
' 6bf565ffa4d825eedecb208c211d90e5b80023cd
' CertUtil: -hashfile command completed successfully.

'SHA3_64bit NakamichiSHA3$, Len(NakamichiSHA3$), SHA328bytes$
'SHA3$ = ""
'For i = 1 To 28
'        MustBeTwoChars$ = Hex$(Asc(Mid$(SHA328bytes$, i, 1)))
'        If Len(MustBeTwoChars$) = 1 Then MustBeTwoChars$ = "0" + MustBeTwoChars$
'        SHA3$ = SHA3$ + MustBeTwoChars$
'Next
'Print SHA3$
'End
'//FIPS202_SHA3_224((unsigned char *)NakamichiSHA3, 9, (unsigned char *)SHA328bytes);
'//SHA3-224
'//Nakamichi
'//6f6f29a1a07131340613af7eaeb0924af7cf605c6eb78f964b601fdf

'Hits = 0
'HaystackLEN%& = Len(Haystack$) ' the workaround in QB64 for lacking casting (in pointer arithmetic) is to define HaystackLEN as _Offset instead of LONG
'NeedleLEN = Len(Needle$)
'PointerHQB64%& = _Offset(Haystack$) 'Dim PointerHQB64 As _Offset
'PointerNQB64%& = _Offset(Needle$) 'Dim PointerNQB64 As _Offset
'FoundAt%& = PointerHQB64%&
'Do
'        FoundAtNew%& = Railgun_Trolldom_64%&(FoundAt%&, PointerNQB64%&, HaystackLEN%& - (FoundAt%& - PointerHQB64%&), NeedleLEN)
'        If FoundAtNew%& = 0 Then Exit Do
'        FoundAt%& = FoundAtNew%& + 1: Hits = Hits + 1
'Loop

'Hits = 0
'HaystackLEN%& = Len(Haystack$) ' the workaround in QB64 for lacking casting (in pointer arithmetic) is to define HaystackLEN as _Offset instead of LONG
'NeedleLEN = Len(Needle$)
'PointerHQB64%& = _Offset(Haystack$) 'Dim PointerHQB64 As _Offset
'PointerNQB64%& = _Offset(Needle$) 'Dim PointerNQB64 As _Offset
'FoundAt%& = PointerHQB64%&
'Do
'        FoundAtNew%& = Railgun_Nyotengu_XMM_YMM_ZMM%&(FoundAt%&, PointerNQB64%&, HaystackLEN%& - (FoundAt%& - PointerHQB64%&), NeedleLEN)
'        If FoundAtNew%& = 0 Then Exit Do
'        FoundAt%& = FoundAtNew%& + 1: Hits = Hits + 1
'Loop

'Open TestFile$ For Binary As #1
'FileLen = LOF(1)
'FuleBuf$ = Space$(FileLen)
'Get #1, , FuleBuf$
''Do While Not EOF(1)
''    Line Input #1, a$: Lines = Lines + 1
''Loop
'Close #1
'FuleBufPadded$ = FuleBuf$ + Space$(FileLen Mod 16)
'FuleBuf$ = ""
'UCASE_XMM_inplace _Offset(FuleBufPadded$), Len(FuleBufPadded$)
'FuleBufPadded$ = ""

'char llTOaDigits[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
'Dim llTOaDigits As String * 27
'printNS 65535, llTOaDigits$, 2
'printNS 8123123123, llTOaDigits$, 16
'Print llTOaDigits$
'Print Hex$(8123123123)

'Dim Benchm As _MEM
'Elements = 10
'Granularity = 17
'Benchm = _MemNew(Elements * Granularity)
'For i = 9 To 0 Step -1
'        Pattern$ = String$(16, Chr$(Asc("0") + i)) + Chr$(0)
'        Print Pattern$
'        _MemPut Benchm, Benchm.OFFSET + Granularity * (9 - i), Pattern$
'Next
'Print: Print "Sorting...": Print
'Quicksort_QB64_Granularity Benchm, Elements, Granularity
'For i = 0 To 9
'        _MemGet Benchm, Benchm.OFFSET + Granularity * i, Pattern$
'        Print Pattern$
'Next
'_MEMFREE Benchm
'End

$ExeIcon:'.\ColumnChart.ico'
_Define A-Z As _INTEGER64

'' Print some globbing examples [

'handle& = _NewImage(120, 62, 0)
'Screen handle&
'_Dest handle&
'Do: Loop Until _ScreenExists: _ScreenMove 102, 3

''//       wildcard '*' any character(s) or empty,
''//       wildcard '.' any ALPHA character(s) or empty,
''//       wildcard '`' any NON-ALPHA character(s) or empty,
''//       wildcard '@'/'#' any character {or empty}/{and not empty},
''//       wildcard '^'/'$' any ALPHA character {or empty}/{and not empty},
''//       wildcard '|'/'~' any NON-ALPHA character {or empty}/{and not empty},
''//       wildcard '+'/'%' any DIGIT character {or empty}/{and not empty},

'WrongHappens_DIFFERENTresults: ' CAUTION: BUG HAPPENS when passing non ASCIIZ strings i.e. QB64 strings should be postfixed with ASCII 0

'F3pattern$ = "###" + Chr$(0) ' matches any string of three or more symbols
'Haystack$ = "12" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "#" + Chr$(0)
'Haystack$ = "aaaaa" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "#####" + Chr$(0)
'Haystack$ = "aaaaa" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "######" + Chr$(0)
'Haystack$ = "aaaaa" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "Qui##" + Chr$(0)
'Haystack$ = "Quiz" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "*aa#" + Chr$(0)
'Haystack$ = "aaaaa" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "#a" + Chr$(0)
'Haystack$ = "aaaaa" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "a#" + Chr$(0)
'Haystack$ = "aaaaa" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "###*" + Chr$(0) ' matches any string of three or more symbols
'Haystack$ = "aaaaa" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "###*" + Chr$(0) ' matches any string of three or more symbols
'Haystack$ = "12" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "*foo*" + Chr$(0)
'Haystack$ = "1_foo23" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "New#Qu*ic*" + Chr$(0)
'Haystack$ = "NewQuickBasic" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "New#Qu*ic*" + Chr$(0)
'Haystack$ = "New QuickBasic" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'F3pattern$ = "New*Qu*ic*" + Chr$(0)
'Haystack$ = "NewQuickBasic" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IterativeWildcards%(_Offset(F3pattern$), _Offset(Haystack$));
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0)

'Print

'F3pattern$ = "New." + Chr$(0)
'Haystack$ = "New64QuickBasic" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0) ' Should be 0

'F3pattern$ = ".`." + Chr$(0)
'Haystack$ = "New64QuickBasic" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0) ' Should be 0

'F3pattern$ = "." + Chr$(0)
'Haystack$ = "New64QuickBasic" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0) ' Should be 0

'F3pattern$ = "Ne+w%%." + Chr$(0)
'Haystack$ = "New64QuickBasic" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0) ' Should be 1

'F3pattern$ = "New@Qu*ic*" + Chr$(0)
'Haystack$ = "NewQuickBasic" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0) ' Should be 1

'F3pattern$ = "New##." + Chr$(0)
'Haystack$ = "New64QuickBasic" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0) ' Should be 1

'F3pattern$ = ".|||." + Chr$(0)
'Haystack$ = "New64QuickBasic" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0) ' Should be 1

'F3pattern$ = "^^^|||$$^^^^^^^^^^^^^^^^^^" + Chr$(0)
'Haystack$ = "New64QuickBasic" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0) ' Should be 1

'F3pattern$ = "%%%++++++++++++++++++++" + Chr$(0)
'Haystack$ = "123456789" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0) ' Should be 1

'F3pattern$ = "$~%%%++++++++++++++++++++" + Chr$(0)
'Haystack$ = "a-123000" + Chr$(0)
'Print "'"; Left$(F3pattern$, Len(F3pattern$) - 1); "' vs '"; Left$(Haystack$, Len(Haystack$) - 1); "':"
'Print IP_enhanched_Kaze%(_Offset(F3pattern$), 0, _Offset(Haystack$), 0) ' Should be 1

'_Delay 3
'Cls
'_Delay .3
'GoTo WrongHappens_DIFFERENTresults
'End
'' Print some globbing examples ]

Dim Shared POSIX_DirCount&&, POSIX_FileCount&&, POSIX_FileDirCount&&
Dim Shared CursorS As Integer
Dim Shared CursorE As Integer
Dim Shared WhichColumnIsSorted As Integer ' 0 for unsorted
Dim Shared kazebyte As String * 1
Dim Shared Get32bytes As String * 64
Dim Shared Get32bytesX2 As String * 128
Dim Shared Get32bytesDUMBINO As String * 64
Dim Shared Get10000elements As String * 640000

Option Base 1
ReDim FileTy(0) As String, FileNa(0) As String, FileSi(0) As String, FileTC(0) As String, FileTA(0) As String, FileTM(0) As String, FileSiRAW(0) As String
Const IS_DIR = 1
Const IS_FILE = 2

Const WhichHash = 2 '0=SHA1-160; 1=SHA3-256; 2=BLAKE3-256

Dim Benchm As _MEM
Const RSHIFTkey& = 100303
Const LSHIFTkey& = 100304
Const RCTRLkey& = 100305
Const LCTRLkey& = 100306
Const RALTkey& = 100307
Const LALTkey& = 100308

Const BACKSPCkey& = 8
Const TABkey& = 9
Const SPACEkey& = 32
Const ESCkey& = 27
Const ENTERkey& = 13

Const HOMEkey& = 18176
Const ENDkey& = 20224

Const INSkey& = 20992
Const DELkey& = 21248

Const PGUPkey& = 18688
Const PGDNkey& = 20736

Const LEFTkey& = 19200
Const RIGHTkey& = 19712
Const UPkey& = 18432
Const DOWNkey& = 20480

ShutDownDuration# = 4 ' 4 seconds
DclickTime# = 0.33 ' 1/3 of a second, usually it is 0.27s, so 0.33 suits even the slow clickers
Dim Button1LOG_firstDetection#(4)
Dim Button1LOG_ForHowLongHolded#(4)
Dim Button2LOG_firstDetection#(4)
Dim Button2LOG_ForHowLongHolded#(4)
PrevClick1# = 0
PrevClick2# = 0

Dim KeyTap_Button1LOG_firstDetection#(4)
Dim KeyTap_Button1LOG_ForHowLongHolded#(4)
Dim KeyTap_Button2LOG_firstDetection#(4)
Dim KeyTap_Button2LOG_ForHowLongHolded#(4)
Dim KeyTap_Button3LOG_firstDetection#(4)
Dim KeyTap_Button3LOG_ForHowLongHolded#(4)
Dim KeyTap_Button4LOG_firstDetection#(4)
Dim KeyTap_Button4LOG_ForHowLongHolded#(4)
Dim KeyTap_Button5LOG_firstDetection#(4)
Dim KeyTap_Button5LOG_ForHowLongHolded#(4)
Dim KeyTap_Button6LOG_firstDetection#(4)
Dim KeyTap_Button6LOG_ForHowLongHolded#(4)
Dim KeyTap_Button7LOG_firstDetection#(4)
Dim KeyTap_Button7LOG_ForHowLongHolded#(4)

KeyTap_PrevClick1# = 0
KeyTap_PrevClick2# = 0
KeyTap_PrevClick3# = 0
KeyTap_PrevClick4# = 0
KeyTap_PrevClick5# = 0
KeyTap_PrevClick6# = 0
KeyTap_PrevClick7# = 0

'Dim Shared OneFullPath As String * 4096
Dim Shared Byte As String * 1
Dim Shared MhandleXMM As _MEM

CursorS = 30
CursorE = 31

FramesPerSecond = 500
LastHit~&& = EpochTime~&& 'assume the start point is at 100%
Stepping = 10 '0..10 where 10 is 100%, 9 is 90%

PurpleFlag = 0

NormalFRGr = 3
If PurpleFlag Then NormalFRGr = 9
NormalBCKGr = 0
If PurpleFlag Then NormalBCKGr = 0

InverseFRGr = 0
If PurpleFlag Then InverseFRGr = 8
InverseBCKGr = 3
If PurpleFlag Then InverseBCKGr = 0

PageScrollBenchmark = 0
LineScrollBenchmark = 0

tCurrentT1# = Timer(.001)
tLASTrelease1# = tCurrentT1#
tLASTpress1# = tCurrentT1#
tCurrentT2# = Timer(.001)
tLASTrelease2# = tCurrentT2#
tLASTpress2# = tCurrentT2#

GraphicOrTextFlag = 0 '0 for Text; 1 for GRAPHICS
If GraphicOrTextFlag Then
    Screen _NewImage(20 * _FontWidth, 6 * _FontHeight, 0 + 256) 'had to enlarge from 20,6 (instead of 80,25) due to nasty white scrollbars flickering
Else
    Screen _NewImage(20, 6, 0) 'had to enlarge from 20,6 (instead of 80,25) due to nasty white scrollbars flickering
End If
Do: Loop Until _ScreenExists: _ScreenMove 102, 3

'Next dimensions are for 1600x900 resolution:
XdimCOL = 186 '1600/8= 198 or 1600/16=99
YdimROW = 44 + 4 '900/16= 50 or 900/32=25
wide& = _DesktopWidth
high& = _DesktopHeight

Dim PopularFormats$(1 To 40)
PopularFormats$(1) = "*.MOBI"
PopularFormats$(2) = "*.EPUB"
PopularFormats$(3) = "*.PDF"
PopularFormats$(4) = "*.DOC"
PopularFormats$(5) = "*.DJVU"
PopularFormats$(6) = "*.RTF"
PopularFormats$(7) = "*.PS"
PopularFormats$(8) = "*.HTM"
PopularFormats$(9) = "*.HTML"
PopularFormats$(10) = "*.TXT"
PopularFormats$(11) = "*.JSON"
PopularFormats$(12) = "*.XML"
PopularFormats$(13) = "*.CHM"

PopularFormats$(14) = "*.PNG"
PopularFormats$(15) = "*.JPG"
PopularFormats$(16) = "*.GIF"

PopularFormats$(17) = "*.TAR"
PopularFormats$(18) = "*.ZIP"
PopularFormats$(19) = "*.RAR"
PopularFormats$(20) = "*.7Z"
PopularFormats$(21) = "*.BZ2"
PopularFormats$(22) = "*.GZ"
PopularFormats$(23) = "*.XZ"

PopularFormats$(24) = "*.ASM"
PopularFormats$(25) = "*.H"
PopularFormats$(26) = "*.C"
PopularFormats$(27) = "*.CPP"
PopularFormats$(28) = "*.DLL"
PopularFormats$(29) = "*.OBJ"
PopularFormats$(30) = "*.LIB"
PopularFormats$(31) = "*.EXE"

PopularFormats$(32) = "*.BAT"
PopularFormats$(33) = "*.SH"

PopularFormats$(34) = "*.MP3"
PopularFormats$(35) = "*.MP4"
PopularFormats$(36) = "*.MKV"
PopularFormats$(37) = "*.AVI"
PopularFormats$(38) = "*.WAV"
PopularFormats$(39) = "*.FLAC"

PopularFormats$(40) = "*.ISO"

$If WINDOWS Then
    PSPlike$ = _CWD$ ' unreliable, when starting PSP.EXE from (C:\mingw, current drive and folder) with D:\PSP.EXE and current folder on D: is D:\temp then _CWD$ instead of "D:\" is "D:\temp", why?!
    PSPreal$ = PATHpsp$
    PSPlike$ = PSPreal$
    If Right$(PSPlike$, 1) <> "\" Then PSPlike$ = PSPlike$ + "\"
    PathToEngage$ = _StartDir$
    If Right$(PathToEngage$, 1) <> "\" Then PathToEngage$ = PathToEngage$ + "\"
$Else
    PSPlike$ = _CWD$
    If Right$(PSPlike$, 1) <> "/" Then PSPlike$ = PSPlike$ + "/"
    PathToEngage$ = _StartDir$
    If Right$(PathToEngage$, 1) <> "/" Then PathToEngage$ = PathToEngage$ + "/"
$End If

'f00 = FreeFile ' Commented out since /usr/bin demands sudo - cannot write there when 'install_D.sh' is used
'Open PSPreal$ + "Dirwalker.log.txt" For Append As #f00 'if not added PSPreal$ then will be created in d:\temp (see the Windows prompt dump below)
ChDir _StartDir$

'Print PSPlike$, _CWD$
'Print PathToEngage$, _StartDir$
'End
'In Windows: PSPlike$ is not correct, it simply holds the current folder of the invoking drive, not the invoking folder
'If it was not for PSPreal$ (using kernel32, Windows API) _CWD$ would report d:\temp i.e. the current drive for D: instead of d:\
'c:\mingw64>dir d:\*.ttf d:\dir*.exe
' Volume in drive D is TEXT
' Volume Serial Number is 38CB-B392

' Directory of d:\

'11/21/2020  02:02            50,660 Mx437_CL_Stingray_8x16.ttf
'11/21/2020  02:02            78,084 Mx437_FMTowns_re_8x16-2x.ttf
'11/21/2020  02:02            53,904 Mx437_FMTowns_re_8x16.ttf
'01/05/2022  06:40           146,744 MxPlus_ToshibaTxL2_8x16.ttf
'11/21/2020  02:02            28,600 Px437_CompaqThin_8x16.ttf
'10/30/2021  15:29            33,160 Px437_Cordata_PPC-400.ttf
'07/28/2021  18:55            25,960 Px437_DOS-V_re_JPN12.ttf

' Directory of d:\

'11/23/2022  23:14         5,001,216 Dirwalker.exe
'               8 File(s)      5,418,328 bytes
'               0 Dir(s)   9,433,153,536 bytes free

'c:\mingw64>dir d:
' Volume in drive D is TEXT
' Volume Serial Number is 38CB-B392

' Directory of D:\temp

'11/23/2022  23:18    <DIR>          .
'11/23/2022  23:18    <DIR>          ..
'               0 File(s)              0 bytes
'               2 Dir(s)   9,433,153,536 bytes free

'c:\mingw64>d:\Dirwalker.exe

'c:\mingw64>dir d:
' Volume in drive D is TEXT
' Volume Serial Number is 38CB-B392

' Directory of D:\temp

'11/23/2022  23:19    <DIR>          .
'11/23/2022  23:19    <DIR>          ..
'11/23/2022  23:19            50,010 Dirwalker.log.txt
'               1 File(s)         50,010 bytes
'               2 Dir(s)   9,433,100,288 bytes free

'c:\mingw64>

FNThandle& = _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 16, "MONOSPACE") '8x16
FNThandleF& = _LoadFont(PSPlike$ + "Mx437_FMTowns_re_8x16.ttf", 16, "MONOSPACE") '8x16 Fujitsu Singlewidth
FNThandleD& = _LoadFont(PSPlike$ + "Mx437_FMTowns_re_8x16-2x.ttf", 16, "MONOSPACE") '16x16 Fujitsu Doublewidth
FNThandleS& = _LoadFont(PSPlike$ + "Mx437_CL_Stingray_8x16.ttf", 16, "MONOSPACE") '8x16 Stingray
FNThandleV& = _LoadFont(PSPlike$ + "Px437_DOS-V_re_JPN12.ttf", 12, "MONOSPACE") '6x12 DOS-V
FNThandleC& = _LoadFont(PSPlike$ + "Px437_CompaqThin_8x16.ttf", 16, "MONOSPACE") '8x16 CompaqThin
FNThandle4& = _LoadFont(PSPlike$ + "Px437_Cordata_PPC-400.ttf", 32, "MONOSPACE") '16x32 Cordata
FNThandleT& = _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 32, "MONOSPACE") '16x32 Toshiba 2x
FNThandle8& = _LoadFont(PSPlike$ + "Mx437_ToshibaTxL2_8x8.ttf", 8, "MONOSPACE") '8x8 Toshiba
FNThandleA& = _LoadFont(PSPlike$ + "Px437_Portfolio_6x8.ttf", 8, "MONOSPACE") '6x8 Atari
FNThandleJ& = _LoadFont(PSPlike$ + "Mx437_DOS-V_re_JPN24.ttf", 24, "MONOSPACE") '12x24 DOS-V

'Print _FontWidth(FNThandleJ&); "x"; _FontHeight(FNThandleJ&): End

_ControlChr Off 'without it couldn't _MAPUNICODE these 7, 9..13, 28..31

WaitingForAKey$ = "" ' default is NONE i.e. hardware font
Line3$ = "" ' use it as a flag
If _FileExists(PSPlike$ + "Dirwalker.ini") Then
    ' C:\>copy con Dirwalker.ini
    '
    ' 222
    ' 62
    ' 3
    ' fullscreen
    ' Ctrl+Z
    ' Above example says: use default font (first line is empty), use 222 columns and 62 lines, and 3GB memory pool for readdir(), enforce fullscreen instead of window mode. Any other string than 'fullscreen' means window mode.
    'Print Time$; " 'Dirwalker.ini' was found, bypassing the font-selection and window-resize. Enforcing";
    Open PSPlike$ + "Dirwalker.ini" For Input As #13 ' 'Binary' was changed to 'Input' since /usr/bin/ complains
    Line Input #13, Line1$
    Line Input #13, Line2$
    Line Input #13, Line3$
    Line Input #13, Line4$
    'Line Input #13, Line5$
    Close #13
    WaitingForAKey$ = Line1$
    XdimCOL = Val(Line2$)
    YdimROW = Val(Line3$)
    'Print " font '"; UCase$(Line1$); "' using"; Val(Line2$); "x"; Val(Line3$); "canvas."
Else
    'Print Time$; " 'Dirwalker.ini' was not found, allowing the font-selection and window-resize."
End If

FULLscr_Flag = 0
_AllowFullScreen _Stretch , _Smooth 'allow Alt+Enter, notice it has to be here before the screen/font stuff below, otherwise it enters all 4 modes back to back.

'img& = _LoadImage("dirwalker_logo.png", 32)
'wide% = _Width(img&): deep% = _Height(img&)
'k& = _NewImage(wide%, deep%, 32)
'Screen k&
'For j = wide% - 1 To 0 Step -1
'        _PutImage (j, 0), img&, k&
'        _Delay (wide% - j) ^ 3 / (100000000000#)
'Next
'_Delay 3

' Not using by default because _mousemove is buggy in 'fullscreen' mode
'If Line5$ = "fullscreen" Then
'    FullS_flag = Not FullS_flag
'    If FullS_flag Then
'        _FullScreen _Stretch , _Smooth
'    End If
'End If

_Title "Dirwalker, " + LTrim$(Str$(XdimCOL)) + "x" + LTrim$(Str$(YdimROW + 1)) + ", revision " + revision$ + "; Current Directory: " + PathToEngage$ + "; Invoking Directory: " + PSPlike$
If Line3$ <> "" Then GoTo SkipDueToCrashing
j = 6
For i = 20 To XdimCOL
    If i Mod 3 = 0 Then
        If j < YdimROW + 1 Then j = j + 1 ' I wanna three times slower on vertical expansion
    End If
    If GraphicOrTextFlag Then
        handle& = _NewImage(i * _FontWidth, j * _FontHeight, 0 + 256)
    Else
        handle& = _NewImage(i, j, 0)
    End If
    Screen handle&
    _Dest handle&
    _Display
    _Delay .3 / i
Next
SkipDueToCrashing:
If GraphicOrTextFlag Then
    handle& = _NewImage(XdimCOL * _FontWidth, (YdimROW + 1) * _FontHeight, 0 + 256)
Else
    handle& = _NewImage(XdimCOL, YdimROW + 1, 0)
End If
Screen handle&
_Dest handle&
_Display

Select Case UCase$(WaitingForAKey$)
    Case "8" 'FNThandle8& = _LoadFont(PSPlike$ + "Mx437_ToshibaTxL2_8x8.ttf", 8, "MONOSPACE") '8x8 Toshiba
        If FNThandle8& > 0 Then _Font FNThandle8&: _Display
    Case "T" 'FNThandleT& = _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 32, "MONOSPACE") '16x32 Toshiba 2x
        If FNThandleT& > 0 Then _Font FNThandleT&: _Display: ToshibaIsSet = 1
    Case "4" 'FNThandle4& = _LoadFont(PSPlike$ + "Px437_Cordata_PPC-400.ttf", 32, "MONOSPACE") '16x32 Cordata
        If FNThandle4& > 0 Then _Font FNThandle4&: _Display
    Case "F" 'FNThandleF& = _LoadFont(PSPlike$ + "Mx437_FMTowns_re_8x16.ttf", 16, "MONOSPACE") '8x16 Fujitsu Singlewidth
        If FNThandleF& > 0 Then _Font FNThandleF&: _Display
    Case "D" 'FNThandleD& = _LoadFont(PSPlike$ + "Mx437_FMTowns_re_8x16-2x.ttf", 16, "MONOSPACE") '16x16 Fujitsu Doublewidth
        If FNThandleD& > 0 Then _Font FNThandleD&: _Display
    Case "S" 'FNThandleS& = _LoadFont(PSPlike$ + "Mx437_CL_Stingray_8x16.ttf", 16, "MONOSPACE") '8x16 Stingray
        If FNThandleS& > 0 Then _Font FNThandleS&: _Display
    Case "V" 'FNThandleV& = _LoadFont(PSPlike$ + "Px437_DOS-V_re_JPN12.ttf", 12, "MONOSPACE") '6x12 DOS-V
        If FNThandleV& > 0 Then _Font FNThandleV&: _Display
    Case "C" 'FNThandleC& = _LoadFont(PSPlike$ + "Px437_CompaqThin_8x16.ttf", 16, "MONOSPACE") '8x16 CompaqThin
        If FNThandleC& > 0 Then _Font FNThandleC&: _Display
    Case "A" 'FNThandleA& = _LoadFont(PSPlike$ + "Px437_Portfolio_6x8.ttf", 8, "MONOSPACE") '6x8 Atari
        If FNThandleA& > 0 Then _Font FNThandleA&: _Display
    Case "J" 'FNThandleJ& = _LoadFont(PSPlike$ + "Mx437_IBM_XGA-AI_7x15.ttf", 15, "MONOSPACE") '7x15 IBM
        If FNThandleJ& > 0 Then _Font FNThandleJ&: _Display
    Case " " 'FNThandle& = _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 16, "MONOSPACE") '8x16
        If FNThandle& > 0 Then _Font FNThandle&: _Display: ToshibaIsSet = 1
    Case Else
        If FNThandle& > 0 Then _Font FNThandle&: _Display: ToshibaIsSet = 1
End Select

_Delay .1 ' Caramba, without this delay the window is not positioned as it should even with below 'Do: Loop Until _ScreenExists'
Do: Loop Until _ScreenExists: _ScreenMove 102, 3
FieldLineLen = 19 'padded length, max
LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
Color 9, 0
ShowF1
UpdateNextToCCL_BUSY ("")
Print
Print Time$; " Reading..."
_Display ' kinda buggy (on Windows10), not rendering all lines on the window?!
ReDim FileArray_FILTERfaster&(1 To 1)
FILTER_apply_flag = 0

PoolToHousePathS_MAXsize&& = 5&&
If Line4$ <> "" Then
    PoolToHousePathS_MAXsize&& = Val(Line4$)
End If
Print Time$; " Allocating"; Str$(PoolToHousePathS_MAXsize&&); "GB for minimum"; Str$(PoolToHousePathS_MAXsize&&); "GB/4096 =~"; Str$(PoolToHousePathS_MAXsize&& * 1024 / 4096); "+ Million MaxLength filepaths (or more likely"; Str$(PoolToHousePathS_MAXsize&&); "GB/256 =~"; Str$(PoolToHousePathS_MAXsize&& * 1024 / 256); "+ Million)..."
PoolToHousePathS_MAXsize&& = PoolToHousePathS_MAXsize&& * 1024 * 1024 * 1024
MhandleXMM = _MemNew(PoolToHousePathS_MAXsize&&)

'GetDirFileList PathToEngage$, FileTy(), FileNa(), FileSi(), FileTC(), FileTA(), FileTM(), FileSiRAW()

' The New Faster and Buggyless 'GetDirFileList' [[[[[[[[[[[[[[[[[[
Entries&& = 0
PoolToHousePathS_REALsize&& = 0
MINGW_OpenReadCloseDIR PathToEngage$ + Chr$(0), _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
'[ Parsing 0 of 2 [
ReDim FileTy(Entries&& + 1) As String, FileNa(Entries&& + 1) As String, FileSi(Entries&& + 1) As String, FileTC(Entries&& + 1) As String, FileTA(Entries&& + 1) As String, FileTM(Entries&& + 1) As String, FileSiRAW(Entries&& + 1) As String '+1 to avoid alloc error when Entries&& is 0
POSIX_DirCount&& = 0: POSIX_FileCount&& = 0: POSIX_FileDirCount&& = 0
'FIELD289$ = Space$(289)
LastFileModification$ = Space$(24)
file_name256ASCIIZ$ = Space$(256)
'// [1byte-type][8bytes-size][24bytes-time][256bytes-name] or 289 bytes

For j = 1 To Entries&& ' Mind 'Entries&&' being >0, since there always is .
    POSIX_FileDirCount&& = POSIX_FileDirCount&& + 1
    flags% = 0
    memcpyKAZE _Offset(flags%), MhandleXMM.OFFSET + (j - 1) * 289&& + 0, 1
    memcpyKAZE _Offset(file_size&&), MhandleXMM.OFFSET + (j - 1) * 289&& + 1, 8
    memcpyKAZE _Offset(LastFileModification$), MhandleXMM.OFFSET + (j - 1) * 289&& + 1 + 8, 24
    memcpyKAZE _Offset(file_name256ASCIIZ$), MhandleXMM.OFFSET + (j - 1) * 289&& + 1 + 8 + 24, 256
    If flags% And IS_DIR Then POSIX_DirCount&& = POSIX_DirCount&& + 1: FileTy(POSIX_FileDirCount&&) = " DIRECTORY"
    If flags% And IS_FILE Then POSIX_FileCount&& = POSIX_FileCount&& + 1: FileTy(POSIX_FileDirCount&&) = " FILE....."
    FileNa(POSIX_FileDirCount&&) = Left$(file_name256ASCIIZ$, strchrKAZE~&&(_Offset(file_name256ASCIIZ$), 0)) 'strchrKAZE~&&(_Offset(file_name256ASCIIZ$), 0) = InStr(file_name256ASCIIZ$, Chr$(0)) - 1
    FileSi(POSIX_FileDirCount&&) = AddCommasPaddedLEN$(Val(LTrim$(Str$(file_size&&))))
    FileSiRAW(POSIX_FileDirCount&&) = LTrim$(Str$(file_size&&))
    FileTM(POSIX_FileDirCount&&) = SwapAndRemove$(LastFileModification$)
Next
'] Parsing 0 of 2 ]
' The New Faster and Buggyless 'GetDirFileList' ]]]]]]]]]]]]]]]]]]
Print Time$; " All Directories-and-Files in the current DIRECTORY (counting '.' and '..'): "; AddCommas$(POSIX_FileDirCount&&)
_Display

Entries&& = 0
Fld&& = 0
Fls&& = 0
$If WINDOWS Then
    If Right$(PathToEngage$, 1) = "\" Then
    'treedump Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, Not 0, _Offset(Entries&&) ' bugfix in r.5+
    treedumpMORE Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, Not 0, _Offset(Entries&&), _Offset(Fld&&), _Offset(Fls&&)
    Else
    'treedump PathToEngage$ + Chr$(0), 0, Not 0, _Offset(Entries&&) ' bugfix in r.5+
    treedumpMORE PathToEngage$ + Chr$(0), 0, Not 0, _Offset(Entries&&), _Offset(Fld&&), _Offset(Fls&&)
    End If
$Else
    If Right$(PathToEngage$, 1) = "/" Then
        'treedump Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&) ' bugfix in r.5+
        treedumpMORE Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), _Offset(Fld&&), _Offset(Fls&&)
    Else
        'treedump PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&) ' bugfix in r.5+
        treedumpMORE PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), _Offset(Fld&&), _Offset(Fls&&)
    End If
$End If
Print Time$; " All Directories-and-Files in the current TREE (not counting '.' and '..'): "; AddCommas$(Entries&&); " where "; AddCommas$(Fld&& - 1); "/"; AddCommas$(Fls&&); " Directories/Files" ' Fld&& - 1 because 'treedumpMORE' counts the current folder as 1
Print Time$; " Done Reading."

'Allocating memory for RECURSIVE (full folder) [[[
Entries&& = 0
'PoolToHousePathS_MAXsize&& =
PoolToHousePathS_REALsize&& = 0

$If WINDOWS Then
    If Right$(PathToEngage$, 1) = "\" Then
    treedumpPOOL Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&) ' bugfix in r.5+
    Else
    treedumpPOOL PathToEngage$ + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&) ' bugfix in r.5+
    End If
$Else
    If Right$(PathToEngage$, 1) = "/" Then
        treedumpPOOL Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
        'treedumpPOOL_FILonly Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
        'treedumpPOOL_DIRonly Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
    Else
        treedumpPOOL PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
        'treedumpPOOL_FILonly PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
        'treedumpPOOL_DIRonly PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
    End If
$End If

'Dim QWORD As _Unsigned _Integer64
'Dim Shared Mwholefile As _MEM
'Function FileArrayFULL$ (i)
'        Shared QWORD, LineLen13
'        'SHARED TheWholeFile$
'        _MemGet MhandleOFF, MhandleOFF.OFFSET + 8&& * (i - 1), QWORD
'        _MemGet MhandleLEN, MhandleLEN.OFFSET + 8&& * (i - 1), LineLen13
'        If ToLoadOrNotFlag Then
'                'BufferForLine$ = MID$(TheWholeFile$, QWORD, LineLen13)
'                BufferForLine$ = Space$(LineLen13)
'                _MemGet Mwholefile, Mwholefile.OFFSET + (QWORD - 1), BufferForLine$
'        Else
'                BufferForLine$ = Space$(LineLen13)
'                Seek #1, QWORD
'                Get #1, , BufferForLine$
'        End If
'        'ExpandTabs (BufferForLine$)
'        FileArrayFULL$ = BufferForLine$
'End Function

''Dim Benchm As _MEM
''Elements = 10
''Granularity = 17
''Benchm = _MemNew(Elements * Granularity)
''For i = 9 To 0 Step -1
''    Pattern$ = String$(16, Chr$(Asc("0") + i)) + Chr$(0)
''    Print Pattern$
''    _MemPut Benchm, Benchm.OFFSET + Granularity * (9 - i), Pattern$
''Next
''Print: Print "Sorting...": Print
''Quicksort_QB64_Granularity Benchm, Elements, Granularity
''For i = 0 To 9
''    _MemGet Benchm, Benchm.OFFSET + Granularity * i, Pattern$
''    Print Pattern$
''Next
'Allocating memory for RECURSIVE (full folder) ]]]

Print Time$; " Parsing..."
_Display
'[ Parsing 1 of 2 [
'Print "Entries&& = "; Entries&&
'Print "PoolToHousePathS_REALsize&& ="; PoolToHousePathS_REALsize&&
ReDim FileArray_TREE$(1 To Entries&& + 1) '+1 to avoid alloc error when Entries&& is 0
j = 1
If PoolToHousePathS_REALsize&& > 0 Then
    For i = 1 To PoolToHousePathS_REALsize&& ' TO-DO: Maximum slow, speed it up...
        'memcpyKAZE MhandleXMM.OFFSET + (i - 1) * 4096, _Offset(OneFullPath), 4096
        memcpyKAZE _Offset(Byte), MhandleXMM.OFFSET + (i - 1), 1
        FileArray_TREE$(j) = FileArray_TREE$(j) + Byte
        If Asc(Byte) = 0 Then j = j + 1
    Next
End If
j = j - 1
'Print "j = "; j; " should be = "; Entries&&
If j = 0 Then j = 1: FileArray_TREE$(1) = " Empty List"
FileCount_TREE = j
FieldLineNum_TREE = Len(AddCommas$(FileCount_TREE))
'] Parsing 1 of 2 ]
'[ Parsing 2 of 2 [
FILTER_apply_flag = 0
DIRorTREE_flag = 0: DIRorTREE_flag = Not DIRorTREE_flag ' 0 for TREE
ReDim FileArrayWINDOW$(YdimROW)
'ReDim DIRs_and_FILEs(1 To POSIX_FileDirCount&&) As String
FileCount = POSIX_FileDirCount&& + 5
FileCount_DIR = FileCount
FieldLineNum = Len(AddCommas$(FileCount))
FieldLineNum_DIR = FieldLineNum
ReDim FileArray$(1 To FileCount)
TotalSize&& = 0
'FileHandle& = FreeFile
'Open "Dirwalker.txt" For Output As FileHandle&
LogPrefix$ = "[Date:" + Right$(Date$, 4) + "-" + Left$(Date$, 5) + "; Time:" + Time$ + "] "
For i = 1 To POSIX_FileDirCount&&
    'DIRs_and_FILEs$(i) = FileTy(i) + "  " + AddCommasPaddedLEN$(Val(FileSi(i))) + "  " + SwapAndRemove$(FileTM(i)) + "  " + FileNa(i)
    TotalSize&& = TotalSize&& + Val(FileSiRAW(i))
    'FileArray$(i) = DIRs_and_FILEs$(i) 'FileArrayWINDOW$(i) = Left$(DIRs_and_FILEs$(i), XdimCOL)
    FileArray$(i) = FileTy(i) + "  " + FileSi(i) + "  " + FileTM(i) + "  " + FileNa(i)
    'Print #FileHandle&, FileArray$(i)
    'Print #f00, LogPrefix$ + FileArray$(i)
Next
FileArray$(POSIX_FileDirCount&& + 1) = "" 'Print
FileArray$(POSIX_FileDirCount&& + 2) = "Path:        " + PathToEngage$ 'Print "Path:        "; PathToEngage$
FileArray$(POSIX_FileDirCount&& + 3) = "Directories: " + AddCommasPaddedLEN$(POSIX_DirCount&&) 'Print "Directories: "; AddCommasPaddedLEN$(POSIX_DirCount&&)
FileArray$(POSIX_FileDirCount&& + 4) = "Files:       " + AddCommasPaddedLEN$(POSIX_FileCount&&) 'Print "Files:       "; AddCommasPaddedLEN$(POSIX_FileCount&&)
FileArray$(POSIX_FileDirCount&& + 5) = "TotalSize:   " + AddCommasPaddedLEN$(TotalSize&&) 'Print "TotalSize:   "; AddCommasPaddedLEN$(TotalSize&&)
'Print #f00, LogPrefix$ + FileArray$(POSIX_FileDirCount&& + 1)
'Print #f00, LogPrefix$ + FileArray$(POSIX_FileDirCount&& + 2)
'Print #f00, LogPrefix$ + FileArray$(POSIX_FileDirCount&& + 3)
'Print #f00, LogPrefix$ + FileArray$(POSIX_FileDirCount&& + 4)
'Print #f00, LogPrefix$ + FileArray$(POSIX_FileDirCount&& + 5)
'Print #f00, LogPrefix$
'] Parsing 2 of 2 ]
Print Time$; " Done Parsing."
GetCL = CsrLin
UpdateNextToCCL_DONE ("")
_Limit FramesPerSecond
buttondown1 = 0
buttondown2 = 0
buttondown3 = 0
mwheel = 0
If Line3$ = "" Then
    'Do While InKey$ = "" And (buttondown1 + buttondown2 + buttondown3 + Abs(mwheel) = 0)
    WaitingForAKey$ = ""
    Do While WaitingForAKey$ = "" And (Abs(mwheel) = 0)
        AsIfItIsINKEY% = _MouseInput '      Check the mouse status
        If AsIfItIsINKEY% Then
            buttondown1 = _MouseButton(1)
            buttondown2 = _MouseButton(2)
            buttondown3 = _MouseButton(3)
            mwheel = _MouseWheel
        End If
        LocateTextGraphCursor GetCL, 1, 0, CursorS, CursorE: Print Time$; " You can resize the window (_ResizeWidth\_FontWidth="; LTrim$(Str$(_ResizeWidth \ _FontWidth)); " x _ResizeHeight\_FontHeight="; LTrim$(Str$(_ResizeHeight \ _FontHeight)); "), waiting for a KeyPress/WheelTurn/TwoFingersOnPad...";
        WaitingForAKey$ = InKey$
        _Display
    Loop
End If
' SETTING WINDOW [[[

Select Case UCase$(WaitingForAKey$)
    Case "8" 'FNThandle8& = _LoadFont(PSPlike$ + "Mx437_ToshibaTxL2_8x8.ttf", 8, "MONOSPACE") '8x8 Toshiba
        If FNThandle8& > 0 Then _Font FNThandle8&: _Display
    Case "T" 'FNThandleT& = _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 32, "MONOSPACE") '16x32 Toshiba 2x
        If FNThandleT& > 0 Then _Font FNThandleT&: _Display: ToshibaIsSet = 1
    Case "4" 'FNThandle4& = _LoadFont(PSPlike$ + "Px437_Cordata_PPC-400.ttf", 32, "MONOSPACE") '16x32 Cordata
        If FNThandle4& > 0 Then _Font FNThandle4&: _Display
    Case "F" 'FNThandleF& = _LoadFont(PSPlike$ + "Mx437_FMTowns_re_8x16.ttf", 16, "MONOSPACE") '8x16 Fujitsu Singlewidth
        If FNThandleF& > 0 Then _Font FNThandleF&: _Display
    Case "D" 'FNThandleD& = _LoadFont(PSPlike$ + "Mx437_FMTowns_re_8x16-2x.ttf", 16, "MONOSPACE") '16x16 Fujitsu Doublewidth
        If FNThandleD& > 0 Then _Font FNThandleD&: _Display
    Case "S" 'FNThandleS& = _LoadFont(PSPlike$ + "Mx437_CL_Stingray_8x16.ttf", 16, "MONOSPACE") '8x16 Stingray
        If FNThandleS& > 0 Then _Font FNThandleS&: _Display
    Case "V" 'FNThandleV& = _LoadFont(PSPlike$ + "Px437_DOS-V_re_JPN12.ttf", 12, "MONOSPACE") '6x12 DOS-V
        If FNThandleV& > 0 Then _Font FNThandleV&: _Display
    Case "C" 'FNThandleC& = _LoadFont(PSPlike$ + "Px437_CompaqThin_8x16.ttf", 16, "MONOSPACE") '8x16 CompaqThin
        If FNThandleC& > 0 Then _Font FNThandleC&: _Display
    Case "A" 'FNThandleA& = _LoadFont(PSPlike$ + "Px437_Portfolio_6x8.ttf", 8, "MONOSPACE") '6x8 Atari
        If FNThandleA& > 0 Then _Font FNThandleA&: _Display
    Case "J" 'FNThandleJ& = _LoadFont(PSPlike$ + "Mx437_IBM_XGA-AI_7x15.ttf", 15, "MONOSPACE") '7x15 IBM
        If FNThandleJ& > 0 Then _Font FNThandleJ&: _Display
    Case " " 'FNThandle& = _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 16, "MONOSPACE") '8x16
        If FNThandle& > 0 Then _Font FNThandle&: _Display: ToshibaIsSet = 1
    Case Else
        If FNThandle& > 0 Then _Font FNThandle&: _Display: ToshibaIsSet = 1
End Select

If Line3$ = "" Then
    If (XdimCOL <> _ResizeWidth \ _FontWidth) Or (YdimROW + 1 <> _ResizeHeight \ _FontHeight) Then
        'Play "v4a" 'CARAMBA, the play statement changes _ResizeWidth and _ResizeHeight ?!
        XdimCOL = _ResizeWidth \ _FontWidth
        YdimROW = _ResizeHeight \ _FontHeight - 1
        ' Caramba, this sometimes (e.g. when turning wheel outside the window) causes program to exit without any error?! [
        'handleNEW& = _NewImage(XdimCOL, YdimROW + 1, 0)
        'Screen handleNEW&
        '_FreeImage handle&
        'handle& = handleNEW&
        ' Caramba, this sometimes (e.g. when turning wheel outside the window) causes program to exit without any error?! ]
        If GraphicOrTextFlag Then
            handle& = _NewImage(XdimCOL * _FontWidth, (YdimROW + 1) * _FontHeight, 0 + 256)
        Else
            handle& = _NewImage(XdimCOL, YdimROW + 1, 0)
        End If
        Screen handle&
        _Dest handle&
        _Delay .001
        ReDim FileArrayWINDOW$(YdimROW)
        Select Case UCase$(WaitingForAKey$)
            Case "8" 'FNThandle8& = _LoadFont(PSPlike$ + "Mx437_ToshibaTxL2_8x8.ttf", 8, "MONOSPACE") '8x8 Toshiba
                If FNThandle8& > 0 Then _Font FNThandle8&: _Display
            Case "T" 'FNThandleT& = _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 32, "MONOSPACE") '16x32 Toshiba 2x
                If FNThandleT& > 0 Then _Font FNThandleT&: _Display: ToshibaIsSet = 1
            Case "4" 'FNThandle4& = _LoadFont(PSPlike$ + "Px437_Cordata_PPC-400.ttf", 32, "MONOSPACE") '16x32 Cordata
                If FNThandle4& > 0 Then _Font FNThandle4&: _Display
            Case "F" 'FNThandleF& = _LoadFont(PSPlike$ + "Mx437_FMTowns_re_8x16.ttf", 16, "MONOSPACE") '8x16 Fujitsu Singlewidth
                If FNThandleF& > 0 Then _Font FNThandleF&: _Display
            Case "D" 'FNThandleD& = _LoadFont(PSPlike$ + "Mx437_FMTowns_re_8x16-2x.ttf", 16, "MONOSPACE") '16x16 Fujitsu Doublewidth
                If FNThandleD& > 0 Then _Font FNThandleD&: _Display
            Case "S" 'FNThandleS& = _LoadFont(PSPlike$ + "Mx437_CL_Stingray_8x16.ttf", 16, "MONOSPACE") '8x16 Stingray
                If FNThandleS& > 0 Then _Font FNThandleS&: _Display
            Case "V" 'FNThandleV& = _LoadFont(PSPlike$ + "Px437_DOS-V_re_JPN12.ttf", 12, "MONOSPACE") '6x12 DOS-V
                If FNThandleV& > 0 Then _Font FNThandleV&: _Display
            Case "C" 'FNThandleC& = _LoadFont(PSPlike$ + "Px437_CompaqThin_8x16.ttf", 16, "MONOSPACE") '8x16 CompaqThin
                If FNThandleC& > 0 Then _Font FNThandleC&: _Display
            Case "A" 'FNThandleA& = _LoadFont(PSPlike$ + "Px437_Portfolio_6x8.ttf", 8, "MONOSPACE") '6x8 Atari
                If FNThandleA& > 0 Then _Font FNThandleA&: _Display
            Case "J" 'FNThandleJ& = _LoadFont(PSPlike$ + "Mx437_IBM_XGA-AI_7x15.ttf", 15, "MONOSPACE") '7x15 IBM
                If FNThandleJ& > 0 Then _Font FNThandleJ&: _Display
            Case " " 'FNThandle& = _LoadFont(PSPlike$ + "MxPlus_ToshibaTxL2_8x16.ttf", 16, "MONOSPACE") '8x16
                If FNThandle& > 0 Then _Font FNThandle&: _Display: ToshibaIsSet = 1
            Case Else
                If FNThandle& > 0 Then _Font FNThandle&: _Display: ToshibaIsSet = 1
        End Select
    End If
    _Delay .1 ' Caramba, without this delay the window is not positioned as it should even with below 'Do: Loop Until _ScreenExists'
End If
' SETTING WINDOW ]]]
Do: Loop Until _ScreenExists: _ScreenMove 102, 3
_Title "Dirwalker, " + LTrim$(Str$(XdimCOL)) + "x" + LTrim$(Str$(YdimROW + 1)) + ", revision " + revision$ + "; Directory: " + PathToEngage$
_Display


' GESCH [[[

If ToshibaIsSet = 1 Then ascii_gesch = 1 ' Mainly for "MxPlus_ToshibaTxL2_8x16.ttf" when set.

'RESTORE Microsoft_pc_cp437 'United States MS DOS
'RESTORE Microsoft_windows_cp1250 'WINDOWS in Central European and Eastern European languages that use Latin script, such as Polish, Czech, Slovak, Hungarian, Slovene, Bosnian, Croatian, Serbian (Latin script), Romanian and Albanian. It may also be used with the German language.
'RESTORE Microsoft_windows_cp1251 'Cyrillic alphabet such as Russian, Bulgarian, Serbian Cyrillic and other languages. It is the most widely used for encoding the Bulgarian, Serbian and Macedonian languages.
'RESTORE Microsoft_pc_cpMIK 'Cyrillic Bulgarian Pravetz 16 for MS-DOS

'Color 4
If ascii_gesch = 1 Then
    Restore Microsoft_pc_cpGESCH 'My codepage a.k.a. Gesch
    Print "Loading GRAPHEMES of Gesch (a.k.a. Schpitz) codepage,": Print "it allows browsing German/Italian/French/Spanish/Bulgarian (and its dialect Russian :P)."
Else
    Restore Microsoft_windows_cp1252
    Print "Loading GRAPHEMES of cp1252 codepage - Windows Western languages with Latin alphabet,": Print "it allows browsing... ugh, it sucks."
End If

If ascii_gesch = 1 Then ' In 2023-Jan-20 had to free the ASCII 000 slot in order ASCIIZ strings (as in Tcheburaschka) to be OK. Trading places of ASCII 000 <-> ASCII 209 (IntegralH) and ASCII 001 <-> ASCII 210 (IntegralL)
    'For ASCIIcode = 0 To 6 'German A:a:O:o:U:u: ss
    For ASCIIcode = 0 To 6 'German A:a:O:o:U:u: ss
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 7 To 7 'Integral high
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 8 To 8 'Integral low
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 14 To 15 'French C,c,
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 16 To 27 'French/Italian E'e' A`a`E`e`I`i`O`o`U`u`
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    'why 28..31 are not available?!
    For ASCIIcode = 128 To 255
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 220 To 223 ' the unnecessary 4 bold drawing chars are replaced with French AE ae I: i:
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 127 To 127 'almost equal to
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 181 To 190 'Cyrillic short vowels
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 198 To 207 'Cyrillic short vowels
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 208 To 216 'misc, Spanish
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 28 To 31 'draw animated block
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
    For ASCIIcode = 11 To 12 'draw animated block
        Read unicode
        _MapUnicode unicode To ASCIIcode
    Next
End If

GoTo SkipASCIItable
ASCIItable
SkipASCIItable:

'Do not place DATA fields after SUB or FUNCTION procedures! QB64 will FAIL to RESTORE properly!

Microsoft_pc_cp737: 'Greek MS DOS displays Greek alphabet for algebraic formulas.
Data 913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928
Data 929,931,932,933,934,935,936,937,945,946,947,948,949,950,951,952
Data 953,954,955,956,957,958,959,960,961,963,962,964,965,966,967,968
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 969,940,941,942,970,943,972,973,971,974,902,904,905,906,908,910
Data 911,177,8805,8804,938,939,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp775: 'Estonian, Lithuanian and Latvian languages.
Data 262,252,233,257,228,291,229,263,322,275,342,343,299,377,196,197
Data 201,230,198,333,246,290,162,346,347,214,220,248,163,216,215,164
Data 256,298,243,379,380,378,8221,166,169,174,172,189,188,321,171,187
Data 9617,9618,9619,9474,9508,260,268,280,278,9571,9553,9559,9565,302,352,9488
Data 9492,9524,9516,9500,9472,9532,370,362,9562,9556,9577,9574,9568,9552,9580,381
Data 261,269,281,279,303,353,371,363,382,9496,9484,9608,9604,9612,9616,9600
Data 211,223,332,323,245,213,181,324,310,311,315,316,326,274,325,8217
Data 173,177,8220,190,182,167,247,8222,176,8729,183,185,179,178,9632,160

Microsoft_pc_cp850: 'Western Europe, Spain, England
Data 199,252,233,226,228,224,229,231,234,235,232,239,238,236,196,197
Data 201,230,198,244,246,242,251,249,255,214,220,248,163,216,215,402
Data 225,237,243,250,241,209,170,186,191,174,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,193,194,192,169,9571,9553,9559,9565,162,165,9488
Data 9492,9524,9516,9500,9472,9532,227,195,9562,9556,9577,9574,9568,9552,9580,164
Data 240,208,202,203,200,305,205,206,207,9496,9484,9608,9604,166,204,9600
Data 211,223,212,210,245,213,181,254,222,218,219,217,253,221,175,180
Data 173,177,8215,190,182,167,247,184,176,168,183,185,179,178,9632,160

Microsoft_pc_cp852: 'Central European languages that use Latin script such as Bosnian, Croatian, Czech, Hungarian, Polish, Romanian, Serbian or Slovak.
Data 199,252,233,226,228,367,263,231,322,235,336,337,238,377,196,262
Data 201,313,314,244,246,317,318,346,347,214,220,356,357,321,215,269
Data 225,237,243,250,260,261,381,382,280,281,172,378,268,351,171,187
Data 9617,9618,9619,9474,9508,193,194,282,350,9571,9553,9559,9565,379,380,9488
Data 9492,9524,9516,9500,9472,9532,258,259,9562,9556,9577,9574,9568,9552,9580,164
Data 273,272,270,203,271,327,205,206,283,9496,9484,9608,9604,354,366,9600
Data 211,223,212,323,324,328,352,353,340,218,341,368,253,221,355,180
Data 173,733,731,711,728,167,247,184,176,168,729,369,344,345,9632,160

Microsoft_pc_cp855: 'Cyrillic code page to be used under MS-DOS
Data 1106,1026,1107,1027,1105,1025,1108,1028,1109,1029,1110,1030,1111,1031,1112,1032
Data 1113,1033,1114,1034,1115,1035,1116,1036,1118,1038,1119,1039,1102,1070,1098,1066
Data 1072,1040,1073,1041,1094,1062,1076,1044,1077,1045,1092,1060,1075,1043,171,187
Data 9617,9618,9619,9474,9508,1093,1061,1080,1048,9571,9553,9559,9565,1081,1049,9488
Data 9492,9524,9516,9500,9472,9532,1082,1050,9562,9556,9577,9574,9568,9552,9580,164
Data 1083,1051,1084,1052,1085,1053,1086,1054,1087,9496,9484,9608,9604,1055,1103,9600
Data 1071,1088,1056,1089,1057,1090,1058,1091,1059,1078,1046,1074,1042,1100,1068,8470
Data 173,1099,1067,1079,1047,1096,1064,1101,1069,1097,1065,1095,1063,167,9632,160

Microsoft_pc_cp857: 'Turkish MS DOS
Data 199,252,233,226,228,224,229,231,234,235,232,239,238,305,196,197
Data 201,230,198,244,246,242,251,249,304,214,220,248,163,216,350,351
Data 225,237,243,250,241,209,286,287,191,174,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,193,194,192,169,9571,9553,9559,9565,162,165,9488
Data 9492,9524,9516,9500,9472,9532,227,195,9562,9556,9577,9574,9568,9552,9580,164
Data 186,170,202,203,200,0,205,206,207,9496,9484,9608,9604,166,204,9600
Data 211,223,212,210,245,213,181,0,215,218,219,217,236,255,175,180
Data 173,177,0,190,182,167,247,184,176,168,183,185,179,178,9632,160

Microsoft_pc_cp860: 'Portuguese language. MS DOS
Data 199,252,233,226,227,224,193,231,234,202,232,205,212,236,195,194
Data 201,192,200,244,245,242,218,249,204,213,220,162,163,217,8359,211
Data 225,237,243,250,241,209,170,186,191,210,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp861: 'Icelandic language (as well as other Nordic languages). MS DOS
Data 199,252,233,226,228,224,229,231,234,235,232,208,240,222,196,197
Data 201,230,198,244,246,254,251,221,253,214,220,248,163,216,8359,402
Data 225,237,243,250,193,205,211,218,191,8976,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp862: 'Hebrew letters in positions 809A hex, but otherwise it is identical to CP437. Now obsolete, see CP1255
Data 1488,1489,1490,1491,1492,1493,1494,1495,1496,1497,1498,1499,1500,1501,1502,1503
Data 1504,1505,1506,1507,1508,1509,1510,1511,1512,1513,1514,162,163,165,8359,402
Data 225,237,243,250,241,209,170,186,191,8976,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp863: 'French language (mainly in Canada). MS DOS
Data 199,252,233,226,194,224,182,231,234,235,232,239,238,8215,192,167
Data 201,200,202,244,203,207,251,249,164,212,220,162,163,217,219,402
Data 166,180,243,250,168,184,179,175,206,8976,172,189,188,190,171,187
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp864: 'Arabic MS DOS
Data 176,183,8729,8730,9618,9472,9474,9532,9508,9516,9500,9524,9488,9484,9492,9496
Data 946,8734,966,177,189,188,8776,171,187,65271,65272,0,0,65275,65276,0
Data 160,173,65154,163,164,65156,0,0,65166,65167,65173,65177,1548,65181,65185,65189
Data 1632,1633,1634,1635,1636,1637,1638,1639,1640,1641,65233,1563,65201,65205,65209,1567
Data 162,65152,65153,65155,65157,65226,65163,65165,65169,65171,65175,65179,65183,65187,65191,65193
Data 65195,65197,65199,65203,65207,65211,65215,65217,65221,65227,65231,166,172,247,215,65225
Data 1600,65235,65239,65243,65247,65251,65255,65259,65261,65263,65267,65213,65228,65230,65229,65249
Data 65149,1617,65253,65257,65260,65264,65266,65232,65237,65269,65270,65245,65241,65265,9632,0

Microsoft_pc_cp865: 'Nordic languages (except Icelandic, for which CP861 is used). MS DOS
Data 199,252,233,226,228,224,229,231,234,235,232,239,238,236,196,197
Data 201,230,198,244,246,242,251,249,255,214,220,248,163,216,8359,402
Data 225,237,243,250,241,209,170,186,191,8976,172,189,188,161,171,164
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cp866: 'Cyrillic alphabetical order code page to be used with MS-DOS
Data 1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055
Data 1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071
Data 1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103
Data 1025,1105,1028,1108,1031,1111,1038,1118,176,8729,183,8730,8470,164,9632,160

Microsoft_pc_cp869: 'Greek MS DOS. Less popular than Code page 737
Data 0,0,0,0,0,0,902,0,183,172,166,8216,8217,904,8213,905
Data 906,938,908,0,0,910,939,169,911,178,179,940,163,941,942,943
Data 970,912,972,973,913,914,915,916,917,918,919,189,920,921,171,187
Data 9617,9618,9619,9474,9508,922,923,924,925,9571,9553,9559,9565,926,927,9488
Data 9492,9524,9516,9500,9472,9532,928,929,9562,9556,9577,9574,9568,9552,9580,931
Data 932,933,934,935,936,937,945,946,947,9496,9484,9608,9604,948,949,9600
Data 950,951,952,953,954,955,956,957,958,959,960,961,963,962,964,900
Data 173,177,965,966,967,167,968,901,176,168,969,971,944,974,9632,160

Microsoft_pc_cp874: 'Thai MS DOS and Windows
Data 8364,0,0,0,0,8230,0,0,0,0,0,0,0,0,0,0
Data 0,8216,8217,8220,8221,8226,8211,8212,0,0,0,0,0,0,0,0
Data 160,3585,3586,3587,3588,3589,3590,3591,3592,3593,3594,3595,3596,3597,3598,3599
Data 3600,3601,3602,3603,3604,3605,3606,3607,3608,3609,3610,3611,3612,3613,3614,3615
Data 3616,3617,3618,3619,3620,3621,3622,3623,3624,3625,3626,3627,3628,3629,3630,3631
Data 3632,3633,3634,3635,3636,3637,3638,3639,3640,3641,3642,0,0,0,0,3647
Data 3648,3649,3650,3651,3652,3653,3654,3655,3656,3657,3658,3659,3660,3661,3662,3663
Data 3664,3665,3666,3667,3668,3669,3670,3671,3672,3673,3674,3675,0,0,0,0

Microsoft_windows_cp1250: 'WINDOWS in Central European and Eastern European languages that use Latin script, such as Polish, Czech, Slovak, Hungarian, Slovene, Bosnian, Croatian, Serbian (Latin script), Romanian and Albanian. It may also be used with the German language.
Data 8364,0,8218,0,8222,8230,8224,8225,0,8240,352,8249,346,356,381,377
Data 0,8216,8217,8220,8221,8226,8211,8212,0,8482,353,8250,347,357,382,378
Data 160,711,728,321,164,260,166,167,168,169,350,171,172,173,174,379
Data 176,177,731,322,180,181,182,183,184,261,351,187,317,733,318,380
Data 340,193,194,258,196,313,262,199,268,201,280,203,282,205,206,270
Data 272,323,327,211,212,336,214,215,344,366,218,368,220,221,354,223
Data 341,225,226,259,228,314,263,231,269,233,281,235,283,237,238,271
Data 273,324,328,243,244,337,246,247,345,367,250,369,252,253,355,729

Microsoft_windows_cp1252: 'Windows Western languages with Latin alphabet, used by default in the legacy components of Microsoft Windows in English.
Data 8364,0,8218,402,8222,8230,8224,8225,710,8240,352,8249,338,0,381,0
Data 0,8216,8217,8220,8221,8226,8211,8212,732,8482,353,8250,339,0,382,376
Data 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175
Data 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
Data 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
Data 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
Data 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
Data 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255

Microsoft_windows_cp1253: 'Greek (but not polytonic Greek) Not fully compatible with ISO 8859-7 (? is located differently).
Data 8364,0,8218,402,8222,8230,8224,8225,0,8240,0,8249,0,0,0,0
Data 0,8216,8217,8220,8221,8226,8211,8212,0,8482,0,8250,0,0,0,0
Data 160,901,902,163,164,165,166,167,168,169,0,171,172,173,174,8213
Data 176,177,178,179,900,181,182,183,904,905,906,187,908,189,910,911
Data 912,913,914,915,916,917,918,919,920,921,922,923,924,925,926,927
Data 928,929,0,931,932,933,934,935,936,937,938,939,940,941,942,943
Data 944,945,946,947,948,949,950,951,952,953,954,955,956,957,958,959
Data 960,961,962,963,964,965,966,967,968,969,970,971,972,973,974,0

Microsoft_windows_cp1254: 'Turkish
Data 8364,0,8218,402,8222,8230,8224,8225,710,8240,352,8249,338,0,0,0
Data 0,8216,8217,8220,8221,8226,8211,8212,732,8482,353,8250,339,0,0,376
Data 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175
Data 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
Data 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
Data 286,209,210,211,212,213,214,215,216,217,218,219,220,304,350,223
Data 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
Data 287,241,242,243,244,245,246,247,248,249,250,251,252,305,351,255

Microsoft_windows_cp1255: 'Hebrew Windows. Modern applications prefer [https://en.wikipedia.org/wiki/UTF-8 UTF-8] or UTF-16 http://www.fileformat.info/info/charset/UTF-16/list.htm to Windows 1255.
Data 8364,0,8218,402,8222,8230,8224,8225,710,8240,0,8249,0,0,0,0
Data 0,8216,8217,8220,8221,8226,8211,8212,732,8482,0,8250,0,0,0,0
Data 160,161,162,163,8362,165,166,167,168,169,215,171,172,173,174,175
Data 176,177,178,179,180,181,182,183,184,185,247,187,188,189,190,191
Data 1456,1457,1458,1459,1460,1461,1462,1463,1464,1465,0,1467,1468,1469,1470,1471
Data 1472,1473,1474,1475,1520,1521,1522,1523,1524,0,0,0,0,0,0,0
Data 1488,1489,1490,1491,1492,1493,1494,1495,1496,1497,1498,1499,1500,1501,1502,1503
Data 1504,1505,1506,1507,1508,1509,1510,1511,1512,1513,1514,0,0,8206,8207,0

Microsoft_windows_cp1256: 'Arabic Latin Windows
Data 8364,1662,8218,402,8222,8230,8224,8225,710,8240,1657,8249,338,1670,1688,1672
Data 1711,8216,8217,8220,8221,8226,8211,8212,1705,8482,1681,8250,339,8204,8205,1722
Data 160,1548,162,163,164,165,166,167,168,169,1726,171,172,173,174,175
Data 176,177,178,179,180,181,182,183,184,185,1563,187,188,189,190,1567
Data 1729,1569,1570,1571,1572,1573,1574,1575,1576,1577,1578,1579,1580,1581,1582,1583
Data 1584,1585,1586,1587,1588,1589,1590,215,1591,1592,1593,1594,1600,1601,1602,1603
Data 224,1604,226,1605,1606,1607,1608,231,232,233,234,235,1609,1610,238,239
Data 1611,1612,1613,1614,244,1615,1616,247,1617,249,1618,251,252,8206,8207,1746

Microsoft_windows_cp1257: 'Estonian (although that can also be written with Windows-1252), Latvian and Lithuanian languages under Microsoft Windows. It is also possible to write Polish and German.
Data 8364,0,8218,0,8222,8230,8224,8225,0,8240,0,8249,0,168,711,184
Data 0,8216,8217,8220,8221,8226,8211,8212,0,8482,0,8250,0,175,731,0
Data 160,0,162,163,164,0,166,167,216,169,342,171,172,173,174,198
Data 176,177,178,179,180,181,182,183,248,185,343,187,188,189,190,230
Data 260,302,256,262,196,197,280,274,268,201,377,278,290,310,298,315
Data 352,323,325,211,332,213,214,215,370,321,346,362,220,379,381,223
Data 261,303,257,263,228,229,281,275,269,233,378,279,291,311,299,316
Data 353,324,326,243,333,245,246,247,371,322,347,363,252,380,382,729

Microsoft_windows_cp1258: 'Vietnamese. [https://en.wikipedia.org/wiki/UTF-8 UTF-8] is the preferred encoding for Vietnamese in modern applications.
Data 8364,0,8218,402,8222,8230,8224,8225,710,8240,0,8249,338,0,0,0
Data 0,8216,8217,8220,8221,8226,8211,8212,732,8482,0,8250,339,0,0,376
Data 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175
Data 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
Data 192,193,194,258,196,197,198,199,200,201,202,203,768,205,206,207
Data 272,209,777,211,212,416,214,215,216,217,218,219,220,431,771,223
Data 224,225,226,259,228,229,230,231,232,233,234,235,769,237,238,239
Data 273,241,803,243,244,417,246,247,248,249,250,251,252,432,8363,255

Microsoft_pc_cp437: 'United States MS DOS
Data 199,252,233,226,228,224,229,231,234,235,232,239,238,236,196,197
Data 201,230,198,244,246,242,251,249,255,214,220,162,163,165,8359,402
Data 225,237,243,250,241,209,170,186,191,8976,172,189,188,161,171,187
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_windows_cp1251: 'Cyrillic alphabet such as Russian, Bulgarian, Serbian Cyrillic and other languages. It is the most widely used for encoding the Bulgarian, Serbian and Macedonian languages.
Data 1026,1027,8218,1107,8222,8230,8224,8225,8364,8240,1033,8249,1034,1036,1035,1039
Data 1106,8216,8217,8220,8221,8226,8211,8212,0,8482,1113,8250,1114,1116,1115,1119
Data 160,1038,1118,1032,164,1168,166,167,1025,169,1028,171,172,173,174,1031
Data 176,177,1030,1110,1169,181,182,183,1105,8470,1108,187,1112,1029,1109,1111
Data 1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055
Data 1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071
Data 1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087
Data 1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103

Microsoft_pc_cpMIK: 'Cyrillic Bulgarian Pravetz 16 for MS-DOS
Data 1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055
Data 1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071
Data 1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087
Data 1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103
Data 9492,9524,9516,9500,9472,9532,9571,9553,9562,9566,9577,9574,9568,9552,9580,9488
Data 9617,9618,9619,9474,9508,8470,167,9559,9565,9496,9484,9608,9604,9612,9616,9600
Data 945,223,915,960,931,963,181,964,934,920,937,948,8734,966,949,8745
Data 8801,177,8805,8804,8992,8993,247,8776,176,8729,183,8730,8319,178,9632,160

Microsoft_pc_cpGESCH: 'Schpitz/Gesch (a.k.a. Georgievica a.k.a. Geschovica) is Sanmayce's layout, combining the MIK and 437, in this way: (NOT RECODING only 009,010,013):
' shpitz

' DEFINITIONS
' top or extreme part
' the ultimate, the best of, "cool"
' typical, classic, a perfect example of; definitively

' LANGUAGES OF ORIGIN
' Yiddish

' ETYMOLOGY
' ????? shpits 'tip, peak'

' ALTERNATIVE SPELLINGS
' schpitz, shpits, shpitzy, shpitsy

'NOTES
'Steinmetz, "Yiddish and English" has an entry for shpits, but the meaning is simply 'tip.'

' ASCII 000..031 have to accomodate German and French  '&H203e = 8254 is upperscore '&H00DC=220
'Data 196,228,214,246,&H00DC,&H00FC,223,&H00c1,&H00e1,&h00C7,&H00E7 ' old
Data &H2320,&H2321,214,246,&H00DC,&H00FC,223,&H00c1,&H00e1,&h00C7,&H00E7
'A:a:O:o:U:u:ss A' a' C'c'
Data &H0c9,&H00e9,&H0c0,&H00e0,&H00c8,&H00e8,&H00cc,&H00ec,&H00d2,&H00f2,&H00d9,&H00f9
' E'e' A`a`E`e`I`i`O`o`U`u`

'DATA &H00cb,&H00eb,&H00cf,&H00ef
' E:e: I:i: ' E:e: are present in Russian, so remove them

'First half of big Cyrillic letters:
Data 1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055
'Second half of big Cyrillic letters:
Data 1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071
'First half of small Cyrillic letters:
Data 1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087
'1st third of CP437 drawing symbols:
Data 9617,9618,9619,9474,9508,9569,9570,9558,9557,9571,9553,9559,9565,9564,9563,9488
'2nd third of CP437 drawing symbols:
Data 9492,9524,9516,9500,9472,9532,9566,9567,9562,9556,9577,9574,9568,9552,9580,9575
'3rd third of CP437 drawing symbols:
Data 9576,9572,9573,9561,9560,9554,9555,9579,9578,9496,9484,9608,9604,9612,9616,9600
'Second half of small Cyrillic letters:
Data 1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103
'Last 16 of CP437 symbols:
'                                                 u-kr E:   e:   <<  >>  Up_ ...
'DATA 8216,8217,8218,8219,8220,8221,8222,8223,176,1118,1025,1105,171,187,175,8230
'                                                MICRO  E:   e:   <<  >>  Up_ ...
Data 8216,8217,8218,8219,8220,8221,8222,8223,176,&h00b5,1025,1105,171,187,175,8230

Data &H00c6,&H00E6,&H0152,&H0153
' AE ae OEoe

Data &h2248
'almost equal to
'DATA &H221a
'square root

Data &H0102,&H0103,&H0114,&H0115,&H014e,&H014f,&H040e,&H045e,&H00cf,&H00ef
'Cyrillic short vowels: AaEeOoYy I:i:
Data &H00c2,&H00e2,&H00ca,&H00ea,&H00ce,&H00ee,&H00d4,&H00f4,&H00db,&H00fb
' A^a^ E^e^ I^i^ O^o^ U^u^

'Data &h2017,&H2320,&H2321,&h00a1,&h00bf,&h00d1,&h00f1,&h00dd,&h00fd 'old
'doubleunderline IntegralH IntegralL, Spanish: r! r? N~ n~ Y` y`
Data &h2017,196,228,&h00a1,&h00bf,&h00d1,&h00f1,&h00dd,&h00fd
'doubleunderline A: a:, Spanish: r! r? N~ n~ Y` y`

Data &h00cd,&h00ed,&h00da,&h00fa
' I'i'U'u'

Data &h00D3,&h00F3
' O' o'

' Portuguese makes use of five diacritics: the cedilla (c,), acute accent (a' e' i' o' u'), circumflex accent (a^, e^, o^), tilde (a~, o~), and grave accent (a`, and rarely e`, i`, o`, and u`).

' GESCH ]]]

GoSub INIT_WINDOW_gosub

' BUG in _MouseMove in _fullscreen, cannot position properly [
'While _MouseInput: Wend

If GraphicOrTextFlag Then
    _MouseMove (XdimCOL - 2) * _FontWidth - 1, (YdimROW - 9) * _FontHeight - 1 '_MouseX, _MouseY
Else
    _MouseMove XdimCOL - 2, YdimROW - 9 '_MouseX, _MouseY
End If
'_MouseMove _Width(0) - 1, _Height(0) - 1
' BUG in _MouseMove in _fullscreen, cannot position properly ]

' Inhere, the four main flags are set:
treedumpPOOLFLAG = 1 ' if 0 then we are in FILE content mode
treedumpPOOL_DIRonlyFLAG = 0 ' 1 for full tree DIRs; 0 for full tree FILEs
' FILTER_apply_flag is set 0 (not applying filters)
' DIRorTREE_flag is set NOT 0 (for DIR)

ReDim Shared ASCIIfast(0 To 255) As String * 2
ReDim Shared ASCIIfastBYTE(0 To 255) As String * 1
For i = 0 To 255
    Superslow$ = Hex$(i)
    If Len(Superslow$) = 1 Then ASCIIfast(i) = "0" + Superslow$ Else ASCIIfast(i) = Superslow$
    If i = 0 Then ASCIIfastBYTE(i) = " " Else ASCIIfastBYTE(i) = Chr$(i)
Next

Do 'mainloop [
    ReturnCOMBO
    IsTILDEreleased = 0
    IsSLASHreleased = 0

    'Esc  F1    F2    F3    F4    F5    F6    F7    F8    F9    F10   F11   F12   Sys  ScL Pause
    ' 27 15104 15360 15616 15872 16128 16384 16640 16896 17152 17408 34048 34304 +316 +302 +019

    '`~  1!  2@  3#  4$  5%  6^  7&  8*  9(  0) -_ =+ BkSp   Ins   Hme   PUp   NumL   /     *    -
    '126 33  64  35  36  37  94  38  42  40  41 95 43   8   20992 18176 18688 +300   47    42   45
    ' 96 49  50  51  52  53  54  55  56  57  48 45 61

    ' Bug appearing in Fedora 35, it prints sporadically 1's among 0's (when Enter is held)?! [
    'Do
    '        BuggyInLinux% = _KeyDown(13)
    '        If BuggyInLinux% <> 0 Then
    '        Else
    '                Print _KeyDown(13);
    '        End If
    'Loop
    ' Bug appearing in Fedora 35, it prints sporadically 1's among 0's (when Enter is held)?! ]

    ' Kaze's Galeon's non-fix of the problem (on Fedora 35) below [
    X = _KeyHit
    If X Then
        If X < 0 Then 'negative value means key released
            X = -X
            If X = 96 And _KeyDown(96) = 0 Then IsTILDEreleased = 1
            If X = 47 And _KeyDown(47) = 0 Then IsSLASHreleased = 1
            If X = 17408 And _KeyDown(17408) = 0 Then IsF10released = 1
        Else
        End If
    End If
    ' Kaze's Galeon's non-fix of the problem (on Fedora 35) below ]

    If IsF10released = 1 And DIRorTREE_flag And FILTER_apply_flag = 0 Then
        IsF10released = 0
        LastHit~&& = EpochTime~&&: Stepping = 10
        If FileTy(CurrentLine) = " DIRECTORY" Then
        Else
            _Title "Dirwalker, " + LTrim$(Str$(XdimCOL)) + "x" + LTrim$(Str$(YdimROW)) + ", revision " + revision$ + "; Directory: " + PathToEngage$ + "; File: " + FileNa(CurrentLine) + "; 'Backspace' to go back"
            crxInfo = Pos(0)
            cryInfo = CsrLin
            UpdateNextToCCL_BUSY ("Released 'F10'")
            '[

            ' SHA1 [
            SHA1$ = ""
            NakamichiFILE$ = FileNa(CurrentLine) + Chr$(0)
            dummy = sha1_stream(NakamichiFILE$, SHA328bytes$)
            SHA1$ = ""
            For i = 1 To 20
                MustBeTwoChars$ = Hex$(Asc(Mid$(SHA328bytes$, i, 1)))
                If Len(MustBeTwoChars$) = 1 Then MustBeTwoChars$ = "0" + MustBeTwoChars$
                SHA1$ = SHA1$ + MustBeTwoChars$
            Next
            ' SHA1 ]
            If fff& Then Close #fff&
            fff& = FreeFile
            Open FileNa(CurrentLine) For Binary As #fff&
            GetItInVariableToCountLFs = LOF(fff&)
            GetItInVariableToCountLFsBAK = GetItInVariableToCountLFs
            NumberOfLFs = 0
            NumberOfCRs = 0
            NumberOfTABs = 0
            NumberOfBytesREAL = 0
            Do While GetItInVariableToCountLFs
                Get #fff&, , Get10000elements$
                OffestOfBuffer%& = _Offset(Get10000elements$)
                If NumberOfBytesREAL + 640000 <= GetItInVariableToCountLFs Then
                    NumberOfBytesREAL = 640000
                Else
                    NumberOfBytesREAL = GetItInVariableToCountLFs
                End If
                GetItInVariableToCountLFs = GetItInVariableToCountLFs - NumberOfBytesREAL
                NumberOfLFs = NumberOfLFs + memcount_sse2&&(OffestOfBuffer%&, 10, NumberOfBytesREAL)
                NumberOfCRs = NumberOfCRs + memcount_sse2&&(OffestOfBuffer%&, 13, NumberOfBytesREAL)
                NumberOfTABs = NumberOfTABs + memcount_sse2&&(OffestOfBuffer%&, 9, NumberOfBytesREAL)

            Loop
            For i = 1 To YdimROW
                LocateTextGraphCursor i, 1, 0, CursorS, CursorE: Print Space$(XdimCOL);
            Next
            Locate 1, 1: Print "SHA1: "; SHA1$; " "; FileNa(CurrentLine)
            Locate 2, 1: Print "Number of LFs  i.e. ASCII 010 ="; NumberOfLFs
            Locate 3, 1: Print "Number of CRs  i.e. ASCII 013 ="; NumberOfCRs
            Locate 4, 1: Print "Number of TABs i.e. ASCII 009 ="; NumberOfTABs
            Get #fff&, GetItInVariableToCountLFsBAK, kazebyte$
            ' after Schmekeriada style:
            NumberOfLLs = NumberOfLFs
            ' printf( "Number of LF-ending lines: %s\n",  _ui64toaKAZEcomma(NumberOfLFs, llTOaDigits, 10));
            '
            ' PlusOneOrTwo=0+1;//bug (crashes the malloc below) fixed
            ' if (AvoidSEEKS[size_in64-1]!=10) {
            '         if (NumberOfLFs == NumberOfCRs) {
            '                 PlusOneOrTwo=2;
            '                 AvoidSEEKS[size_in64]=13;
            '                 AvoidSEEKS[size_in64+1]=10;
            '                 NumberOfCRs++;
            '                 NumberOfLFs++;
            '                 printf( "Postfixing the last \"line\" with a CRLF.\n");
            '         } else {
            '                 PlusOneOrTwo=1;
            '                 AvoidSEEKS[size_in64]=10;
            '                 NumberOfLFs++;
            '                 printf( "Postfixing the last \"line\" with a LF.\n");
            '         }
            ' }

            If kazebyte$ <> Chr$(10) Then
                NumberOfLLs = NumberOfLFs + 1
            End If
            Locate 5, 1: Print "Number of logical lines ="; NumberOfLLs
            _Display
            Do While InKey$ <> Chr$(8): Loop
            GoSub INIT_WINDOW_gosub

            ']
            UpdateNextToCCL_DONE ("Released 'F10'")
            LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
        End If
    End If

    'BuggyInLinux& = _KeyDown(47)
    'If BuggyInLinux& Then
    '        IsSLASHreleased = -1
    'Else
    '        If IsSLASHreleased = -1 Then IsSLASHreleased = 1 Else IsSLASHreleased = 0
    'End If

    'BuggyInLinux& = _KeyDown(96)
    'If BuggyInLinux& Then
    '        IsTILDEreleased = -1
    'Else
    '        If IsTILDEreleased = -1 Then IsTILDEreleased = 1 Else IsTILDEreleased = 0
    'End If

    BuggyInLinux& = _KeyDown(34304)
    If BuggyInLinux& Then
        IsF12released_Flag = -1
    Else
        If IsF12released_Flag = -1 Then IsF12released_Flag = 1 Else IsF12released_Flag = 0
    End If

    BuggyInLinux& = _KeyDown(15104)
    If BuggyInLinux& Then
        IsF1released_Flag = -1
    Else
        If IsF1released_Flag = -1 Then IsF1released_Flag = 1 Else IsF1released_Flag = 0
    End If
    BuggyInLinux& = _KeyDown(15360)
    If BuggyInLinux& Then
        IsF2released_Flag = -1
    Else
        If IsF2released_Flag = -1 Then IsF2released_Flag = 1 Else IsF2released_Flag = 0
    End If
    BuggyInLinux& = _KeyDown(15616)
    If BuggyInLinux& Then
        IsF3released_Flag = -1
    Else
        If IsF3released_Flag = -1 Then IsF3released_Flag = 1 Else IsF3released_Flag = 0
    End If
    BuggyInLinux& = _KeyDown(15872)
    If BuggyInLinux& Then
        IsF4released_Flag = -1
    Else
        If IsF4released_Flag = -1 Then IsF4released_Flag = 1 Else IsF4released_Flag = 0
    End If

    BuggyInLinux& = _KeyDown(16128)
    If BuggyInLinux& Then
        IsF5released_Flag = -1
    Else
        If IsF5released_Flag = -1 Then IsF5released_Flag = 1 Else IsF5released_Flag = 0
    End If

    If IsF5released_Flag = 1 Then ASCIItable

    BuggyInLinux& = _KeyDown(13) ' Caramba, failed to mask/bypass some RAlt+Enter, it treats it as Enter?! Known_bug.
    If BuggyInLinux& Then
        If _KeyDown(RALTkey&) <> -1 Then IsENTERreleased_Flag = -1
    Else
        If IsENTERreleased_Flag = -1 Then
            If _KeyDown(RALTkey&) <> -1 Then IsENTERreleased_Flag = 1
        Else
            IsENTERreleased_Flag = 0
        End If
    End If

    BuggyInLinux& = _MouseButton(3)
    If BuggyInLinux& Then
        IsButton3released_Flag = -1
    Else
        If IsButton3released_Flag = -1 Then IsButton3released_Flag = 1 Else IsButton3released_Flag = 0
    End If

    If IsF12released_Flag = 1 Then
        '/*
        'int main() {
        '    int DonutHeight = 64; // Height, 84 is good
        '    int Eghty = 140; // Width
        '    int VerOff = 32;//68;
        '    int HorOff = 68;
        '    int VerSize = 90;
        '    int HorSize = 42;

        '    int chrnum = DonutHeight*Eghty;
        '    float A = 0.0, B = 0.0;
        '    float PI= 3.14159;
        '    float StepA = 0.000001; // 0.000005 is good, Left-Right axis rotate speed, lesser the value the slower
        '    float StepB = 0.000001; // 0.000005 is good, Depth-Front axis rotate speed, lesser the value the slower
        '    unsigned char b[chrnum];
        '    long long RenderedFrames=0;
        '    long long FPS;
        '    int k;
        '    clock_t start;
        '    start = clock();
        '    for(;;) {
        '        RenderedFrames++;
        '        memset(&b[0],32,chrnum);
        '        Torus(b, DonutHeight, Eghty, A, B, VerOff, HorOff, VerSize, HorSize);
        '        for(k = 0; k < chrnum+1; k++) {
        '            putchar(k % Eghty ? b[k] : 10);
        '            A += StepA;
        '            B += StepB;
        '        }
        '        //usleep(100000);
        '        if (A>8*PI) {
        '                A = 0.0;
        '                B = 0.0;
        '        }
        '        FPS = RenderedFrames/((double)(clock() - start) / CLOCKS_PER_SEC);
        '        printf("Frames-Per-Second (real-time rendering):%d\n",FPS);
        '        printf("Ver.size:%d\n",DonutHeight);
        '        printf("Hor.size:%d\n",Eghty);
        '        printf("A:%f; StepA:%f\n",A,StepA);
        '        printf("B:%f; StepB:%f\n",B,StepB);
        '        printf("Use 'Ctrl+S' to Pause, and 'Ctrl+Q' to Continue.\n");
        '    } //for(;;) {
        '    return 0;
        '}
        '*/
        $Checking:Off
        _Limit 2000

        DonutHeight% = 100 'YdimROW or canvas VER
        Eghty% = 302 'XdimCOL or canvas HOR
        VerOff% = 32
        HorOff% = 68
        VerSize% = 90
        HorSize% = 42
        chrnum% = DonutHeight% * Eghty%
        A! = 0.0
        B! = 0.0
        PI! = 3.1415926535
        StepA! = 0.01
        StepB! = 0.01
        b$ = Space$(chrnum%)
        RenderedFrames = 0
        TimeScrollA = Timer
        'ReDim TRS$(1 To DonutHeight%)
        'For i = 1 To DonutHeight%
        'TRS$(i) = Space$(Eghty%)
        'Next
        Color 9, 0
        For i = 1 To YdimROW
            LocateTextGraphCursor i, 1, 0, CursorS, CursorE: Print Space$(XdimCOL);
        Next
        Do
            AdjustTorus = _KeyHit
            RenderedFrames = RenderedFrames + 1
            dummy%& = memsetKAZE%&(_Offset(b$), Asc(" "), chrnum%)
            'b$ = String$(DonutHeight% * Eghty%, " ")

            Torus b$, DonutHeight%, Eghty%, A!, B!, VerOff%, HorOff%, VerSize%, HorSize%
            'For i = 1 To DonutHeight%
            'memcpyKAZE _Offset(TRS$(i)), _Offset(b$) + (i - 1 + 1) * Eghty%, Eghty%
            'Next
            For i = 1 To MIN&(DonutHeight%, YdimROW)
                'Locate i, 1: Print Mid$(TRS$(i), 2, XdimCOL);
                LocateTextGraphCursor i, 1, 0, CursorS, CursorE: Print Mid$(b$, (i - 1 + 1) * Eghty% + 2, XdimCOL);
            Next
            A! = A! + StepA!
            B! = B! + StepB!
            If A! > 8 * PI! Then
                A! = 0.0
                B! = 0.0
            End If
            TimeScrollB = Timer
            ElapsedTime% = TimeScrollB - TimeScrollA
            If ElapsedTime% < 0 Then ElapsedTime% = (86400 - TimeScrollA) + TimeScrollB
            If ElapsedTime% = 0 Then ElapsedTime% = 1
            FPS = RenderedFrames / ElapsedTime%

            If AdjustTorus = 18432 And HorSize% < 78 Then VerSize% = VerSize% + 3: HorSize% = HorSize% + 2: _KeyClear
            If AdjustTorus = 20480 And HorSize% > 32 Then VerSize% = VerSize% - 3: HorSize% = HorSize% - 2: _KeyClear

            LocateTextGraphCursor YdimROW - 1, 1, 0, CursorS, CursorE: Print "HorSize x VerSize (use Up and Down):"; HorSize%; "x"; VerSize%;
            LocateTextGraphCursor YdimROW, 1, 0, CursorS, CursorE: Print "Frames-Per-Second (real-time rendering):"; FPS;
            _Display
        Loop While AdjustTorus <> 27
        UpdateWindowFrame NormalFRGr, NormalBCKGr
        $Checking:On
        _Limit FramesPerSecond
    End If

    MustBeLONGssigned& = _KeyHit
    If MustBeLONGssigned& Then
        Select Case MustBeLONGssigned&
            Case -33: 'LShift+1=! released, there were STICKY problem when _KeyDown(33) was used?!
                If SortedByLEN = 0 Then
                    'ReportSortingLength (MostRightField): _Display
                    ''UpdateNextToCCL_BUSY (MostRightField): _Display
                    'Quicksort_QB64_v7_linesize MhandleOFF.OFFSET, MhandleLEN.OFFSET, 0, filecount - 1
                    'UpdateWindowFrame NormalFRGr, NormalBCKGr
                    'UpdateNextToCCL_DONE (MostRightField)
                    '_Display
                    '_KeyClear
                    'SortedByLEN = 1 ' don't sort again if sorted by LEN
                    'SortedByOFF = 0 ' don't sort again if sorted by OFF
                End If
            Case -64: 'LShift+2=@ released, there were STICKY problem when _KeyDown(64) was used?!
                If SortedByOFF = 0 Then
                    'ReportSortingOffset (MostRightField): _Display
                    ''UpdateNextToCCL_BUSY (MostRightField): _Display
                    'Quicksort_QB64_v7_linesize MhandleLEN.OFFSET, MhandleOFF.OFFSET, 0, filecount - 1
                    'UpdateWindowFrame NormalFRGr, NormalBCKGr
                    'UpdateNextToCCL_DONE (MostRightField)
                    '_Display
                    '_KeyClear
                    'SortedByOFF = 1 ' don't sort again if sorted by OFF
                    'SortedByLEN = 0 ' don't sort again if sorted by LEN
                End If
            Case -20992: 'Ins released
                LastHit~&& = EpochTime~&&: Stepping = 10
                If CursorS = 0 Then
                    $If WINDOWS Then
                        Play "v3o2l32ba"
                    $End If
                    CursorS = 30
                    CursorE = 31
                Else
                    $If WINDOWS Then
                        Play "v3o2l32eef"
                    $End If
                    CursorS = 0
                    CursorE = 31
                End If
                _Display
            Case -9: 'Tab released while LShift is held
                ''If _KeyDown(LSHIFTkey&) Then

                'LastHit~&& = EpochTime~&&: Stepping = 10
                'UpdateCLineHIGHLIGHTword cry, 1, InverseFRGr, InverseBCKGr, cry
                'Locate 1, 1, 0, CursorS, CursorE: _Display 'adding refresh in order to get rid of eventual cursor (caught as visible while blinking)
                'Color 9, 0

                '' Scrolling into 3D djamtche [
                ''SUB DrawBoxShadow3 (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
                'dictTAB$ = "Masakari's dictionaries"
                'If Len(dictTAB$) > 70 Then Reduced$ = "..." + Right$(dictTAB$, 70) Else Reduced$ = dictTAB$
                'Call DrawBoxShadowOED(3 + 3, 3, 35, 125, Reduced$, 1)
                'BckGRcolor = 1 '6
                'PhysicalLine& = 1
                'dictTAB_TotalWrd& = 23
                '$If WINDOWS Then
                '        Play "v3o2l32ga"
                '$End If

                's$ = LTrim$(Str$(PhysicalLine&))
                'If Len(s$) > 3 Then
                '        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
                '        s$ = ""
                '        For i = 1 To Len(x$) Step 3
                '                s$ = s$ + Mid$(x$, i, 3) + ","
                '        Next
                '        s$ = Left$(s$, Len(s$) - 1)
                'End If
                's$ = LTrim$(s$)
                'Padded$ = "0,000,000,000"
                'Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
                'Color 0, BckGRcolor: Locate 35, 3 + 97: Print "[ Entry: ";: Color 7, BckGRcolor: Print Padded$;: Color 0, BckGRcolor: Print " ]";
                'Locate , , 0

                'DjamPoolLength = 125 - 3 + 1 - 4
                'DjamPoolHeight = 35 - (3 + 3) + 1 - 4
                'CurrentPos& = PhysicalLine& ' Notice that CurrentPos& = 1..(dictTAB_TotalWrd& - DjamPoolHeight + 1)
                '' inhere it could be between 1.. due to BINARY search
                'If dictTAB_TotalWrd& < DjamPoolHeight Then CurrentPos2max& = 1 Else CurrentPos2max& = (dictTAB_TotalWrd& - DjamPoolHeight + 1)
                'If CurrentPos& > CurrentPos2max& Then CurrentPos& = CurrentPos2max&
                'PoolLinePos = 1
                'Do
                '        key$ = InKey$
                '        'DO: a$ = INKEY$: LOOP UNTIL a$ <> "" ' prevent ASC empty string read error
                '        If key$ <> "" Then
                '                code% = Asc(key$):
                '                If code% Then ' ASC returns any value greater than 0
                '                        Select Case Asc(key$)
                '                                Case 13:
                '                                        If CurrentPos& + (PoolLinePos - 1) = 13 Then
                '                                                Call dict02sub
                '                                                GoTo DirtyGo
                '                                        End If
                '                                Case 32:
                '                                Case 65 TO 97: 'PRINT key$;
                '                                Case Asc("a") TO Asc("z"): 'PRINT key$;
                '                                        'CASE 27: COLOR 7, 0: SYSTEM 'END
                '                        End Select
                '                Else
                '                        Select Case Asc(key$, 2)
                '                                Case 72:
                '                                        If PoolLinePos > 1 Then
                '                                                PoolLinePos = PoolLinePos - 1
                '                                        Else
                '                                                If CurrentPos& > 1 Then CurrentPos& = CurrentPos& - 1
                '                                        End If
                '                                Case 80:
                '                                        If PoolLinePos < MIN&(DjamPoolHeight, dictTAB_TotalWrd&) Then
                '                                                PoolLinePos = PoolLinePos + 1
                '                                        Else
                '                                                If CurrentPos& < CurrentPos2max& Then CurrentPos& = CurrentPos& + 1
                '                                        End If
                '                                Case 75: 'Left
                '                                Case 77: 'Right
                '                                Case 71: 'Home
                '                                        PoolLinePos = 1
                '                                        CurrentPos& = 1
                '                                Case 79: 'End
                '                                        PoolLinePos = MIN&(DjamPoolHeight, dictTAB_TotalWrd&)
                '                                        CurrentPos& = CurrentPos2max&
                '                                Case 73: 'PgUp
                '                                        If CurrentPos& - DjamPoolHeight >= 1 Then CurrentPos& = CurrentPos& - DjamPoolHeight
                '                                Case 81: 'PgDn
                '                                        If CurrentPos& + DjamPoolHeight <= CurrentPos2max& Then CurrentPos& = CurrentPos& + DjamPoolHeight
                '                                Case 61: 'F3
                '                                Case 13: 'Enter

                '                        End Select
                '                End If
                '        End If

                '        For i = 1 To MIN&(DjamPoolHeight, dictTAB_TotalWrd&) ' with dictionaries all are bigger than ~40 lines
                '                PADDED_EntryAll$ = DCTNS$(CurrentPos& + (i - 1)) + String$(DjamPoolLength - Len(DCTNS$(CurrentPos& + (i - 1))), " ")
                '                Locate 3 + 3 + 2 + (i - 1), 3 + 2
                '                If i = PoolLinePos Then Color BckGRcolor, 0 Else Color 0, BckGRcolor
                '                Print PADDED_EntryAll$;
                '        Next
                '        s$ = LTrim$(Str$(CurrentPos& + PoolLinePos - 1))
                '        If Len(s$) > 3 Then
                '                If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
                '                s$ = ""
                '                For i = 1 To Len(x$) Step 3
                '                        s$ = s$ + Mid$(x$, i, 3) + ","
                '                Next
                '                s$ = Left$(s$, Len(s$) - 1)
                '        End If
                '        s$ = LTrim$(s$)
                '        Padded$ = "0,000,000,000"
                '        Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
                '        Color 0, BckGRcolor: Locate 35, 3 + 97: Print "[ Entry: ";: Color 7, BckGRcolor: Print Padded$;: Color 0, BckGRcolor: Print " ]";
                '        _Display 'in order to not having frozen screen
                '        _Limit 60
                'Loop Until _KeyDown(27)
                '' Scrolling into 3D djamtche ]
                'DirtyGo:
                '_KeyClear 2
                'UpdateWindowFrame NormalFRGr, NormalBCKGr
                '_Display
                ''End If
            Case Else
        End Select
        If MustBeLONGssigned& < 0 Then 'negative value means key released
            MustBeLONGssigned& = -MustBeLONGssigned&
            If MustBeLONGssigned& \ 256 = 133 Then
                IsF11released_Flag = 1
            Else
            End If
            If MustBeLONGssigned& \ 256 = 68 Then '17408=F10
                IsF10released_Flag = 1
            Else
            End If
        End If
    End If

    If ShowRightsidePanel = 1 Then 'Must show
        RibbonFlag = 1
        ShowRightsidePanel = 0
        RightsidePanelFlag = -1 'shown now
        XdimCOL = XdimCOL - 45
        DrawBoxCAPTION 5, 1, XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
    End If
    If ShowRightsidePanel = -1 Then 'Must hide
        RibbonFlag = 0
        ShowRightsidePanel = 0
        RightsidePanelFlag = 0 'hidden now
        XdimCOL = XdimCOL + 45
        UpdateWindowFrame NormalFRGr, NormalBCKGr
        StatuLine$ = "[Status: DONE;"
        LocateTextGraphCursor YdimROW + 1, 1, 0, CursorS, CursorE: Color 9: Print Space$((XdimCOL - posit) - 1) + "]";
        LocateTextGraphCursor YdimROW + 1, 1, 0, CursorS, CursorE: Color 9: Print StatuLine$;
    End If

    If LALT_RALT Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        LALT_RALT = 0 'clear from buffer
        crxInfo = Pos(0)
        cryInfo = CsrLin
        UpdateNextToCCL_BUSY ("Pressed 'LeftALTkey+RightALTkey'")
        '[

        ']
        LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
        UpdateNextToCCL_DONE ("Pressed 'LeftALTkey+RightALTkey'")
        $If WINDOWS Then
            Play "v3o2l32g"
        $End If
    End If
    If (_KeyDown(LALTkey&) Or _KeyDown(RALTkey&)) And (_KeyDown(81) Or _KeyDown(113)) Then UpdateNextToCCL_BUSY "Terminating...": System
    If (_KeyDown(LALTkey&) Or _KeyDown(RALTkey&)) And (_KeyDown(88) Or _KeyDown(120)) Then UpdateNextToCCL_BUSY "Terminating...": System
    If (_KeyDown(LCTRLkey&) Or _KeyDown(RCTRLkey&)) And (_KeyDown(81) Or _KeyDown(113)) Then UpdateNextToCCL_BUSY "Terminating...": System
    If (_KeyDown(LCTRLkey&) Or _KeyDown(RCTRLkey&)) And (_KeyDown(88) Or _KeyDown(120)) Then UpdateNextToCCL_BUSY "Terminating...": System

    If (_KeyDown(LCTRLkey&) Or _KeyDown(RCTRLkey&)) And (_KeyDown(83) Or _KeyDown(115)) Then 'Ctrl+S saving what is shown - mimicking UPDATEwindow
        UpdateNextToCCL_BUSY "Saving to " + PathToEngage$ + " ..."
        f00 = FreeFile
        TimeNoSemicolons$ = Time$
        For slowy = 1 To Len(TimeNoSemicolons$)
            If Mid$(TimeNoSemicolons$, slowy, 1) = ":" Then Mid$(TimeNoSemicolons$, slowy, 1) = "-"
        Next
        Open PathToEngage$ + "Dirwalker_" + Date$ + "_" + TimeNoSemicolons$ + ".txt" For Output As #f00
        If FILTER_apply_flag = 0 Then
            If DIRorTREE_flag Then
                For Dumpy = 1 To FileCount
                    If Right$(FileArray$(Dumpy), 1) = Chr$(0) Then
                        Print #f00, Left$(FileArray$(Dumpy), Len(FileArray$(Dumpy)) - 1) ' Had to remove the trailing ASCII 000 in order to not be treated as non-txt
                    Else
                        Print #f00, FileArray$(Dumpy) 'Oops, when sorted it also is postfixed with ASCII 000
                    End If
                Next
            Else
                For Dumpy = 1 To FileCount_TREE
                    If treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG + Abs(DIRorTREE_flag) = 0 Then
                        DumboReadOnceNotThrice$ = GetHEXline$(Dumpy) ' not enough - all ASCII < 032 should be 032:
                        For TxpoAgain = 1 To Len(Get32bytes)
                            If Asc(Mid$(DumboReadOnceNotThrice$, TxpoAgain, 1)) < 32 Then Mid$(DumboReadOnceNotThrice$, TxpoAgain, 1) = " "
                        Next
                    Else
                        DumboReadOnceNotThrice$ = FileArray_TREE$(Dumpy)
                    End If
                    If Right$(DumboReadOnceNotThrice$, 1) = Chr$(0) Then
                        Print #f00, Left$(DumboReadOnceNotThrice$, Len(DumboReadOnceNotThrice$) - 1) ' Had to remove the trailing ASCII 000 in order to not be treated as non-txt
                    Else
                        Print #f00, DumboReadOnceNotThrice$ 'Oops, when sorted it also is postfixed with ASCII 000
                    End If
                Next
            End If
            UpdateNextToCCL_DONE "Saved" + Str$(FileCount) + " lines"
        Else
            ' FileCount/FileCount_FILTER could be 0, only with FileArray_FILTERfunction$(), must be handled
            If FileCount_FILTER <> 0 Then
                For i = 1 To FileCount_FILTER
                    DumboReadOnceNotThrice$ = FileArray_FILTERfunction$(i)
                    If treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG + Abs(DIRorTREE_flag) = 0 Then
                        For TxpoAgain = 1 To Len(Get32bytes)
                            If Asc(Mid$(DumboReadOnceNotThrice$, TxpoAgain, 1)) < 32 Then Mid$(DumboReadOnceNotThrice$, TxpoAgain, 1) = " "
                        Next
                    End If
                    If Right$(DumboReadOnceNotThrice$, 1) = Chr$(0) Then
                        Print #f00, Left$(DumboReadOnceNotThrice$, Len(DumboReadOnceNotThrice$) - 1) ' Had to remove the trailing ASCII 000 in order to not be treated as non-txt
                    Else
                        Print #f00, DumboReadOnceNotThrice$ 'Oops, when sorted it also is postfixed with ASCII 000
                    End If
                Next
            End If
            UpdateNextToCCL_DONE "Saved" + Str$(FileCount_FILTER) + " lines"
        End If
        Close #f00
    End If

    ''IF _KEYDOWN(LCTRLkey&) AND (_KEYDOWN(83) OR _KEYDOWN(115)) THEN 'Ctrl+S
    'If (_KeyDown(RSHIFTkey&) And _KeyDown(LSHIFTkey&) = 0) Or (_KeyDown(RCTRLkey&) And _KeyDown(LCTRLkey&) = 0) And PageScrollBenchmark = 0 And LineScrollBenchmark <> 0 Then
    'Shift was removed since it triggers Windows STICKY keys
    If (_KeyDown(RCTRLkey&) And _KeyDown(LCTRLkey&) = 0) And (PageScrollBenchmark <> 0 Or LineScrollBenchmark <> 0) Then
        'LastHit~&& = EpochTime~&&: Stepping = 10
        'InverseL = CsrLin

        ''[[[[[[[[[[[[[[[[[[[[[[[[

        'FiCbig$ = UCase$(Chr$(97))
        'SeCbig$ = UCase$(Chr$(122))

        'For i = 1 To MIN&(YdimROW, FileCount)
        '        'IF LEN(FileArray$(i + (File_Frame_y - 1))) >= XdimCOL THEN
        '        '    FileArrayWINDOW$(i) = MID$(FileArray$(i + (File_Frame_y - 1)), 1, XdimCOL)
        '        'ELSE
        '        '    FileArrayWINDOW$(i) = FileArray$(i + (File_Frame_y - 1)) + SPACE$(XdimCOL - LEN(FileArray$(i + (File_Frame_y - 1))))
        '        'END IF

        '        'LOCATE I, 1: PRINT FileArrayWINDOW$(I);
        '        Moron$ = FileArrayWINDOW$(i)
        '        BigMoron$ = Space$(Len(Moron$))

        '        SuperSlow$ = UCase$(Moron$)
        '        Matrox% = Len(SuperSlow$)
        '        j% = 0
        '        wrd$ = ""
        '        Do
        '                Again2:
        '                j% = j% + 1
        '                IamStupid$ = Mid$(SuperSlow$, j%, 1)
        '                If IamStupid$ >= FiCbig$ And IamStupid$ <= SeCbig$ Then
        '                        wrd$ = wrd$ + IamStupid$
        '                End If
        '                If wrd$ = "" And j% < Matrox% Then GoTo Again2
        '                If wrd$ = "" And j% = Matrox% Then GoTo Nothing2
        '                If wrd$ <> "" And j% < Matrox% Then
        '                        IamStupid2$ = Mid$(SuperSlow$, j% + 1, 1)
        '                        If IamStupid2$ >= FiCbig$ And IamStupid2$ <= SeCbig$ Then GoTo Again2
        '                End If

        '                WRDpresent% = 0
        '                Open "masakari.wrd" For Binary As #6
        '                If LOF(6) Then
        '                        Close #6
        '                        Open "masakari.ind" For Random Access Read As #6 Len = 32
        '                        LeftPoint& = 1
        '                        RightPoint& = TotalWrd&
        '                        Do
        '                                If RightPoint& - LeftPoint& <= 1 Then 'Sxsedtcheta
        '                                        Get #6, LeftPoint&, lfixed$
        '                                        If wrd$ = UCase$(RTrim$(lfixed$)) Then WRDpresent% = 1
        '                                        Get #6, RightPoint&, lfixed$
        '                                        If wrd$ = UCase$(RTrim$(lfixed$)) Then WRDpresent% = 1
        '                                        Exit Do
        '                                End If
        '                                SplitPoint& = (LeftPoint& + RightPoint&) \ 2
        '                                Get #6, SplitPoint&, lfixed$
        '                                If wrd$ < UCase$(RTrim$(lfixed$)) Then
        '                                        RightPoint& = SplitPoint&
        '                                ElseIf wrd$ > UCase$(RTrim$(lfixed$)) Then
        '                                        LeftPoint& = SplitPoint&
        '                                Else
        '                                        WRDpresent% = 1: Exit Do
        '                                End If
        '                        Loop
        '                        Close #6
        '                Else
        '                        Close #6
        '                        Kill "masakari.wrd"
        '                        WRDpresent% = 2
        '                End If
        '                If WRDpresent% = 0 Then
        '                        For Underdog% = j% - Len(wrd$) + 1 To j%
        '                                Mid$(BigMoron$, Underdog%, 1) = "#"
        '                        Next
        '                End If

        '                wrd$ = ""
        '                Nothing2:
        '        Loop While j% < Matrox%

        '        For j% = 1 To XdimCOL
        '                If Mid$(BigMoron$, j%, 1) <> " " Then
        '                        If i = InverseL Then ' inverse line
        '                                Locate i, j%: Color 15, InverseBCKGr: Print Mid$(Moron$, j%, 1);
        '                        Else
        '                                Locate i, j%: Color 15, 0: Print Mid$(Moron$, j%, 1);
        '                        End If
        '                End If
        '        Next
        '        'CALL MovePage(VideoBuffer%, 0, 8)
        'Next

        '']]]]]]]]]]]]]]]]]]]]]]]]
        '$If WINDOWS Then
        '        Play "v3o2l32g"
        '$End If
        'Do Until _KeyDown(RCTRLkey&) = 0 And _KeyDown(RSHIFTkey&) = 0
        '        _Display 'Caramba, when this line is commented the loop is not working as it should?!
        'Loop
    End If

    ' keyboard mumbo-jumbo - handling of double-hits [
    KeyTap_buttondown1 = _KeyDown(LSHIFTkey&)
    KeyTap_buttondown2 = _KeyDown(LCTRLkey&)
    KeyTap_buttondown3 = _KeyDown(LALTkey&)
    KeyTap_buttondown4 = _KeyDown(RALTkey&)

    KeyTap_buttondown5 = _KeyDown(RSHIFTkey&)
    KeyTap_buttondown6 = _KeyDown(RCTRLkey&)
    KeyTap_buttondown7 = _KeyDown(TABkey&)

    If (KeyTap_buttondown1 And KeyTap_PrevClick1# = 0) Then 'first detection of the click
        KeyTap_PrevClick1# = Timer(0.001)
    End If
    If (KeyTap_buttondown2 And KeyTap_PrevClick2# = 0) Then 'first detection of the click
        KeyTap_PrevClick2# = Timer(0.001)
    End If
    If (KeyTap_buttondown3 And KeyTap_PrevClick3# = 0) Then 'first detection of the click
        KeyTap_PrevClick3# = Timer(0.001)
    End If
    If (KeyTap_buttondown4 And KeyTap_PrevClick4# = 0) Then 'first detection of the click
        KeyTap_PrevClick4# = Timer(0.001)
    End If
    If (KeyTap_buttondown5 And KeyTap_PrevClick5# = 0) Then 'first detection of the click
        KeyTap_PrevClick5# = Timer(0.001)
    End If
    If (KeyTap_buttondown6 And KeyTap_PrevClick6# = 0) Then 'first detection of the click
        KeyTap_PrevClick6# = Timer(0.001)
    End If
    If (KeyTap_buttondown7 And KeyTap_PrevClick7# = 0) Then 'first detection of the click
        KeyTap_PrevClick7# = Timer(0.001)
    End If

    If (KeyTap_buttondown1 And KeyTap_PrevClick1# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed1# = Timer(0.001) - KeyTap_PrevClick1#
    End If
    If (KeyTap_buttondown2 And KeyTap_PrevClick2# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed2# = Timer(0.001) - KeyTap_PrevClick2#
    End If
    If (KeyTap_buttondown3 And KeyTap_PrevClick3# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed3# = Timer(0.001) - KeyTap_PrevClick3#
    End If
    If (KeyTap_buttondown4 And KeyTap_PrevClick4# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed4# = Timer(0.001) - KeyTap_PrevClick4#
    End If
    If (KeyTap_buttondown5 And KeyTap_PrevClick5# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed5# = Timer(0.001) - KeyTap_PrevClick5#
    End If
    If (KeyTap_buttondown6 And KeyTap_PrevClick6# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed6# = Timer(0.001) - KeyTap_PrevClick6#
    End If
    If (KeyTap_buttondown7 And KeyTap_PrevClick7# <> 0) Then 'already clicked
        KeyTap_ForHowLongWasPressed7# = Timer(0.001) - KeyTap_PrevClick7#
    End If

    If KeyTap_buttondown1 = 0 And KeyTap_PrevClick1# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button1LOG_firstDetection#(MumboJumbo) = KeyTap_Button1LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button1LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button1LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button1LOG_firstDetection#(4) = KeyTap_PrevClick1#
        KeyTap_Button1LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed1#
        KeyTap_PrevClick1# = 0
    End If

    If KeyTap_buttondown2 = 0 And KeyTap_PrevClick2# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button2LOG_firstDetection#(MumboJumbo) = KeyTap_Button2LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button2LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button2LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button2LOG_firstDetection#(4) = KeyTap_PrevClick2#
        KeyTap_Button2LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed2#
        KeyTap_PrevClick2# = 0
    End If

    If KeyTap_buttondown3 = 0 And KeyTap_PrevClick3# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button3LOG_firstDetection#(MumboJumbo) = KeyTap_Button3LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button3LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button3LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button3LOG_firstDetection#(4) = KeyTap_PrevClick3#
        KeyTap_Button3LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed3#
        KeyTap_PrevClick3# = 0
    End If

    If KeyTap_buttondown4 = 0 And KeyTap_PrevClick4# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button4LOG_firstDetection#(MumboJumbo) = KeyTap_Button4LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button4LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button4LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button4LOG_firstDetection#(4) = KeyTap_PrevClick4#
        KeyTap_Button4LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed4#
        KeyTap_PrevClick4# = 0
    End If

    If KeyTap_buttondown5 = 0 And KeyTap_PrevClick5# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button5LOG_firstDetection#(MumboJumbo) = KeyTap_Button5LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button5LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button5LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button5LOG_firstDetection#(4) = KeyTap_PrevClick5#
        KeyTap_Button5LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed5#
        KeyTap_PrevClick5# = 0
    End If

    If KeyTap_buttondown6 = 0 And KeyTap_PrevClick6# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button6LOG_firstDetection#(MumboJumbo) = KeyTap_Button6LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button6LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button6LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button6LOG_firstDetection#(4) = KeyTap_PrevClick6#
        KeyTap_Button6LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed6#
        KeyTap_PrevClick6# = 0
    End If

    If KeyTap_buttondown7 = 0 And KeyTap_PrevClick7# <> 0 Then 'write to the log
        For MumboJumbo = 1 To 3
            KeyTap_Button7LOG_firstDetection#(MumboJumbo) = KeyTap_Button7LOG_firstDetection#(MumboJumbo + 1)
            KeyTap_Button7LOG_ForHowLongHolded#(MumboJumbo) = KeyTap_Button7LOG_ForHowLongHolded#(MumboJumbo + 1)
        Next
        KeyTap_Button7LOG_firstDetection#(4) = KeyTap_PrevClick7#
        KeyTap_Button7LOG_ForHowLongHolded#(4) = KeyTap_ForHowLongWasPressed7#
        KeyTap_PrevClick7# = 0
    End If

    If KeyTap_Button1LOG_firstDetection#(3) And (KeyTap_Button1LOG_firstDetection#(4) - KeyTap_Button1LOG_firstDetection#(3) < DclickTime#) Then Double_LSHIFTkey = 1 Else Double_LSHIFTkey = 0
    If KeyTap_Button1LOG_firstDetection#(2) And (KeyTap_Button1LOG_firstDetection#(4) - KeyTap_Button1LOG_firstDetection#(2) < DclickTime# * 2) Then Triple_LSHIFTkey = 1 Else Triple_LSHIFTkey = 0

    If KeyTap_Button2LOG_firstDetection#(3) And (KeyTap_Button2LOG_firstDetection#(4) - KeyTap_Button2LOG_firstDetection#(3) < DclickTime#) Then Double_LCTRLkey = 1 Else Double_LCTRLkey = 0
    If KeyTap_Button3LOG_firstDetection#(3) And (KeyTap_Button3LOG_firstDetection#(4) - KeyTap_Button3LOG_firstDetection#(3) < DclickTime#) Then Double_LALTkey = 1 Else Double_LALTkey = 0
    If KeyTap_Button4LOG_firstDetection#(3) And (KeyTap_Button4LOG_firstDetection#(4) - KeyTap_Button4LOG_firstDetection#(3) < DclickTime#) Then Double_RALTkey = 1 Else Double_RALTkey = 0

    If KeyTap_Button5LOG_firstDetection#(3) And (KeyTap_Button5LOG_firstDetection#(4) - KeyTap_Button5LOG_firstDetection#(3) < DclickTime#) Then Double_RSHIFTkey = 1 Else Double_RSHIFTkey = 0
    If KeyTap_Button6LOG_firstDetection#(3) And (KeyTap_Button6LOG_firstDetection#(4) - KeyTap_Button6LOG_firstDetection#(3) < DclickTime#) Then Double_RCTRLkey = 1 Else Double_RCTRLkey = 0

    If KeyTap_Button7LOG_firstDetection#(3) And (KeyTap_Button7LOG_firstDetection#(4) - KeyTap_Button7LOG_firstDetection#(3) < DclickTime#) Then Double_TAB = 1 Else Double_TAB = 0

    '    IF Button1LOG_firstDetection#(3) AND (Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3) < DclickTime#) THEN Double_LeftClick = 1 ELSE Double_LeftClick = 0
    '    IF Double_LeftClick = 1 THEN PRINT "Double_LeftClick detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3)) * 1000); "ms."

    '    IF Button1LOG_firstDetection#(2) AND (Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(2) < DclickTime# * 2) THEN Triple_LeftClick = 1 ELSE Triple_LeftClick = 0
    '    IF Triple_LeftClick = 1 THEN PRINT "Triple_LeftClick detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(2)) * 1000); "ms."

    '    IF Button1LOG_firstDetection#(1) AND (Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(1) < DclickTime# * 3) THEN Quadruple_LeftClick = 1 ELSE Quadruple_LeftClick = 0
    '    IF Quadruple_LeftClick = 1 THEN PRINT "Quadruple_LeftClick detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(1)) * 1000); "ms."

    'If Triple_LSHIFTkey = 1 Then
    '        Print "Triple_LSHIFTkey detected. Done in"; Int((KeyTap_Button1LOG_firstDetection#(4) - KeyTap_Button1LOG_firstDetection#(2)) * 1000); "ms."
    '        Triple_LSHIFTkey = 0
    '        For MumboJumbo = 1 To 4
    '                KeyTap_Button1LOG_firstDetection#(MumboJumbo) = 0
    '                KeyTap_Button1LOG_ForHowLongHolded#(MumboJumbo) = 0
    '        Next
    'End If

    ' keyboard mumbo-jumbo - handling of double-hits ]

    If _KeyDown(8) Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        LineScrollBenchmark = 0
        PageScrollBenchmark = 0
        If treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG + Abs(DIRorTREE_flag) = 0 Then ' Ugh, not good idea summing them since one is NOT 0 i.e. -1
            Double_LSHIFTkey = 1
        End If
    End If

    If Double_TAB = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Double_TAB = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            KeyTap_Button7LOG_firstDetection#(MumboJumbo) = 0
            KeyTap_Button7LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        crxInfo = Pos(0)
        cryInfo = CsrLin
        UpdateNextToCCL_BUSY ("Pressed 'Double_TAB'")
        '[

        SHA1flag = 1
        GoSub Double_LSHIFTkey_GOSUB

        ']
        Locate cryInfo, crxInfo, 0, CursorS, CursorE
        StatsHash$ = ":" + Str$(HashedSoFar \ 1024 \ 1024) + " MB hashed in" + Str$(ElapsedTime%) + " seconds, or" + Str$(HashedSoFar \ 1024 \ 1024 \ ElapsedTime%) + " MB/s"
        UpdateNextToCCL_DONE ("Pressed 'Double_TAB'" + StatsHash$)
        $If WINDOWS Then
            Play "v3o2l32g"
        $End If
    End If

    If Double_LSHIFTkey = 1 Then
        GoSub Double_LSHIFTkey_GOSUB
    End If

    'If Double_LCTRLkey = 1 Then
    '        LastHit~&& = EpochTime~&&: Stepping = 10
    '        Double_LCTRLkey = 0 'clear from buffer
    '        For MumboJumbo = 1 To 4
    '                KeyTap_Button2LOG_firstDetection#(MumboJumbo) = 0
    '                KeyTap_Button2LOG_ForHowLongHolded#(MumboJumbo) = 0
    '        Next
    '        crxInfo = Pos(0)
    '        cryInfo = CsrLin
    '        UpdateNextToCCL_BUSY ("Pressed 'Double_LeftCTRLkey'")
    '        _Display
    '        '[

    '        ']
    '        Locate cryInfo, crxInfo, 0, CursorS, CursorE
    '        UpdateNextToCCL_DONE ("Pressed 'Double_LeftCTRLkey'")
    '        _Display
    '        $If WINDOWS Then
    '                Play "v3o2l32g"
    '        $End If
    'End If
    If Double_LALTkey = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Double_LALTkey = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            KeyTap_Button3LOG_firstDetection#(MumboJumbo) = 0
            KeyTap_Button3LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        crxInfo = Pos(0)
        cryInfo = CsrLin
        UpdateNextToCCL_BUSY ("Pressed 'Double_LeftALTkey'")
        '[

        FullS_flag = Not FullS_flag
        If FullS_flag Then
            _FullScreen _Stretch , _Smooth
        Else
            _FullScreen Off
        End If

        ']
        LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
        UpdateNextToCCL_DONE ("Pressed 'Double_LeftALTkey'")
        $If WINDOWS Then
            Play "v3o2l32g"
        $End If
    End If
    If Double_RALTkey = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Double_RALTkey = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            KeyTap_Button4LOG_firstDetection#(MumboJumbo) = 0
            KeyTap_Button4LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        crxInfo = Pos(0)
        cryInfo = CsrLin
        UpdateNextToCCL_BUSY ("Pressed 'Double_RightALTkey'")
        '[

        ']
        LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
        UpdateNextToCCL_DONE ("Pressed 'Double_RightALTkey'")
        $If WINDOWS Then
            Play "v3o2l32g"
        $End If
    End If
    If Double_RSHIFTkey = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Double_RSHIFTkey = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            KeyTap_Button5LOG_firstDetection#(MumboJumbo) = 0
            KeyTap_Button5LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        crxInfo = Pos(0)
        cryInfo = CsrLin
        UpdateNextToCCL_BUSY ("Pressed 'Double_RightSHIFTkey'")
        '[

        '' 4 modes for now [[[
        '' TREE-mode-FILE-only with:    if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 1 then
        'DIRorTREE_flag = 0
        'treedumpPOOLFLAG = 1
        'treedumpPOOL_DIRonlyFLAG = 0
        '' TREE-mode-DIR-only with:     if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 2 then
        'DIRorTREE_flag = 0
        'treedumpPOOLFLAG = 1
        'treedumpPOOL_DIRonlyFLAG = 1
        '' DIR-mode with:               if abs(DIRorTREE_flag) = 1 then
        'DIRorTREE_flag = Not 0
        '' TREE-mode-FILE-CONTENT with: if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 0 then
        'DIRorTREE_flag = 0
        'treedumpPOOLFLAG = 0
        'treedumpPOOL_DIRonlyFLAG = 0
        '' 4 modes for now ]]]

        'Enforce always TREE-mode-DIR-only with STATS
        treedumpPOOLFLAG = 1 '        ]
        treedumpPOOL_DIRonlyFLAG = 1 ']

        _Title "Dirwalker, " + LTrim$(Str$(XdimCOL)) + "x" + LTrim$(Str$(YdimROW)) + ", revision " + revision$ + "; Directory: " + PathToEngage$
        Entries&& = 0
        PoolToHousePathS_REALsize&& = 0
        $If WINDOWS Then
            If Right$(PathToEngage$, 1) = "\" Then
            'treedumpPOOL Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&) ' bugfix in r.5+
            treedumpPOOL_DIRonly Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
            Else
            'treedumpPOOL PathToEngage$ + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&) ' bugfix in r.5+
            treedumpPOOL_DIRonly PathToEngage$ + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
            End If
        $Else
            If Right$(PathToEngage$, 1) = "/" Then
                'treedumpPOOL Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                'treedumpPOOL_FILonly Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                treedumpPOOL_DIRonly Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
            Else
                'treedumpPOOL PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                'treedumpPOOL_FILonly PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                treedumpPOOL_DIRonly PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
            End If
        $End If
        '[ Parsing 1 of 2 [
        ReDim FileArray_TREE$(1 To Entries&& + 1) '+1 to avoid alloc error when Entries&& is 0
        j = 1
        If PoolToHousePathS_REALsize&& > 0 Then
            For i = 1 To PoolToHousePathS_REALsize&& ' TO-DO: Maximum slow, speed it up...
                memcpyKAZE _Offset(Byte), MhandleXMM.OFFSET + (i - 1), 1
                FileArray_TREE$(j) = FileArray_TREE$(j) + Byte
                If Asc(Byte) = 0 Then j = j + 1
            Next
        End If
        j = j - 1
        If j = 0 Then j = 1: FileArray_TREE$(1) = " Empty List"
        FileCount_TREE = j
        FieldLineNum_TREE = Len(AddCommas$(FileCount_TREE))
        '] Parsing 1 of 2 ]

        FILTER_apply_flag = 0
        If DIRorTREE_flag <> 0 Then 'if we are in DIR i.e. NOT 0 mode then toggle
            DIRorTREE_flag = Not DIRorTREE_flag
        Else 'if we are in TREE i.e. 0 mode then remain in it
            If treedumpPOOL_DIRonlyFLAG = 1 Then DIRorTREE_flag = Not DIRorTREE_flag
        End If

        If DIRorTREE_flag Then
            FileCount = FileCount_DIR
            FieldLineNum = FieldLineNum_DIR
        Else
            FileCount = FileCount_TREE
            FieldLineNum = FieldLineNum_TREE
        End If
        GoSub INIT_WINDOW_gosub

        ']
        UpdateNextToCCL_DONE ("Pressed 'Double_RightSHIFTkey'")
        LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
    End If
    If Double_RCTRLkey = 1 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        Double_RCTRLkey = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            KeyTap_Button6LOG_firstDetection#(MumboJumbo) = 0
            KeyTap_Button6LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        crxInfo = Pos(0)
        cryInfo = CsrLin
        UpdateNextToCCL_BUSY ("Pressed 'Double_RightCTRLkey'")
        '[

        ']
        LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
        UpdateNextToCCL_DONE ("Pressed 'Double_RightCTRLkey'")
        $If WINDOWS Then
            Play "v3o2l32g"
        $End If
    End If

    If IsTILDEreleased = 1 Then ' _KeyDown(LSHIFTkey&) = 0 And _KeyDown(15616) And _KeyDown(LALTkey&) Then 'LAlt+F3released
        ' Interactive search, from the line below the INVERSE one, forward ... [
        IsTILDEreleased = 0
        LastHit~&& = EpochTime~&&: Stepping = 10
        F3pattern$ = DrawBoxShadow3exact$(3 + 1, 3, 9 + 1, 104 - 13, "`(released): Case-Insensitive Search Panel, under the INVERSE one, downward")
        _KeyClear

        Do While CurrentLine < FileCount
            ' Simulating Dn [
            'CASE 80:
            If CurrentLine < FileCount Then CurrentLine = CurrentLine + 1
            If cry < YdimROW Then
                If cry < FileCount Then cry = cry + 1 'down
            Else 'scrolling is needed
                If File_Frame_y < FileCount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
                'UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If
            ' Simulating Dn ]
            'ANIMATING [
            If cryOLD <> cry Then
                'UpdateCLine cryOLD, 1, InverseFRGr, InverseBCKGr, cryOLD
                cryOLD = cry
            End If
            UpdateWindowFrame NormalFRGr, NormalBCKGr
            UpdateCLine cryOLD, 1, InverseFRGr, InverseBCKGr, cryOLD
            UpdateCLL (CurrentLine)
            _Display
            'ANIMATING ]
            If FILTER_apply_flag = 0 Then
                If DIRorTREE_flag Then
                    TheNewCL$ = FileArray$(CurrentLine)
                Else
                    If treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG + Abs(DIRorTREE_flag) = 0 Then
                        TheNewCL$ = GetHEXline$(CurrentLine)
                    Else
                        TheNewCL$ = FileArray_TREE$(CurrentLine)
                    End If
                End If
            Else
                TheNewCL$ = FileArray_FILTERfunction$(CurrentLine)
            End If
            Needle$ = F3pattern$ + Chr$(0) ' ASCIIZ string must be
            Haystack$ = TheNewCL$ + Chr$(0)
            'If InStr(TheNewCL$, F3pattern$) Then
            If Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(Needle$), _Offset(Haystack$)) Then
                Exit Do
            Else
                If CurrentLine = FileCount Then
                    $If WINDOWS Then
                        Play "v3o2l32c"
                    $End If
                    Exit Do
                End If
            End If
            If InKey$ <> "" Then Exit Do
        Loop
        UpdateWindowFrame NormalFRGr, NormalBCKGr
        ' Interactive search, from the line below the INVERSE one, forward ... ]
        _KeyClear
    End If

    If IsSLASHreleased = 1 Then ' _KeyDown(LSHIFTkey&) = 0 And _KeyDown(15616) And _KeyDown(LALTkey&) Then 'LAlt+F3released
        IsSLASHreleased = 0
        LastHit~&& = EpochTime~&&: Stepping = 10
        'SUB DrawBoxShadow3 (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
        F3pattern$ = DrawBoxShadow3exactSLASH$(3 + 1, 3, 9 + 1, 104 - 13, "/(released): Case-Insensitive Filter Panel, only matching lines to be shown")

        crxInfo = Pos(0)
        cryInfo = CsrLin
        UpdateNextToCCL_BUSY ("Released '/'")
        '[

        If F3pattern$ = "" Then
            If DIRorTREE_flag Then
                FileCount = FileCount_DIR
                FieldLineNum = FieldLineNum_DIR
            Else
                FileCount = FileCount_TREE
                FieldLineNum = FieldLineNum_TREE
            End If
            FILTER_apply_flag = 0
        Else
            If DIRorTREE_flag Then
                'ReDim FileArray_FILTER$(1 To FileCount_DIR) ' NASTILY SLOW! Had to avoid the stupid doubling of STRING array with "pointers" i.e. indexes to the original STRING array.
                ReDim FileArray_FILTERfaster&(1 To FileCount_DIR)
                j = 0
                Needle$ = F3pattern$ + Chr$(0) ' ASCIIZ string must be
                For i = 1 To FileCount_DIR
                    'If InStr(FileArray$(i), F3pattern$) Then ' Case-Sensitive Exact Search
                    Haystack$ = FileArray$(i) + Chr$(0)
                    If Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(Needle$), _Offset(Haystack$)) Then
                        j = j + 1
                        FileArray_FILTERfaster&(j) = i
                    End If
                Next i
                'If j = 0 Then j = 1: FileArray_FILTER$(1) = " Empty List"
            Else
                'ReDim FileArray_FILTER$(1 To FileCount_TREE) ' NASTILY SLOW! Had to avoid the stupid doubling of STRING array with "pointers" i.e. indexes to the original STRING array.
                ReDim FileArray_FILTERfaster&(1 To FileCount_TREE)
                j = 0
                TimeScrollA = Timer
                Needle$ = UCase$(F3pattern$) + Chr$(0) ' ASCIIZ string must be
                NeedleSLOW$ = F3pattern$ + Chr$(0) ' ASCIIZ string must be
                IsItWildcardPattern = InStr(F3pattern$, "*") + InStr(F3pattern$, "#") ' 0 if exact
                For i = 1 To FileCount_TREE ' search only in ASCII field (and not in HEX and in OFFSET fields)
                    If treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG + Abs(DIRorTREE_flag) = 0 Then
                        Haystack$ = GetHEXlineCACHED$(i) + Chr$(0)
                        If ExactAndWildcardUnderOneROOF(IsItWildcardPattern, (Needle$), (Haystack$)) Then
                            j = j + 1
                            FileArray_FILTERfaster&(j) = i
                        Else 'try for eventual "between two lines" hit
                            ' Initially the idea was to search in vanilla lines (physical), however it was not useful, therefore searching (only if Previous and Current lines yield no hits, BOTH) into concatenated 2 lines of 64B results in no hit misses (within 128B).
                            ' That is, if two consecutive lines yield no matches then search the 128B sum
                            If i < FileCount_TREE Then
                                Haystack2$ = GetHEXlineCACHED$(i + 1) + Chr$(0)
                                If ExactAndWildcardUnderOneROOF(IsItWildcardPattern, (Needle$), (Haystack2$)) Then
                                    ' pass
                                Else
                                    HaystackDUO$ = Left$(Haystack$, 64) + Left$(Haystack2$, 64) + Chr$(0) ' TO-DO: add and the HEX fields
                                    If ExactAndWildcardUnderOneROOF(IsItWildcardPattern, (Needle$), (HaystackDUO$)) Then
                                        j = j + 1
                                        FileArray_FILTERfaster&(j) = i
                                        j = j + 1
                                        FileArray_FILTERfaster&(j) = i + 1
                                    End If
                                End If
                            End If
                        End If
                        If InKey$ = Chr$(27) Then
                            Exit For
                        End If
                        If i Mod (1024) = 0 Then
                            TimeScrollB = Timer
                            ElapsedTime% = TimeScrollB - TimeScrollA
                            If ElapsedTime% < 0 Then ElapsedTime% = (86400 - TimeScrollA) + TimeScrollB
                            If ElapsedTime% = 0 Then ElapsedTime% = 1
                            BPS = ((i * 64&&) / 1024) / ElapsedTime%
                            UpdateNextToCCL_ProgressBar i, FileCount_TREE, BPS
                        End If
                    Else
                        ' Bugfix for r.7++ [
                        Haystack$ = FileArray_TREE$(i) + Chr$(0)
                        If Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(NeedleSLOW$), _Offset(Haystack$)) Then
                            j = j + 1
                            FileArray_FILTERfaster&(j) = i
                        End If
                        ' Bugfix for r.7++ ]
                    End If
                Next i
                'If j = 0 Then j = 1: FileArray_FILTER$(1) = " Empty List"
            End If
            FileCount = j
            FileCount_FILTER = FileCount
            FieldLineNum = Len(AddCommas$(FileCount))
            FieldLineNum_FILTER = FieldLineNum
            FILTER_apply_flag = 1 ' had to deactivate it when DIR/TREE initializations
        End If
        GoSub INIT_WINDOW_gosub

        ']
        UpdateNextToCCL_DONE ("Released '/'")
        LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
    End If

    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) = 0 And _KeyDown(15616) Then 'LShift+(F3 released)
        LastHit~&& = EpochTime~&&: Stepping = 10
        Do While _KeyDown(15616): Locate , , 0: _Display: Loop
        'DO UNTIL IsF3released: LOCATE , , 0: _DISPLAY: LOOP ' doesn't work on Linux Fedora 33
        'UpdateNextToCCL_F3 MostRightField
        _Display
        If InStr(_Clipboard$, Chr$(10)) Then '_CLIPBOARD$ could be multi-line, so get the first
            a2$ = Left$(_Clipboard$, InStr(_Clipboard$, Chr$(10)) - 1)
            If Right$(a2$, 1) = Chr$(13) Then a2$ = Left$(a2$, Len(a2$) - 1)
            F3pattern$ = a2$
        Else
            F3pattern$ = _Clipboard$
        End If
        ' Interactive search, from the line below the INVERSE one, forward ... [
        Do While CurrentLine < FileCount
            ' Simulating Dn [
            'CASE 80:
            If CurrentLine < FileCount Then CurrentLine = CurrentLine + 1
            If cry < YdimROW Then
                If cry < FileCount Then cry = cry + 1 'down
            Else 'scrolling is needed
                If File_Frame_y < FileCount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
                'UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If
            ' Simulating Dn ]
            TheNewCL$ = FileArray$(CurrentLine)
            If InStr(TheNewCL$, F3pattern$) Then
                UpdateWindowFrame NormalFRGr, NormalBCKGr
                _Display
                Exit Do
            Else
                If CurrentLine = FileCount Then
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                    _Display
                    $If WINDOWS Then
                        Play "v3o2l32c"
                    $End If
                    Exit Do
                End If
            End If
        Loop

        ' Interactive search, from the line below the INVERSE one, forward ... ]
        'UpdateNextToCCL_DONE MostRightField
    End If

    If _KeyDown(LSHIFTkey&) = 0 And _KeyDown(LCTRLkey&) = 0 And _KeyDown(15616) And _KeyDown(LALTkey&) Then 'LAlt+F3released
        LastHit~&& = EpochTime~&&: Stepping = 10
        Do While _KeyDown(15616): Locate , , 0: _Display: Loop
        'DO UNTIL IsF3released: LOCATE , , 0: _DISPLAY: LOOP ' doesn't work on Linux Fedora 33
        'UpdateNextToCCL_F3 MostRightField
        _Display
        F3pattern$ = CurrentWord$

        ' Interactive search, from the line below the INVERSE one, forward ... [

        Do While CurrentLine < FileCount
            ' Simulating Dn [
            'CASE 80:
            If CurrentLine < FileCount Then CurrentLine = CurrentLine + 1
            If cry < YdimROW Then
                If cry < FileCount Then cry = cry + 1 'down
            Else 'scrolling is needed
                If File_Frame_y < FileCount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
                'UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If
            ' Simulating Dn ]
            TheNewCL$ = FileArray$(CurrentLine)
            If InStr(TheNewCL$, F3pattern$) Then
                UpdateWindowFrame NormalFRGr, NormalBCKGr
                _Display
                Exit Do
            Else
                If CurrentLine = FileCount Then
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                    _Display
                    $If WINDOWS Then
                        Play "v3o2l32c"
                    $End If
                    Exit Do
                End If
            End If
        Loop

        ' Interactive search, from the line below the INVERSE one, forward ... ]
        'UpdateNextToCCL_DONE MostRightField
    End If

    If LALT_Up = 1 Then
        'LastHit~&& = EpochTime~&&: Stepping = 10
        'If _FileExists(PSPlike$ + "Masakari.RGB") = 0 Then
        '        GoSub SetColorScheme
        '        RGB3x16$ = Space$(3 * 16)
        '        For attribute = 0 To 15
        '                Out &H3C7, attribute 'set color attribute to read
        '                red = Inp(&H3C9) 'multiply by 4 to convert intensity to 0 to 255 RGB values
        '                grn = Inp(&H3C9)
        '                blu = Inp(&H3C9)
        '                Mid$(RGB3x16$, 3 * attribute + 1, 1) = Chr$(red)
        '                Mid$(RGB3x16$, 3 * attribute + 2, 1) = Chr$(grn)
        '                Mid$(RGB3x16$, 3 * attribute + 3, 1) = Chr$(blu)
        '        Next
        'Else
        '        f00 = FreeFile
        '        Open "Masakari.RGB" For Binary As #f00
        '        RGB3x16$ = Space$(3 * 16)
        '        Get #f00, , RGB3x16$
        '        Close #f00
        '        For ii = 0 To 15
        '                _PaletteColor ii, _RGB32(Asc(Mid$(RGB3x16$, 3 * ii + 1, 1)) * 4, Asc(Mid$(RGB3x16$, 3 * ii + 2, 1)) * 4, Asc(Mid$(RGB3x16$, 3 * ii + 3, 1)) * 4)
        '        Next
        '        $If WINDOWS Then
        '                Play "v3o2l32c"
        '        $End If
        'End If

        'SimulateBlinking& = 0
        'Locate , , 0
        'rChannel% = 0
        'gChannel% = 0
        'bChannel% = 0
        'Brightness% = 0
        'GoSub UpdateColors
        'Do
        '        reentrance& = _KeyHit
        '        If reentrance& Then
        '                Select Case reentrance&
        '                        Case -114: '"r":
        '                                If rChannel% > -63 Then rChannel% = rChannel% - 1
        '                                GoSub UpdateColors
        '                                $If WINDOWS Then
        '                                        Play "v3o2l48d"
        '                                $End If
        '                        Case -82 '"R":
        '                                If rChannel% < 63 Then rChannel% = rChannel% + 1
        '                                GoSub UpdateColors
        '                                $If WINDOWS Then
        '                                        Play "v3o2l48d"
        '                                $End If
        '                        Case -103: '"g":
        '                                If gChannel% > -63 Then gChannel% = gChannel% - 1
        '                                GoSub UpdateColors
        '                                $If WINDOWS Then
        '                                        Play "v3o2l48e"
        '                                $End If
        '                        Case -71: '"G":
        '                                If gChannel% < 63 Then gChannel% = gChannel% + 1
        '                                GoSub UpdateColors
        '                                $If WINDOWS Then
        '                                        Play "v3o2l48e"
        '                                $End If
        '                        Case -98: '"b":
        '                                If bChannel% > -63 Then bChannel% = bChannel% - 1
        '                                GoSub UpdateColors
        '                                $If WINDOWS Then
        '                                        Play "v3o2l48f"
        '                                $End If
        '                        Case -66: '"B":
        '                                If bChannel% < 63 Then bChannel% = bChannel% + 1
        '                                GoSub UpdateColors
        '                                $If WINDOWS Then
        '                                        Play "v3o2l48f"
        '                                $End If
        '                        Case -105: '"i":
        '                                If Brightness% > -63 Then Brightness% = Brightness% - 1
        '                                GoSub UpdateColors
        '                                $If WINDOWS Then
        '                                        Play "v3o2l48a"
        '                                $End If
        '                        Case -73: '"I":
        '                                If Brightness% < 63 Then Brightness% = Brightness% + 1
        '                                GoSub UpdateColors
        '                                $If WINDOWS Then
        '                                        Play "v3o2l48a"
        '                                $End If
        '                        Case Else
        '                End Select
        '        End If
        '        _Limit 20: _Display: '_Delay .9
        'Loop Until reentrance& = -27
        'Do While _KeyDown(LALTkey&) Or _KeyDown(UPkey&): _Limit 10: Loop ' to avoid flickering i.e. reentrance
        'UpdateWindowFrame NormalFRGr, NormalBCKGr
        '_Display
    End If

    If LALT_Down = 1 Then
        'LastHit~&& = EpochTime~&&: Stepping = 10
        ''GoSub UpdateColorSchemeFile
        'ReDim red(0 To 15)
        'ReDim grn(0 To 15)
        'ReDim blu(0 To 15)
        'For attribute = 0 To 15
        '        Out &H3C7, attribute 'set color attribute to read
        '        red = Inp(&H3C9) * 4 'multiply by 4 to convert intensity to 0 to 255 RGB values
        '        grn = Inp(&H3C9) * 4
        '        blu = Inp(&H3C9) * 4
        '        red(attribute) = red
        '        grn(attribute) = grn
        '        blu(attribute) = blu
        'Next
        ''Sepiascale
        ''outputRed = (inputRed * .393) + (inputGreen * .769) + (inputBlue * .189)
        ''outputGreen = (inputRed * .349) + (inputGreen * .686) + (inputBlue * .168)
        ''outputBlue = (inputRed * .272) + (inputGreen * .534) + (inputBlue * .131)
        'For i = 0 To 15
        '        'Sepiascale
        '        _PaletteColor i, _RGB32(Int(red(i) * .393) + Int(grn(i) * .769) + Int(blu(i) * .189), Int(red(i) * .349) + Int(grn(i) * .686) + Int(blu(i) * .168), Int(red(i) * .272) + Int(grn(i) * .534) + Int(blu(i) * .131))
        '        'Greyscale
        '        _PaletteColor i, _RGB32((red(i) + grn(i) + blu(i)) \ 3, (red(i) + grn(i) + blu(i)) \ 3, (red(i) + grn(i) + blu(i)) \ 3)
        '        'Amberscale
        'Next
        'For i = 1 To 6
        '        Dummy$ = DrawBoxShadowDUMMY$(i, 2 + (i - 1) * 6, 2, 6 + (i - 1) * 6, 116, "Dummy window with background color" + Str$(i))
        'Next
        'Locate , , 0
        'Do While InKey$ = ""
        '        SimulateBlinking& = Not SimulateBlinking&
        '        If SimulateBlinking& = 0 Then
        '                Locate 38, 2: Color 0, 7: Print "Note1: File 'Masakari.RGB' has NOT been updated with current (before Greyscaling) color settings.";
        '                Locate 39, 2: Color 0, 7: Print "Note2: In order to have your own color scheme, you can manually change the values of 'Masakari.RGB' (3x16 bytes long).";
        '        Else
        '                'Locate 38, 2: Color 15, 7: Print "Note1: File 'Masakari.RGB' has been updated with current (before Greyscaling) color settings.";
        '                'Locate 39, 2: Color 15, 7: Print "Note2: In order to have your own color scheme, you can manually change the values of 'Masakari.RGB' (3x16 bytes long).";
        '        End If
        '        _Limit 20: _Display: '_Delay .9
        'Loop
        'Do While _KeyDown(LALTkey&) Or _KeyDown(DOWNkey&): _Limit 10: Loop ' to avoid flickering i.e. reentrance
        'UpdateWindowFrame NormalFRGr, NormalBCKGr
        '_Display
    End If

    If LSHIFT_RSHIFT Or LineScrollBenchmark = 1 Then 'same as scroll page-by-page benchmark, but line-by-line
        LastHit~&& = EpochTime~&&: Stepping = 10
        If LineScrollBenchmark = 0 Then TimeScrollA = Timer
        LineScrollBenchmark = 1
        'PgDn - just add the page height i.e. 'YdimROW' to 'File_Frame_y'
        ' Don't execute PgDn (advancing the 'CurrentLine') if 'File_Frame_y' is not "eligible":
        'IF File_Frame_y < filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
        'IF File_Frame_y + 1 <= filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
        'CAUTION [
        ' Next three line beep NOT
        'DEFLNG A-Z
        'aaa = 61
        'bbb = -48
        'IF aaa <= bbb THEN BEEP: END
        'Next three line beep
        'aaa~& = 61
        'bbb~& = -48
        'IF aaa~& <= bbb~& THEN BEEP: END
        'Next three line beep NOT
        'aaa& = 61
        'bbb& = -48
        'IF aaa& <= bbb& THEN BEEP: END
        'Next line works even when unsigned!
        'IF File_Frame_y + YdimROW - (filecount - (YdimROW - 1)) <= 0 THEN
        'CAUTION ]
        'Next line doesn't work when unsigned!
        If File_Frame_y + 1 <= FileCount - (YdimROW - 1) Then
            File_Frame_y = File_Frame_y + 1
            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
            If CurrentLine + 1 <= FileCount Then CurrentLine = CurrentLine + 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        Else
            If LineScrollBenchmark = 1 Then
                TimeScrollB = Timer
                _KeyClear
                ReportTimeToScroll
                LineScrollBenchmark = 0
                _Display
            End If
        End If
    End If

    ' Esc  F1  F2  F3  F4  F5  F6  F7  F8  F9  F10  F11  F12  Sys ScL Pause
    '  27 +59 +60 +61 +62 +63 +64 +65 +66 +67 +68  +133 +134   -   -    -
    ' `~  1!  2@  3#  4$  5%  6^  7&  8*  9(  0) -_ =+ BkSp   Ins Hme PUp   NumL  /   *    -
    ' 126 33  64  35  36  37  94  38  42  40  41 95 43   8    +82 +71 +73    -    47  42   45
    '  96 49  50  51  52  53  54  55  56  57  48 45 61
    ' Tab Q   W   E   R   T   Y   U   I   O   P  [{  ]}  \|   Del End PDn   7Hme 8/  9PU  +
    '  9  81  87  69  82  84  89  85  73  79  80 123 125 124  +83 +79 +81   +71  +72  +73  43
    '    113 119 101 114 116 121 117 105 111 112  91  93  92                 55   56   57
    ' CapL  A   S   D   F   G   H   J   K   L   ;:  '" Enter                4/-  5   6/-
    '   -   65  83  68  70  71  72  74  75  76  58  34  13                  +75  +76  +77  E
    '       97 115 100 102 103 104 106 107 108  59  39                       52   53   54  n
    '
    ' Shift  Z   X   C   V   B   N   M   ,<  .>  /?    Shift               1End 2/  3PD  t
    '   *    90  88  67  86  66  78  77  60  62  63      *        +72       +79  +80  +81  e
    '       122 120  99 118  98 110 109  44  46  47                          49   50   51  r
    ' Ctrl Win Alt       Spacebar          Alt Win Menu Ctrl   -     -   0Ins     .Del
    '  *    -   *           32              *   -   -    *    +75 +80 +77   +82       +83  13
    '                                                                        48        46
    '
    '     Italics = LCase/NumLock On  ____________  + = 2 Byte: CHR$(0) + CHR$(code)
    'NOTE: The above commented table can be copied and pasted directly into the QB64 IDE

    key$ = InKey$
    'DO: a$ = INKEY$: LOOP UNTIL a$ <> "" ' prevent ASC empty string read error
    If key$ <> "" Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        code% = Asc(key$):
        If code% Then ' ASC returns any value greater than 0
            Select Case Asc(key$)
                Case 32:
                    'a$ = RTrim$(FileArray$(CurrentLine))
                    'If _FileExists(a$) Then
                    '    'Close #1
                    '    '_MemFree MhandleOFF
                    '    '_MemFree MhandleLEN
                    '    'If ToLoadOrNotFlag Then
                    '    '        _MemFree Mwholefile
                    '    'End If
                    '    'GoTo GettingStarted 'Before going above lines must be executed, i.e. to initialize.
                    'End If
                Case 65 TO 97: 'PRINT key$;
                Case Asc("a") TO Asc("z"): 'PRINT key$;
                    'CASE 27: COLOR 7, 0: SYSTEM 'END
            End Select
        Else
            If Len(key$) > 1 Then
                Select Case Asc(key$, 2)
                    Case 59:
                        'Locate 1, 1, 0, CursorS, CursorE
                        'For i = 1 To YdimROW
                        '        Locate i, 1: Print Space$(XdimCOL);
                        'Next
                        'Locate 1, 1
                        'ShowF1
                        'Print "Press ESC...";
                        '_Display
                        '$If WINDOWS Then
                        '        Play "v3o2l32g"
                        '$End If
                        'Do While InKey$ <> Chr$(27)
                        '        _Limit 10
                        '        _Display 'in order to not having frozen screen
                        'Loop
                        'UpdateWindowFrame NormalFRGr, NormalBCKGr
                    Case 133: 'f11

                    Case 134: 'f12

                    Case 72:
                        If CurrentLine > 1 Then CurrentLine = CurrentLine - 1
                        If cry > 1 Then
                            cry = cry - 1 'up
                        Else 'scrolling is needed
                            If File_Frame_y > 1 Then File_Frame_y = File_Frame_y - 1
                            UpdateWindowFrame NormalFRGr, NormalBCKGr
                        End If
                    Case 80:
                        If CurrentLine < FileCount Then CurrentLine = CurrentLine + 1
                        If cry < YdimROW Then
                            If cry < FileCount Then cry = cry + 1 'down
                        Else 'scrolling is needed
                            If File_Frame_y < FileCount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
                            UpdateWindowFrame NormalFRGr, NormalBCKGr
                        End If
                    Case 75: If crx > 1 Then crx = crx - 1 'left
                    Case 77: If crx < XdimCOL Then crx = crx + 1 'right
                    Case 73: 'PgUp
                        If File_Frame_y - YdimROW >= 1 Then
                            File_Frame_y = File_Frame_y - YdimROW
                            If CurrentLine - YdimROW >= 1 Then CurrentLine = CurrentLine - YdimROW
                            UpdateWindowFrame NormalFRGr, NormalBCKGr
                        End If
                    Case 81: 'PgDn
                        If File_Frame_y + YdimROW <= FileCount - (YdimROW - 1) Then
                            File_Frame_y = File_Frame_y + YdimROW
                            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
                            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
                            If CurrentLine + YdimROW <= FileCount Then CurrentLine = CurrentLine + YdimROW
                            UpdateWindowFrame NormalFRGr, NormalBCKGr
                        End If
                End Select
            End If
        End If
    End If
    If cryOLD <> cry Then
        UpdateCLine cryOLD, 1, NormalFRGr, NormalBCKGr, cryOLD
        cryOLD = cry
    Else 'it 'cry' could be changed by Mouse Wheel too, check it
        AsIfItIsINKEY% = _MouseInput '      Check the mouse status
        'WHILE _MOUSEINPUT: WEND '2021-Apr-23
        If AsIfItIsINKEY% Then
            buttondown1 = _MouseButton(1)
            buttondown2 = _MouseButton(2)
            buttondown3 = _MouseButton(3)
            mwheel = _MouseWheel
        End If

        If IsF10released_Flag Then
            'LastHit~&& = EpochTime~&&: Stepping = 10
            'UpdateCLineHIGHLIGHTword cry, 1, InverseFRGr, InverseBCKGr, cry
            'Locate 1, 1, 0, CursorS, CursorE: _Display 'adding refresh in order to get rid of eventual cursor (caught as visible while blinking)
            'Color 9, 0
            'Call dict03sub
            '_KeyClear 2
            'UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If

        If IsF11released_Flag Then
            'LastHit~&& = EpochTime~&&: Stepping = 10
            'UpdateCLineHIGHLIGHTword cry, 1, InverseFRGr, InverseBCKGr, cry
            'Locate 1, 1, 0, CursorS, CursorE: _Display 'adding refresh in order to get rid of eventual cursor (caught as visible while blinking)
            'Color 9, 0
            'Call dict02sub
            '_KeyClear 2
            'UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If

        If IsF12released_Flag Then
            'LastHit~&& = EpochTime~&&: Stepping = 10
            'UpdateCLineHIGHLIGHTword cry, 1, InverseFRGr, InverseBCKGr, cry
            'Locate 1, 1, 0, CursorS, CursorE: _Display 'adding refresh in order to get rid of eventual cursor (caught as visible while blinking)
            'Color 9, 0
            'Call dict01sub
            '_KeyClear 2
            'UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If

        If _KeyDown(LSHIFTkey&) Or _KeyDown(LCTRLkey&) Or _KeyDown(LALTkey&) Then ShutDownIsNoLonger = 1: ShutDownIsNoLongerR = 1 ' do not forget there are key+button shortcuts

        If (buttondown1 And PrevClick1# = 0) Then 'first detection of the click
            PrevClick1# = Timer(0.001)
            SaveMouseX2 = MouseXfun%
            SaveMouseY2 = MouseYfun%
            ShutDownIsNoLonger = 0
        End If

        If (buttondown2 And PrevClick2# = 0) Then 'first detection of the click
            PrevClick2# = Timer(0.001)
            SaveMouseXR = MouseXfun%
            SaveMouseYR = MouseYfun%
            ShutDownIsNoLongerR = 0
        End If

        If (buttondown1 And PrevClick1# <> 0) Then 'already clicked
            ForHowLongWasPressed1# = Timer(0.001) - PrevClick1#
            If (SaveMouseX2 <> MouseXfun%) Or (SaveMouseY2 <> MouseYfun%) Then ShutDownIsNoLonger = 1
        End If

        If (buttondown2 And PrevClick2# <> 0) Then 'already clicked
            ForHowLongWasPressed2# = Timer(0.001) - PrevClick2#
            If (SaveMouseXR <> MouseXfun%) Or (SaveMouseYR <> MouseYfun%) Then ShutDownIsNoLongerR = 1
        End If

        If buttondown1 = 0 And PrevClick1# <> 0 Then 'write to the log
            For MumboJumbo = 1 To 3
                Button1LOG_firstDetection#(MumboJumbo) = Button1LOG_firstDetection#(MumboJumbo + 1)
                Button1LOG_ForHowLongHolded#(MumboJumbo) = Button1LOG_ForHowLongHolded#(MumboJumbo + 1)
            Next
            Button1LOG_firstDetection#(4) = PrevClick1#
            Button1LOG_ForHowLongHolded#(4) = ForHowLongWasPressed1#
            PrevClick1# = 0
        End If

        If buttondown2 = 0 And PrevClick2# <> 0 Then 'write to the log
            For MumboJumbo = 1 To 3
                Button2LOG_firstDetection#(MumboJumbo) = Button2LOG_firstDetection#(MumboJumbo + 1)
                Button2LOG_ForHowLongHolded#(MumboJumbo) = Button2LOG_ForHowLongHolded#(MumboJumbo + 1)
            Next
            Button2LOG_firstDetection#(4) = PrevClick2#
            Button2LOG_ForHowLongHolded#(4) = ForHowLongWasPressed2#
            PrevClick2# = 0
        End If

        If Button1LOG_firstDetection#(3) And (Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3) < DclickTime#) Then
            If ScrollbarFlag <> 1 And RibbonFlag <> 1 Then Double_LeftClick = 1 'in r6 we need Scrollbar to be DLC free, in r6+ Ribbonbar also
        Else
            Double_LeftClick = 0
        End If
        'IF Double_LeftClick = 1 THEN PRINT "Double_LeftClick detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3)) * 1000); "ms."

        If Button2LOG_firstDetection#(3) And (Button2LOG_firstDetection#(4) - Button2LOG_firstDetection#(3) < DclickTime#) Then Double_RightClick = 1 Else Double_RightClick = 0
        'IF Double_LeftClick = 1 THEN PRINT "Double_LeftClick detected. Done in"; INT((Button1LOG_firstDetection#(4) - Button1LOG_firstDetection#(3)) * 1000); "ms."

        If ScrollbarFlag <> 1 And RibbonFlag <> 1 Then ' don't wanna incidental exits during scrolling
            If (ForHowLongWasPressed1# > ShutDownDuration#) And (ShutDownIsNoLonger = 0) Then 'the pointer should not be moved (in perfect case), inhere should be as the pointer during the initial click
                ShutDownIsNoLonger = 1
                UpdateNextToCCL_BUSY "Terminating...": System
            End If
        End If

        If (ForHowLongWasPressed2# > ShutDownDuration#) And (ShutDownIsNoLongerR = 0) Then 'the pointer should not be moved (in perfect case), inhere should be as the pointer during the initial click
            ShutDownIsNoLongerR = 1
            buttondown2 = 0
            'add some common task here, mapped onto held Button2

            '' 4 modes for now [[[
            '' TREE-mode-FILE-only with:    if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 1 then
            'DIRorTREE_flag = 0
            'treedumpPOOLFLAG = 1
            'treedumpPOOL_DIRonlyFLAG = 0
            '' TREE-mode-DIR-only with:     if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 2 then
            'DIRorTREE_flag = 0
            'treedumpPOOLFLAG = 1
            'treedumpPOOL_DIRonlyFLAG = 1
            '' DIR-mode with:               if abs(DIRorTREE_flag) = 1 then
            'DIRorTREE_flag = Not 0
            '' TREE-mode-FILE-CONTENT with: if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 0 then
            'DIRorTREE_flag = 0
            'treedumpPOOLFLAG = 0
            'treedumpPOOL_DIRonlyFLAG = 0
            '' 4 modes for now ]]]

            'Enforce always TREE-mode-FILE-only with STATS
            DIRorTREE_flag = Not 0 '      ] This line will be NEGATED/reversed
            treedumpPOOLFLAG = 1 '        ]
            treedumpPOOL_DIRonlyFLAG = 0 ']

            ' The same as DoubleLeftShift [[
            LastHit~&& = EpochTime~&&: Stepping = 10
            Double_LSHIFTkey = 0 'clear from buffer
            For MumboJumbo = 1 To 4
                KeyTap_Button1LOG_firstDetection#(MumboJumbo) = 0
                KeyTap_Button1LOG_ForHowLongHolded#(MumboJumbo) = 0
            Next
            crxInfo = Pos(0)
            cryInfo = CsrLin
            UpdateNextToCCL_BUSY ("Held 'RightButton' for 4 seconds")
            '[

            _Title "Dirwalker, " + LTrim$(Str$(XdimCOL)) + "x" + LTrim$(Str$(YdimROW)) + ", revision " + revision$ + "; Directory: " + PathToEngage$
            Entries&& = 0
            PoolToHousePathS_REALsize&& = 0
            $If WINDOWS Then
                If Right$(PathToEngage$, 1) = "\" Then
                treedumpPOOL Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&) ' bugfix in r.5+
                'treedumpPOOL_DIRonly Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                Else
                treedumpPOOL PathToEngage$ + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&) ' bugfix in r.5+
                'treedumpPOOL_DIRonly PathToEngage$ + Chr$(0), 0,  Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                End If
            $Else
                If Right$(PathToEngage$, 1) = "/" Then
                    treedumpPOOL Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                    'treedumpPOOL_FILonly Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                    'treedumpPOOL_DIRonly Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                Else
                    treedumpPOOL PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                    'treedumpPOOL_FILonly PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                    'treedumpPOOL_DIRonly PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                End If
            $End If
            '[ Parsing 1 of 2 [
            ReDim FileArray_TREE$(1 To Entries&& + 1) '+1 to avoid alloc error when Entries&& is 0
            j = 1
            If PoolToHousePathS_REALsize&& > 0 Then
                For i = 1 To PoolToHousePathS_REALsize&& ' TO-DO: Maximum slow, speed it up...
                    memcpyKAZE _Offset(Byte), MhandleXMM.OFFSET + (i - 1), 1
                    FileArray_TREE$(j) = FileArray_TREE$(j) + Byte
                    If Asc(Byte) = 0 Then j = j + 1
                Next
            End If
            j = j - 1
            If j = 0 Then j = 1: FileArray_TREE$(1) = " Empty List"
            FileCount_TREE = j
            FieldLineNum_TREE = Len(AddCommas$(FileCount_TREE))
            '] Parsing 1 of 2 ]

            FILTER_apply_flag = 0
            If DIRorTREE_flag <> 0 Then 'if we are in DIR i.e. NOT 0 mode then toggle
                DIRorTREE_flag = Not DIRorTREE_flag
            Else 'if we are in TREE i.e. 0 mode then remain in it
                If treedumpPOOLFLAG = 1 Then DIRorTREE_flag = Not DIRorTREE_flag
            End If
            treedumpPOOLFLAG = 1
            treedumpPOOL_DIRonlyFLAG = 0

            If DIRorTREE_flag Then
                FileCount = FileCount_DIR
                FieldLineNum = FieldLineNum_DIR
            Else
                FileCount = FileCount_TREE
                FieldLineNum = FieldLineNum_TREE
            End If
            GoSub INIT_WINDOW_gosub

            If DIRorTREE_flag Or YdimROW < 48 Then '48 in order to house all the 44 extensions
                ' don't show in DIR mode
            Else
                'For i = 1 To 6
                '        Dummy$ = DrawBoxShadowDUMMY$(i, 2 + (i - 1) * 6, 2, 6 + (i - 1) * 6, 116, "Dummy window with background color" + Str$(i))
                'Next
                DrawBoxShadowINFO 2, 3, 3, 46, 65, "Popular File Types Statistics (within the whole list)"
                For k = 1 To 40
                    j = 0: g = 0
                    For i = 1 To FileCount_TREE
                        Needle$ = PopularFormats$(k) + Chr$(0) ' ASCIIZ string must be
                        'Haystack$ = FileArray_TREE$(i) + Chr$(0) ' This is for 'treedumpPOOL_FILonly'
                        PointPart = InStr(FileArray_TREE$(i), ":") + 8
                        Haystack$ = Mid$(FileArray_TREE$(i), PointPart, Len(FileArray_TREE$(i)) - (PointPart - 1)) + Chr$(0) ' This is for 'treedumpPOOL'
                        If Tcheburaschka_Wildcard_CaseInsensitive%(_Offset(Needle$), _Offset(Haystack$)) Then
                            j = j + 1
                            f01 = FreeFile
                            Open Left$(Haystack$, Len(Haystack$) - 1) For Input As #f01
                            g = g + LOF(f01)
                            Close #f01
                        End If
                    Next i
                    LocateTextGraphCursor 3 + 2 + (k - 1), 5, 0, CursorS, CursorE
                    Color 11 - 4 * (k Mod 2), 2 '5
                    Print "Found "; Space$(12 - Len(AddCommas$(j))) + AddCommas$(j) + " "; Space$(6 - Len(PopularFormats$(k))) + PopularFormats$(k); " files in "; Space$(18 - Len(AddCommas$(g))) + AddCommas$(g); " bytes";
                Next
                LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
                UpdateNextToCCL_DONE ("Held 'RightButton' for 4 seconds")
                Do While InKey$ <> "": Loop
                While _MouseInput: Wend
                Do
                    infoExists%% = _MouseInput
                    If _MouseButton(1) = -1 Or _MouseButton(3) = -1 Or _MouseWheel Or InKey$ <> "" Then Exit Do
                Loop
                GoSub INIT_WINDOW_gosub
            End If

            ']
            UpdateNextToCCL_DONE ("Held 'RightButton' for 4 seconds")
            LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
            ' The same as DoubleLeftShift ]]
        End If
    End If

    If (_KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) = 0) And buttondown1 Then 'Fast Up
        LastHit~&& = EpochTime~&&: Stepping = 10
        If CurrentLine > 1 Then CurrentLine = CurrentLine - 1
        If cry > 1 Then
            cry = cry - 1 'up
        Else 'scrolling is needed
            If File_Frame_y > 1 Then File_Frame_y = File_Frame_y - 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        'UpdateNextToCCL_DONE ("Clicked 'Button1' + LSHIFT")
    End If

    If (_KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) = 0) And buttondown2 Then 'Fast Down
        LastHit~&& = EpochTime~&&: Stepping = 10
        If CurrentLine < FileCount Then CurrentLine = CurrentLine + 1
        If cry < YdimROW Then
            If cry < FileCount Then cry = cry + 1 'down
        Else 'scrolling is needed
            If File_Frame_y < FileCount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        'UpdateNextToCCL_DONE ("Clicked 'Button2' + LSHIFT")
    End If

    ' LALTkey is used in Linux, so replaced by LCTRLkey+LSHIFTkey
    If (_KeyDown(LCTRLkey&) And _KeyDown(LSHIFTkey&)) And buttondown1 Then 'LCTRL_HOME
        LastHit~&& = EpochTime~&&: Stepping = 10
        LCTRL_HOME = 1
        'UpdateNextToCCL_DONE ("Clicked 'Button1' + LCTRL + LSHIFT")
    End If
    If (_KeyDown(LCTRLkey&) And _KeyDown(LSHIFTkey&)) And buttondown2 Then 'LCTRL_END
        LastHit~&& = EpochTime~&&: Stepping = 10
        LCTRL_END = 1
        'UpdateNextToCCL_DONE ("Clicked 'Button2' + LCTRL + LSHIFT")
    End If

    If (_KeyDown(LCTRLkey&) And _KeyDown(LSHIFTkey&) = 0) And buttondown1 Then 'Fast PgUp
        LastHit~&& = EpochTime~&&: Stepping = 10
        If File_Frame_y - YdimROW >= 1 Then
            File_Frame_y = File_Frame_y - YdimROW
            If CurrentLine - YdimROW >= 1 Then CurrentLine = CurrentLine - YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        'UpdateNextToCCL_DONE ("Clicked 'Button1' + LCTRL")
    End If

    If (_KeyDown(LCTRLkey&) And _KeyDown(LSHIFTkey&) = 0) And buttondown2 Then 'Fast PgDn, grmbl, for some reason (LShift+button3) and (LShift+button1) are not spitting?!
        LastHit~&& = EpochTime~&&: Stepping = 10
        If File_Frame_y + YdimROW <= FileCount - (YdimROW - 1) Then
            File_Frame_y = File_Frame_y + YdimROW
            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
            If CurrentLine + YdimROW <= FileCount Then CurrentLine = CurrentLine + YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        'UpdateNextToCCL_DONE ("Clicked 'Button2' + LCTRL")
    End If

    If mwheel = 1 And buttondown2 = 0 Then ' as if Down
        LastHit~&& = EpochTime~&&: Stepping = 10
        If CurrentLine < FileCount Then CurrentLine = CurrentLine + 1
        If cry < YdimROW Then
            If cry < FileCount Then cry = cry + 1 'down
        Else 'scrolling is needed
            If File_Frame_y < FileCount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
    End If
    If mwheel = -1 And buttondown2 = 0 Then ' as if Up
        LastHit~&& = EpochTime~&&: Stepping = 10
        If CurrentLine > 1 Then CurrentLine = CurrentLine - 1
        If cry > 1 Then
            cry = cry - 1 'up
        Else 'scrolling is needed
            If File_Frame_y > 1 Then File_Frame_y = File_Frame_y - 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
    End If
    If (_KeyDown(LSHIFTkey&) = 0) And buttondown1 And ScrollbarFlag = 0 Then
        If RightsidePanelFlag = -1 And (MouseXfun% > XdimCOL And MouseXfun% <= XdimCOL + 45) Then 'if Rightside panel is shown
        Else
            LastHit~&& = EpochTime~&&: Stepping = 10
            crxOLD = crx
            cryOLD = cry
            If MouseYfun% <= MIN&(YdimROW, FileCount) Then
                cry = MouseYfun%
                crx = MouseXfun%
                UpdateCLine cryOLD, 1, NormalFRGr, NormalBCKGr, cryOLD
                Do While cryOLD > cry
                    cryOLD = cryOLD - 1
                    If CurrentLine > 1 Then CurrentLine = CurrentLine - 1
                Loop
                Do While cryOLD < cry
                    cryOLD = cryOLD + 1
                    If CurrentLine < FileCount Then CurrentLine = CurrentLine + 1
                Loop
            End If
        End If
    End If

    'If (mwheel = -1) And buttondown1 Then ' same as LCTRL_HOME
    '        LastHit~&& = EpochTime~&&: Stepping = 10
    '        UpdateNextToCCL_DONE ("Clicked 'Button1' + WheelUp")
    '        LCTRL_HOME = 1
    '        ShutDownIsNoLonger = 1
    'End If
    'If (mwheel = 1) And buttondown1 Then ' same as LCTRL_END
    '        LastHit~&& = EpochTime~&&: Stepping = 10
    '        UpdateNextToCCL_DONE ("Clicked 'Button1' + WheelDn")
    '        LCTRL_END = 1
    '        ShutDownIsNoLonger = 1
    'End If

    If (mwheel = -1) And buttondown2 Then ' same as PgUp
        LastHit~&& = EpochTime~&&: Stepping = 10
        UpdateNextToCCL_DONE ("Clicked 'Button2' + WheelUp")
        If File_Frame_y - YdimROW >= 1 Then
            File_Frame_y = File_Frame_y - YdimROW
            If CurrentLine - YdimROW >= 1 Then CurrentLine = CurrentLine - YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
    End If
    If (mwheel = 1) And buttondown2 Then ' same as PgDn
        LastHit~&& = EpochTime~&&: Stepping = 10
        UpdateNextToCCL_DONE ("Clicked 'Button2' + WheelDn")
        If File_Frame_y + YdimROW <= FileCount - (YdimROW - 1) Then
            File_Frame_y = File_Frame_y + YdimROW
            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
            If CurrentLine + YdimROW <= FileCount Then CurrentLine = CurrentLine + YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
    End If

    If buttondown2 Then ' 'drawing a line' gesture - 100 cells at least long, COMBO: Alt+X, Alt+Q
        LastHit~&& = EpochTime~&&: Stepping = 10
        ReadOnceY = MouseYfun%
        ReadOnceX = MouseXfun%
        If Button2Down = 0 Then Mouse2Press! = Timer: Button2Down = 1
        If WidenessINIT = 0 Then WidenessINIT = ReadOnceX
        If HighnessINIT = 0 Then HighnessINIT = ReadOnceY
        If ReadOnceY < YdimROW + 1 Then LocateTextGraphCursor ReadOnceY, ReadOnceX, 0, CursorS, CursorE: Print Chr$(176); 'don't write trail in status line
    Else
        Button2Down = 0
        Mouse2Release! = Timer
        If WidenessINIT And (Mouse2Release! - Mouse2Press! > 0 And Mouse2Release! - Mouse2Press! < 2) Then
            If Abs(MouseXfun% - WidenessINIT) >= XdimCOL * 3 / 4 Then System 'Play "v3o2l8g" 'bidirectional i.e. can be drawn from left to right and vice versa
            If Abs(MouseXfun% - WidenessINIT) >= XdimCOL * 1 / 4 Then
                If MouseXfun% > WidenessINIT Then
                    If RightsidePanelFlag = -1 Then ShowRightsidePanel = -1
                End If
                If MouseXfun% < WidenessINIT Then
                    If RightsidePanelFlag = 0 And YdimROW >= 48 Then ShowRightsidePanel = 1 'don't show Rightside panel if no enough canvas
                End If
            End If
            WidenessINIT = 0
        End If

        'simulate PgDn (from bottom to top, as the hand cursor in PhotoShop), but not repetitive i.e. not-buffered
        If HighnessINIT And (Mouse2Release! - Mouse2Press! > 0 And Mouse2Release! - Mouse2Press! < 2) Then
            If (HighnessINIT - MouseYfun%) + 1 >= 7 Then 'Play "v3o2l8g"

                If File_Frame_y + YdimROW <= FileCount - (YdimROW - 1) Then
                    File_Frame_y = File_Frame_y + YdimROW
                    'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
                    'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
                    If CurrentLine + YdimROW <= FileCount Then CurrentLine = CurrentLine + YdimROW
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                End If
                ' Here is the layout:
                ' The window-frame is 1..crx or 1..128 |  The file-frame is 1..LongestLine
                '                     .         .      |                    .
                '                     .         .      |                    .
                '                     cry       60     |                    filecount
                '              FileArrayWINDOW$(60)    |          FileArray(filecount)
                ' if File_Frame_x < 128 then PADDING to 128 else File_Frame_x = 1..LongestLine-(128-1)
                ' if File_Frame_y < 60 then PADDING to 60 else File_Frame_y = 1..filecount-(60-1)

            End If
        End If
        'simulate PgUp (from top to bottom, as the hand cursor in PhotoShop), but not repetitive i.e. not-buffered
        If HighnessINIT And (Mouse2Release! - Mouse2Press! > 0 And Mouse2Release! - Mouse2Press! < 2) Then
            If (MouseYfun% - HighnessINIT) + 1 >= 7 Then 'Play "v3o2l8g"

                If File_Frame_y - YdimROW >= 1 Then
                    File_Frame_y = File_Frame_y - YdimROW
                    If CurrentLine - YdimROW >= 1 Then CurrentLine = CurrentLine - YdimROW
                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                End If

            End If
        End If
        HighnessINIT = 0
    End If

    If LCTRL_RCTRL Then PageScrollBenchmark = 1: TimeScrollA = Timer
    'If buttondown3 Or PageScrollBenchmark Then 'PgDn - just add the page height i.e. 'YdimROW' to 'File_Frame_y'
    If PageScrollBenchmark Then 'PgDn - just add the page height i.e. 'YdimROW' to 'File_Frame_y'
        ' Hell, on Fedora 36, holding Button1 and Button2 together is registered as Button3 only?!
        LastHit~&& = EpochTime~&&: Stepping = 10
        ' Don't execute PgDn (advancing the 'CurrentLine') if 'File_Frame_y' is not "eligible":
        'IF File_Frame_y < filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
        'IF File_Frame_y + 1 <= filecount - (YdimROW - 1) THEN File_Frame_y = File_Frame_y + 1
        'CAUTION [
        ' Next three line beep NOT
        'DEFLNG A-Z
        'aaa = 61
        'bbb = -48
        'IF aaa <= bbb THEN BEEP: END
        'Next three line beep
        'aaa~& = 61
        'bbb~& = -48
        'IF aaa~& <= bbb~& THEN BEEP: END
        'Next three line beep NOT
        'aaa& = 61
        'bbb& = -48
        'IF aaa& <= bbb& THEN BEEP: END
        'Next line works even when unsigned!
        'IF File_Frame_y + YdimROW - (filecount - (YdimROW - 1)) <= 0 THEN
        'CAUTION ]
        'Next line doesn't work when unsigned!
        If File_Frame_y + YdimROW <= FileCount - (YdimROW - 1) Then
            File_Frame_y = File_Frame_y + YdimROW
            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
            If CurrentLine + YdimROW <= FileCount Then CurrentLine = CurrentLine + YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
            _Display
        Else
            If PageScrollBenchmark = 1 Then
                TimeScrollB = Timer
                _KeyClear
                ReportTimeToScroll
                PageScrollBenchmark = 0
                _Display
            End If
        End If
    End If

    If cryOLD <> cry Then
        UpdateCLine cryOLD, 1, NormalFRGr, NormalBCKGr, cryOLD
        cryOLD = cry
    End If

    If LCTRL_HOME Or RCTRL_HOME Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
        crx = Pos(0)
        cry = CsrLin
        crxOLD = crx
        cryOLD = cry
        File_Frame_x = 1
        File_Frame_y = 1
        CurrentLine = 1
        UpdateWindowFrame NormalFRGr, NormalBCKGr
        'DO WHILE _MOUSEINPUT: LOOP
    End If
    If LCTRL_END Or RCTRL_END Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        If FileCount >= YdimROW Then
            If FileCount - (YdimROW - 1) Then
                LocateTextGraphCursor YdimROW, 1, 0, CursorS, CursorE
                crx = Pos(0)
                cry = CsrLin
                crxOLD = crx
                cryOLD = cry
                File_Frame_x = 1
                File_Frame_y = FileCount - (YdimROW - 1)
                CurrentLine = FileCount
                If CurrentLine = 0 Then CurrentLine = 1 ' kinda bugfix, when 'Empty List' we simulate having 1 line
                UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If
        Else
            ' FileCount/FileCount_FILTER could be 0, only with FileArray_FILTERfunction$(), must be handled
            If FileCount = 0 Then
                LocateTextGraphCursor FileCount + 1, 1, 0, CursorS, CursorE
            Else
                LocateTextGraphCursor FileCount, 1, 0, CursorS, CursorE
            End If
            crx = Pos(0)
            cry = CsrLin
            crxOLD = crx
            cryOLD = cry
            File_Frame_x = 1
            File_Frame_y = 1
            CurrentLine = FileCount
            If CurrentLine = 0 Then CurrentLine = 1 ' kinda bugfix, when 'Empty List' we simulate having 1 line
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        'DO WHILE _MOUSEINPUT: LOOP
    End If

    ' @QB64team shared this clear code:
    'DO
    '    WHILE _MOUSEINPUT: WEND
    '    IF _MOUSEBUTTON(1) THEN
    '        IF timeElapsedSince!(lastClick!) <= .3 THEN
    '            PRINT "... and make it double!"
    '        ELSE
    '            PRINT
    '            PRINT "Click!";
    '        END IF
    '        lastClick! = TIMER
    '        WHILE _MOUSEBUTTON(1): i = _MOUSEINPUT: WEND
    '    END IF
    '    _LIMIT 60
    'LOOP UNTIL _KEYHIT = 27

    'FUNCTION timeElapsedSince! (startTime!)
    '    IF startTime! > TIMER THEN startTime! = startTime! - 86400
    '    timeElapsedSince! = TIMER - startTime!
    'END FUNCTION

    'WHILE _MOUSEINPUT: WEND
    'IF _MOUSEBUTTON(1) THEN
    '    IF timeElapsedSince!(lastClick!) <= .3 THEN
    '        ' Double-click
    '        a$ = RTRIM$(FileArray$(CurrentLine))
    '        IF _FILEEXISTS(a$) THEN
    '            CLOSE #1
    '            _MEMFREE MhandleOFF
    '            _MEMFREE MhandleLEN
    '            IF ToLoadOrNotFlag THEN
    '                _MEMFREE Mwholefile
    '            END IF
    '            GOTO GettingStarted 'Before going above lines must be executed, i.e. to initialize.
    '        ELSE ' not responsive enough - it misses some double-clicks?!
    '            IF File_Frame_y - YdimROW >= 1 THEN
    '                File_Frame_y = File_Frame_y - YdimROW
    '                IF CurrentLine - YdimROW >= 1 THEN CurrentLine = CurrentLine - YdimROW
    '                UpdateWindowFrame NormalFRGr, NormalBCKGr
    '            END IF
    '        END IF
    '    ELSE
    '        ' Single-click
    '    END IF
    '    lastClick! = TIMER
    '    WHILE _MOUSEBUTTON(1): idummy = _MOUSEINPUT: WEND
    'END IF

    ' Grmbl, my doulbe-click sucks, therefore going to limbo... Yet, the above replacement nullifies/discards further events :( thus banning my other mouse functionality!
    ' No grmbls anymore, fixed:
    If Double_LeftClick Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        'a$ = RTrim$(FileArray$(CurrentLine))
        'If _FileExists(a$) Then
        '    'Close #1
        '    '_MemFree MhandleOFF
        '    '_MemFree MhandleLEN
        '    'If ToLoadOrNotFlag Then
        '    '        _MemFree Mwholefile
        '    'End If
        '    'GoTo GettingStarted 'Before going above lines must be executed, i.e. to initialize.
        'Else ' not responsive enough - it misses some double-clicks?!
        If File_Frame_y - YdimROW >= 1 Then
            File_Frame_y = File_Frame_y - YdimROW
            If CurrentLine - YdimROW >= 1 Then CurrentLine = CurrentLine - YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        'End If
        Double_LeftClick = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            Button1LOG_firstDetection#(MumboJumbo) = 0
            Button1LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        UpdateNextToCCL_DONE ("Double_LeftClick")
    End If

    'WHILE _MOUSEINPUT: WEND
    'IF _MOUSEBUTTON(2) THEN
    '    IF timeElapsedSince!(lastClick!) <= .3 THEN
    '        ' Double-click
    '        IF File_Frame_y + YdimROW <= filecount - (YdimROW - 1) THEN
    '            File_Frame_y = File_Frame_y + YdimROW
    '            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
    '            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
    '            IF CurrentLine + YdimROW <= filecount THEN CurrentLine = CurrentLine + YdimROW
    '            UpdateWindowFrame NormalFRGr, NormalBCKGr
    '        END IF
    '    ELSE
    '        ' Single-click
    '    END IF
    '    lastClick! = TIMER
    '    WHILE _MOUSEBUTTON(2): idummy = _MOUSEINPUT: WEND
    'END IF

    ' Grmbl, my doulbe-click sucks, therefore going to limbo... Yet, the above replacement nullifies/discards further events :( thus banning my other mouse functionality!
    ' No grmbls anymore, fixed:
    If Double_RightClick Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        If File_Frame_y + YdimROW <= FileCount - (YdimROW - 1) Then
            File_Frame_y = File_Frame_y + YdimROW
            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
            If CurrentLine + YdimROW <= FileCount Then CurrentLine = CurrentLine + YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        Double_RightClick = 0 'clear from buffer
        For MumboJumbo = 1 To 4
            Button2LOG_firstDetection#(MumboJumbo) = 0
            Button2LOG_ForHowLongHolded#(MumboJumbo) = 0
        Next
        UpdateNextToCCL_DONE ("Double_RightClick")
    End If

    LocateTextGraphCursor cry, crx, 0, CursorS, CursorE
    UpdateCLine cry, 1, InverseFRGr, InverseBCKGr, cry
    UpdateCLL (CurrentLine)

    HorMP = MouseXfun%
    VerMP = MouseYfun%

    If RightsidePanelFlag = -1 And (HorMP > XdimCOL And HorMP <= XdimCOL + 45) Then 'if Rightside panel is shown
        crxOSC = Pos(0)
        cryOSC = CsrLin

        Color 0, 5
        LocateTextGraphCursor (1) + 2 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Top - Ctrl+Home"
        LocateTextGraphCursor (1) + 5 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "PgUp"
        LocateTextGraphCursor (1) + 8 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Up"

        LocateTextGraphCursor (1) + 12 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F1 - Sort by FileType i.e. Column #1"
        LocateTextGraphCursor (1) + 15 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F2 - Sort by FileSize i.e. Column #2"
        LocateTextGraphCursor (1) + 18 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F3 - Sort by FileTime i.e. Column #3"
        LocateTextGraphCursor (1) + 21 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F4 - Sort by FileName i.e. Column #4"

        LocateTextGraphCursor (1) + 24 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Enter - enters the DIRECTORY"
        LocateTextGraphCursor (1) + 27 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "DoubleTap LShift - toggle mode"
        LocateTextGraphCursor (1) + 30 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Alt+X or Alt+Q - quit to the system"

        LocateTextGraphCursor (YdimROW + 1) - 9 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Dn"
        LocateTextGraphCursor (YdimROW + 1) - 6 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "PgDn"
        LocateTextGraphCursor (YdimROW + 1) - 3 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "End - Ctrl+End"

        If VerMP >= (YdimROW + 1) - 9 + 1 - 1 And VerMP <= (YdimROW + 1) - 9 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (YdimROW + 1) - 9 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Dn"
            If buttondown1 Then
                B1wasdown_OverDn = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (YdimROW + 1) - 9, (XdimCOL + 1) + 2, (YdimROW + 1) - 9 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (YdimROW + 1) - 9 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Dn"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverDn = 1 Then
                B1wasdown_OverDn = 0: ScrollRibbonDN = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (YdimROW + 1) - 9, (XdimCOL + 1) + 2, (YdimROW + 1) - 9 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (YdimROW + 1) - 9 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Dn"
                _Display
            End If
        Else
            If B1wasdown_OverDn = 1 Then ' Cancel the button press
                B1wasdown_OverDn = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (YdimROW + 1) - 9, (XdimCOL + 1) + 2, (YdimROW + 1) - 9 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (YdimROW + 1) - 9 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Dn"
                _Display
            End If
        End If

        If VerMP >= (YdimROW + 1) - 6 + 1 - 1 And VerMP <= (YdimROW + 1) - 6 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (YdimROW + 1) - 6 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "PgDn"
            If buttondown1 Then
                B1wasdown_OverPgDn = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (YdimROW + 1) - 6, (XdimCOL + 1) + 2, (YdimROW + 1) - 6 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (YdimROW + 1) - 6 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "PgDn"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverPgDn = 1 Then
                B1wasdown_OverPgDn = 0: ScrollRibbonPGDN = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (YdimROW + 1) - 6, (XdimCOL + 1) + 2, (YdimROW + 1) - 6 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (YdimROW + 1) - 6 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "PgDn"
                _Display
            End If
        Else
            If B1wasdown_OverPgDn = 1 Then ' Cancel the button press
                B1wasdown_OverPgDn = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (YdimROW + 1) - 6, (XdimCOL + 1) + 2, (YdimROW + 1) - 6 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (YdimROW + 1) - 6 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "PgDn"
                _Display
            End If
        End If

        If VerMP >= (YdimROW + 1) - 3 + 1 - 1 And VerMP <= (YdimROW + 1) - 3 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (YdimROW + 1) - 3 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "End - Ctrl+End"
            If buttondown1 Then
                B1wasdown_OverCEnd = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (YdimROW + 1) - 3, (XdimCOL + 1) + 2, (YdimROW + 1) - 3 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (YdimROW + 1) - 3 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "End - Ctrl+End"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverCEnd = 1 Then
                B1wasdown_OverCEnd = 0: ScrollRibbonEND = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (YdimROW + 1) - 3, (XdimCOL + 1) + 2, (YdimROW + 1) - 3 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (YdimROW + 1) - 3 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "End - Ctrl+End"
                _Display
            End If
        Else
            If B1wasdown_OverCEnd = 1 Then ' Cancel the button press
                B1wasdown_OverCEnd = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (YdimROW + 1) - 3, (XdimCOL + 1) + 2, (YdimROW + 1) - 3 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (YdimROW + 1) - 3 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "End - Ctrl+End"
                _Display
            End If
        End If

        If VerMP >= (1) + 2 + 1 - 1 And VerMP <= (1) + 2 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (1) + 2 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Top - Ctrl+Home"
            If buttondown1 Then
                B1wasdown_OverTOP = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (1) + 2, (XdimCOL + 1) + 2, (1) + 2 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 2 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Top - Ctrl+Home"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverTOP = 1 Then
                B1wasdown_OverTOP = 0: ScrollRibbonTOP = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 2, (XdimCOL + 1) + 2, (1) + 2 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 2 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Top - Ctrl+Home"
                _Display
            End If
        Else
            If B1wasdown_OverTOP = 1 Then ' Cancel the button press
                B1wasdown_OverTOP = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 2, (XdimCOL + 1) + 2, (1) + 2 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (1) + 2 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Top - Ctrl+Home"
                _Display
            End If
        End If

        If VerMP >= (1) + 5 + 1 - 1 And VerMP <= (1) + 5 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (1) + 5 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "PgUp"
            If buttondown1 Then
                B1wasdown_OverPgUP = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (1) + 5, (XdimCOL + 1) + 2, (1) + 5 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 5 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "PgUp"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverPgUP = 1 Then
                B1wasdown_OverPgUP = 0: ScrollRibbonPGUP = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 5, (XdimCOL + 1) + 2, (1) + 5 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 5 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "PgUp"
                _Display
            End If
        Else
            If B1wasdown_OverPgUP = 1 Then ' Cancel the button press
                B1wasdown_OverPgUP = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 5, (XdimCOL + 1) + 2, (1) + 5 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (1) + 5 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "PgUp"
                _Display
            End If
        End If

        If VerMP >= (1) + 8 + 1 - 1 And VerMP <= (1) + 8 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (1) + 8 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Up"
            If buttondown1 Then
                B1wasdown_OverUP = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (1) + 8, (XdimCOL + 1) + 2, (1) + 8 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 8 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Up"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverUP = 1 Then
                B1wasdown_OverUP = 0: ScrollRibbonUP = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 8, (XdimCOL + 1) + 2, (1) + 8 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 8 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Up"
                _Display
            End If
        Else
            If B1wasdown_OverUP = 1 Then ' Cancel the button press
                B1wasdown_OverUP = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 8, (XdimCOL + 1) + 2, (1) + 8 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (1) + 8 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Up"
                _Display
            End If
        End If

        If VerMP >= (1) + 12 + 1 - 1 And VerMP <= (1) + 12 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (1) + 12 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F1 - Sort by FileType i.e. Column #1"
            If buttondown1 Then
                B1wasdown_OverF1 = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (1) + 12, (XdimCOL + 1) + 2, (1) + 12 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 12 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F1 - Sort by FileType i.e. Column #1"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverF1 = 1 Then
                B1wasdown_OverF1 = 0: IsF1released_Flag = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 12, (XdimCOL + 1) + 2, (1) + 12 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 12 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F1 - Sort by FileType i.e. Column #1"
                _Display
            End If
        Else
            If B1wasdown_OverF1 = 1 Then ' Cancel the button press
                B1wasdown_OverF1 = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 12, (XdimCOL + 1) + 2, (1) + 12 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (1) + 12 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F1 - Sort by FileType i.e. Column #1"
                _Display
            End If
        End If

        If VerMP >= (1) + 15 + 1 - 1 And VerMP <= (1) + 15 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (1) + 15 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F2 - Sort by FileSize i.e. Column #2"
            If buttondown1 Then
                B1wasdown_OverF2 = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (1) + 15, (XdimCOL + 1) + 2, (1) + 15 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 15 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F2 - Sort by FileSize i.e. Column #2"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverF2 = 1 Then
                B1wasdown_OverF2 = 0: IsF2released_Flag = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 15, (XdimCOL + 1) + 2, (1) + 15 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 15 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F2 - Sort by FileSize i.e. Column #2"
                _Display
            End If
        Else
            If B1wasdown_OverF2 = 1 Then ' Cancel the button press
                B1wasdown_OverF2 = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 15, (XdimCOL + 1) + 2, (1) + 15 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (1) + 15 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F2 - Sort by FileSize i.e. Column #2"
                _Display
            End If
        End If

        If VerMP >= (1) + 18 + 1 - 1 And VerMP <= (1) + 18 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (1) + 18 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F3 - Sort by FileTime i.e. Column #3"
            If buttondown1 Then
                B1wasdown_OverF3 = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (1) + 18, (XdimCOL + 1) + 2, (1) + 18 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 18 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F3 - Sort by FileTime i.e. Column #3"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverF3 = 1 Then
                B1wasdown_OverF3 = 0: IsF3released_Flag = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 18, (XdimCOL + 1) + 2, (1) + 18 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 18 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F3 - Sort by FileTime i.e. Column #3"
                _Display
            End If
        Else
            If B1wasdown_OverF3 = 1 Then ' Cancel the button press
                B1wasdown_OverF3 = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 18, (XdimCOL + 1) + 2, (1) + 18 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (1) + 18 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F3 - Sort by FileTime i.e. Column #3"
                _Display
            End If
        End If

        If VerMP >= (1) + 21 + 1 - 1 And VerMP <= (1) + 21 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (1) + 21 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F4 - Sort by FileName i.e. Column #4"
            If buttondown1 Then
                B1wasdown_OverF4 = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (1) + 21, (XdimCOL + 1) + 2, (1) + 21 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 21 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F4 - Sort by FileName i.e. Column #4"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverF4 = 1 Then
                B1wasdown_OverF4 = 0: IsF4released_Flag = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 21, (XdimCOL + 1) + 2, (1) + 21 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 21 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F4 - Sort by FileName i.e. Column #4"
                _Display
            End If
        Else
            If B1wasdown_OverF4 = 1 Then ' Cancel the button press
                B1wasdown_OverF4 = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 21, (XdimCOL + 1) + 2, (1) + 21 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (1) + 21 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "F4 - Sort by FileName i.e. Column #4"
                _Display
            End If
        End If

        If VerMP >= (1) + 24 + 1 - 1 And VerMP <= (1) + 24 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (1) + 24 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Enter - enters the DIRECTORY"
            If buttondown1 Then
                B1wasdown_OverEn = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (1) + 24, (XdimCOL + 1) + 2, (1) + 24 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 24 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Enter - enters the DIRECTORY"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverEn = 1 Then
                B1wasdown_OverEn = 0: IsENTERreleased_Flag = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 24, (XdimCOL + 1) + 2, (1) + 24 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 24 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Enter - enters the DIRECTORY"
                _Display
            End If
        Else
            If B1wasdown_OverEn = 1 Then ' Cancel the button press
                B1wasdown_OverEn = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 24, (XdimCOL + 1) + 2, (1) + 24 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (1) + 24 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Enter - enters the DIRECTORY"
                _Display
            End If
        End If

        If VerMP >= (1) + 27 + 1 - 1 And VerMP <= (1) + 27 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (1) + 27 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "DoubleTap LShift - toggle mode"
            If buttondown1 Then
                B1wasdown_OverShift = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (1) + 27, (XdimCOL + 1) + 2, (1) + 27 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 27 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "DoubleTap LShift - toggle mode"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverShift = 1 Then
                B1wasdown_OverShift = 0: Double_LSHIFTkey = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 27, (XdimCOL + 1) + 2, (1) + 27 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 27 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "DoubleTap LShift - toggle mode"
                _Display
            End If
            If Double_LSHIFTkey = 1 Then
                GoSub Double_LSHIFTkey_GOSUB
            End If
        Else
            If B1wasdown_OverShift = 1 Then ' Cancel the button press
                B1wasdown_OverShift = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 27, (XdimCOL + 1) + 2, (1) + 27 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (1) + 27 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "DoubleTap LShift - toggle mode"
                _Display
            End If
        End If

        If VerMP >= (1) + 30 + 1 - 1 And VerMP <= (1) + 30 + 1 + 1 And HorMP >= (XdimCOL + 1) + 2 And HorMP <= (XdimCOL + 45) - 2 Then
            Color 15 - 8, 5
            '     DrawBoxCAPTION 5,          1,       XdimCOL + 1, YdimROW + 1, XdimCOL + 45, "Rightside Panel, use MouseButton 1"
            'Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol,     BottomRrow,  BottomRcol,   Captnn$)
            LocateTextGraphCursor (1) + 30 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Alt+X or Alt+Q - quit to the system"
            If buttondown1 Then
                B1wasdown_OverQuit = 1
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonLo 5, (1) + 30, (XdimCOL + 1) + 2, (1) + 30 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 30 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Alt+X or Alt+Q - quit to the system"
                _Display: '_Delay .1
            End If
            If buttondown1 = 0 And B1wasdown_OverQuit = 1 Then
                B1wasdown_OverQuit = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 30, (XdimCOL + 1) + 2, (1) + 30 + 2, (XdimCOL + 45) - 2
                Color 15 - 8, 5
                LocateTextGraphCursor (1) + 30 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Alt+X or Alt+Q - quit to the system"
                _Display
                UpdateNextToCCL_BUSY "Terminating...": System
            End If
        Else
            If B1wasdown_OverQuit = 1 Then ' Cancel the button press
                B1wasdown_OverQuit = 0
                'DrawButtonLo BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
                DrawButtonHi 5, (1) + 30, (XdimCOL + 1) + 2, (1) + 30 + 2, (XdimCOL + 45) - 2
                Color 0, 5
                LocateTextGraphCursor (1) + 30 + 1, (XdimCOL + 1) + 2 + 2, 0, CursorS, CursorE: Print "Alt+X or Alt+Q - quit to the system"
                _Display
            End If
        End If

        LocateTextGraphCursor cryOSC, crxOSC, 0, CursorS, CursorE
    End If

    ' Auto-hiding ScrollBar
    If HorMP >= XdimCOL - (3 - 1) And (HorMP <= XdimCOL) Then 'And _MouseY = YdimROW
        ScrollbarFlag = 1
        BarMotif$ = Chr$(176)
        VRibbon1$ = "[T][O][P]" + BarMotif$ + BarMotif$ + BarMotif$ + "[P][G][U][P]" + BarMotif$ + BarMotif$ + BarMotif$ + "[U][P]"
        VRibbonT$ = BarMotif$ + BarMotif$ + BarMotif$ + "[1]" + "[2]" + "[3]" + "[4]" + BarMotif$ + BarMotif$ + BarMotif$ + "[E]"
        VRibbon2$ = "[D][N]" + BarMotif$ + BarMotif$ + BarMotif$ + "[P][G][D][N]" + BarMotif$ + BarMotif$ + BarMotif$ + "[E][N][D]"
        GAP$ = ""
        For BugProne = 1 To (YdimROW - (Len(VRibbon1$) + Len(VRibbonT$) + Len(VRibbon2$)) / 3) * 3
            GAP$ = GAP$ + BarMotif$
        Next
        WholeRibbonScrollBar$ = VRibbon1$ + VRibbonT$ + GAP$ + VRibbon2$
        crxOSC = Pos(0)
        cryOSC = CsrLin
        Color 9, 0
        For ribb = 1 To YdimROW
            LocateTextGraphCursor ribb, XdimCOL - (3 - 1), 0, CursorS, CursorE
            Print Mid$(WholeRibbonScrollBar$, (ribb - 1) * 3 + 1, 3);
        Next

        If VerMP >= 1 And VerMP <= 3 Then
            Color 15 - 8
            LocateTextGraphCursor 1, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[T]";
            LocateTextGraphCursor 2, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[O]";
            LocateTextGraphCursor 3, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[P]";
            If buttondown1 Then B1wasdown = 1
            If buttondown1 = 0 And B1wasdown = 1 Then B1wasdown = 0: ScrollRibbonTOP = 1
        End If

        If VerMP >= 5 And VerMP <= 8 Then
            Color 15 - 8
            LocateTextGraphCursor 5, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[P]";
            LocateTextGraphCursor 6, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[G]";
            LocateTextGraphCursor 7, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[U]";
            LocateTextGraphCursor 8, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[P]";
            If buttondown1 Then B1wasdown = 1
            If buttondown1 = 0 And B1wasdown = 1 Then B1wasdown = 0: ScrollRibbonPGUP = 1
        End If

        If VerMP >= 10 And VerMP <= 11 Then
            Color 15 - 8
            LocateTextGraphCursor 10, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[U]";
            LocateTextGraphCursor 11, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[P]";
            If buttondown1 Then B1wasdown = 1
            If buttondown1 = 0 And B1wasdown = 1 Then B1wasdown = 0: ScrollRibbonUP = 1
        End If

        If VerMP = 13 Then
            Color 15 - 8
            LocateTextGraphCursor 13, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[1]";
            If buttondown1 Then B1wasdown = 1
            If buttondown1 = 0 And B1wasdown = 1 Then B1wasdown = 0: IsF1released_Flag = 1
        End If
        If VerMP = 14 Then
            Color 15 - 8
            LocateTextGraphCursor 14, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[2]";
            If buttondown1 Then B1wasdown = 1
            If buttondown1 = 0 And B1wasdown = 1 Then B1wasdown = 0: IsF2released_Flag = 1
        End If
        If VerMP = 15 Then
            Color 15 - 8
            LocateTextGraphCursor 15, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[3]";
            If buttondown1 Then B1wasdown = 1
            If buttondown1 = 0 And B1wasdown = 1 Then B1wasdown = 0: IsF3released_Flag = 1
        End If
        If VerMP = 16 Then
            Color 15 - 8
            LocateTextGraphCursor 16, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[4]";
            If buttondown1 Then B1wasdown = 1
            If buttondown1 = 0 And B1wasdown = 1 Then B1wasdown = 0: IsF4released_Flag = 1
        End If

        If VerMP = 18 Then
            Color 15 - 8
            LocateTextGraphCursor 18, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[E]";
            If buttondown1 Then B1wasdown = 1
            If buttondown1 = 0 And B1wasdown = 1 Then B1wasdown = 0: IsENTERreleased_Flag = 1
        End If

        If VerMP >= YdimROW - 10 And VerMP <= YdimROW - 9 Then
            Color 15 - 8
            LocateTextGraphCursor YdimROW - 10, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[D]";
            LocateTextGraphCursor YdimROW - 9, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[N]";
            If buttondown1 Then B1wasdown = 1
            If buttondown1 = 0 And B1wasdown = 1 Then B1wasdown = 0: ScrollRibbonDN = 1
        End If

        If VerMP >= YdimROW - 7 And VerMP <= YdimROW - 4 Then
            Color 15 - 8
            LocateTextGraphCursor YdimROW - 7, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[P]";
            LocateTextGraphCursor YdimROW - 6, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[G]";
            LocateTextGraphCursor YdimROW - 5, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[D]";
            LocateTextGraphCursor YdimROW - 4, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[N]";
            If buttondown1 Then B1wasdown = 1
            If buttondown1 = 0 And B1wasdown = 1 Then B1wasdown = 0: ScrollRibbonPGDN = 1
        End If

        If VerMP >= YdimROW - 2 And VerMP <= YdimROW - 0 Then
            Color 15 - 8
            LocateTextGraphCursor YdimROW - 2, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[E]";
            LocateTextGraphCursor YdimROW - 1, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[N]";
            LocateTextGraphCursor YdimROW - 0, XdimCOL - (3 - 1), 0, CursorS, CursorE: Print "[D]";
            If buttondown1 Then B1wasdown = 1
            If buttondown1 = 0 And B1wasdown = 1 Then B1wasdown = 0: ScrollRibbonEND = 1
        End If
        LocateTextGraphCursor cryOSC, crxOSC, 0, CursorS, CursorE
    Else
        If ScrollbarFlag = 1 Then ' hide the bar if focus is lost
            UpdateWindowFrame NormalFRGr, NormalBCKGr
            LocateTextGraphCursor cry, crx, 0, CursorS, CursorE
            UpdateCLine cry, 1, InverseFRGr, InverseBCKGr, cry
            UpdateCLL (CurrentLine)
        End If
        ScrollbarFlag = 0
    End If

    If ScrollRibbonUP = 1 Then ' on purpose Double-Right-CLick is left active, handy it is having it while hovering on 'UP' or 'DN'
        ScrollRibbonUP = 0
        ' Duplicate (copy-and-paste from a bit above) [[[
        LastHit~&& = EpochTime~&&: Stepping = 10
        If CurrentLine > 1 Then CurrentLine = CurrentLine - 1
        If cry > 1 Then
            cry = cry - 1 'up
        Else 'scrolling is needed
            If File_Frame_y > 1 Then File_Frame_y = File_Frame_y - 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        ' Duplicate (copy-and-paste from a bit above) ]]]
        Button1LOG_firstDetection#(3) = 0 ' there might have been Double-Left-Click(s) incidentally clicked
        ShutDownIsNoLonger = 1 ' 'Shutdown' now is forgone
    End If

    If ScrollRibbonDN = 1 Then ' on purpose Double-Right-CLick is left active, handy it is having it while hovering on 'UP' or 'DN'
        ScrollRibbonDN = 0
        ' Duplicate (copy-and-paste from a bit above) [[[
        LastHit~&& = EpochTime~&&: Stepping = 10
        If CurrentLine < FileCount Then CurrentLine = CurrentLine + 1
        If cry < YdimROW Then
            If cry < FileCount Then cry = cry + 1 'down
        Else 'scrolling is needed
            If File_Frame_y < FileCount - (YdimROW - 1) Then File_Frame_y = File_Frame_y + 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        ' Duplicate (copy-and-paste from a bit above) ]]]
        Button1LOG_firstDetection#(3) = 0 ' there might have been Double-Left-Click(s) incidentally clicked
        ShutDownIsNoLonger = 1 ' 'Shutdown' now is forgone
    End If

    If ScrollRibbonEND = 1 Then
        ScrollRibbonEND = 0
        ' Duplicate (copy-and-paste from a bit above) [[[
        LastHit~&& = EpochTime~&&: Stepping = 10
        If FileCount >= YdimROW Then
            If FileCount - (YdimROW - 1) Then
                LocateTextGraphCursor YdimROW, 1, 0, CursorS, CursorE
                crx = Pos(0)
                cry = CsrLin
                crxOLD = crx
                cryOLD = cry
                File_Frame_x = 1
                File_Frame_y = FileCount - (YdimROW - 1)
                CurrentLine = FileCount
                If CurrentLine = 0 Then CurrentLine = 1 ' kinda bugfix, when 'Empty List' we simulate having 1 line
                UpdateWindowFrame NormalFRGr, NormalBCKGr
            End If
        Else
            ' FileCount/FileCount_FILTER could be 0, only with FileArray_FILTERfunction$(), must be handled
            If FileCount = 0 Then
                LocateTextGraphCursor FileCount + 1, 1, 0, CursorS, CursorE
            Else
                LocateTextGraphCursor FileCount, 1, 0, CursorS, CursorE
            End If
            crx = Pos(0)
            cry = CsrLin
            crxOLD = crx
            cryOLD = cry
            File_Frame_x = 1
            File_Frame_y = 1
            CurrentLine = FileCount
            If CurrentLine = 0 Then CurrentLine = 1 ' kinda bugfix, when 'Empty List' we simulate having 1 line
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        'DO WHILE _MOUSEINPUT: LOOP
        ' Duplicate (copy-and-paste from a bit above) ]]]
        Button1LOG_firstDetection#(3) = 0 ' there might have been Double-Left-Click(s) incidentally clicked
        ShutDownIsNoLonger = 1 ' 'Shutdown' now is forgone
    End If

    If ScrollRibbonTOP = 1 Then
        ScrollRibbonTOP = 0
        ' Duplicate (copy-and-paste from a bit above) [[[
        LastHit~&& = EpochTime~&&: Stepping = 10
        LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
        crx = Pos(0)
        cry = CsrLin
        crxOLD = crx
        cryOLD = cry
        File_Frame_x = 1
        File_Frame_y = 1
        CurrentLine = 1
        UpdateWindowFrame NormalFRGr, NormalBCKGr
        'DO WHILE _MOUSEINPUT: LOOP
        ' Duplicate (copy-and-paste from a bit above) ]]]
        Button1LOG_firstDetection#(3) = 0 ' there might have been Double-Left-Click(s) incidentally clicked
        ShutDownIsNoLonger = 1 ' 'Shutdown' now is forgone
    End If

    If ScrollRibbonPGUP = 1 Then
        ScrollRibbonPGUP = 0
        ' Duplicate (copy-and-paste from a bit above) [[[
        LastHit~&& = EpochTime~&&: Stepping = 10
        UpdateNextToCCL_DONE ("PgUp")
        If File_Frame_y - YdimROW >= 1 Then
            File_Frame_y = File_Frame_y - YdimROW
            If CurrentLine - YdimROW >= 1 Then CurrentLine = CurrentLine - YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        ' Duplicate (copy-and-paste from a bit above) ]]]
        Button1LOG_firstDetection#(3) = 0 ' there might have been Double-Left-Click(s) incidentally clicked
        ShutDownIsNoLonger = 1 ' 'Shutdown' now is forgone
    End If

    If ScrollRibbonPGDN = 1 Then
        ScrollRibbonPGDN = 0
        ' Duplicate (copy-and-paste from a bit above) [[[
        LastHit~&& = EpochTime~&&: Stepping = 10
        UpdateNextToCCL_DONE ("PgDn")
        If File_Frame_y + YdimROW <= FileCount - (YdimROW - 1) Then
            File_Frame_y = File_Frame_y + YdimROW
            'IF CurrentLine < filecount THEN CurrentLine = CurrentLine + 1
            'IF CurrentLine + 1 <= filecount THEN CurrentLine = CurrentLine + 1
            If CurrentLine + YdimROW <= FileCount Then CurrentLine = CurrentLine + YdimROW
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If
        ' Duplicate (copy-and-paste from a bit above) ]]]
        Button1LOG_firstDetection#(3) = 0 ' there might have been Double-Left-Click(s) incidentally clicked
        ShutDownIsNoLonger = 1 ' 'Shutdown' now is forgone
    End If

    _Display

    'If buttondown2 And buttondown1 Then 'pagoda, GRMBL, for now the file being handled SHOULD be in the invocation/home folder!
    'buttondown2 = 0
    'buttondown1 = 0 ' have to nullify because the cleaning of mouseinputs below prevents zeroing the variable in the main cycle where release is awaited but never registered.
    'ShutDownIsNoLonger = 1
    'UpdateCLineHIGHLIGHTword cry, 1, InverseFRGr, InverseBCKGr, cry
    'UpdateCLL CurrentLine, Len(Dumbo$) + 1 + 1
    'Locate cry, crx, 0, CursorS, CursorE 'hide the cursor
    '_Display
    'If Len(CurrentWord$) > 1 Then
    '        UpdateNextToCCL_BUSY (MostRightField): _Display
    '        p$ = LoadedFile$
    '        If InStr(p$, Slash) Then
    '                pTRIMMED = 0
    '                Do Until Mid$(p$, Len(p$) - pTRIMMED, 1) = Slash
    '                        pTRIMMED = pTRIMMED + 1
    '                Loop
    '                p$ = Right$(p$, pTRIMMED)
    '        End If
    '        $If WINDOWS Then
    '                $If 32BIT Then
    '                        Shell _Hide "call " + "XGRAM_PAGODA5_32bit.bat" + " " + LCase$(CurrentWord$) + " " + Chr$(34) + p$ + Chr$(34)
    '                $End If
    '                $If 64BIT Then
    '                        SHELL _HIDE "call " + "XGRAM_PAGODA5_64bit.bat" + " " + LCASE$(CurrentWord$) + " " + CHR$(34) + p$ + CHR$(34)
    '                $End If
    '        $Else
    '                Shell _Hide "sh " + "XGRAM_PAGODA5.sh" + " " + LCase$(CurrentWord$) + " " + Chr$(34) + p$ + Chr$(34)
    '        $End If
    '        UpdateNextToCCL_DONE (MostRightField): _Display
    '        While _MouseInput: Wend

    '        Locate 1, 1, 0, CursorS, CursorE
    '        For i = 1 To YdimROW
    '                Locate i, 1: Print Space$(XdimCOL);
    '        Next

    '        If _FileExists(PSPlike$ + p$ + "_" + LCase$(CurrentWord$) + ".PAGODA-order-5.txt") Then
    '                reportNAME$ = p$ + "_" + LCase$(CurrentWord$) + ".PAGODA-order-5.txt"
    '                pgd& = FreeFile
    '                Open PSPlike$ + p$ + "_" + LCase$(CurrentWord$) + ".PAGODA-order-5.txt" For Input As #pgd&
    '                pgdlines = 0
    '                Do While Not EOF(pgd&)
    '                        pgdlines = pgdlines + 1
    '                        Line Input #pgd&, dummyl$
    '                Loop
    '                Close #pgd&
    '                ReDim xgrams$(1 To pgdlines)
    '                SCROLLABLEheight = (YdimROW - 2) - 4 + 1
    '                pgd& = FreeFile
    '                Open PSPlike$ + p$ + "_" + LCase$(CurrentWord$) + ".PAGODA-order-5.txt" For Input As #pgd&
    '                Locate 1, 1
    '                Print "PAGODA size: "; AddCommas$(pgdlines); " lines or "; AddCommas$(LOF(pgd&)); " bytes";
    '                Locate 2, 1
    '                Print "PAGODA name: "; Left$(reportNAME$, XdimCOL - Len("PAGODA name: "));
    '                pgdlines = 0
    '                Do While Not EOF(pgd&)
    '                        pgdlines = pgdlines + 1
    '                        Line Input #pgd&, xgrams$(pgdlines)
    '                        For j = 1 To Len(xgrams$(pgdlines))
    '                                If pgdlines Mod 2 = 0 Then
    '                                        If Mid$(xgrams$(pgdlines), j, 1) = " " Then Mid$(xgrams$(pgdlines), j, 1) = "."
    '                                End If
    '                        Next
    '                Loop
    '                Close #pgd&
    '                For i = 1 To MIN&(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
    '                        Locate i + 3, 1: Print Left$(xgrams$(i), XdimCOL);
    '                Next

    '        End If
    '        Print
    '        Print
    '        Print "Press ESC... for vertical scroll use Up/Down, MouseLeftButton/MouseRightButton or Mouse Wheel.";
    '        _Display
    '        $If WINDOWS Then
    '                Play "v3o2l32g"
    '        $End If
    '        LinesScroled = 0: LinesScroledMAX = pgdlines - SCROLLABLEheight
    '        Do While InKey$ <> Chr$(27)
    '                If pgdlines > SCROLLABLEheight Then
    '                        AsIfItIsINKEY% = _MouseInput '      Check the mouse status
    '                        buttondown1 = _MouseButton(1)
    '                        buttondown2 = _MouseButton(2)
    '                        buttondown3 = _MouseButton(3)
    '                        mwheel = _MouseWheel
    '                        If buttondown2 Or mwheel = 1 Or _KeyDown(DOWNkey&) Then ' as if Down
    '                                If LinesScroled < LinesScroledMAX Then
    '                                        LinesScroled = LinesScroled + 1
    '                                End If
    '                                For i = 1 To MIN(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
    '                                        Locate i + 3, 1: Print CROPorPADatRIGHT$(xgrams$(i + LinesScroled), XdimCOL);
    '                                Next
    '                        End If
    '                        If buttondown1 Or mwheel = -1 Or _KeyDown(UPkey&) Then ' as if Up
    '                                If LinesScroled > 0 Then
    '                                        LinesScroled = LinesScroled - 1
    '                                End If
    '                                For i = 1 To MIN(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
    '                                        Locate i + 3, 1: Print CROPorPADatRIGHT$(xgrams$(i + LinesScroled), XdimCOL);
    '                                Next
    '                        End If
    '                End If
    '                _Limit 500
    '                _Display
    '        Loop
    '        While _MouseInput: Wend
    '        UpdateWindowFrame NormalFRGr, NormalBCKGr
    'End If
    'End If

    ' Inhere, the four main flags are set:
    'treedumpPOOLFLAG = 1 ' if 0 then we are in FILE content mode
    'treedumpPOOL_DIRonlyFLAG = 0 ' 1 for full tree DIRs; 0 for full tree FILEs
    ' FILTER_apply_flag is set 0 (not applying filters)
    ' DIRorTREE_flag is set NOT 0 (for DIR)
    'Note: In below 'Enter' section we are allowed to enter both FILE and TREE mode (except the DIR only TREE mode, which is Double_RShift), meaning, exclude treedumpPOOLFLAG+treedumpPOOL_DIRonlyFLAG=2 , ugh, should exclude HEX mode i.e. when treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG + Abs(DIRorTREE_flag) = 0

    '' 4 modes for now [[[
    '' TREE-mode-FILE-only with:    if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 1 then
    'DIRorTREE_flag = 0
    'treedumpPOOLFLAG = 1
    'treedumpPOOL_DIRonlyFLAG = 0
    '' TREE-mode-DIR-only with:     if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 2 then
    'DIRorTREE_flag = 0
    'treedumpPOOLFLAG = 1
    'treedumpPOOL_DIRonlyFLAG = 1
    '' DIR-mode with:               if abs(DIRorTREE_flag) = 1 then
    'DIRorTREE_flag = Not 0
    '' TREE-mode-FILE-CONTENT with: if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 0 then
    'DIRorTREE_flag = 0
    'treedumpPOOLFLAG = 0
    'treedumpPOOL_DIRonlyFLAG = 0
    '' 4 modes for now ]]]

    '+---------------------------+-----------------------------------------------------------------------+----------------+
    '| Modes                     | Flags                                                                 | Transitions    |
    '+---------------------------+-----------------------------------------------------------------------+----------------+
    '| #1 DIR-mode               | abs(DIRorTREE_flag) = 1                                               | ]-> #1; ]-> #4 |
    '| #2 TREE-mode-FILE-only    | abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 1 | ]-> #4         |
    '| #3 TREE-mode-DIR-only     | abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 2 | ]-> #1         |
    '| #4 TREE-mode-FILE-CONTENT | abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 0 |                | ! A variant: when entering a folder, to remain in mode #4, instead of transitioning to mode #1
    '+---------------------------+-----------------------------------------------------------------------+----------------+

    DirtyGo:
    If ((IsButton3released_Flag = 1) Or (Double_LCTRLkey = 1) Or (IsENTERreleased_Flag = 1 And (_KeyDown(RALTkey&) = 0 And _KeyDown(LALTkey&) = 0))) Then ' Wrap the current/INVERSE line, and scroll it up/down as the PAGODA
        LastHit~&& = EpochTime~&&: Stepping = 10
        IsENTERreleased_Flag = 0
        If CurrentLine <= POSIX_FileDirCount&& Then
            If (DIRorTREE_flag) Then
                If FileTy(CurrentLine) = " DIRECTORY" Or SaveNameForExecution$ <> "" Then ' We come here either from Mode #1 or Mode #4
                    WhichColumnIsSorted = 0 'fixed in r6+
                    $If WINDOWS Then
                        ChDir FileNa(CurrentLine) + "\" 'dbg
                        PathToEngage$ = _CWD$
                        If Right$(PathToEngage$, 1) <> "\" Then PathToEngage$ = PathToEngage$ + "\"
                    $Else
                        If SaveNameForExecution$ = "" Then
                            ChDir FileNa(CurrentLine) + "/" 'dbg
                            PathToEngage$ = _CWD$
                        Else
                            PathToEngage$ = SaveNameForExecution$
                            ChDir PathToEngage$
                            SaveNameForExecution$ = "" ' avoid reentrance
                        End If
                        If Right$(PathToEngage$, 1) <> "/" Then PathToEngage$ = PathToEngage$ + "/"
                    $End If
                    _Title "Dirwalker, " + LTrim$(Str$(XdimCOL)) + "x" + LTrim$(Str$(YdimROW)) + ", revision " + revision$ + "; Directory: " + PathToEngage$

                    'Reading&Parsing&Updating [[[
                    If Double_LCTRLkey = 1 Then
                        UpdateNextToCCL_BUSY ("Double_LCTRLkey")
                    ElseIf (IsButton3released_Flag = 1) Then
                        UpdateNextToCCL_BUSY ("Button3 released")
                    Else
                        UpdateNextToCCL_BUSY ("Enter released")
                    End If
                    FILTER_apply_flag = 0
                    'GetDirFileList PathToEngage$, FileTy(), FileNa(), FileSi(), FileTC(), FileTA(), FileTM(), FileSiRAW()

                    ' The New Faster and Buggyless 'GetDirFileList' [[[[[[[[[[[[[[[[[[
                    Entries&& = 0
                    'PoolToHousePathS_MAXsize&& =
                    PoolToHousePathS_REALsize&& = 0
                    MINGW_OpenReadCloseDIR PathToEngage$ + Chr$(0), _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
                    '[ Parsing 0 of 2 [
                    ReDim FileTy(Entries&& + 1) As String, FileNa(Entries&& + 1) As String, FileSi(Entries&& + 1) As String, FileTC(Entries&& + 1) As String, FileTA(Entries&& + 1) As String, FileTM(Entries&& + 1) As String, FileSiRAW(Entries&& + 1) As String '+1 to avoid alloc error when Entries&& is 0
                    POSIX_DirCount&& = 0: POSIX_FileCount&& = 0: POSIX_FileDirCount&& = 0
                    'FIELD289$ = Space$(289)
                    LastFileModification$ = Space$(24)
                    file_name256ASCIIZ$ = Space$(256)
                    '// [1byte-type][8bytes-size][24bytes-time][256bytes-name] or 289 bytes

                    For j = 1 To Entries&& ' Mind 'Entries&&' being >0, since there always is .
                        POSIX_FileDirCount&& = POSIX_FileDirCount&& + 1
                        flags% = 0
                        memcpyKAZE _Offset(flags%), MhandleXMM.OFFSET + (j - 1) * 289&& + 0, 1
                        memcpyKAZE _Offset(file_size&&), MhandleXMM.OFFSET + (j - 1) * 289&& + 1, 8
                        memcpyKAZE _Offset(LastFileModification$), MhandleXMM.OFFSET + (j - 1) * 289&& + 1 + 8, 24
                        memcpyKAZE _Offset(file_name256ASCIIZ$), MhandleXMM.OFFSET + (j - 1) * 289&& + 1 + 8 + 24, 256
                        If flags% And IS_DIR Then POSIX_DirCount&& = POSIX_DirCount&& + 1: FileTy(POSIX_FileDirCount&&) = " DIRECTORY"
                        If flags% And IS_FILE Then POSIX_FileCount&& = POSIX_FileCount&& + 1: FileTy(POSIX_FileDirCount&&) = " FILE....."
                        FileNa(POSIX_FileDirCount&&) = Left$(file_name256ASCIIZ$, strchrKAZE~&&(_Offset(file_name256ASCIIZ$), 0)) 'strchrKAZE~&&(_Offset(file_name256ASCIIZ$), 0) = InStr(file_name256ASCIIZ$, Chr$(0)) - 1
                        FileSi(POSIX_FileDirCount&&) = AddCommasPaddedLEN$(Val(LTrim$(Str$(file_size&&))))
                        FileSiRAW(POSIX_FileDirCount&&) = LTrim$(Str$(file_size&&))
                        FileTM(POSIX_FileDirCount&&) = SwapAndRemove$(LastFileModification$)
                    Next
                    '] Parsing 0 of 2 ]
                    ' The New Faster and Buggyless 'GetDirFileList' ]]]]]]]]]]]]]]]]]]

                    '[ Parsing [
                    FileCount = POSIX_FileDirCount&& + 5
                    FileCount_DIR = FileCount
                    FieldLineNum = Len(AddCommas$(FileCount))
                    FieldLineNum_DIR = FieldLineNum
                    ReDim FileArray$(1 To FileCount)
                    TotalSize&& = 0
                    LogPrefix$ = "[Date:" + Right$(Date$, 4) + "-" + Left$(Date$, 5) + "; Time:" + Time$ + "] "
                    For i = 1 To POSIX_FileDirCount&&
                        'DIRs_and_FILEs$(i) = FileTy(i) + "  " + AddCommasPaddedLEN$(Val(FileSi(i))) + "  " + SwapAndRemove$(FileTM(i)) + "  " + FileNa(i)
                        TotalSize&& = TotalSize&& + Val(FileSiRAW(i))
                        'FileArray$(i) = DIRs_and_FILEs$(i) 'FileArrayWINDOW$(i) = Left$(DIRs_and_FILEs$(i), XdimCOL)
                        FileArray$(i) = FileTy(i) + "  " + FileSi(i) + "  " + FileTM(i) + "  " + FileNa(i)
                        'Print #f00, LogPrefix$ + FileArray$(i)
                    Next
                    FileArray$(POSIX_FileDirCount&& + 1) = "" 'Print
                    FileArray$(POSIX_FileDirCount&& + 2) = "Path:        " + PathToEngage$ 'Print "Path:        "; PathToEngage$
                    FileArray$(POSIX_FileDirCount&& + 3) = "Directories: " + AddCommasPaddedLEN$(POSIX_DirCount&&) 'Print "Directories: "; AddCommasPaddedLEN$(POSIX_DirCount&&)
                    FileArray$(POSIX_FileDirCount&& + 4) = "Files:       " + AddCommasPaddedLEN$(POSIX_FileCount&&) 'Print "Files:       "; AddCommasPaddedLEN$(POSIX_FileCount&&)
                    FileArray$(POSIX_FileDirCount&& + 5) = "TotalSize:   " + AddCommasPaddedLEN$(TotalSize&&) 'Print "TotalSize:   "; AddCommasPaddedLEN$(TotalSize&&)
                    'Print #f00, LogPrefix$ + FileArray$(POSIX_FileDirCount&& + 1)
                    'Print #f00, LogPrefix$ + FileArray$(POSIX_FileDirCount&& + 2)
                    'Print #f00, LogPrefix$ + FileArray$(POSIX_FileDirCount&& + 3)
                    'Print #f00, LogPrefix$ + FileArray$(POSIX_FileDirCount&& + 4)
                    'Print #f00, LogPrefix$ + FileArray$(POSIX_FileDirCount&& + 5)
                    'Print #f00, LogPrefix$
                    '] Parsing ]
                    UpdateNextToCCL_DONE ("")
                    File_Frame_x = 1
                    File_Frame_y = 1
                    LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
                    crx = Pos(0)
                    cry = CsrLin
                    crxOLD = crx
                    cryOLD = cry
                    Color NormalFRGr, NormalBCKGr
                    'UpdateWindowFrame NormalFRGr, NormalBCKGr
                    ' Here is the layout:
                    ' The window-frame is 1..crx or 1..128 |  The file-frame is 1..LongestLine
                    '                     .         .      |                    .
                    '                     .         .      |                    .
                    '                     cry       60     |                    filecount
                    '              FileArrayWINDOW$(60)    |          FileArray(filecount)
                    ' if File_Frame_x < 128 then PADDING to 128 else File_Frame_x = 1..LongestLine-(128-1)
                    ' if File_Frame_y < 60 then PADDING to 60 else File_Frame_y = 1..filecount-(60-1)

                    UpdateWindowFrame NormalFRGr, NormalBCKGr
                    UpdateCLine 1, 1, InverseFRGr, InverseBCKGr, 1

                    FieldLineNum = Len(AddCommas$(FileCount))
                    CurrentLine = 1
                    UpdateCLL (CurrentLine)
                    If Double_LCTRLkey = 1 Then
                        UpdateNextToCCL_DONE ("Double_LCTRLkey")
                    ElseIf (IsButton3released_Flag = 1) Then
                        UpdateNextToCCL_DONE ("Button3 released")
                    Else
                        UpdateNextToCCL_DONE ("Enter released")
                    End If
                    'Reading&Parsing&Updating ]]]

                    'Wwidth% = XdimCOL
                    'UpdateCLL CurrentLine, Len(Dumbo$) + 1 + 1
                    'Locate cry, crx, 0, CursorS, CursorE 'hide the cursor
                    '_Display
                    'If Len(FileArrayFULL$(CurrentLine)) > XdimCOL Then
                    '        UpdateNextToCCL_BUSY (MostRightField): _Display
                    '        l$ = FileArrayFULL$(CurrentLine)
                    '        ExpandTabsFULL l$
                    '        ' [[[
                    '        ' Firstly do the wrapping virtually (in order to avoid writing some wrapped chunks and encounter unwrappable chunk) - we need either a wrapped line (in its entirety) or none:
                    '        AssumeLineIsWrappable = 1
                    '        pgdlines = 0
                    '        lX$ = l$
                    '        Do While Len(lX$) > Wwidth%
                    '                Glupak% = Wwidth%
                    '                Do 'UNTIL (MID$(lX$, Glupak% + 1, 1) = " " OR MID$(lX$, Glupak% + 1, 1) = "\" OR MID$(lX$, Glupak% + 1, 1) = "/" OR MID$(lX$, Glupak% + 1, 1) = "_" OR MID$(lX$, Glupak% + 1, 1) = ";" OR MID$(lX$, Glupak% + 1, 1) = ",") AND MID$(lX$, Glupak%, 1) <> " "
                    '                        InvokeOnce$ = Mid$(lX$, Glupak% + 1, 1)
                    '                        If InStr(" \/_;,.-|+%=:", InvokeOnce$) And Mid$(lX$, Glupak%, 1) <> " " Then Exit Do
                    '                        'IF (InvokeOnce$ = " " OR InvokeOnce$ = "\" OR InvokeOnce$ = "/" OR InvokeOnce$ = "_" OR InvokeOnce$ = ";" OR InvokeOnce$ = "," OR InvokeOnce$ = "." OR InvokeOnce$ = "-" OR InvokeOnce$ = "|" OR InvokeOnce$ = "+" OR InvokeOnce$ = "%") AND MID$(lX$, Glupak%, 1) <> " " THEN EXIT DO
                    '                        Glupak% = Glupak% - 1
                    '                        If Glupak% = 0 Then
                    '                                AssumeLineIsWrappable = 0
                    '                                pgdlines = 0
                    '                                GoTo B4TxpanarVIRTUAL2
                    '                        End If
                    '                Loop
                    '                lX$ = LTrim$(Mid$(lX$, Glupak% + 1, Len(lX$) - (Glupak%)))
                    '                pgdlines = pgdlines + 1
                    '        Loop
                    '        pgdlines = pgdlines + 1 ' don't forget the last chunk/remainder
                    '        ReDim xgrams$(1 To pgdlines)

                    '        B4TxpanarVIRTUAL2:
                    '        pgdlines = 0
                    '        If AssumeLineIsWrappable = 1 Then
                    '                lX$ = l$
                    '                Do While Len(lX$) > Wwidth%
                    '                        Glupak% = Wwidth%
                    '                        Do 'UNTIL (MID$(lX$, Glupak% + 1, 1) = " " OR MID$(lX$, Glupak% + 1, 1) = "\" OR MID$(lX$, Glupak% + 1, 1) = "/" OR MID$(lX$, Glupak% + 1, 1) = "_" OR MID$(lX$, Glupak% + 1, 1) = ";" OR MID$(lX$, Glupak% + 1, 1) = ",") AND MID$(lX$, Glupak%, 1) <> " "
                    '                                InvokeOnce$ = Mid$(lX$, Glupak% + 1, 1)
                    '                                If InStr(" \/_;,.-|+%=:", InvokeOnce$) And Mid$(lX$, Glupak%, 1) <> " " Then Exit Do
                    '                                'IF (InvokeOnce$ = " " OR InvokeOnce$ = "\" OR InvokeOnce$ = "/" OR InvokeOnce$ = "_" OR InvokeOnce$ = ";" OR InvokeOnce$ = "," OR InvokeOnce$ = "." OR InvokeOnce$ = "-" OR InvokeOnce$ = "|" OR InvokeOnce$ = "+" OR InvokeOnce$ = "%") AND MID$(lX$, Glupak%, 1) <> " " THEN EXIT DO
                    '                                Glupak% = Glupak% - 1
                    '                                If Glupak% = 0 Then
                    '                                        GoTo B4Txpanar2
                    '                                End If
                    '                        Loop
                    '                        pgdlines = pgdlines + 1
                    '                        xgrams$(pgdlines) = Left$(lX$, Glupak%) 'PRINT #3, LEFT$(lX$, Glupak%)
                    '                        lX$ = LTrim$(Mid$(lX$, Glupak% + 1, Len(lX$) - (Glupak%)))
                    '                Loop
                    '                pgdlines = pgdlines + 1 ' don't forget the last chunk/remainder
                    '                xgrams$(pgdlines) = lX$ 'PRINT #3, lX$
                    '                B4Txpanar2:
                    '        Else 'unwrappable
                    '                $If WINDOWS Then
                    '                        Play "v3o2l60aba"
                    '                $End If
                    '        End If

                    '        ']]]
                    '        UpdateNextToCCL_DONE (MostRightField): _Display
                    '        While _MouseInput: Wend

                    '        If pgdlines Then
                    '                Locate 1, 1, 0, CursorS, CursorE
                    '                For i = 1 To YdimROW
                    '                        Locate i, 1: Print Space$(XdimCOL);
                    '                Next

                    '                SCROLLABLEheight = (YdimROW - 2) - 3 + 1

                    '                Locate 1, 1, 0
                    '                Print "Original Current/INVERSE line size: "; AddCommas$(Len(FileArrayFULL$(CurrentLine))); " bytes ";

                    '                For i = 1 To MIN&(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
                    '                        Locate i + 2, 1: Print Left$(xgrams$(i), XdimCOL);
                    '                Next

                    '                Print
                    '                Print
                    '                Print "Release Enter (or press Esc)... for vertical scroll use Up/Down, MouseLeftButton/MouseRightButton or Mouse Wheel.";
                    '                _Display

                    '                $If WINDOWS Then
                    '                        Play "v3o2l32g"
                    '                $End If
                    '                LinesScroled = 0: LinesScroledMAX = pgdlines - SCROLLABLEheight
                    '                Do While InKey$ <> Chr$(27) And IsENTERreleased = 0
                    '                        If pgdlines > SCROLLABLEheight Then
                    '                                AsIfItIsINKEY% = _MouseInput '      Check the mouse status
                    '                                buttondown1 = _MouseButton(1)
                    '                                buttondown2 = _MouseButton(2)
                    '                                buttondown3 = _MouseButton(3)
                    '                                mwheel = _MouseWheel
                    '                                If buttondown2 Or mwheel = 1 Or _KeyDown(DOWNkey&) Then ' as if Down
                    '                                        If LinesScroled < LinesScroledMAX Then
                    '                                                LinesScroled = LinesScroled + 1
                    '                                        End If
                    '                                        For i = 1 To MIN(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
                    '                                                Locate i + 2, 1: Print CROPorPADatRIGHT$(xgrams$(i + LinesScroled), XdimCOL);
                    '                                        Next
                    '                                End If
                    '                                If buttondown1 Or mwheel = -1 Or _KeyDown(UPkey&) Then ' as if Up
                    '                                        If LinesScroled > 0 Then
                    '                                                LinesScroled = LinesScroled - 1
                    '                                        End If
                    '                                        For i = 1 To MIN(SCROLLABLEheight, pgdlines) ' -2 due to PRINT: PRINT "Press ESC..."
                    '                                                Locate i + 2, 1: Print CROPorPADatRIGHT$(xgrams$(i + LinesScroled), XdimCOL);
                    '                                        Next
                    '                                End If
                    '                        End If
                    '                        _Limit 50
                    '                        _Display
                    '                Loop
                    '                While _MouseInput: Wend
                    '                UpdateWindowFrame NormalFRGr, NormalBCKGr
                    '        End If 'IF pgdlines THEN
                    'End If
                    '_KeyClear 2 'in order to get rid of all eventual 'Enter' hits during above scrolling
                Else
                    ' TO-DO: Rewrite this without using array AT ALL, also get rid of the other array housing 'FILE' - again use function (with the name of the array) to collect FILEattributes on the fly! [
                    _Title "Dirwalker, " + LTrim$(Str$(XdimCOL)) + "x" + LTrim$(Str$(YdimROW)) + ", revision " + revision$ + "; Directory: " + PathToEngage$ + "; File: " + FileNa(CurrentLine) + "; 'Backspace' to go back"
                    UpdateNextToCCL_BUSY ("")
                    'SaveNameForExecution$ = FileNa(CurrentLine)
                    If fff& Then Close #fff&
                    fff& = FreeFile
                    Open FileNa(CurrentLine) For Binary As #fff&
                    GetItInVariable = LOF(fff&)
                    GetNumOfHEXLines = GetItInVariable \ 64 + 1
                    If GetItInVariable Mod 64 = 0 Then GetNumOfHEXLines = GetNumOfHEXLines - 1
                    If GetNumOfHEXLines = 0 Then GetNumOfHEXLines = 1
                    'ReDim FileArray_TREE$(1 To GetNumOfHEXLines)
                    'For i = 1 To GetNumOfHEXLines ' grrr, too much memory, unable to browse Wikipedia, so make it using directly via GetHEXline$(i) when 'treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG + DIRorTREE_flag = 0'
                    '        FileArray_TREE$(i) = GetHEXline$(i)
                    'Next
                    'Close #fff&
                    'If GetItInVariable = 0 Then FileArray_TREE$(1) = " Empty List"
                    FileCount_TREE = GetNumOfHEXLines
                    FieldLineNum_TREE = Len(AddCommas$(FileCount_TREE))

                    treedumpPOOLFLAG = 0
                    treedumpPOOL_DIRonlyFLAG = 0

                    DIRorTREE_flag = Not DIRorTREE_flag ' 0 for TREE
                    If DIRorTREE_flag Then
                        FileCount = FileCount_DIR
                        FieldLineNum = FieldLineNum_DIR
                    Else
                        FileCount = FileCount_TREE
                        FieldLineNum = FieldLineNum_TREE
                    End If
                    GoSub INIT_WINDOW_gosub
                    UpdateNextToCCL_DONE ("")
                    ' TO-DO: Rewrite this without using array AT ALL, also get rid of the other array housing 'FILE' - again use function (with the name of the array) to collect FILEattributes on the fly! ]
                End If 'If FileTy(CurrentLine) = " DIRECTORY" Then
            Else 'If (DIRorTREE_flag) Then
                If FILTER_apply_flag = 0 Then
                    If DIRorTREE_flag Then
                        SaveNameForExecution$ = FileArray$(CurrentLine)
                    Else
                        SaveNameForExecution$ = FileArray_TREE$(CurrentLine)
                    End If
                Else
                    ' FileCount/FileCount_FILTER could be 0, only with FileArray_FILTERfunction$(), must be handled
                    If FileCount_FILTER <> 0 Then
                        SaveNameForExecution$ = FileArray_FILTERfunction$(CurrentLine)
                    End If
                End If
                If Abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 0 Then
                    SaveNameForExecution$ = ""
                End If
                If SaveNameForExecution$ <> "" Then
                    UpdateNextToCCL_BUSY ("")
                    If Right$(SaveNameForExecution$, 1) = Chr$(0) Then
                        SaveNameForExecution$ = Left$(SaveNameForExecution$, Len(SaveNameForExecution$) - 1) ' Had to remove the trailing ASCII 000 in order to not be treated as non-txt
                    End If
                    If Abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG <> 2 Then ' no DoubleSPC in #3
                        BeginOfFilename = _InStrRev(SaveNameForExecution$, "  ") + 2
                        SaveNameForExecution$ = Mid$(SaveNameForExecution$, BeginOfFilename, Len(SaveNameForExecution$) - (BeginOfFilename - 1))
                    End If
                    _Title "Dirwalker, " + LTrim$(Str$(XdimCOL)) + "x" + LTrim$(Str$(YdimROW)) + ", revision " + revision$ + "; Directory: " + PathToEngage$ + "; File: " + SaveNameForExecution$ + "; 'Backspace' to go back"
                    '| #2 TREE-mode-FILE-only    | abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 1 | ]-> #4         |
                    '| #3 TREE-mode-DIR-only     | abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 2 | ]-> #1         |
                    '| #4 TREE-mode-FILE-CONTENT | abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 0 |                |
                    If Abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 1 Then

                        If fff& Then Close #fff&
                        fff& = FreeFile
                        Open SaveNameForExecution$ For Binary As #fff& 'Open FileNa(CurrentLine) For Binary As #fff&
                        GetItInVariable = LOF(fff&)
                        GetNumOfHEXLines = GetItInVariable \ 64 + 1
                        If GetItInVariable Mod 64 = 0 Then GetNumOfHEXLines = GetNumOfHEXLines - 1
                        If GetNumOfHEXLines = 0 Then GetNumOfHEXLines = 1
                        FileCount_TREE = GetNumOfHEXLines
                        FieldLineNum_TREE = Len(AddCommas$(FileCount_TREE))

                        treedumpPOOLFLAG = 0
                        treedumpPOOL_DIRonlyFLAG = 0

                        DIRorTREE_flag = 0 ' 0 for TREE
                        If DIRorTREE_flag Then
                            FileCount = FileCount_DIR
                            FieldLineNum = FieldLineNum_DIR
                        Else
                            FileCount = FileCount_TREE
                            FieldLineNum = FieldLineNum_TREE
                        End If
                        GoSub INIT_WINDOW_gosub

                    ElseIf Abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 2 Then
                        'ChDir SaveNameForExecution$
                        IsENTERreleased_Flag = 1 ' enforce reentrance
                        DIRorTREE_flag = Not 0 ' enforce Mode #1
                        GoTo DirtyGo
                    ElseIf Abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 0 Then
                        ' Do nothing in HEX mode
                    End If
                    UpdateNextToCCL_DONE ("")
                    ' TO-DO: Rewrite this without using array AT ALL, also get rid of the other array housing 'FILE' - again use function (with the name of the array) to collect FILEattributes on the fly! ]
                End If 'If SaveNameForExecution$ <> "" Then
            End If 'If (DIRorTREE_flag) Then
        End If 'If CurrentLine <= POSIX_FileDirCount&& then
        If Double_LCTRLkey = 1 Then
            Double_LCTRLkey = 0 'clear from buffer
            For MumboJumbo = 1 To 4
                KeyTap_Button2LOG_firstDetection#(MumboJumbo) = 0
                KeyTap_Button2LOG_ForHowLongHolded#(MumboJumbo) = 0
            Next
            $If WINDOWS Then
                Shell _DontWait _Hide "CMD /C " + chr$(34)+SaveNameForExecution$+chr$(34)
            $End If
            $If LINUX Then
                Shell _DontWait _Hide "vlc -f --no-video-title-show " + Chr$(34) + SaveNameForExecution$ + Chr$(34) '"cvlc -f --no-video-title-show "
            $End If
        End If
        'IsF4released_Flag = 1 'since r.6+ sorting the column #4 i.e. name by default
    End If 'IF IsENTERreleased_Flag THEN

    If IsF1released_Flag = 1 And (_KeyDown(RALTkey&) = 0 And _KeyDown(LALTkey&) = 0) And DIRorTREE_flag And FILTER_apply_flag = 0 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        IsF1released_Flag = 0 'clear from buffer
        WhichColumnIsSorted = 1
        crxInfo = Pos(0)
        cryInfo = CsrLin
        UpdateNextToCCL_BUSY ("F1 released")
        '[

        ' SORT CORE [[[
        If POSIX_FileDirCount&& > 1 Then
            'Dim Benchm As _MEM
            Elements = POSIX_FileDirCount&&
            Granularity = Len(FileTy(0 + 1) + "  " + FileSi(0 + 1) + "  " + FileTM(0 + 1) + "  " + FileNa(0 + 1) + String$(256 - Len(FileNa(0 + 1)), 32) + Chr$(0)) '+1 for ASCIIZ
            'Cls: Print Granularity, 12 + 2 + 19 + 2 + 20 + 2 + 256 + 1: _Display: _Delay 4 '314, 314
            Pattern$ = String$(Granularity, 0)
            Benchm = _MemNew(Elements * Granularity)
            '[Field#1   ]  [Field#2          ]  [Field#3           ]  [Field#4   ...]
            ' FILE.......  ............151,552  2022 Feb 10 04:27:40  Leprechaun_x-leton_64bit_Intel_04_001p.exe
            '^          ^  ^                 ^  ^                  ^  ^
            '1         12  15               33  36                55  58
            '[12-1+1=12 ]  [33-15+1=19       ]  [55-36+1=20        ]  [Field#4   ...]
            ' DIRECTORY..  ..............4,096  2021_12/Dec-31_15:56:08  internal
            '^          ^  ^                 ^  ^                     ^  ^
            '1         12  15               33  36                   58  61
            '[12-1+1=12 ]  [33-15+1=19       ]  [58-36+1=23           ]  [Field#4   ...]
            ' DIRECTORY  ..............4,096  2021_12/Dec-31_15:56:08  internal
            '^        ^  ^                 ^  ^                     ^  ^
            '1       10  13               31  34                   56  59
            '[12-1+1=12 ]  [33-15+1=19       ]  [58-36+1=23           ]  [Field#4   ...]

            For i = 0 To Elements - 1
                Pattern$ = FileTy(i + 1) + "  " + FileSi(i + 1) + "  " + FileTM(i + 1) + "  " + FileNa(i + 1) + String$(256 - Len(FileNa(i + 1)), 32) + Chr$(0)
                _MemPut Benchm, Benchm.OFFSET + Granularity * i, Pattern$
            Next
            'Print: Print "Sorting...": Print
            Quicksort_QB64_Granularity Benchm, Elements, Granularity
            For i = 0 To Elements - 1
                _MemGet Benchm, Benchm.OFFSET + Granularity * i, Pattern$
                FileArray$(i + 1) = Pattern$
                FileTy(i + 1) = Mid$(Pattern$, 1, 10)
                FileSi(i + 1) = Mid$(Pattern$, 13, 19)
                FileTM(i + 1) = Mid$(Pattern$, 34, 23)
                FileNa(i + 1) = RTrim$(Mid$(Pattern$, 59, Len(Pattern$) - 58 - 1))
            Next
            _MemFree Benchm
            LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
            crx = Pos(0)
            cry = CsrLin
            crxOLD = crx
            cryOLD = cry
            File_Frame_x = 1
            File_Frame_y = 1
            CurrentLine = 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If 'If POSIX_FileDirCount&& > 1 Then
        ' SORT CORE ]]]

        ']
        LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
        UpdateNextToCCL_DONE ("F1 released")
        $If WINDOWS Then
            Play "v3o2l32g"
        $End If
    End If

    If IsF2released_Flag = 1 And (_KeyDown(RALTkey&) = 0 And _KeyDown(LALTkey&) = 0) And DIRorTREE_flag And FILTER_apply_flag = 0 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        IsF2released_Flag = 0 'clear from buffer
        WhichColumnIsSorted = 2
        crxInfo = Pos(0)
        cryInfo = CsrLin
        UpdateNextToCCL_BUSY ("F2 released")
        '[

        ' SORT CORE [[[
        If POSIX_FileDirCount&& > 1 Then
            'Dim Benchm As _MEM
            Elements = POSIX_FileDirCount&&
            Granularity = Len(FileTy(0 + 1) + "  " + FileSi(0 + 1) + "  " + FileTM(0 + 1) + "  " + FileNa(0 + 1) + String$(256 - Len(FileNa(0 + 1)), 32) + Chr$(0)) '+1 for ASCIIZ
            'Cls: Print Granularity, 12 + 2 + 19 + 2 + 20 + 2 + 256 + 1: _Display: _Delay 4 '314, 314
            Pattern$ = String$(Granularity, 0)
            Benchm = _MemNew(Elements * Granularity)
            '[Field#1   ]  [Field#2          ]  [Field#3           ]  [Field#4   ...]
            ' FILE.......  ............151,552  2022 Feb 10 04:27:40  Leprechaun_x-leton_64bit_Intel_04_001p.exe
            '^          ^  ^                 ^  ^                  ^  ^
            '1         12  15               33  36                55  58
            '[12-1+1=12 ]  [33-15+1=19       ]  [55-36+1=20        ]  [Field#4   ...]
            ' DIRECTORY..  ..............4,096  2021_12/Dec-31_15:56:08  internal
            '^          ^  ^                 ^  ^                     ^  ^
            '1         12  15               33  36                   58  61
            '[12-1+1=12 ]  [33-15+1=19       ]  [58-36+1=23           ]  [Field#4   ...]

            For i = 0 To Elements - 1
                Pattern$ = FileSi(i + 1) + FileTy(i + 1) + "  " + "  " + FileTM(i + 1) + "  " + FileNa(i + 1) + String$(256 - Len(FileNa(i + 1)), 32) + Chr$(0)
                _MemPut Benchm, Benchm.OFFSET + Granularity * i, Pattern$
            Next
            'Print: Print "Sorting...": Print
            Quicksort_QB64_Granularity Benchm, Elements, Granularity
            For i = 0 To Elements - 1
                _MemGet Benchm, Benchm.OFFSET + Granularity * i, Pattern$
                Pattern$ = Mid$(Pattern$, 20, 12) + Left$(Pattern$, 19) + Right$(Pattern$, Len(Pattern$) - (19 + 10 + 2))
                FileArray$(i + 1) = Pattern$
                FileTy(i + 1) = Mid$(Pattern$, 1, 10)
                FileSi(i + 1) = Mid$(Pattern$, 13, 19)
                FileTM(i + 1) = Mid$(Pattern$, 34, 23)
                FileNa(i + 1) = RTrim$(Mid$(Pattern$, 59, Len(Pattern$) - 58 - 1))
            Next
            _MemFree Benchm
            LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
            crx = Pos(0)
            cry = CsrLin
            crxOLD = crx
            cryOLD = cry
            File_Frame_x = 1
            File_Frame_y = 1
            CurrentLine = 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If 'If POSIX_FileDirCount&& > 1 Then
        ' SORT CORE ]]]

        ']
        LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
        UpdateNextToCCL_DONE ("F2 released")
        $If WINDOWS Then
            Play "v3o2l32g"
        $End If
    End If

    If IsF3released_Flag = 1 And (_KeyDown(RALTkey&) = 0 And _KeyDown(LALTkey&) = 0) And DIRorTREE_flag And FILTER_apply_flag = 0 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        IsF3released_Flag = 0 'clear from buffer
        WhichColumnIsSorted = 3
        crxInfo = Pos(0)
        cryInfo = CsrLin
        UpdateNextToCCL_BUSY ("F3 released")
        '[

        ' SORT CORE [[[
        If POSIX_FileDirCount&& > 1 Then
            'Dim Benchm As _MEM
            Elements = POSIX_FileDirCount&&
            Granularity = Len(FileTy(0 + 1) + "  " + FileSi(0 + 1) + "  " + FileTM(0 + 1) + "  " + FileNa(0 + 1) + String$(256 - Len(FileNa(0 + 1)), 32) + Chr$(0)) '+1 for ASCIIZ
            'Cls: Print Granularity, 12 + 2 + 19 + 2 + 20 + 2 + 256 + 1: _Display: _Delay 4 '314, 314
            Pattern$ = String$(Granularity, 0)
            Benchm = _MemNew(Elements * Granularity)
            '[Field#1   ]  [Field#2          ]  [Field#3           ]  [Field#4   ...]
            ' FILE.......  ............151,552  2022 Feb 10 04:27:40  Leprechaun_x-leton_64bit_Intel_04_001p.exe
            '^          ^  ^                 ^  ^                  ^  ^
            '1         12  15               33  36                55  58
            '[12-1+1=12 ]  [33-15+1=19       ]  [55-36+1=20        ]  [Field#4   ...]
            ' DIRECTORY..  ..............4,096  2021_12/Dec-31_15:56:08  internal
            '^          ^  ^                 ^  ^                     ^  ^
            '1         12  15               33  36                   58  61
            '[12-1+1=12 ]  [33-15+1=19       ]  [58-36+1=23           ]  [Field#4   ...]

            For i = 0 To Elements - 1
                Pattern$ = FileTM(i + 1) + FileTy(i + 1) + "  " + FileSi(i + 1) + "  " + "  " + FileNa(i + 1) + String$(256 - Len(FileNa(i + 1)), 32) + Chr$(0)
                _MemPut Benchm, Benchm.OFFSET + Granularity * i, Pattern$
            Next
            'Print: Print "Sorting...": Print
            Quicksort_QB64_Granularity Benchm, Elements, Granularity
            For i = 0 To Elements - 1
                _MemGet Benchm, Benchm.OFFSET + Granularity * i, Pattern$
                Pattern$ = Mid$(Pattern$, 24, 33) + Left$(Pattern$, 23) + Right$(Pattern$, Len(Pattern$) - (23 + 31 + 2))
                FileArray$(i + 1) = Pattern$
                FileTy(i + 1) = Mid$(Pattern$, 1, 10)
                FileSi(i + 1) = Mid$(Pattern$, 13, 19)
                FileTM(i + 1) = Mid$(Pattern$, 34, 23)
                FileNa(i + 1) = RTrim$(Mid$(Pattern$, 59, Len(Pattern$) - 58 - 1))
            Next
            _MemFree Benchm
            LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
            crx = Pos(0)
            cry = CsrLin
            crxOLD = crx
            cryOLD = cry
            File_Frame_x = 1
            File_Frame_y = 1
            CurrentLine = 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If 'If POSIX_FileDirCount&& > 1 Then
        ' SORT CORE ]]]

        ']
        LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
        UpdateNextToCCL_DONE ("F3 released")
        $If WINDOWS Then
            Play "v3o2l32g"
        $End If
    End If

    If IsF4released_Flag = 1 And (_KeyDown(RALTkey&) = 0 And _KeyDown(LALTkey&) = 0) And DIRorTREE_flag And FILTER_apply_flag = 0 Then
        LastHit~&& = EpochTime~&&: Stepping = 10
        IsF4released_Flag = 0 'clear from buffer
        WhichColumnIsSorted = 4
        crxInfo = Pos(0)
        cryInfo = CsrLin
        UpdateNextToCCL_BUSY ("F4 released")
        '[

        ' SORT CORE [[[
        If POSIX_FileDirCount&& > 1 Then
            'Dim Benchm As _MEM
            Elements = POSIX_FileDirCount&&
            Granularity = Len(FileTy(0 + 1) + "  " + FileSi(0 + 1) + "  " + FileTM(0 + 1) + "  " + FileNa(0 + 1) + String$(256 - Len(FileNa(0 + 1)), 32) + Chr$(0)) '+1 for ASCIIZ
            'Cls: Print Granularity, 12 + 2 + 19 + 2 + 20 + 2 + 256 + 1: _Display: _Delay 4 '314, 314
            Pattern$ = String$(Granularity, 0)
            Benchm = _MemNew(Elements * Granularity)
            '[Field#1   ]  [Field#2          ]  [Field#3           ]  [Field#4   ...]
            ' FILE.......  ............151,552  2022 Feb 10 04:27:40  Leprechaun_x-leton_64bit_Intel_04_001p.exe
            '^          ^  ^                 ^  ^                  ^  ^
            '1         12  15               33  36                55  58
            '[12-1+1=12 ]  [33-15+1=19       ]  [55-36+1=20        ]  [Field#4   ...]
            ' DIRECTORY..  ..............4,096  2021_12/Dec-31_15:56:08  internal
            '^          ^  ^                 ^  ^                     ^  ^
            '1         12  15               33  36                   58  61
            '[12-1+1=12 ]  [33-15+1=19       ]  [58-36+1=23           ]  [Field#4   ...]

            For i = 0 To Elements - 1
                Pattern$ = FileNa(i + 1) + String$(256 - Len(FileNa(i + 1)), 32) + FileTy(i + 1) + "  " + FileSi(i + 1) + "  " + FileTM(i + 1) + "  " + Chr$(0)
                _MemPut Benchm, Benchm.OFFSET + Granularity * i, Pattern$
            Next
            'Print: Print "Sorting...": Print
            Quicksort_QB64_Granularity Benchm, Elements, Granularity
            For i = 0 To Elements - 1
                _MemGet Benchm, Benchm.OFFSET + Granularity * i, Pattern$
                Pattern$ = Mid$(Pattern$, 257, Len(Pattern$) - 256 - 1) + Left$(Pattern$, 256) + Chr$(0)
                FileArray$(i + 1) = Pattern$
                FileTy(i + 1) = Mid$(Pattern$, 1, 10)
                FileSi(i + 1) = Mid$(Pattern$, 13, 19)
                FileTM(i + 1) = Mid$(Pattern$, 34, 23)
                FileNa(i + 1) = RTrim$(Mid$(Pattern$, 59, Len(Pattern$) - 58 - 1))
            Next
            _MemFree Benchm
            LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
            crx = Pos(0)
            cry = CsrLin
            crxOLD = crx
            cryOLD = cry
            File_Frame_x = 1
            File_Frame_y = 1
            CurrentLine = 1
            UpdateWindowFrame NormalFRGr, NormalBCKGr
        End If 'If POSIX_FileDirCount&& > 1 Then
        ' SORT CORE ]]]

        ']
        LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
        UpdateNextToCCL_DONE ("F4 released")
        $If WINDOWS Then
            Play "v3o2l32g"
        $End If
    End If

    'DO WHILE INKEY$ <> "": LOOP ' have to clear the keyboard buffer
    '_Limit 500 '_LIMIT 30 'commented because the wheel up/down was not working?!
    'Caution: Above line works fine with "mainstream" mouse like a cheap HP 3-button one, but when attaching "game" mouse as White Shark Lancelot, it became superlaggy and unresponsive, maybe due to REPORT RATE aka POLL RATE being high, had to set it to 125Hz in order to work as if "cheap".

    'k$ = InKey$
    'If k$ <> "" Then LastHit~&& = EpochTime~&&: Stepping = 10
    Select Case EpochTime~&& - LastHit~&&
        Case Is > 13 * 60: Stepping = 0 'the 13th minute is maximum idleness
        Case Is > 9 * 60: Stepping = 1
        Case Is > 8 * 60: Stepping = 2
        Case Is > 7 * 60: Stepping = 3
        Case Is > 6 * 60: Stepping = 4
        Case Is > 5 * 60: Stepping = 5
        Case Is > 4 * 60: Stepping = 6
        Case Is > 3 * 60: Stepping = 7
        Case Is > 2 * 60: Stepping = 8
        Case Is > 1 * 60: Stepping = 9
        Case Else
    End Select
    _Limit Int(FramesPerSecond * (Stepping * .1)) + 5 'to avoid 0

Loop 'mainloop ]
End

INIT_WINDOW_gosub:
' INIT WINDOW [[[[
File_Frame_x = 1
File_Frame_y = 1
LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
crx = Pos(0)
cry = CsrLin
crxOLD = crx
cryOLD = cry
Color NormalFRGr, NormalBCKGr

' Here is the layout:
' The window-frame is 1..crx or 1..128 |  The file-frame is 1..LongestLine
'                     .         .      |                    .
'                     .         .      |                    .
'                     cry       60     |                    filecount
'              FileArrayWINDOW$(60)    |          FileArray(filecount)
' if File_Frame_x < 128 then PADDING to 128 else File_Frame_x = 1..LongestLine-(128-1)
' if File_Frame_y < 60 then PADDING to 60 else File_Frame_y = 1..filecount-(60-1)

UpdateWindowFrame NormalFRGr, NormalBCKGr
UpdateCLine 1, 1, InverseFRGr, InverseBCKGr, 1

CurrentLine = 1
UpdateCLL (CurrentLine)
_Display
' INIT WINDOW ]]]]
$If WINDOWS Then
    Play "v3o2l32ba"
$End If
Return

Double_LSHIFTkey_GOSUB:
LastHit~&& = EpochTime~&&: Stepping = 10
Double_LSHIFTkey = 0 'clear from buffer
For MumboJumbo = 1 To 4
    KeyTap_Button1LOG_firstDetection#(MumboJumbo) = 0
    KeyTap_Button1LOG_ForHowLongHolded#(MumboJumbo) = 0
Next
crxInfo = Pos(0)
cryInfo = CsrLin
UpdateNextToCCL_BUSY ("Pressed 'Double_LeftSHIFTkey'")
'[

'' 4 modes for now [[[
'' TREE-mode-FILE-only with:    if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 1 then
'DIRorTREE_flag = 0
'treedumpPOOLFLAG = 1
'treedumpPOOL_DIRonlyFLAG = 0
'' TREE-mode-DIR-only with:     if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 2 then
'DIRorTREE_flag = 0
'treedumpPOOLFLAG = 1
'treedumpPOOL_DIRonlyFLAG = 1
'' DIR-mode with:               if abs(DIRorTREE_flag) = 1 then
'DIRorTREE_flag = Not 0
'' TREE-mode-FILE-CONTENT with: if abs(DIRorTREE_flag) + treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG = 0 then
'DIRorTREE_flag = 0
'treedumpPOOLFLAG = 0
'treedumpPOOL_DIRonlyFLAG = 0
'' 4 modes for now ]]]

'Enforce always TREE-mode-FILE-only with STATS
treedumpPOOLFLAG = 1 '        ] exit the FILE content/HEX mode
treedumpPOOL_DIRonlyFLAG = 0 ']

_Title "Dirwalker, " + LTrim$(Str$(XdimCOL)) + "x" + LTrim$(Str$(YdimROW)) + ", revision " + revision$ + "; Directory: " + PathToEngage$
Entries&& = 0
PoolToHousePathS_REALsize&& = 0
$If WINDOWS Then
    If Right$(PathToEngage$, 1) = "\" Then
    treedumpPOOL Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&) ' bugfix in r.5+
    'treedumpPOOL_DIRonly Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
    Else
    treedumpPOOL PathToEngage$ + Chr$(0), 0, Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&) ' bugfix in r.5+
    'treedumpPOOL_DIRonly PathToEngage$ + Chr$(0), 0,  Not 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
    End If
$Else
    If Right$(PathToEngage$, 1) = "/" Then
        treedumpPOOL Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
        'treedumpPOOL_FILonly Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
        'treedumpPOOL_DIRonly Left$(PathToEngage$, Len(PathToEngage$) - 1) + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
    Else
        treedumpPOOL PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
        'treedumpPOOL_FILonly PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
        'treedumpPOOL_DIRonly PathToEngage$ + Chr$(0), 0, 0, _Offset(Entries&&), MhandleXMM.OFFSET, _Offset(PoolToHousePathS_MAXsize&&), _Offset(PoolToHousePathS_REALsize&&)
    End If
$End If
'[ Parsing 1 of 2 [
ReDim FileArray_TREE$(1 To Entries&& + 1) '+1 to avoid alloc error when Entries&& is 0
j = 1
If PoolToHousePathS_REALsize&& > 0 Then
    For i = 1 To PoolToHousePathS_REALsize&& ' TO-DO: Maximum slow, speed it up...
        memcpyKAZE _Offset(Byte), MhandleXMM.OFFSET + (i - 1), 1
        FileArray_TREE$(j) = FileArray_TREE$(j) + Byte
        If Asc(Byte) = 0 Then
            j = j + 1
        End If
    Next
End If
j = j - 1
If j = 0 Then
    j = 1: FileArray_TREE$(1) = " Empty List"
Else
    If SHA1flag Then
        HashedSoFar = 0
        TimeScrollA = Timer
        For Yoko = 1 To j
            ' SHA1 [
            SHA1$ = ""
            NakamichiFILE$ = Right$(FileArray_TREE$(Yoko), Len(FileArray_TREE$(Yoko)) - 51)
            If WhichHash = 0 Then '0=SHA1-160; 1=SHA3-256; 2=BLAKE3-256
                HashedSoFar = HashedSoFar + sha1_stream&&(NakamichiFILE$, SHA332bytes$)
            ElseIf WhichHash = 1 Then
                HashedSoFar = HashedSoFar + sha3_stream&&(NakamichiFILE$, SHA332bytes$)
            Else
                HashedSoFar = HashedSoFar + BLAKE3_stream&&(NakamichiFILE$, SHA332bytes$)
            End If
            SHA1$ = ""
            If WhichHash = 0 Then '0=SHA1-160; 1=SHA3-256; 2=BLAKE3-256
                For Bozo = 1 To 20
                    MustBeTwoChars$ = Hex$(Asc(Mid$(SHA332bytes$, Bozo, 1)))
                    If Len(MustBeTwoChars$) = 1 Then MustBeTwoChars$ = "0" + MustBeTwoChars$
                    SHA1$ = SHA1$ + MustBeTwoChars$
                Next
            Else
                For Bozo = 1 To 32
                    MustBeTwoChars$ = Hex$(Asc(Mid$(SHA332bytes$, Bozo, 1)))
                    If Len(MustBeTwoChars$) = 1 Then MustBeTwoChars$ = "0" + MustBeTwoChars$
                    SHA1$ = SHA1$ + MustBeTwoChars$
                Next
            End If
            ' SHA1 ]
            If WhichHash = 0 Then '0=SHA1-160; 1=SHA3-256; 2=BLAKE3-256
                FileArray_TREE$(Yoko) = "SHA1-160:" + SHA1$ + "  " + FileArray_TREE$(Yoko)
            ElseIf WhichHash = 1 Then
                FileArray_TREE$(Yoko) = "SHA3-256:" + SHA1$ + "  " + FileArray_TREE$(Yoko)
            Else
                FileArray_TREE$(Yoko) = "BLAKE3-256:" + SHA1$ + "  " + FileArray_TREE$(Yoko)
            End If
            If Yoko Mod (1) = 0 Then
                TimeScrollB = Timer
                ElapsedTime% = TimeScrollB - TimeScrollA
                If ElapsedTime% < 0 Then ElapsedTime% = (86400 - TimeScrollA) + TimeScrollB
                If ElapsedTime% = 0 Then ElapsedTime% = 1
                BPS = (HashedSoFar / 1024) / ElapsedTime%
                UpdateNextToCCL_ProgressBar Yoko, j, BPS
            End If
        Next
        ' r8+ [
        ReDim HashDuplicationCheck%(1 To j) ' should be all 0
        For Yoko = 1 To j
            HashDuplicationCheck%(Yoko) = 0
        Next Yoko
        If WhichHash = 0 Then '0=SHA1-160; 1=SHA3-256; 2=BLAKE3-256
            Dumbino$ = "SHA1-160:" + SHA1$ + "  "
            DumbinoHashLen = 20
        ElseIf WhichHash = 1 Then
            Dumbino$ = "SHA3-256:" + SHA1$ + "  "
            DumbinoHashLen = 32
        Else
            Dumbino$ = "BLAKE3-256:" + SHA1$ + "  "
            DumbinoHashLen = 32
        End If
        SkipDumbino = Len(Dumbino$) + 1
        For Yoko = 1 To j
            YokoIn = Yoko + 1
            Do While YokoIn <= j ' For YokoIn = 1 To j ' NASTILY SLOW...
                If Mid$(FileArray_TREE$(Yoko), SkipDumbino, DumbinoHashLen) = Mid$(FileArray_TREE$(YokoIn), SkipDumbino, DumbinoHashLen) Then ' speed it up with memcmp() ...
                    HashDuplicationCheck%(Yoko) = 1
                    HashDuplicationCheck%(YokoIn) = 1
                End If
                If Yoko Mod (3333) = 0 Then
                    UpdateNextToCCL_ProgressBarDUPLICATE Yoko, j
                End If
                YokoIn = YokoIn + 1
            Loop ' Next YokoIn
        Next Yoko
        For Yoko = 1 To j
            If HashDuplicationCheck%(Yoko) = 1 Then
                FileArray_TREE$(Yoko) = "DUPLET " + FileArray_TREE$(Yoko)
            Else
                FileArray_TREE$(Yoko) = "unique " + FileArray_TREE$(Yoko)
            End If
        Next Yoko
        ' r8+ ]
    End If
End If
FileCount_TREE = j
FieldLineNum_TREE = Len(AddCommas$(FileCount_TREE))
'] Parsing 1 of 2 ]

SHA1flag = 0
FILTER_apply_flag = 0
If DIRorTREE_flag <> 0 Then 'if we are in DIR i.e. NOT 0 mode then toggle
    DIRorTREE_flag = Not DIRorTREE_flag
Else 'if we are in TREE i.e. 0 mode then remain in it
    If treedumpPOOLFLAG = 1 Then DIRorTREE_flag = Not DIRorTREE_flag
End If

If DIRorTREE_flag Then
    FileCount = FileCount_DIR
    FieldLineNum = FieldLineNum_DIR
Else
    FileCount = FileCount_TREE
    FieldLineNum = FieldLineNum_TREE
End If
GoSub INIT_WINDOW_gosub

']
UpdateNextToCCL_DONE ("Pressed 'Double_LeftSHIFTkey'")
LocateTextGraphCursor cryInfo, crxInfo, 0, CursorS, CursorE
Return

Function AddCommasPaddedLEN$ (numeral)
    Shared FieldLineLen
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    'Padded$ = Right$("000,000,000,000,000", FieldLineLen)
    'Padded$ = Right$("                   ", FieldLineLen)
    Padded$ = Right$("...................", FieldLineLen)
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    AddCommasPaddedLEN$ = Padded$
End Function

Function SwapAndRemove$ (NoNeedOfDayOfWeek_HasToBeSortable$)
    InsertZERO$ = NoNeedOfDayOfWeek_HasToBeSortable$
    If Mid$(NoNeedOfDayOfWeek_HasToBeSortable$, 9, 1) = " " Then Mid$(InsertZERO$, 9, 1) = "0"
    Mid$(InsertZERO$, 11, 1) = "_"
    Mid$(InsertZERO$, 8, 1) = "-"
    'Cls: Print "["; Right$(InsertZERO$, 4) + "_" + Month2Num$(Mid$(InsertZERO$, 5, 3)) + "/" + Mid$(InsertZERO$, 5, 24 - 4 - (4 + 1)); "]": _Display: _Delay 4
    SwapAndRemove$ = Right$(InsertZERO$, 4) + "_" + Month2Num$(Mid$(InsertZERO$, 5, 3)) + "/" + Mid$(InsertZERO$, 5, 24 - 4 - (4 + 1))
End Function

Function Month2Num$ (NoNeedOfDayOfWeek_HasToBeSortable$)
    Select Case NoNeedOfDayOfWeek_HasToBeSortable$
        Case "Jan"
            Month2Num$ = "01"
        Case "Feb"
            Month2Num$ = "02"
        Case "Mar"
            Month2Num$ = "03"
        Case "Apr"
            Month2Num$ = "04"
        Case "May"
            Month2Num$ = "05"
        Case "Jun"
            Month2Num$ = "06"
        Case "Jul"
            Month2Num$ = "07"
        Case "Aug"
            Month2Num$ = "08"
        Case "Sep"
            Month2Num$ = "09"
        Case "Oct"
            Month2Num$ = "10"
        Case "Nov"
            Month2Num$ = "11"
        Case "Dec"
            Month2Num$ = "12"
    End Select
End Function

' //dirfile.h [[[
' #include <dirent.h>   //DIR* __cdecl __MINGW_NOTHROW opendir (const char*);
'           //struct dirent* __cdecl __MINGW_NOTHROW readdir (DIR*);
'           //int __cdecl __MINGW_NOTHROW closedir (DIR*);
' #include <sys/stat.h>     //_CRTIMP int __cdecl __MINGW_NOTHROW  _stati64(const char *, struct _stati64 *);
' #include <string.h>   //char * __cdecl strchr (const char * string, int ch)
' #include <time.h> //_CRTIMP char* __cdecl __MINGW_NOTHROW     ctime (const time_t*);
'
' const int IS_DIR_FLAG = 1, IS_FILE_FLAG = 2;
'
' static DIR *dirPointer;
' struct dirent *next_entry;
' struct _stati64 statbuf_64;
'
' int MINGW_opendir (char * path) {
'   dirPointer = opendir(path);
'   if (dirPointer==NULL) return 0; //On error, NULL is returned,...
'   return -1;
' }
'
' int MINGW_readdir (char* file_name, long long* file_size, int* flags, char* LastStatusChange, char* LastFileAccess, char* LastFileModification) {
'   next_entry = readdir(dirPointer);
'   if (next_entry==NULL) return 0;
'   //https://man7.org/linux/man-pages/man3/readdir.3.html
'   //struct dirent {
'   //...
'   //char d_name[256]; /* Null-terminated filename */
'   //};
'   _stati64(next_entry->d_name, &statbuf_64);
'   //return strlen(next_entry->d_name);
'   strcpy(file_name, next_entry->d_name);
'   *file_size = statbuf_64.st_size;
'   *flags = 0;
'   if (S_ISDIR(statbuf_64.st_mode)) *flags = IS_DIR_FLAG;
'   if (S_ISREG(statbuf_64.st_mode)) *flags = IS_FILE_FLAG;
'   strcpy(LastStatusChange, ctime(&statbuf_64.st_ctime));
'   strcpy(LastFileAccess, ctime(&statbuf_64.st_atime));
'   strcpy(LastFileModification, ctime(&statbuf_64.st_mtime));
' }
'
' int MINGW_closedir () {
'   return closedir(dirPointer); // The closedir() function returns 0 on success.  On error, -1 is returned,...
' }
'
' //Function strchrKAZE~&& (ByVal buf1 As _Offset, Byval byteSOUGHT As integer)
' uint64_t strchrKAZE (char * buf1, uint16_t byteSOUGHT)
' {
' return (uint64_t)(strchr(buf1, byteSOUGHT)-buf1);
' }
' //char * __cdecl strchr (const char * string, int ch)
' //char *strchr(string, c) - search a string for a character
' //
' //Purpose:
' //       Searches a string for a given character, which may be the
' //       null character '\0'.
' //
' //Entry:
' //       char *string - string to search in
' //       char c - character to search for
' //
' //Exit:
' //       returns pointer to the first occurence of c in string
' //       returns NULL if c does not occur in string
'
'
' /*
' #if defined (__MSVCRT__)
' struct _stati64 {
'     _dev_t st_dev;
'     _ino_t st_ino;
'     _mode_t st_mode;
'     short st_nlink;
'     short st_uid;
'     short st_gid;
'     _dev_t st_rdev;
'     __int64 st_size;
'     time_t st_atime; //Accessed date
'     time_t st_mtime; //Modified time
'     time_t st_ctime; //Creation time
' };
' */
'
' /*
' #if defined (__MSVCRT__)
' #if __MSVCRT_VERSION__ < 0x0800
' _CRTIMP int __cdecl __MINGW_NOTHROW  _fstati64(int, struct _stati64 *);
' _CRTIMP int __cdecl __MINGW_NOTHROW  _stati64(const char *, struct _stati64 *);
' */
' //dirfile.h ]]]


' // treedump.c
' #include <stdio.h>
' #include <string.h>
' #include <dirent.h>
' void treedump(char *basePath, const int root, int WindowsFlag);
' int main(int argc, char **argv)
' {
'   char name[2048];
'   //printf("Enter path to list files: ");
'   //scanf("%s", name);
'   if (argc == 1) strcpy(name, "."); // default : current directory
'   else strcpy(name, argv[1]);
'   if ( name[strlen(name)-1] == ':' || name[strlen(name)-1] == '/' || name[strlen(name)-1] == '\\' ) {
'       name[strlen(name)] = '.';
'       name[strlen(name)+1] = 0;
'   }
'   treedump(name, 0, !0); // name should not end with ':', '/' or '\', if so then postfix the path with '.', (not 0) for Windows
'   return 0;
' }
' void treedump(char *basePath, const int root, int WindowsFlag) {
'   char path[2048];
'   struct dirent *dp;
'   DIR *dir = opendir(basePath);
'   int i;
'   if (!dir) return;
'   while ((dp = readdir(dir)) != NULL) {
'       if (strcmp(dp->d_name, ".") != 0 && strcmp(dp->d_name, "..") != 0) {
' /*
'           for (i=0; i<root; i++) {
'               if (i%2 == 0) printf("%c", 179);
'               else printf(" ");
'           }
'           printf("%c%c%s\n", 195, 196, dp->d_name);
' */
' //            printf("%s\n", dp->d_name);
'           strcpy(path, basePath);
'           if (WindowsFlag) strcat(path, "\\");
'           else strcat(path, "/");
'           strcat(path, dp->d_name);
'           printf("%s\n", path);
'           treedump(path, root + 2, WindowsFlag);
'       }
'   }
'   closedir(dir);
' }

Sub UpdateWindowFrame (FRGR, BACKGR)
    Shared YdimROW, FileCount, File_Frame_y, File_Frame_x, XdimCOL, FileArrayWINDOW$(), FileArray$()
    Shared DIRorTREE_flag, FileArray_TREE$(), FileCount_TREE, FileCount_FILTER
    Shared treedumpPOOLFLAG, treedumpPOOL_DIRonlyFLAG
    Shared FILTER_apply_flag
    Color FRGR, BACKGR
    If FILTER_apply_flag = 0 Then
        If DIRorTREE_flag Then
            If YdimROW > FileCount Then
                For i = 1 To YdimROW
                    LocateTextGraphCursor i, 1, 0, CursorS, CursorE: Print Space$(XdimCOL);
                Next
            End If
            For i = 1 To MIN&(YdimROW, FileCount)
                DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
                If Len(DumboReadOnceNotThrice$) >= XdimCOL Then
                    FileArrayWINDOW$(i) = Mid$(DumboReadOnceNotThrice$, File_Frame_x, XdimCOL)
                Else
                    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + Space$(XdimCOL - Len(DumboReadOnceNotThrice$))
                End If
                'since r.8 the goal is to browse properly binary/.tar files
                'FOR j = 1 TO LEN(FileArrayWINDOW$(i))
                'since r.9 the goal is to browse properly German/Spanish/French/Italian files, SO COMMENTING OUT:
                'IF MID$(FileArrayWINDOW$(i), j, 1) < " " THEN MID$(FileArrayWINDOW$(i), j, 1) = CHR$(32)
                'NEXT
                LocateTextGraphCursor i, 1, 0, CursorS, CursorE: Print FileArrayWINDOW$(i);
            Next
        Else
            If YdimROW > FileCount_TREE Then
                For i = 1 To YdimROW
                    LocateTextGraphCursor i, 1, 0, CursorS, CursorE: Print Space$(XdimCOL);
                Next
            End If
            For i = 1 To MIN&(YdimROW, FileCount_TREE)
                If treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG + Abs(DIRorTREE_flag) = 0 Then
                    DumboReadOnceNotThrice$ = GetHEXline$(i + (File_Frame_y - 1))
                Else
                    DumboReadOnceNotThrice$ = FileArray_TREE$(i + (File_Frame_y - 1))
                End If
                If Right$(DumboReadOnceNotThrice$, 1) = Chr$(0) Then
                    DumboReadOnceNotThrice$ = Left$(DumboReadOnceNotThrice$, Len(DumboReadOnceNotThrice$) - 1) ' Had to remove the trailing ASCII 000 in order to not be shown
                End If
                If Len(DumboReadOnceNotThrice$) >= XdimCOL Then
                    FileArrayWINDOW$(i) = Mid$(DumboReadOnceNotThrice$, File_Frame_x, XdimCOL)
                Else
                    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + Space$(XdimCOL - Len(DumboReadOnceNotThrice$))
                End If
                'since r.8 the goal is to browse properly binary/.tar files
                'FOR j = 1 TO LEN(FileArrayWINDOW$(i))
                'since r.9 the goal is to browse properly German/Spanish/French/Italian files, SO COMMENTING OUT:
                'IF MID$(FileArrayWINDOW$(i), j, 1) < " " THEN MID$(FileArrayWINDOW$(i), j, 1) = CHR$(32)
                'NEXT
                LocateTextGraphCursor i, 1, 0, CursorS, CursorE: Print FileArrayWINDOW$(i);
            Next
        End If
    Else
        If YdimROW > FileCount_FILTER Then
            For i = 1 To YdimROW
                LocateTextGraphCursor i, 1, 0, CursorS, CursorE: Print Space$(XdimCOL);
            Next
        End If
        ' FileCount/FileCount_FILTER could be 0, only with FileArray_FILTERfunction$(), must be handled
        If FileCount_FILTER <> 0 Then
            For i = 1 To MIN&(YdimROW, FileCount_FILTER)
                DumboReadOnceNotThrice$ = FileArray_FILTERfunction$(i + (File_Frame_y - 1))
                If Right$(DumboReadOnceNotThrice$, 1) = Chr$(0) Then
                    DumboReadOnceNotThrice$ = Left$(DumboReadOnceNotThrice$, Len(DumboReadOnceNotThrice$) - 1) ' Had to remove the trailing ASCII 000 in order to not be shown
                End If
                If Len(DumboReadOnceNotThrice$) >= XdimCOL Then
                    FileArrayWINDOW$(i) = Mid$(DumboReadOnceNotThrice$, File_Frame_x, XdimCOL)
                Else
                    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + Space$(XdimCOL - Len(DumboReadOnceNotThrice$))
                End If
                LocateTextGraphCursor i, 1, 0, CursorS, CursorE: Print FileArrayWINDOW$(i);
            Next
        Else
            For i = 1 To 1
                DumboReadOnceNotThrice$ = " Empty List"
                FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + Space$(XdimCOL - Len(DumboReadOnceNotThrice$))
                LocateTextGraphCursor i, 1, 0, CursorS, CursorE: Print FileArrayWINDOW$(i);
            Next
        End If
    End If
End Sub

Function MIN& (YdimROW, filecount)
    If YdimROW < filecount Then MIN& = YdimROW Else MIN& = filecount
End Function

Function AddCommas$ (numeral)
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    AddCommas$ = LTrim$(s$)
End Function

Function AddCommasPaddedNUM$ (numeral)
    Shared DIRorTREE_flag, FieldLineNum, FieldLineNum_TREE, FieldLineNum_FILTER, FILTER_apply_flag
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)
    If DIRorTREE_flag Then
        Padded$ = Right$("000,000,000,000", FieldLineNum)
    Else
        Padded$ = Right$("000,000,000,000", FieldLineNum_TREE)
    End If
    If FILTER_apply_flag Then
        Padded$ = Right$("000,000,000,000", FieldLineNum_FILTER)
    End If
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    AddCommasPaddedNUM$ = Padded$
End Function

Function AddZeros$ (numeral)
    s$ = LTrim$(Str$(numeral))
    If Len(s$) > 3 Then
        If (Len(s$) Mod 3) Then x$ = String$(3 - (Len(s$) Mod 3), " ") + s$ Else x$ = s$
        s$ = ""
        For i = 1 To Len(x$) Step 3
            s$ = s$ + Mid$(x$, i, 3) + ","
        Next
        s$ = Left$(s$, Len(s$) - 1)
    End If
    s$ = LTrim$(s$)

    Padded$ = Right$("000,000,000,000", 7)
    Mid$(Padded$, Len(Padded$) - Len(s$) + 1, Len(s$)) = s$
    AddZeros$ = Padded$
End Function

Sub UpdateCLine (lineToWrite, columnToWrite, FRGR, BACKGR, ln)
    Shared FileArrayWINDOW$()
    Shared XdimCOL
    Shared CurrentWord$
    crx = Pos(0)
    cry = CsrLin
    Color FRGR, BACKGR
    LocateTextGraphCursor lineToWrite, columnToWrite, 0, CursorS, CursorE
    Print FileArrayWINDOW$(ln);

    If Left$(FileArrayWINDOW$(ln), 10) = " FILE....." Or Left$(FileArrayWINDOW$(ln), 10) = " DIRECTORY" Then
        ' DIRECTORY  ..............4,096  2021_12/Dec-31_15:56:08  internal
        '^        ^  ^                 ^  ^                     ^  ^
        '1       10  13               31  34                   56  59
        '[12-1+1=12 ]  [33-15+1=19       ]  [58-36+1=23           ]  [Field#4   ...]
        Select Case WhichColumnIsSorted
            Case 1
                If FRGR = 0 Then Color 15 - 8 + 4, BACKGR Else Color FRGR, BACKGR
                LocateTextGraphCursor lineToWrite, 1, 0, CursorS, CursorE
                Print Left$(FileArrayWINDOW$(ln), 10);
            Case 2
                If FRGR = 0 Then Color 15 - 8 + 4, BACKGR Else Color FRGR, BACKGR
                LocateTextGraphCursor lineToWrite, 13, 0, CursorS, CursorE
                Print Mid$(FileArrayWINDOW$(ln), 13, 19);
            Case 3
                If FRGR = 0 Then Color 15 - 8 + 4, BACKGR Else Color FRGR, BACKGR
                LocateTextGraphCursor lineToWrite, 34, 0, CursorS, CursorE
                Print Mid$(FileArrayWINDOW$(ln), 34, 23);
            Case 4
                If FRGR = 0 Then Color 15 - 8 + 4, BACKGR Else Color FRGR, BACKGR
                LocateTextGraphCursor lineToWrite, 59, 0, CursorS, CursorE
                Print Mid$(FileArrayWINDOW$(ln), 59, XdimCOL - 58);
        End Select
    End If

    'get the word under the cursor [
    'LeftM = crx: RightM = crx 'both can go within 1..XdimCOL
    'CurrentChar$ = Mid$(FileArrayWINDOW$(ln), LeftM, 1)
    'If (CurrentChar$ >= "a" And CurrentChar$ <= "z") Or (CurrentChar$ >= "A" And CurrentChar$ <= "Z") Then
    '        Do While LeftM > 1
    '                CurrentChar$ = Mid$(FileArrayWINDOW$(ln), LeftM - 1, 1)
    '                If (CurrentChar$ >= "a" And CurrentChar$ <= "z") Or (CurrentChar$ >= "A" And CurrentChar$ <= "Z") Then
    '                        LeftM = LeftM - 1
    '                Else
    '                        Exit Do
    '                End If
    '        Loop
    '        Do While RightM < XdimCOL
    '                CurrentChar$ = Mid$(FileArrayWINDOW$(ln), RightM + 1, 1)
    '                If (CurrentChar$ >= "a" And CurrentChar$ <= "z") Or (CurrentChar$ >= "A" And CurrentChar$ <= "Z") Then
    '                        RightM = RightM + 1
    '                Else
    '                        Exit Do
    '                End If
    '        Loop
    'End If
    'If RightM - LeftM > 0 Then CurrentWord$ = Mid$(FileArrayWINDOW$(ln), LeftM, RightM - LeftM + 1) Else CurrentWord$ = ""
    'get the word under the cursor ]
    LocateTextGraphCursor cry, crx, 0, CursorS, CursorE
End Sub

Sub ReturnCOMBO
    Shared LSHIFT_RSHIFT
    Shared LCTRL_RCTRL
    Shared LALT_RALT

    Shared LALT_HOME
    Shared LALT_END

    Shared LALT_INS
    Shared LALT_DEL

    Shared LALT_PGUP
    Shared LALT_PGDN

    Shared LALT_Left
    Shared LALT_Right
    Shared LALT_Up
    Shared LALT_Down

    Shared RALT_HOME
    Shared RALT_END

    Shared RALT_INS
    Shared RALT_DEL

    Shared RALT_PGUP
    Shared RALT_PGDN

    Shared RALT_Left
    Shared RALT_Right
    Shared RALT_Up
    Shared RALT_Down

    Shared LSHIFT_HOME
    Shared LSHIFT_END

    Shared LSHIFT_INS
    Shared LSHIFT_DEL

    Shared LSHIFT_PGUP
    Shared LSHIFT_PGDN

    Shared LSHIFT_Left
    Shared LSHIFT_Right
    Shared LSHIFT_Up
    Shared LSHIFT_Down

    Shared RSHIFT_HOME
    Shared RSHIFT_END

    Shared RSHIFT_INS
    Shared RSHIFT_DEL

    Shared RSHIFT_PGUP
    Shared RSHIFT_PGDN

    Shared RSHIFT_Left
    Shared RSHIFT_Right
    Shared RSHIFT_Up
    Shared RSHIFT_Down

    Shared LCTRL_HOME
    Shared LCTRL_END

    Shared LCTRL_INS
    Shared LCTRL_DEL

    Shared LCTRL_PGUP
    Shared LCTRL_PGDN

    Shared LCTRL_Left
    Shared LCTRL_Right
    Shared LCTRL_Up
    Shared LCTRL_Down

    Shared RCTRL_HOME
    Shared RCTRL_END

    Shared RCTRL_INS
    Shared RCTRL_DEL

    Shared RCTRL_PGUP
    Shared RCTRL_PGDN

    Shared RCTRL_Left
    Shared RCTRL_Right
    Shared RCTRL_Up
    Shared RCTRL_Down

    Shared LSHIFT_LCTRL_HOME
    Shared LSHIFT_LCTRL_END

    Shared LSHIFT_LCTRL_INS
    Shared LSHIFT_LCTRL_DEL

    Shared LSHIFT_LCTRL_PGUP
    Shared LSHIFT_LCTRL_PGDN

    Shared LSHIFT_LCTRL_Left
    Shared LSHIFT_LCTRL_Right
    Shared LSHIFT_LCTRL_Up
    Shared LSHIFT_LCTRL_Down

    Shared LSHIFT_BackSpace
    Shared LSHIFT_TAB
    Shared LSHIFT_SPACE
    Shared LSHIFT_ESC
    Shared LSHIFT_ENTER

    Shared RSHIFT_BackSpace
    Shared RSHIFT_TAB
    Shared RSHIFT_SPACE
    Shared RSHIFT_ESC
    Shared RSHIFT_ENTER

    Shared LCTRL_SPACE
    Shared LCTRL_ENTER

    Shared RCTRL_SPACE
    Shared RCTRL_ENTER

    If _KeyDown(LSHIFTkey&) And _KeyDown(RSHIFTkey&) Then LSHIFT_RSHIFT = 1 Else LSHIFT_RSHIFT = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(RCTRLkey&) Then LCTRL_RCTRL = 1 Else LCTRL_RCTRL = 0
    If _KeyDown(LALTkey&) And _KeyDown(RALTkey&) Then LALT_RALT = 1 Else LALT_RALT = 0

    'LALT:
    If _KeyDown(LALTkey&) And _KeyDown(HOMEkey&) Then LALT_HOME = 1 Else LALT_HOME = 0
    If _KeyDown(LALTkey&) And _KeyDown(ENDkey&) Then LALT_END = 1 Else LALT_END = 0

    If _KeyDown(LALTkey&) And _KeyDown(INSkey&) Then LALT_INS = 1 Else LALT_INS = 0
    If _KeyDown(LALTkey&) And _KeyDown(DELkey&) Then LALT_DEL = 1 Else LALT_DEL = 0

    If _KeyDown(LALTkey&) And _KeyDown(PGUPkey&) Then LALT_PGUP = 1 Else LALT_PGUP = 0
    If _KeyDown(LALTkey&) And _KeyDown(PGDNkey&) Then LALT_PGDN = 1 Else LALT_PGDN = 0

    If _KeyDown(LALTkey&) And _KeyDown(LEFTkey&) Then LALT_Left = 1 Else LALT_Left = 0
    If _KeyDown(LALTkey&) And _KeyDown(RIGHTkey&) Then LALT_Right = 1 Else LALT_Right = 0
    If _KeyDown(LALTkey&) And _KeyDown(UPkey&) Then LALT_Up = 1 Else LALT_Up = 0
    If _KeyDown(LALTkey&) And _KeyDown(DOWNkey&) Then LALT_Down = 1 Else LALT_Down = 0

    'RALT:
    If _KeyDown(RALTkey&) And _KeyDown(HOMEkey&) Then RALT_HOME = 1 Else RALT_HOME = 0
    If _KeyDown(RALTkey&) And _KeyDown(ENDkey&) Then RALT_END = 1 Else RALT_END = 0

    If _KeyDown(RALTkey&) And _KeyDown(INSkey&) Then RALT_INS = 1 Else RALT_INS = 0
    If _KeyDown(RALTkey&) And _KeyDown(DELkey&) Then RALT_DEL = 1 Else RALT_DEL = 0

    If _KeyDown(RALTkey&) And _KeyDown(PGUPkey&) Then RALT_PGUP = 1 Else RALT_PGUP = 0
    If _KeyDown(RALTkey&) And _KeyDown(PGDNkey&) Then RALT_PGDN = 1 Else RALT_PGDN = 0

    If _KeyDown(RALTkey&) And _KeyDown(LEFTkey&) Then Print RALT_Left = 1 Else RALT_Left = 0
    If _KeyDown(RALTkey&) And _KeyDown(RIGHTkey&) Then RALT_Right = 1 Else RALT_Right = 0
    If _KeyDown(RALTkey&) And _KeyDown(UPkey&) Then RALT_Up = 1 Else RALT_Up = 0
    If _KeyDown(RALTkey&) And _KeyDown(DOWNkey&) Then RALT_Down = 1 Else RALT_Down = 0
    'LSHIFT:
    If _KeyDown(LSHIFTkey&) And _KeyDown(HOMEkey&) Then LSHIFT_HOME = 1 Else LSHIFT_HOME = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(ENDkey&) Then LSHIFT_END = 1 Else LSHIFT_END = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(INSkey&) Then LSHIFT_INS = 1 Else LSHIFT_INS = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(DELkey&) Then LSHIFT_DEL = 1 Else LSHIFT_DEL = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(PGUPkey&) Then LSHIFT_PGUP = 1 Else LSHIFT_PGUP = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(PGDNkey&) Then LSHIFT_PGDN = 1 Else LSHIFT_PGDN = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(LEFTkey&) Then LSHIFT_Left = 1 Else LSHIFT_Left = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(RIGHTkey&) Then LSHIFT_Right = 1 Else LSHIFT_Right = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(UPkey&) Then LSHIFT_Up = 1 Else LSHIFT_Up = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(DOWNkey&) Then LSHIFT_Down = 1 Else LSHIFT_Down = 0

    'RSHIFT:
    If _KeyDown(RSHIFTkey&) And _KeyDown(HOMEkey&) Then RSHIFT_HOME = 1 Else RSHIFT_HOME = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(ENDkey&) Then RSHIFT_END = 1 Else RSHIFT_END = 0

    If _KeyDown(RSHIFTkey&) And _KeyDown(INSkey&) Then RSHIFT_INS = 1 Else RSHIFT_INS = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(DELkey&) Then RSHIFT_DEL = 1 Else RSHIFT_DEL = 0

    If _KeyDown(RSHIFTkey&) And _KeyDown(PGUPkey&) Then RSHIFT_PGUP = 1 Else RSHIFT_PGUP = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(PGDNkey&) Then RSHIFT_PGDN = 1 Else RSHIFT_PGDN = 0

    If _KeyDown(RSHIFTkey&) And _KeyDown(LEFTkey&) Then RSHIFT_Left = 1 Else RSHIFT_Left = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(RIGHTkey&) Then RSHIFT_Right = 1 Else RSHIFT_Right = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(UPkey&) Then RSHIFT_Up = 1 Else RSHIFT_Up = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(DOWNkey&) Then RSHIFT_Down = 1 Else RSHIFT_Down = 0

    'LCTRL:
    If _KeyDown(LCTRLkey&) And _KeyDown(HOMEkey&) Then LCTRL_HOME = 1 Else LCTRL_HOME = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(ENDkey&) Then LCTRL_END = 1 Else LCTRL_END = 0

    If _KeyDown(LCTRLkey&) And _KeyDown(INSkey&) Then LCTRL_INS = 1 Else LCTRL_INS = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(DELkey&) Then LCTRL_DEL = 1 Else LCTRL_DEL = 0

    If _KeyDown(LCTRLkey&) And _KeyDown(PGUPkey&) Then LCTRL_PGUP = 1 Else LCTRL_PGUP = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(PGDNkey&) Then LCTRL_PGDN = 1 Else LCTRL_PGDN = 0

    If _KeyDown(LCTRLkey&) And _KeyDown(LEFTkey&) Then LCTRL_Left = 1 Else LCTRL_Left = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(RIGHTkey&) Then LCTRL_Right = 1 Else LCTRL_Right = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(UPkey&) Then LCTRL_Up = 1 Else LCTRL_Up = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(DOWNkey&) Then LCTRL_Down = 1 Else LCTRL_Down = 0

    'RCTRL:
    If _KeyDown(RCTRLkey&) And _KeyDown(HOMEkey&) Then RCTRL_HOME = 1 Else RCTRL_HOME = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(ENDkey&) Then RCTRL_END = 1 Else RCTRL_END = 0

    If _KeyDown(RCTRLkey&) And _KeyDown(INSkey&) Then RCTRL_INS = 1 Else RCTRL_INS = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(DELkey&) Then RCTRL_DEL = 1 Else RCTRL_DEL = 0

    If _KeyDown(RCTRLkey&) And _KeyDown(PGUPkey&) Then RCTRL_PGUP = 1 Else RCTRL_PGUP = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(PGDNkey&) Then RCTRL_PGDN = 1 Else RCTRL_PGDN = 0

    If _KeyDown(RCTRLkey&) And _KeyDown(LEFTkey&) Then RCTRL_Left = 1 Else RCTRL_Left = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(RIGHTkey&) Then RCTRL_Right = 1 Else RCTRL_Right = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(UPkey&) Then RCTRL_Up = 1 Else RCTRL_Up = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(DOWNkey&) Then RCTRL_Down = 1 Else RCTRL_Down = 0

    'LSHIFT+LCTRL: NOTICE: LSHIFT+LCTRL+Left triggers 3 variables on - 1] LSHIFT_LCTRL_Left 2] LSHIFT_Left 3] LCTRL_Left
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(HOMEkey&) Then LSHIFT_LCTRL_HOME = 1 Else LSHIFT_LCTRL_HOME = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(ENDkey&) Then LSHIFT_LCTRL_END = 1 Else LSHIFT_LCTRL_END = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(INSkey&) Then LSHIFT_LCTRL_INS = 1 Else LSHIFT_LCTRL_INS = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(DELkey&) Then LSHIFT_LCTRL_DEL = 1 Else LSHIFT_LCTRL_DEL = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(PGUPkey&) Then LSHIFT_LCTRL_PGUP = 1 Else LSHIFT_LCTRL_PGUP = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(PGDNkey&) Then LSHIFT_LCTRL_PGDN = 1 Else LSHIFT_LCTRL_PGDN = 0

    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(LEFTkey&) Then LSHIFT_LCTRL_Left = 1 Else LSHIFT_LCTRL_Left = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(RIGHTkey&) Then LSHIFT_LCTRL_Right = 1 Else LSHIFT_LCTRL_Right = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(UPkey&) Then LSHIFT_LCTRL_Up = 1 Else LSHIFT_LCTRL_Up = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(LCTRLkey&) And _KeyDown(DOWNkey&) Then LSHIFT_LCTRL_Down = 1 Else LSHIFT_LCTRL_Down = 0

    'LSHIFT:
    If _KeyDown(LSHIFTkey&) And _KeyDown(BACKSPCkey&) Then LSHIFT_BackSpace = 1 Else LSHIFT_BackSpace = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(TABkey&) Then LSHIFT_TAB = 1 Else LSHIFT_TAB = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(SPACEkey&) Then LSHIFT_SPACE = 1 Else LSHIFT_SPACE = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(ESCkey&) Then LSHIFT_ESC = 1 Else LSHIFT_ESC = 0
    If _KeyDown(LSHIFTkey&) And _KeyDown(ENTERkey&) Then LSHIFT_ENTER = 1 Else LSHIFT_ENTER = 0
    'RSHIFT:
    If _KeyDown(RSHIFTkey&) And _KeyDown(BACKSPCkey&) Then RSHIFT_BackSpace = 1 Else RSHIFT_BackSpace = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(TABkey&) Then RSHIFT_TAB = 1 Else RSHIFT_TAB = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(SPACEkey&) Then RSHIFT_SPACE = 1 Else RSHIFT_SPACE = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(ESCkey&) Then RSHIFT_ESC = 1 Else RSHIFT_ESC = 0
    If _KeyDown(RSHIFTkey&) And _KeyDown(ENTERkey&) Then RSHIFT_ENTER = 1 Else RSHIFT_ENTER = 0

    'LCTRL:
    If _KeyDown(LCTRLkey&) And _KeyDown(SPACEkey&) Then LCTRL_SPACE = 1 Else LCTRL_SPACE = 0
    If _KeyDown(LCTRLkey&) And _KeyDown(ENTERkey&) Then LCTRL_ENTER = 1 Else LCTRL_ENTER = 0
    'RCTRL:
    If _KeyDown(RCTRLkey&) And _KeyDown(SPACEkey&) Then RCTRL_SPACE = 1 Else RCTRL_SPACE = 0
    If _KeyDown(RCTRLkey&) And _KeyDown(ENTERkey&) Then RCTRL_ENTER = 1 Else RCTRL_ENTER = 0

    '_KEYCLEAR
End Sub

Sub ShowF1
    Shared revision$, revDATE$
    Print "________   .__                          .__    __                   "
    Print "\______ \  |__|_______ __  _  _______   |  |  |  | __  ____ _______ "
    Print " |    |  \ |  |\_  __ \\ \/ \/ /\__  \  |  |  |  |/ /_/ __ \\_  __ \"
    Print " |    `   \|  | |  | \/ \     /  / __ \_|  |__|    < \  ___/ |  | \/"
    Print "/_______  /|__| |__|     \/\_/  (____  /|____/|__|_ \ \___  >|__|   "
    Print "        \/                           \/            \/     \/        "
    Print "'Dirwalker' - Linux/Windows simplistic directory browser, written by Kaze(sanmayce@sanmayce.com), revision "; revision$; ", "; revDATE$
    Print "Mouse:"
    Print "    Button 1 - sets the cursor and the inverse line to the chosen position; hold (without moving for 4 seconds) to quit"
    Print "    Button 2 - [when held] Draws; hold (without moving for 4 seconds) - toggles Directory/TreeFILE mode; it is as Double-LShift but shows also 'stats' in TREE mode"
    Print "    Button 3 - [when released] - enters the DIRECTORY; Wheel Up/Dn - Up/Dn; Button 2 + Wheel Up/Dn - same as PgUp/PgDn"
    '        Print "       Button 2 + Wheel Up/Dn - going to the top/bottom left position"
    Print "    Button 2 + dragging (sideways) for at least 3/4 of all columns/cells (within 2 seconds) - same as Alt+X, Alt+Q"
    Print "    Button 2 + dragging (from top to bottom) for at least 7 lines/cells (within 2 seconds) - same as PgUp"
    Print "    Button 2 + dragging (from bottom to top) for at least 7 lines/cells (within 2 seconds) - same as PgDn"
    Print "    Button 2 + dragging (from left to right) for at least 1/4 of all columns/cells (within 2 seconds) - hides RightsidePanel"
    Print "    Button 2 + dragging (from right to left) for at least 1/4 of all columns/cells (within 2 seconds) - shows RightsidePanel"
    Print "    Button 1 + Button 1 (within 0.33 seconds) - Double-Left-Click - PgUp"
    Print "    Button 2 + Button 2 (within 0.33 seconds) - Double-Right-Click - PgDn"
    Print "Mouse+Keyboard:"
    Print "    LShift + Button 1/2 - Burst Up/Dn; LCtrl + Button 1/2 - Burst PgUp/PgDn"
    Print "    LShift + LCtrl + Button 1/2 = LCtrl+Home - going to the top left position / LCtrl+End - going to the bottom left position"
    ' LAlt + Button 1 is used already in Linux (for hand tool)
    '        Print "       LAlt + Button 1/2 = LCtrl+Home - going to the top left position / LCtrl+End - going to the bottom left position"
    Print "Keyboard:"
    Print "    Double-LShift - toggles Directory/TreeFILE mode; Double-RShift - toggles Directory/TreeDIRECTORY mode; Double-LCtrl or Enter(released) - enters the DIRECTORY" ' Double-LCtrl "executes" the FILE (runs vlc in Linux, or just relies on association in Windows)
    Print "    F1(released), F2(released), F3(released), F4(released) sorts the respective FileType/FileSize/FileModifiedTime/FileName column, F12(released) Torus, F5(released) ASCII table"
    Print "    Ctrl+Home/End - going to the top/bottom left position; Up/Dn/PgUp/PgDn; Ins - toggles low/high cursor"
    Print "    Double-LAlt or Alt+Enter - toggles window/fullscreen mode; Alt+X, Ctrl+X, Alt+Q or Ctrl+Q - quit to the system, without demanding keypress"
    'Print "   LCtrl+F3 - Search Panel, Kazahana (with 16 threads) searches Externally the file, currently displayed"
    'Print "   LAlt+F3 released - Non-Interactive search for Current_Word, from the line below the INVERSE one, downward"
    'Print "   LShift+F3 released - Non-Interactive search for CLIPBOARD, from the line below the INVERSE one, downward"
    'Print "   F2/F3 released - Search Panel, Interactive search for User_Input, from the line below the INVERSE one, downward"
    'Note: The [LShift+]F3 search modes are Exact and Case-Sensitive, non-whole word as well
    Print "    LCtrl+RCtrl - Reporting (in status line in red color) the time for PgDn-ing (page-by-page) the entire directory"
    Print "    LShift+RShift - Reporting (in status line in red color) the time for Down-ing (line-by-line) the entire directory"
    Print "    Esc - Stops the auto-scrolling started with LCtrl+RCtrl or LShift+RShift; `(released) - Wildcard Case-Insensitive Animated Search, under the INVERSE one, downward"
    Print "    /(released) - Wildcard Case-Insensitive Filter for currently loaded list; Double-TAB - toggles Directory/TreeFILE mode with BLAKE3-256"
    Print "    Double-LCtrl - "; Chr$(34); "executes"; Chr$(34); " the current FILE (runs vlc in Linux, or just relies on association in Windows)"
    Print "Notes:"
    Print "    During the auto-scroll, you can still press PgUp, PgDn, Ctrl+Home, Ctrl+End, Esc; Move mouse cursor within 3 most right columns to unhide the ScrollBar/ToolRibbon"
    Print "    For font, hit '4' 16x32 Cordata, 'T' 2x(8x16) Toshiba, 'F' 8x16 Fujitsu, 'D' 16x16 Fujitsu, 'S' 8x16 Stingray, 'C' 8x16 CompaqThin, 'V' 6x12 DOS-V, '8' 8x8 Toshiba, 'J' 12x24 DOS-V" ' 'A' 6x8 Atari
    'Print "    Writing (in APPEND mode) each visited DIRECTORY to 'Dirwalker.log.txt', located in the invoking (home to the binary) folder"
    Print "    Pressing Ctrl+S writes current list down (to 'Dirwalker_'+DATE$+TIME$+'.txt'), in the current folder"
End Sub

Sub UpdateCLL (l)
    Shared XdimCOL
    Shared YdimROW
    Shared FileCount
    crx = Pos(0)
    cry = CsrLin
    RepStr$ = "Line: " + AddCommasPaddedNUM$(l) + "]"
    prcn% = l * 100! / FileCount
    Select Case prcn%
        Case Is <= 9:
            prcn$ = "00" + LTrim$(Str$(prcn%))
        Case Is <= 99
            prcn$ = "0" + LTrim$(Str$(prcn%))
        Case Else
            prcn$ = "100"
    End Select
    RepStr$ = "Offset: " + prcn$ + "%; " + RepStr$
    LocateTextGraphCursor YdimROW + 1, XdimCOL - Len(RepStr$) + 1, 0, CursorS, CursorE: Color 9, 0
    Print RepStr$;
    LocateTextGraphCursor cry, crx, 0, CursorS, CursorE
End Sub

Sub UpdateNextToCCL_ProgressBar (CurrentVal, MaximumVal, BPS)
    Shared XdimCOL
    Shared YdimROW
    crx = Pos(0)
    cry = CsrLin
    ProgressBarLen = XdimCOL - Len("[Status: BUSY; ") - Len("]")
    ' MaximumVal : ProgressBarLen
    SearchRate$ = AddZeros$(BPS)
    If BPS > 999999 Then SearchRate$ = "999,999"
    LocateTextGraphCursor YdimROW + 1, XdimCOL - Len("To skip the rest, press 'Esc', " + SearchRate$ + " KB/s"), 0, CursorS, CursorE: Color 9, 0: Print "To skip the rest, press 'Esc', " + SearchRate$ + " KB/s";
    StatuLine$ = "[Status: BUSY; " + String$((CurrentVal * ProgressBarLen) \ MaximumVal, Chr$(176))
    LocateTextGraphCursor YdimROW + 1, 1, 0, CursorS, CursorE: Color 9, 0: Print StatuLine$;
    LocateTextGraphCursor cry, crx, 0, CursorS, CursorE
    _Display
End Sub

Sub UpdateNextToCCL_ProgressBarDUPLICATE (CurrentVal, MaximumVal)
    Shared XdimCOL
    Shared YdimROW
    crx = Pos(0)
    cry = CsrLin
    ProgressBarLen = XdimCOL - Len("[Status: BUSY; ") - Len("]")
    ' MaximumVal : ProgressBarLen
    SearchRate$ = AddZeros$(BPS)
    LocateTextGraphCursor YdimROW + 1, XdimCOL - ProgressBarLen, 0, CursorS, CursorE: Color 9, 0: Print Space$(ProgressBarLen);
    LocateTextGraphCursor YdimROW + 1, XdimCOL - Len("Tagging with unique/DUPLET ..."), 0, CursorS, CursorE: Color 9, 0: Print "Tagging with unique/DUPLET ...";
    StatuLine$ = "[Status: BUSY; " + String$((CurrentVal * ProgressBarLen) \ MaximumVal, Chr$(176))
    LocateTextGraphCursor YdimROW + 1, 1, 0, CursorS, CursorE: Color 9, 0: Print StatuLine$;
    LocateTextGraphCursor cry, crx, 0, CursorS, CursorE
    _Display
End Sub

Sub UpdateNextToCCL_BUSY (LastKeyMouse$)
    Shared XdimCOL
    Shared YdimROW
    crx = Pos(0)
    cry = CsrLin
    If LastKeyMouse$ = "" Then LastKeyMouse$ = Chr$(34) + Chr$(34)
    StatuLine$ = "[Status: BUSY; LastKeyMouseInput: " + LastKeyMouse$ + ";"
    LocateTextGraphCursor YdimROW + 1, 1, 0, CursorS, CursorE: Color 9, 0: Print Space$((XdimCOL - posit) - 1) + "]";
    LocateTextGraphCursor YdimROW + 1, 1, 0, CursorS, CursorE: Color 9, 0: Print StatuLine$;
    LocateTextGraphCursor cry, crx, 0, CursorS, CursorE
    Greyscaling: _Display
    _Delay .5
End Sub

Sub UpdateNextToCCL_DONE (LastKeyMouse$)
    Shared XdimCOL
    Shared YdimROW
    crx = Pos(0)
    cry = CsrLin
    If LastKeyMouse$ = "" Then LastKeyMouse$ = Chr$(34) + Chr$(34)
    StatuLine$ = "[Status: DONE; LastKeyMouseInput: " + LastKeyMouse$ + ";"
    LocateTextGraphCursor YdimROW + 1, 1, 0, CursorS, CursorE: Color 9, 0: Print Space$((XdimCOL - posit) - 1) + "]";
    LocateTextGraphCursor YdimROW + 1, 1, 0, CursorS, CursorE: Color 9, 0: Print StatuLine$;
    LocateTextGraphCursor cry, crx, 0, CursorS, CursorE
    SetOriginalColorScheme: _Display
End Sub

' Written by Sanmayce, 2021-Dec-12
' The indexes are signed, but the elements are unsigned.
_Define A-Z As _INTEGER64
Sub Quicksort_QB64_Granularity (MemBlock As _MEM, NumberOfElements As _Integer64, Granularity As Integer)
    Left = 1 - 1
    Right = NumberOfElements - 1
    ReDim Stack&&(Left To Right)
    SwapBuffer$ = Space$(Granularity)
    Pivot$ = Space$(Granularity)
    StackPtr = 0
    StackPtr = StackPtr + 1
    Stack&&(StackPtr) = Left
    StackPtr = StackPtr + 1
    Stack&&(StackPtr) = Right
    Do 'Until StackPtr = 0
        Right = Stack&&(StackPtr)
        StackPtr = StackPtr - 1
        Left = Stack&&(StackPtr)
        StackPtr = StackPtr - 1
        Do 'Until Left >= Right
            'Pivot~&& = QWORDS~&&((Left + Right) \ 2)
            memcpyKAZE _Offset(Pivot$), MemBlock.OFFSET + Granularity * ((Left + Right) \ 2), Granularity
            Indx = Left
            Jndx = Right
            Do
                'Do While (QWORDS~&&(Indx) < Pivot~&&)
                BuggyWithLinuxNotOneOrMinusOne% = memcmpKAZE%(MemBlock.OFFSET + Granularity * Indx, _Offset(Pivot$), Granularity)
                Do While (BuggyWithLinuxNotOneOrMinusOne% < 0) '= -1)
                    Indx = Indx + 1
                    BuggyWithLinuxNotOneOrMinusOne% = memcmpKAZE%(MemBlock.OFFSET + Granularity * Indx, _Offset(Pivot$), Granularity)
                Loop
                'Do While (QWORDS~&&(Jndx) > Pivot~&&)
                BuggyWithLinuxNotOneOrMinusOne% = memcmpKAZE%(MemBlock.OFFSET + Granularity * Jndx, _Offset(Pivot$), Granularity)
                Do While (BuggyWithLinuxNotOneOrMinusOne% > 0) '= 1)
                    Jndx = Jndx - 1
                    BuggyWithLinuxNotOneOrMinusOne% = memcmpKAZE%(MemBlock.OFFSET + Granularity * Jndx, _Offset(Pivot$), Granularity)
                Loop
                If Indx <= Jndx Then
                    If Indx < Jndx Then
                        'Swap QWORDS~&&(Indx), QWORDS~&&(Jndx)
                        memcpyKAZE _Offset(SwapBuffer$), MemBlock.OFFSET + Granularity * Jndx, Granularity
                        memcpyKAZE MemBlock.OFFSET + Granularity * Jndx, MemBlock.OFFSET + Granularity * Indx, Granularity
                        memcpyKAZE MemBlock.OFFSET + Granularity * Indx, _Offset(SwapBuffer$), Granularity
                    End If
                    Indx = Indx + 1
                    Jndx = Jndx - 1
                End If
            Loop While Indx <= Jndx
            If Indx < Right Then
                StackPtr = StackPtr + 1
                Stack&&(StackPtr) = Indx
                StackPtr = StackPtr + 1
                Stack&&(StackPtr) = Right
            End If
            Right = Jndx
        Loop Until Left >= Right
    Loop Until StackPtr = 0
End Sub

Sub Greyscaling
    Shared GraphicOrTextFlag
    'If GraphicOrTextFlag = 0 Then
    ReDim red(0 To 15)
    ReDim grn(0 To 15)
    ReDim blu(0 To 15)
    For attribute = 0 To 15
        Out &H3C7, attribute 'set color attribute to read
        red = Inp(&H3C9) * 4 'multiply by 4 to convert intensity to 0 to 255 RGB values
        grn = Inp(&H3C9) * 4
        blu = Inp(&H3C9) * 4
        red(attribute) = red
        grn(attribute) = grn
        blu(attribute) = blu
    Next
    'Sepiascale
    'outputRed = (inputRed * .393) + (inputGreen * .769) + (inputBlue * .189)
    'outputGreen = (inputRed * .349) + (inputGreen * .686) + (inputBlue * .168)
    'outputBlue = (inputRed * .272) + (inputGreen * .534) + (inputBlue * .131)
    For i = 0 To 15
        'Sepiascale
        '_PaletteColor i, _RGB32(Int(red(i) * .393) + Int(grn(i) * .769) + Int(blu(i) * .189), Int(red(i) * .349) + Int(grn(i) * .686) + Int(blu(i) * .168), Int(red(i) * .272) + Int(grn(i) * .534) + Int(blu(i) * .131))
        'Greyscale
        _PaletteColor i, _RGB32((red(i) + grn(i) + blu(i)) \ 3, (red(i) + grn(i) + blu(i)) \ 3, (red(i) + grn(i) + blu(i)) \ 3)
        'Amberscale
    Next
    'End If
End Sub

Sub SetOriginalColorScheme
    Shared GraphicOrTextFlag
    'If GraphicOrTextFlag = 0 Then
    'Colorscale .000..255:

    '0   Black            0             0             0
    '1   Dark Blue        0             0             168
    '2   Dark Green       0             168           0
    '3   Dark Cyan        0             168           168
    '4   Dark Red         168           0             0
    '5   Dark Magenta     168           0             168
    '6   Dark Yellow      168           84            0
    '7   Light Grey       168           168           168

    '8+0 Dark Grey        84            84            84
    '8+1 Blue             84            84            252
    '8+2 Green            84            252           84
    '8+3 Cyan             84            252           252
    '8+4 Red              252           84            84
    '8+5 Magenta          252           84            252
    '8+6 Yellow           252           252           84
    '8+7 White            252           252           252

    'Colorscale 00..63:
    '0   Black            0      0       0
    '1   Dark Blue        0      0      42
    '2   Dark Green       0     42       0
    '3   Dark Cyan        0     42      42
    '4   Dark Red        42      0       0
    '5   Dark Magenta    42      0      42
    '6   Dark Yellow     42     21       0
    '7   Light Grey      42     42      42

    '8+0 Dark Grey       21     21      21
    '8+1 Blue            21     21      63
    '8+2 Green           21     63      21
    '8+3 Cyan            21     63      63
    '8+4 Red             63     21      21
    '8+5 Magenta         63     21      63
    '8+6 Yellow          63     63      21
    '8+7 White           63     63      63

    'Colorscale
    _PaletteColor 0, _RGB32(0, 0, 0)
    _PaletteColor 1, _RGB32(0, 0, 168)
    _PaletteColor 2, _RGB32(0, 168, 0)
    _PaletteColor 3, _RGB32(0, 168, 168)
    _PaletteColor 4, _RGB32(168, 0, 0)
    _PaletteColor 5, _RGB32(168, 0, 168)
    _PaletteColor 6, _RGB32(168, 84, 0)
    _PaletteColor 7, _RGB32(168, 168, 168)

    _PaletteColor 8, _RGB32(84, 84, 84)
    _PaletteColor 9, _RGB32(84, 84, 252)
    _PaletteColor 10, _RGB32(84, 252, 84)
    _PaletteColor 11, _RGB32(84, 252, 252)
    _PaletteColor 12, _RGB32(252, 84, 84)
    _PaletteColor 13, _RGB32(252, 84, 252)
    _PaletteColor 14, _RGB32(252, 252, 84)
    _PaletteColor 15, _RGB32(252, 252, 252)

    _PaletteColor 3, _RGB32(0, 168 - 10, 168 - 10) 'darker Cyan
    _PaletteColor 8, _RGB32(84 - 22, 84 - 22, 84 - 22) 'make Grey darker

    _PaletteColor 4, _RGB32(110, 2, 25) 'Carminish
    _PaletteColor 4 + 8, _RGB32(110 + 44, 2 + 44, 25 + 44) 'make Carmin more lighter

    _PaletteColor 1, _RGB32(168 - 20, 84 - 20, 0) 'make the Amber more darker
    _PaletteColor 6 + 8, _RGB32(168 + 54, 84 + 54, 0) 'make the Amber more lighter

    ' Change the Purple to SteelBlue
    _PaletteColor 5, _RGB32(33, 99, 122)
    _PaletteColor 5 + 8, _RGB32(33 + 44, 99 + 44, 122 + 44)
    ' Change the Green to Cyanish
    _PaletteColor 2, _RGB32(1, 80, 80)
    _PaletteColor 2 + 8, _RGB32(1 + 44, 80 + 44, 80 + 44)
    'End If
End Sub

Sub ReportTimeToScroll
    Shared YdimROW, XdimCOL
    Shared TimeScrollA, TimeScrollB
    Shared LineScrollBenchmark
    Shared PageScrollBenchmark
    Shared FileCount
    crx = Pos(0)
    cry = CsrLin
    ElapsedTime% = TimeScrollB - TimeScrollA
    If ElapsedTime% < 0 Then ElapsedTime% = (86400 - TimeScrollA) + TimeScrollB
    If ElapsedTime% = 0 Then ElapsedTime% = 1
    'Line-By-Line or Line granularity Scroll Rate; LPS stands for Lines-Per-Second
    'Page-By-Page or Page granularity Scroll Rate; PPS stands for Pages-Per-Second
    'Locate YdimROW + 1, posit: Color 4, 0: Print Space$((XdimCOL - posit) - 0);
    LocateTextGraphCursor YdimROW + 1, 1, 0, CursorS, CursorE: Color 9, 0: Print "["; Space$((XdimCOL - posit) - 2) + "]";
    If XdimCOL > 130 Then
        If LineScrollBenchmark = 1 Then LocateTextGraphCursor YdimROW + 1, 2, 0, CursorS, CursorE: Color 4, 0: Print "DOWNed in"; ElapsedTime%; "second(s), or "; AddCommas$(FileCount / ElapsedTime%); " LPS (Line-By-Line or Line granularity Scroll Rate; LPS stands for Lines-Per-Second)";
        If PageScrollBenchmark = 1 Then LocateTextGraphCursor YdimROW + 1, 2, 0, CursorS, CursorE: Color 4, 0: Print "PGDNed in"; ElapsedTime%; "second(s), or "; AddCommas$((FileCount / YdimROW) / ElapsedTime%); " PPS (Page-By-Page or Page granularity Scroll Rate; PPS stands for Pages-Per-Second)";
    Else
        If LineScrollBenchmark = 1 Then LocateTextGraphCursor YdimROW + 1, 2, 0, CursorS, CursorE: Color 4, 0: Print "DOWNed in"; ElapsedTime%; "second(s).";
        If PageScrollBenchmark = 1 Then LocateTextGraphCursor YdimROW + 1, 2, 0, CursorS, CursorE: Color 4, 0: Print "PGDNed in"; ElapsedTime%; "second(s).";
    End If
    LocateTextGraphCursor cry, crx, 0, CursorS, CursorE
End Sub

Function DrawBoxShadowDUMMY$ (BckGRcolor, TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, FileCount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    Color 8, BACKGR
    For i = 1 To MIN&(YdimROW, FileCount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
        End If
    Next
    'Outer frame
    LocateTextGraphCursor TopLrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: LocateTextGraphCursor TopLrow, TopLcol + 2, 0, CursorS, CursorE: Print "[ ";: Color 15 - 8, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: LocateTextGraphCursor i, TopLcol, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor BottomRrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    'In case of YdimROW = 40 then shrunk panel
    shrunkP = 14 'BckGRcolor * 6
    LocateTextGraphCursor TopLrow + 38 - 23 - shrunkP, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 39 - 23 - shrunkP To TopLrow + 40 - 23 - shrunkP
        Color 0, BckGRcolor: LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor TopLrow + 40 - 23 - shrunkP, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    LocateTextGraphCursor TopLrow + 2, TopLcol + 2, 0, CursorS, CursorE
    Color 7, BckGRcolor

    HelpLine$ = "Edit keys, allowed: Home, Left, Right, End, Backspace, Del, Esc"
    LocateTextGraphCursor TopLrow + 41 - 23 - shrunkP, TopLcol + 3, 0, CursorS, CursorE: Print HelpLine$
    Color 0, BckGRcolor
    LocateTextGraphCursor TopLrow + 41 - 23 - shrunkP, TopLcol + 2, 0, CursorS, CursorE: Print "["
    LocateTextGraphCursor TopLrow + 41 - 23 - shrunkP, TopLcol + 3 + Len(HelpLine$), 0, CursorS, CursorE: Print "]"
    Color BckGRcolor, 0: LocateTextGraphCursor TopLrow + 41 - 23 - shrunkP - 2, TopLcol + 2, 0, CursorS, CursorE: Print "Background ";: Color BckGRcolor + 8, 0: Print "Background+8";: Color , BckGRcolor: Color 0: Print " COLOR #00 ";: Color 8: Print " COLOR #08 ";: Color 9: Print " COLOR #09 ";: Color 10: Print " COLOR #10 ";: Color 11: Print " COLOR #11 ";: Color 12: Print " COLOR #12 ";: Color 13: Print " COLOR #13 ";: Color 14: Print " COLOR #14 ";
    _Display
    DrawBoxShadowDUMMY$ = InKey$
    LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
End Function

Sub DrawBoxShadowINFO (BckGRcolor, TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared YdimROW, FileCount, File_Frame_y, XdimCOL, FileArrayWINDOW$()
    'Shadow
    Color 8, BACKGR
    For i = 1 To MIN&(YdimROW, FileCount)
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
        End If
    Next
    'Outer frame
    LocateTextGraphCursor TopLrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: LocateTextGraphCursor TopLrow, TopLcol + 2, 0, CursorS, CursorE: Print "[ ";: Color 15 - 8, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: LocateTextGraphCursor i, TopLcol, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor BottomRrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)

    'Inner frame
    LocateTextGraphCursor TopLrow + 1, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));

    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 2 To BottomRrow - 2
        Color 0, BckGRcolor: LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor BottomRrow - 1, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    'Locate TopLrow + 2, TopLcol + 2
    'Color 11, BckGRcolor: Locate TopLrow + 2, TopLcol + 2: Print "Background ";
    _Display
End Sub

Sub DrawBoxCAPTION (BckGRcolor, TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, FileCount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    Shared NormalFRGr, NormalBCKGr
    'Shadow
    'Color 8, BACKGR
    'For i = 1 To MIN&(YdimROW, FileCount)
    '        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
    '        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
    '        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
    '        'ELSE
    '        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
    '        'END IF
    '        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
    '                Locate i, TopLcol + 1: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
    '        End If
    'Next
    'Outer frame
    LocateTextGraphCursor TopLrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    If Captnn$ <> "" Then
        Color 7, BckGRcolor: LocateTextGraphCursor TopLrow, TopLcol + 2, 0, CursorS, CursorE: Print "[ ";: Color 7, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    End If
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: LocateTextGraphCursor i, TopLcol, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor BottomRrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217);

    DrawButtonHi BckGRcolor, TopLrow + 2, TopLcol + 2, TopLrow + 2 + 2, BottomRcol - 2
    DrawButtonHi BckGRcolor, TopLrow + 5, TopLcol + 2, TopLrow + 5 + 2, BottomRcol - 2
    DrawButtonHi BckGRcolor, TopLrow + 8, TopLcol + 2, TopLrow + 8 + 2, BottomRcol - 2
    LocateTextGraphCursor TopLrow + 2 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "Top - Ctrl+Home"
    LocateTextGraphCursor TopLrow + 5 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "PgUp"
    LocateTextGraphCursor TopLrow + 8 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "Up"

    DrawButtonHi BckGRcolor, TopLrow + 12, TopLcol + 2, TopLrow + 12 + 2, BottomRcol - 2
    DrawButtonHi BckGRcolor, TopLrow + 15, TopLcol + 2, TopLrow + 15 + 2, BottomRcol - 2
    DrawButtonHi BckGRcolor, TopLrow + 18, TopLcol + 2, TopLrow + 18 + 2, BottomRcol - 2
    DrawButtonHi BckGRcolor, TopLrow + 21, TopLcol + 2, TopLrow + 21 + 2, BottomRcol - 2
    LocateTextGraphCursor TopLrow + 12 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "F1 - Sort by FileType i.e. Column #1"
    LocateTextGraphCursor TopLrow + 15 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "F2 - Sort by FileSize i.e. Column #2"
    LocateTextGraphCursor TopLrow + 18 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "F3 - Sort by FileTime i.e. Column #3"
    LocateTextGraphCursor TopLrow + 21 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "F4 - Sort by FileName i.e. Column #4"

    DrawButtonHi BckGRcolor, TopLrow + 24, TopLcol + 2, TopLrow + 24 + 2, BottomRcol - 2
    DrawButtonHi BckGRcolor, TopLrow + 27, TopLcol + 2, TopLrow + 27 + 2, BottomRcol - 2
    DrawButtonHi BckGRcolor, TopLrow + 30, TopLcol + 2, TopLrow + 30 + 2, BottomRcol - 2
    LocateTextGraphCursor TopLrow + 24 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "Enter - enters the DIRECTORY"
    LocateTextGraphCursor TopLrow + 27 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "DoubleTap LShift - toggle mode"
    LocateTextGraphCursor TopLrow + 30 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "Alt+X or Alt+Q - quit to the system"

    DrawButtonHi BckGRcolor, BottomRrow - 9, TopLcol + 2, BottomRrow - 9 + 2, BottomRcol - 2
    DrawButtonHi BckGRcolor, BottomRrow - 6, TopLcol + 2, BottomRrow - 6 + 2, BottomRcol - 2
    DrawButtonHi BckGRcolor, BottomRrow - 3, TopLcol + 2, BottomRrow - 3 + 2, BottomRcol - 2
    LocateTextGraphCursor BottomRrow - 9 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "Dn"
    LocateTextGraphCursor BottomRrow - 6 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "PgDn"
    LocateTextGraphCursor BottomRrow - 3 + 1, TopLcol + 2 + 2, 0, CursorS, CursorE: Print "End - Ctrl+End"

    UpdateWindowFrame NormalFRGr, NormalBCKGr
    _Display
End Sub

Sub DrawButtonHi (BckGRcolor, TopLrow, TopLcol, BottomRrow, BottomRcol)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, FileCount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    ''Shadow
    'Color 8, BACKGR
    'For i = 1 To MIN&(YdimROW, FileCount)
    '        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
    '        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
    '        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
    '        'ELSE
    '        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
    '        'END IF
    '        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
    '                Locate i, TopLcol + 1: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
    '        End If
    'Next
    'Outer frame
    LocateTextGraphCursor TopLrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: LocateTextGraphCursor i, TopLcol, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor BottomRrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217);
End Sub

Sub DrawButtonLo (BckGRcolor, TopLrow, TopLcol, BottomRrow, BottomRcol)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, FileCount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    ''Shadow
    'Color 8, BACKGR
    'For i = 1 To MIN&(YdimROW, FileCount)
    '        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
    '        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
    '        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
    '        'ELSE
    '        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
    '        'END IF
    '        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
    '                Locate i, TopLcol + 1: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
    '        End If
    'Next
    'Inner frame
    LocateTextGraphCursor TopLrow, TopLcol, 0, CursorS, CursorE
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));

    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 1 To BottomRrow - 1
        Color 0, BckGRcolor: LocateTextGraphCursor i, TopLcol, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor BottomRrow, TopLcol, 0, CursorS, CursorE
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217);
End Sub

$If WINDOWS Then
    Function PATHpsp$ 'TITLE$
    'Shared PATH$ 'optional path information shared with main module only
    Declare Library 'Directory Information using KERNEL32 provided by Dav
    Function GetModuleFileNameA (ByVal Module As Long, FileName As String, Byval nSize As Long)
    End Declare

    FileName$ = Space$(256)
    Result = GetModuleFileNameA(0, FileName$, Len(FileName$)) '0 designates the current program
    If Result Then 'Result returns the length or bytes of the string information
    PATH$ = Left$(FileName$, Result)
    start = 1
    Do
    posit = InStr(start, PATH$, "\")
    If posit Then last = posit
    start = posit + 1
    Loop Until posit = 0
    'TITLE$ = Mid$(PATH$, last + 1)
    PATHpsp$ = Left$(PATH$, last)
    Else
    'TITLE$ = ""
    PATHpsp$ = ""
    End If
    End Function
$End If

Function DrawBoxShadow3exact$ (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, FileCount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    BckGRcolor = 6
    Color 8, BACKGR
    For i = 1 To MIN&(YdimROW, FileCount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
        End If
    Next
    'Outer frame
    LocateTextGraphCursor TopLrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: LocateTextGraphCursor TopLrow, TopLcol + 2, 0, CursorS, CursorE: Print "[ ";: Color 15 - 8, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: LocateTextGraphCursor i, TopLcol, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor BottomRrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    LocateTextGraphCursor TopLrow + 1, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 2 To TopLrow + 3
        Color 0, BckGRcolor: LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor TopLrow + 3, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    LocateTextGraphCursor TopLrow + 2, TopLcol + 2, 0, CursorS, CursorE
    Color 7, BckGRcolor

    HelpLine1$ = "Edit keys, allowed: Home, Left, Right, End, Backspace, Del, Esc, `(released)"
    HelpLine2$ = "Wildcards, allowed: '*' any character(s) or empty; '#' any character and not empty"
    LocateTextGraphCursor TopLrow + 4, TopLcol + 2, 0, CursorS, CursorE: Print HelpLine1$
    LocateTextGraphCursor TopLrow + 5, TopLcol + 2, 0, CursorS, CursorE: Print HelpLine2$
    _Display
    DrawBoxShadow3exact$ = InputLine$(TopLrow + 2, TopLcol + 2, BottomRcol - TopLcol - 1 - 2)
    LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
End Function

Function InputLine$ (Irow, Icol, LineLen)
    Static a$
    Shared CurrentWord$, FramesPerSecond
    LocateTextGraphCursor Irow, Icol, 1, CursorS, CursorE
    MaxCol = Icol + LineLen - 1
    CurCol = Icol 'Icol..MaxCol
    'IF CurrentWord$ = "" THEN
    '    IF INSTR(_CLIPBOARD$, CHR$(10)) THEN '_CLIPBOARD$ could be multi-line, so get the first
    '        a2$ = LEFT$(_CLIPBOARD$, INSTR(_CLIPBOARD$, CHR$(10)) - 1)
    '        IF RIGHT$(a2$, 1) = CHR$(13) THEN a2$ = LEFT$(a2$, LEN(a2$) - 1)
    '        a$ = LEFT$(a2$, LineLen - 1) '""
    '    ELSE
    '        a$ = LEFT$(_CLIPBOARD$, LineLen - 1) '""
    '    END IF
    '    CurCol = Icol + LEN(a$)
    'ELSE
    '    a$ = CurrentWord$
    'END IF

    '_Delay .5 ' This kinda fixes the nasty (again) inability to handle release of ~ - it enters the function as if ~ was released within?!
    RsmLoop:
    _KeyClear
    BuggyInLinux& = 0
    Do
        ' Kaze's Galeon's non-fix of the problem (on Fedora 35) below [
        x = _KeyHit
        If x Then
            If x < 0 Then 'negative value means key released
                x = -x
                If x = 96 And _KeyDown(96) = 0 Then Exit Do
            Else
            End If
        End If
        ' Kaze's Galeon's non-fix of the problem (on Fedora 35) below ]

        '    ' On Windows 10, after a minute, self activating?!
        '    'BuggyInLinux& = _KeyDown(96)
        '    'If BuggyInLinux& Then
        '    '    IsTILDEreleased = -1
        '    'Else
        '    '    If IsTILDEreleased = -1 Then IsTILDEreleased = 1 Else IsTILDEreleased = 0
        '    'End If
        '    'If IsTILDEreleased = 1 Then IsTILDEreleased = 0: Exit Do

        key$ = InKey$
        ' Even this doesn't fix it fully, holding for 5+ seconds triggers .... release?! [
        'If key$ <> "" Then
        '    BuggyInLinux& = _KeyDown(96)
        'End If
        'If BuggyInLinux& Then
        '    BuggyInLinux& = _KeyDown(96)
        '    IsTILDEreleased = -1
        'Else
        '    If IsTILDEreleased = -1 Then IsTILDEreleased = 1 Else IsTILDEreleased = 0
        'End If
        'If IsTILDEreleased = 1 Then IsTILDEreleased = 0: Exit Do
        ' Even this doesn't fix it fully, holding for 5+ seconds triggers .... release?! ]

        If key$ <> "" Then
            code% = Asc(key$):
            If code% Then ' ASC returns any value greater than 0
                Select Case Asc(key$)
                    Case 96: 'nothing
                    Case 27:
                        a$ = "": CurCol = Icol
                        'Case 13:
                        '        If a$ <> "" Then Exit Do
                    Case 8: 'Backspace
                        If CurCol <> Icol Then
                            If CurCol = Icol + Len(a$) Then ' this condition includes a$ = ""
                                a$ = Left$(a$, Len(a$) - 1)
                            Else 'inhere we are not at the end i.e. 1..len(a$)-1
                                a$ = Left$(a$, (CurCol - Icol) - 1) + Right$(a$, Len(a$) - (CurCol - Icol))
                            End If
                            CurCol = CurCol - 1
                        End If
                    Case 32 TO 127 - 1:
                        If Len(a$) < LineLen - 1 Then 'a$ = a$ + key$: CurCol = CurCol + 1 '-1 because cursor goes next to the field otherwise
                            If CurCol = Icol + Len(a$) Then ' this condition includes a$ = ""
                                a$ = a$ + key$
                            Else 'inhere we are not at the end i.e. 1..len(a$)-1
                                ' Insert at (CurCol - Icol) + 1:
                                a$ = Left$(a$, (CurCol - Icol)) + key$ + Right$(a$, Len(a$) - (CurCol - Icol))
                            End If
                            CurCol = CurCol + 1
                        End If
                End Select
            Else
                If Len(key$) > 1 Then
                    Select Case Asc(key$, 2)
                        Case 75: If CurCol > Icol Then CurCol = CurCol - 1
                        Case 77: If CurCol < MaxCol And CurCol < Icol + Len(a$) Then CurCol = CurCol + 1
                        Case 71: CurCol = Icol 'Home
                        Case 79: CurCol = Icol + Len(a$) 'End
                        Case 83: 'Del
                            If a$ <> "" Then
                                a$ = Left$(a$, (CurCol - Icol)) + Right$(a$, Len(a$) - (CurCol - Icol) - 1)
                            End If
                        Case 82: 'Ins
                    End Select
                End If
            End If
        End If
        LocateTextGraphCursor Irow, Icol, 0, CursorS, CursorE
        Print String$(LineLen, " ");
        LocateTextGraphCursor Irow, Icol, 0, CursorS, CursorE
        Print a$;
        LocateTextGraphCursor Irow, CurCol, 1, CursorS, CursorE
        _Display
        _Limit 30 ' had to comment it out due to slow hiding-n-drawing of the inverse line - it was flickering
    Loop
    _Limit FramesPerSecond
    ' Stupid pseudo-fix of the buggy behavior (injecting 1's and 0's when only 0's are expected) on Fedora 35 [
    For i = 1 To 3333
        StupidFix$ = InKey$
        If _KeyDown(96) Then GoTo RsmLoop
    Next
    ' Stupid pseudo-fix of the buggy behavior (injecting 1's and 0's when only 0's are expected) on Fedora 35 ]
    InputLine$ = a$
End Function

Function DrawBoxShadow3exactSLASH$ (TopLrow, TopLcol, BottomRrow, BottomRcol, Captnn$)
    Shared FileSize
    Shared LoadedFile$
    Shared PSPlike$
    Shared YdimROW, FileCount, File_Frame_y, XdimCOL, FileArrayWINDOW$() ', FileArray$()
    'Shadow
    BckGRcolor = 4
    Color 8, BACKGR
    For i = 1 To MIN&(YdimROW, FileCount)
        'DumboReadOnceNotThrice$ = FileArray$(i + (File_Frame_y - 1))
        'IF LEN(DumboReadOnceNotThrice$) >= XdimCOL THEN
        '    FileArrayWINDOW$(i) = MID$(DumboReadOnceNotThrice$, 1, XdimCOL)
        'ELSE
        '    FileArrayWINDOW$(i) = DumboReadOnceNotThrice$ + SPACE$(XdimCOL - LEN(DumboReadOnceNotThrice$))
        'END IF
        If i >= TopLrow + 1 And i <= BottomRrow + 1 Then
            LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Mid$(FileArrayWINDOW$(i), TopLcol + 1, BottomRcol - TopLcol + 1);
        End If
    Next
    'Outer frame
    LocateTextGraphCursor TopLrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor
    Print Chr$(218); String$(BottomRcol - TopLcol - 1, Chr$(196));
    Color 0, BckGRcolor: Print Chr$(191);
    Color 7, BckGRcolor: LocateTextGraphCursor TopLrow, TopLcol + 2, 0, CursorS, CursorE: Print "[ ";: Color 15 - 8, BckGRcolor: Print Captnn$;: Color 7, BckGRcolor: Print " ]";
    For i = TopLrow + 1 To BottomRrow - 1
        Color 7, BckGRcolor: LocateTextGraphCursor i, TopLcol, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - TopLcol - 1, Chr$(32));: Color 0, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor BottomRrow, TopLcol, 0, CursorS, CursorE
    Color 7, BckGRcolor: Print Chr$(192);
    Color 0, BckGRcolor: Print String$(BottomRcol - TopLcol - 1, Chr$(196)); Chr$(217)
    'Inner frame
    LocateTextGraphCursor TopLrow + 1, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor
    Print Chr$(218); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196));
    Color 7, BckGRcolor: Print Chr$(191);
    For i = TopLrow + 2 To TopLrow + 3
        Color 0, BckGRcolor: LocateTextGraphCursor i, TopLcol + 1, 0, CursorS, CursorE: Print Chr$(179); String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(32));: Color 7, BckGRcolor: Print Chr$(179);
    Next
    LocateTextGraphCursor TopLrow + 3, TopLcol + 1, 0, CursorS, CursorE
    Color 0, BckGRcolor: Print Chr$(192);
    Color 7, BckGRcolor: Print String$(BottomRcol - 1 - (TopLcol + 1) - 1, Chr$(196)); Chr$(217)

    LocateTextGraphCursor TopLrow + 2, TopLcol + 2, 0, CursorS, CursorE
    Color 7, BckGRcolor

    HelpLine1$ = "Edit keys, allowed: Home, Left, Right, End, Backspace, Del, Esc, /(released)"
    HelpLine2$ = "Wildcards, allowed: '*' any character(s) or empty; '#' any character and not empty"
    LocateTextGraphCursor TopLrow + 4, TopLcol + 2, 0, CursorS, CursorE: Print HelpLine1$
    LocateTextGraphCursor TopLrow + 5, TopLcol + 2, 0, CursorS, CursorE: Print HelpLine2$
    _Display
    DrawBoxShadow3exactSLASH$ = InputLineSLASH$(TopLrow + 2, TopLcol + 2, BottomRcol - TopLcol - 1 - 2)
    LocateTextGraphCursor 1, 1, 0, CursorS, CursorE
End Function

Function InputLineSLASH$ (Irow, Icol, LineLen)
    Static a$
    Shared CurrentWord$, FramesPerSecond
    LocateTextGraphCursor Irow, Icol, 1, CursorS, CursorE
    MaxCol = Icol + LineLen - 1
    CurCol = Icol 'Icol..MaxCol
    'IF CurrentWord$ = "" THEN
    '    IF INSTR(_CLIPBOARD$, CHR$(10)) THEN '_CLIPBOARD$ could be multi-line, so get the first
    '        a2$ = LEFT$(_CLIPBOARD$, INSTR(_CLIPBOARD$, CHR$(10)) - 1)
    '        IF RIGHT$(a2$, 1) = CHR$(13) THEN a2$ = LEFT$(a2$, LEN(a2$) - 1)
    '        a$ = LEFT$(a2$, LineLen - 1) '""
    '    ELSE
    '        a$ = LEFT$(_CLIPBOARD$, LineLen - 1) '""
    '    END IF
    '    CurCol = Icol + LEN(a$)
    'ELSE
    '    a$ = CurrentWord$
    'END IF

    '_Delay .5 ' This kinda fixes the nasty (again) inability to handle release of / - it enters the function as if / was released within?!
    RsmLoopSLASH:
    _KeyClear
    BuggyInLinux& = 0
    Do
        ' Kaze's Galeon's non-fix of the problem (on Fedora 35) below [
        x = _KeyHit
        If x Then
            If x < 0 Then 'negative value means key released
                x = -x
                If x = 47 And _KeyDown(47) = 0 Then Exit Do
            Else
            End If
        End If
        ' Kaze's Galeon's non-fix of the problem (on Fedora 35) below ]

        '    ' On Windows 10, after a minute, self activating?!
        '    'BuggyInLinux& = _KeyDown(96)
        '    'If BuggyInLinux& Then
        '    '    IsTILDEreleased = -1
        '    'Else
        '    '    If IsTILDEreleased = -1 Then IsTILDEreleased = 1 Else IsTILDEreleased = 0
        '    'End If
        '    'If IsTILDEreleased = 1 Then IsTILDEreleased = 0: Exit Do

        key$ = InKey$
        ' Even this doesn't fix it fully, holding for 5+ seconds triggers .... release?! [
        'If key$ <> "" Then
        '    BuggyInLinux& = _KeyDown(96)
        'End If
        'If BuggyInLinux& Then
        '    BuggyInLinux& = _KeyDown(96)
        '    IsTILDEreleased = -1
        'Else
        '    If IsTILDEreleased = -1 Then IsTILDEreleased = 1 Else IsTILDEreleased = 0
        'End If
        'If IsTILDEreleased = 1 Then IsTILDEreleased = 0: Exit Do
        ' Even this doesn't fix it fully, holding for 5+ seconds triggers .... release?! ]

        If key$ <> "" Then
            code% = Asc(key$):
            If code% Then ' ASC returns any value greater than 0
                Select Case Asc(key$)
                    Case 47: 'nothing
                    Case 27:
                        a$ = "": CurCol = Icol
                        'Case 13:
                        '        If a$ <> "" Then Exit Do
                    Case 8: 'Backspace
                        If CurCol <> Icol Then
                            If CurCol = Icol + Len(a$) Then ' this condition includes a$ = ""
                                a$ = Left$(a$, Len(a$) - 1)
                            Else 'inhere we are not at the end i.e. 1..len(a$)-1
                                a$ = Left$(a$, (CurCol - Icol) - 1) + Right$(a$, Len(a$) - (CurCol - Icol))
                            End If
                            CurCol = CurCol - 1
                        End If
                    Case 32 TO 127 - 1:
                        If Len(a$) < LineLen - 1 Then 'a$ = a$ + key$: CurCol = CurCol + 1 '-1 because cursor goes next to the field otherwise
                            If CurCol = Icol + Len(a$) Then ' this condition includes a$ = ""
                                a$ = a$ + key$
                            Else 'inhere we are not at the end i.e. 1..len(a$)-1
                                ' Insert at (CurCol - Icol) + 1:
                                a$ = Left$(a$, (CurCol - Icol)) + key$ + Right$(a$, Len(a$) - (CurCol - Icol))
                            End If
                            CurCol = CurCol + 1
                        End If
                End Select
            Else
                If Len(key$) > 1 Then
                    Select Case Asc(key$, 2)
                        Case 75: If CurCol > Icol Then CurCol = CurCol - 1
                        Case 77: If CurCol < MaxCol And CurCol < Icol + Len(a$) Then CurCol = CurCol + 1
                        Case 71: CurCol = Icol 'Home
                        Case 79: CurCol = Icol + Len(a$) 'End
                        Case 83: 'Del
                            If a$ <> "" Then
                                a$ = Left$(a$, (CurCol - Icol)) + Right$(a$, Len(a$) - (CurCol - Icol) - 1)
                            End If
                        Case 82: 'Ins
                    End Select
                End If
            End If
        End If
        LocateTextGraphCursor Irow, Icol, 0, CursorS, CursorE
        Print String$(LineLen, " ");
        LocateTextGraphCursor Irow, Icol, 0, CursorS, CursorE
        Print a$;
        LocateTextGraphCursor Irow, CurCol, 1, CursorS, CursorE
        _Display
        _Limit 30 ' had to comment it out due to slow hiding-n-drawing of the inverse line - it was flickering
    Loop
    _Limit FramesPerSecond
    ' Stupid pseudo-fix of the buggy behavior (injecting 1's and 0's when only 0's are expected) on Fedora 35 [
    For i = 1 To 3333
        StupidFix$ = InKey$
        If _KeyDown(47) Then GoTo RsmLoopSLASH
    Next
    ' Stupid pseudo-fix of the buggy behavior (injecting 1's and 0's when only 0's are expected) on Fedora 35 ]
    InputLineSLASH$ = a$
End Function

Function EpochTime~&&
    DATEstamp$ = Date$: TIMEstamp$ = Time$
    Do While DATEstamp$ <> Date$ 'redo
        DATEstamp$ = Date$: TIMEstamp$ = Time$
    Loop
    m = Val(Left$(DATEstamp$, 2))
    d~&& = Val(Mid$(DATEstamp$, 4, 2))
    y~&& = Val(Right$(DATEstamp$, 4)) - 1970
    For i = 1 To m
        Select Case i 'Add the number of days for each previous month passed
            Case 1: d~&& = d~&& 'January doestn't have any carry over days.
            Case 2, 4, 6, 8, 9, 11: d~&& = d~&& + 31
            Case 3: d~&& = d~&& + 28
            Case 5, 7, 10, 12: d~&& = d~&& + 30
        End Select
    Next
    d~&& = d~&& + y~&& * 365
    For i = 2 To y Step 4
        If m > 2 Then d~&& = d~&& + 1 'add an extra day for leap year every 4 years, starting in 1970
    Next
    d~&& = d~&& - 1 'for year 2000
    EpochTime~&& = d~&& * 24 * 60 * 60 + Val(Left$(TIMEstamp$, 2)) * 3600 + Val(Mid$(TIMEstamp$, 4, 2)) * 60 + Val(Right$(TIMEstamp$, 2))
End Function

Function FileArray_FILTERfunction$ (IndirectIndex)
    Shared DIRorTREE_flag, FileArray_TREE$(), FileArray$(), FileArray_FILTERfaster&()
    Shared treedumpPOOLFLAG, treedumpPOOL_DIRonlyFLAG
    If DIRorTREE_flag Then
        FileArray_FILTERfunction$ = FileArray$(FileArray_FILTERfaster&(IndirectIndex))
    Else
        If treedumpPOOLFLAG + treedumpPOOL_DIRonlyFLAG + Abs(DIRorTREE_flag) = 0 Then
            FileArray_FILTERfunction$ = GetHEXline$(FileArray_FILTERfaster&(IndirectIndex))
        Else
            FileArray_FILTERfunction$ = FileArray_TREE$(FileArray_FILTERfaster&(IndirectIndex))
        End If
    End If
End Function

Function GetHEXlineCACHED$ (j) ' j should be increasing since last call
    Shared fff&
    Static LastElement

    If j = 1 Then LastElement = 0
    If LastElement = 0 Or j - LastElement >= 10000 Then ' if j is within 1..10000 don't read;
        Get #fff&, (j - 1) * 64 + 1, Get10000elements$ ' 64x10000
        UCASE_XMM_inplace_NULL2SPC _Offset(Get10000elements$), Len(Get10000elements$) ' 64*10000 is multiple of 16, so no padding needed
        LastElement = j
    End If
    'Get32bytes$ = Mid$(Get10000elements$, (j - LastElement) * 64 + 1, 64)
    'If InStr(Get32bytes$, Chr$(0)) Then
    '        For i = 1 To 64
    '                If Asc(Mid$(Get32bytes$, i, 1)) = 0 Then
    '                        Mid$(Get32bytes$, i, 1) = " "
    '                End If
    '        Next
    'End If
    'GetHEXlineCACHED$ = Get32bytes$
    GetHEXlineCACHED$ = Mid$(Get10000elements$, (j - LastElement) * 64 + 1, 64)
End Function

Function GetHEXline$ (j)
    Shared fff&
    Get #fff&, (j - 1) * 64 + 1, Get32bytes$
    'Dumbino$ = ""
    'Dumbino2$ = ""
    ' Too slow [
    'For i = 1 To 64
    '        Superslow$ = Hex$(Asc(Mid$(Get32bytes$, i, 1)))
    '        If Len(Superslow$) = 1 Then Superslow$ = "0" + Superslow$
    '        Dumbino2$ = Dumbino2$ + Superslow$
    '        If Asc(Mid$(Get32bytes$, i, 1)) = 0 Then
    '                Dumbino$ = Dumbino$ + " "
    '        Else
    '                Dumbino$ = Dumbino$ + Mid$(Get32bytes$, i, 1)
    '        End If
    '        'If Asc(Mid$(Get32bytes$, i, 1)) < 32 Then
    '        '        Dumbino$ = Dumbino$ + " "
    '        'Else
    '        '        Dumbino$ = Dumbino$ + Mid$(Get32bytes$, i, 1)
    '        'End If
    'Next
    ' Too slow ]
    SourceA%& = _Offset(ASCIIfast(0))
    TargetA%& = _Offset(Get32bytesX2)
    SourceB%& = _Offset(ASCIIfastBYTE(0))
    TargetB%& = _Offset(Get32bytesDUMBINO)
    For i = 1 To 64
        kazebyte = Mid$(Get32bytes$, i, 1)
        memcpyKAZE TargetA%& + (i - 1) * 2, SourceA%& + Asc(kazebyte) * 2, 2 ' _Offset(ASCIIfast(Asc(Mid$(Get32bytes$, i, 1))))
        memcpyKAZE TargetB%& + (i - 1) * 1, SourceB%& + Asc(kazebyte) * 1, 1
    Next
    Dumbino3$ = Hex$((j - 1) * 64)
    Dumbino3$ = String$(16 - Len(Dumbino3$), "0") + Dumbino3$
    'GetHEXline$ = Dumbino$ + " " + Dumbino2$ + " " + Dumbino3$
    GetHEXline$ = Get32bytesDUMBINO + " " + Get32bytesX2 + " " + Dumbino3$
End Function

Function MouseXfun%
    Shared GraphicOrTextFlag
    If GraphicOrTextFlag Then
        MouseXfun% = _MouseX \ _FontWidth + 1
    Else
        MouseXfun% = _MouseX
    End If
End Function

Function MouseYfun%
    Shared GraphicOrTextFlag
    If GraphicOrTextFlag Then
        MouseYfun% = _MouseY \ _FontHeight + 1
    Else
        MouseYfun% = _MouseY
    End If
End Function

Sub LocateTextGraphCursor (CursorGraphX, CursorGraphY, Visibility, CurS, CurE)
    Shared GraphicOrTextFlag
    Locate CursorGraphX, CursorGraphY, Visibility, CurS, CurE
    If GraphicOrTextFlag = 1 Then
        If Visibility Then
            Line ((CursorGraphY - 1) * _FontWidth, (CursorGraphX - 1) * _FontHeight)-((CursorGraphY) * _FontWidth - 1, (CursorGraphX) * _FontHeight - 1), 9 - 2 * (Int(Timer) Mod 2), B
        End If
    End If
End Sub

Function IsCapsLockOn%
    $If WINDOWS Then
        IsCapsLockOn% = _CapsLock
    $Else
        Shell "xset -q>xset.txt"
        ff = FreeFile
        Open "xset.txt" For Input As #ff
        Do While Not EOF(ff)
            Line Input #ff, q$
            If InStr(q$, "00: Caps Lock:   on") Then CapsLockStatus% = -1
            If InStr(q$, "00: Caps Lock:   off") Then CapsLockStatus% = 0
        Loop
        Close #ff
        IsCapsLockOn% = CapsLockStatus%
    $End If
End Function

Function IsNumLockOn%
    $If WINDOWS Then
        IsNumLockOn% = _NumLock
    $Else
        Shell "xset -q>xset.txt"
        ff = FreeFile
        Open "xset.txt" For Input As #ff
        Do While Not EOF(ff)
            Line Input #ff, q$
            If InStr(q$, "01: Num Lock:    on") Then NumLockStatus% = -1
            If InStr(q$, "01: Num Lock:    off") Then NumLockStatus% = 0
        Loop
        Close #ff
        IsNumLockOn% = NumLockStatus%
    $End If
End Function

Function ExactAndWildcardUnderOneROOF (IsItWildcardPattern, Needle$, Haystack$)
    If IsItWildcardPattern Then
        ExactAndWildcardUnderOneROOF = Tcheburaschka_Wildcard_CaseSensitive%((Needle$), (Haystack$))
    Else
        'HaystackLEN = Len(Haystack$) - 1 '-1 because the given Needle is ASCIIZ
        'NeedleLEN = Len(Needle$) - 1 '-1 because the given Needle is ASCIIZ
        'PointerHQB64%& = _Offset(Haystack$) 'Dim PointerHQB64 As _Offset
        'PointerNQB64%& = _Offset(Needle$) 'Dim PointerNQB64 As _Offset
        'FoundAtNew%& = Railgun_Trolldom_64%&(PointerHQB64%&, PointerNQB64%&, HaystackLEN, NeedleLEN) 'Function Railgun_Trolldom_64%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As _Integer64, Byval NeedleLEN As Long)
        'If FoundAtNew%& = 0 Then ExactAndWildcardUnderOneROOF = 0 Else ExactAndWildcardUnderOneROOF = 1

        'HaystackLEN%& = Len(Haystack$) - 1 'The workaround of lacking casting
        'NeedleLEN = Len(Needle$) - 1
        'PointerHQB64%& = _Offset(Haystack$) 'Dim PointerHQB64 As _Offset
        'PointerNQB64%& = _Offset(Needle$) 'Dim PointerNQB64 As _Offset
        'FoundAt%& = PointerHQB64%&
        ''Do
        ''        FoundAtNew%& = Railgun_Trolldom_64%&(FoundAt%&, PointerNQB64%&, HaystackLEN%& - (FoundAt%& - PointerHQB64%&), NeedleLEN)
        ''        If FoundAtNew%& = 0 Then Exit Do
        ''        FoundAt%& = FoundAtNew%& + 1: Hits = Hits + 1
        ''Loop
        'FoundAtNew%& = Railgun_Trolldom_64%&(FoundAt%&, PointerNQB64%&, HaystackLEN%& - (FoundAt%& - PointerHQB64%&), NeedleLEN) 'Function Railgun_Trolldom_64%& (ByVal HaystackADDR As _Offset, Byval NeedleADDR As _Offset, Byval HaystackLEN As _Offset, Byval NeedleLEN As Long)
        'If FoundAtNew%& = 0 Then ExactAndWildcardUnderOneROOF = 0 Else ExactAndWildcardUnderOneROOF = 1

        If Len(Needle$) - 1 = 1 Then ' Railguns don't accept length=1 for pattern
            If InStr(Left$(Haystack$, Len(Haystack$) - 1), Left$(Needle$, Len(Needle$) - 1)) = 0 Then ExactAndWildcardUnderOneROOF = 0 Else ExactAndWildcardUnderOneROOF = 1
        Else
            FoundAtNew%& = Railgun_Doublet%&(Haystack$, Needle$, Len(Haystack$) - 1, Len(Needle$) - 1)
            If FoundAtNew%& = 0 Then ExactAndWildcardUnderOneROOF = 0 Else ExactAndWildcardUnderOneROOF = 1
        End If
    End If
End Function

Sub ASCIItable
    toggleCyanPurpleWhite = 3
    Color toggleCyanPurpleWhite
    If cnt Mod 16 = 0 Then Print String$(3 - Len(LTrim$(Str$(cnt))), "0") + LTrim$(Str$(cnt)); " ";
    For i = 0 To 255
        'IF i <> 11 AND i <> 12 AND i <> 9 AND i <> 7 AND i <> 13 AND i <> 10 THEN
        Print Chr$(i) + " ";
        'ELSE
        'PRINT "  ";
        'END IF
        cnt = cnt + 1
        If (cnt <= 255) And (cnt Mod 16 = 0) Then
            If toggleCyanPurpleWhite = 3 Then
                toggleCyanPurpleWhite = 7
            ElseIf toggleCyanPurpleWhite = 7 Then
                toggleCyanPurpleWhite = 9
            Else
                toggleCyanPurpleWhite = 3
            End If
            Color toggleCyanPurpleWhite
            Print: Print String$(3 - Len(LTrim$(Str$(cnt))), "0") + LTrim$(Str$(cnt)); " ";
        End If
    Next
    _Display: Sleep 'Do While InKey$ <> Chr$(27): Loop
End Sub

